batch /* ***********************  M3564/RPC353 Init File  ************************* */
#MODULE INI_INIT #VERSION V5.41
^VERSION ptr ^NH_INI_VER

/*                              RP4INI.UC
**     REQUIRES Firmware M4.52f
**
**     V5.41 JRC 08Apr2013 Increased delay in pause after increasing motor current. (v5.39 only wait longer.)
**     V5.40 JRC 08Apr2013 Fixed Z-Speed not following feerate override in Follow_X or Follow_Y modes.   
**     V5.39 JRC 04Apr2013 Fixed stalling when resuming from pause after jogging in pause (monFP before returning to PD)  
**     V5.38 JRC 08Mar2013 Changed index_cyl to relative moves.  
**     V5.37 JRC 05Mar2013 Added wait_plot to index_cyl 
**     V5.36 JRC 04Mar2013 Added CYL_FACTOR and pi multipliers to index_cyl. 
**     V5.35 JRC 04Mar2013 Added wait_plot to ZO 100 (we weren't waiting for motion to finish before changing spindle speed.) 
**     V5.34 JRC 04Mar2013 Added (ZO 301,<degrees>) for indexing cylinder without diameter
**     V5.33 JRC 06Feb2013 Not applying feedrate override to controled_z motion per Jeff.
**     V5.32 JRC 09Jan2013 Changed msg 1304 per Jeff.
**     V5.31 JRC 13Dec2012 Fixed key funcs being allowed in pause detect.
**                         Now clearing Job name when switching from DNC to Engrave Lab jobs.
**     V5.30 JRC 07Dec2012 Fixed VST mode allowing bad motion if canceleing from search for point. 
**     V5.29 JRC 04Dec2012 Fixed key funcs, menus and estop don't look good when in Sol Test mode. 
**     V5.28 JRC 28Nov2012 Fixed Local DNC not putting controller back in HPGL mode 
**     V5.27 JRC 27Nov2012 Fixed keypad threads still running in estop. 
**     V5.26 JRC 26Nov2012 Fixed estop_detect not being called until after performing motion.
**     V5.25 JRC 26Nov2012 Improved graphics handling for pause, estop, and obounds from move menu.
**     V5.24 JRC 26Nov2012 Fixed move menu not returning main font color to custom scheme.
**     V5.23 JRC 21Nov2012 Fixed version display variables to be more compatible with Suite 4 Applications. Added ^NH_INI_VER
**     V5.22 JRC 21Nov2012 Fixed display issues when estopping while in a menu.
**                         Fixed coordinates not showing correctly for numbers -10.0 or less in menu_move current position. 
**                         Fixed display issues when menu_move produces oBounds.
**                         Craig already fixed typo in specify IP menu item.
**                         James fixed showing the HPGL message in the terminal when entering HPGL mode.
**                         Removed "Ethernet Status" menu item, it's not implemented on the 353.
**     V5.21 CAS 18Sep2012 Local DCN if you press Enter a second time, inform user to press start to load job.
**     V5.20 CAS 27Aug2012 Local DCN saving file would show Cut Speed in the menu area.
**                         Do not clear batch number if Exit key pressed when idle.
**                         Report of Park always parking at home but can't reproduce.
**     V5.19 CAS 05Jul2012 Local DNC would not preview job.
**                         HPGL and G&M selection was backwards.
**                         Stack error would occur when the digitize key was pressed but no Z control.
**                         Look for flag from dnc_begin to know whether host timed out.
**                         Change from 0 set_thread_restart to 1 set_thread_restart
**     V5.18 CAS 03Jul2012 Could not change between G&M and HPGL.
**                         If datums are turned off and you run the motor phase test, it will ask to home machine even though datums are off.
**                         Local DNC display was overlapping with time.
**                         After running a Local DNC job, the keys would be locked out.
**                         To replay VST, press START, wait for blinking led, then press VST and jog to position and press VST again.
**                         Skip the Digitize key (key 6) if machine doesn't have a controlled Z.
**                         Reported that Parking doesn't work (only home mode) but I could not reproduce.
**     V5.17 CAS 26Jun2012 Pull Out Estop message was being truncated (turned out to be center_string, now replace CR with spaces).
**                         At the end of a BATCH job, the screen would be messed up.
** 50u V5.16 CAS 22Jun2012 Require 4.50u firmware.
**                         Initiate self-test by putting it in the ring-buffer.
**                         At end of job, if we are in hpgl or cnc, assume job did not come from JC so don't send DNCEndOfJob
**                         Add Job Preview to keypad.
** 50s V5.15 CAS 21May2012 Require 4.50s firmware. 
**                         Allow cancel for keypad move operations.
**                         Move code around for size limitations.
**     V5.14 CAS 10May2012 If right spindle and pneumatic, don't ask to set surface at start of job.
**                         The menu Cut Speed Global/Individual didn't have a space between the words.
**                         Update SHOW command to dump ring buffer of last job executed. 
**     V5.13 CAS 08May2012 Create my_cancel instead of calling firmware cancel.
**                         Kill inque would sometimes eat the SP0, so add it in manually.
**                         The Go Home button when paused would sometimes show the coords on the display.
**                         Add error buffer to save messages that occur during job, use SHOW command to view.
**                         Serial port was not working every time.
**     V5.12 CAS 25Apr2012 Add better display of error messages (added check_for_faults)
**     V5.11 CAS 20Apr2012 The Cut speed box would flash max cut speed briefly before showing actual cut speed.
**                         Feedrate override would remain on after some cylindrical jobs, make changes but don't know if fixed yet.
**                         VST Restart would sometime lock up, especially if you tried to restart within a restart.
**                         Don't show the spindle and home when jogging to do a VST restart (there isn't enough room)
**     V5.10 CAS 16Apr2012 Z Delta display was on top of Cut Speed display.
**                         If option to display Z Depth and Z Delta were both selected, Z Delta would be on top of Z Depth.
**                         If we are NOT displaying the Z Depth and Passes on a multipass job, go ahead and display the NH Logo 
**     V5.09 CAS 09Apr2012 Job Multipass was not working. 
**                         Change boot leds to follow the boot sequence a little better.
**                         After the splash screen before the idle screen, the screen would flash an intermediate screen.
**                         Change arg push at end to use eventqueue.
**                         If the Job Complete message is displayed at end of job and you jog, the screen would be messed up.
**                         Sometimes the machine would be left with FRO enabled. 
**                         Pause button would not be re-enabled after the first pause.
**                         Time display would be refreshed too soon when continuing from pause.
** 50q V5.08 CAS 03Apr2012 Change arg push at end for Serial Operation. Requires v4.50q2 or later firmware.
**                         Added more debug. Automatically set parameter 406 to 1 if not set and reboot.
**                         Take out test_dhcp for now. Make a file_space command that allows up to 5 meg of space.
**                         Some cases when running VST then Time would be on top of the X Y display.
**     V5.07 CAS 26Mar2012 If in 3D Mode, set the current Z feedrate to Z Vmax when calling machine_mode.  
**     V5.06 CAS 21Mar2012 If Y limit switch is disabled, do not set Y home position at end of find_limits routine.
**                         After pause/cancel, the spindle LEDs and Aux Leds would still be active. Also, the next job ran would not turn on spindle.
**                         Change "CutSpeed" to "Cut Speed"
**     V5.05 CAS 28Feb2012 Call cold for warm_boot so machine parameters reboots after changing a parameter.
**                         Make Jog Z key be the fast key when Z is not used.
**     V5.04 CAS 24Feb2012 Set parameter 104 to run Inverted Z cnc jobs.
**     V5.03 CAS 06Feb2012 Show Spindle ID in Proper text instead of all caps.
**                         Change preview to not use firmware version so we have more control.
**                         Vertically center the "Center" text for home location.
**     V5.02 CAS 02Feb2012 Change cut speed display to show "Left Spindle", "Right Spindle", "Both Spindles"
**                         Move Z Depth box over when running multi-pass jobs.
**                         Show Spindle ID and Home location in preview.
**                         Allow user to press START when in preview to start job.
**                         Cleaned up showing main screen. 
**                         If DNC was not connected, show message that it failed to connect.
**                         If no limits, change the table size so Job Console does not report out of bounds.
** 50m V5.01 CAS 01Feb2012 The display of string 29 will be centered and you can use '|' for multi-line.
**                         Add splash screen. Add option to display FRO. Add displaying Job Spindle ID and Home Position.
**                         Estop would not always recover. Change cylindrical diameter limits from 20 to 12.
**                         Show preview when starting job through DNC.
**                         Update cutspeed on display when knob is changed.
**                         Machine parameters would not show 1st parameter (X Resolution) when loading.
**                         FRO didn't work (firmware update)
**                         Ethernet address was not updated until after reboot (firmware update)
** 49a V5.00 CAS 09Jan2012 Initial Release
*
*
* outputs CodeBit  M54   M2564
*  sol1     18     2:4    p124
*  sol2     20     2:16   p125
*  sol3     --     p126   p123
*  Relay2   16     2:1    101:1         relay 2 H2 pins 1 & 2
*  iso1     17     2:2    101:2         was Opto now relay H3 pind 3 & 4
*  Aux1     12     1:16   101:4
*  Aux2     13     1:32   101:8
*  K1     rotary   2:128  Drive4        Use Drive4, no relay switching now
-- */

` ifneeded get_socket_info                  : get_socket_info drop drop -1 ;
` ifneeded file_space                       : file_space 0 0 0 ;
ifmissing get_dhcp_state                    : get_dhcp_state 0 ;  ` Not really used, in test_dhcp which is not currently included.

` If the serial is setup as a job input port.
406 param? 1 <> #ifdef "" \007 Configuring Serial Port...\n" write_err 1 406 set_integer ' COLD 0 .5 2 eventqueue drop leave #endif
406 param? 1 =  #ifdef 406 get_integer 1 <> #ifdef "" \007 Configuring Serial Port...\n" write_err 1 406 set_integer ' COLD 0 .5 2 eventqueue drop leave #endif #endif


"" 4.52f" ptr pFIRMWARE_REQUIRED

59 param? 1 <> #ifdef 1108 59 set_integer #endif  ` default 59 if not set.
59 get_integer ivar KEYPAD_TYPE     ` 0 is none, 20, or 1020
1108 == KEYPAD_TYPE ` force to 1108 for now
KEYPAD_TYPE 1020 = KEYPAD_TYPE 1021 = or ivar KDM20G?
KEYPAD_TYPE 1012 =                       ivar KDM12G?  ` KDM12G is the Touch Screen.
KEYPAD_TYPE 1108 =                       ivar KDM8G?  ` KDM8G is the NH keypad with 320x240 graphical

  0 ivar COLOR_SCHEME
252 ivar cTEXT_COLOR  
133 ivar BGCOLOR  ` Teal
  1 == cBLACK
: splash_screen
    KEYPAD_TYPE 0x310000 kdm_init     ` just to enable channel, enable JOG ADV, USE LINE
    200 millisecond_delay
    1 3 kdm_led  ` turn on first LED.
    1905 param? 1 = if
        1905 get_integer == cTEXT_COLOR
    endif
    1900 param? 1 = if
        1900 get_integer == COLOR_SCHEME
    endif
    COLOR_SCHEME 0 max 9 min 1+ select
    => 133 => cBLUE => 208 => 153 => cBLACK => 212 => 64 => 132 => 145 => 129 => 1903 param? 1 = if 1903 get_integer else 133 endif endselect
    dup == BGCOLOR dup glcd_bg glcd_fg
    ` 8 63 64 126 glcd_set_palette  ` I just had to change the palette... :(
    0 0 320 240 glcd_box
    BGCOLOR cBLACK = if
        255 255 255 0 glcd_set_palette
    endif
    1 0 0 0 glcd_resource
    
    ifexists glcd_set_splash_bg BGCOLOR glcd_set_splash_bg
;
splash_screen

/* FILE LOCATIONS */
 0  ivar TABLECOMP_FILE
 1  ivar SELFTEST_FILE
 3  ivar DEVICE_FILE   ` The last loaded file.
 4  ivar LANGUAGE_FILE  ` Add parameter to default language. (was hardcoded to location 4)

57 param? 1 <> #ifdef 0 57 set_integer #endif 
57 get_integer ivar UNITS           ` 0 for english, 1 for metric

 40 104 sysallocate ptr pItoa
 40 104 sysallocate ptr pItoaTemp
: itoa pItoa true iformat ;
: ftoa pItoa fformat ;
: ftoa.1 1 fprec ftoa 7 fprec ;
: ftoa.2 2 fprec 1000. f* round 1000. f/ ftoa 7 fprec ; ` round to avoid -0.000 being displayed
: ftoa.3 3 fprec 10000. f* round 10000. f/ ftoa 7 fprec ;
: ftoa.4 4 fprec ftoa 7 fprec ;
: ftoa.units UNITS if ftoa.2 else ftoa.3 endif ;
: mcitoa "" M" pItoa s! pItoaTemp 0 iformat pItoa s+! pItoa ;

/* Flash Parameters Access Routines */
ln get_integer gi
ln get_float gf
ln get_string gs
` set_float/integer (will only set if different)
: si dup param? 1 = if 2dup get_integer <> if set_integer else 2drop endif else set_integer endif ;
: sf dup param? 2 = if fdup dup get_float f- fabs .000001 f> if set_float else drop fdrop endif else set_float endif ;

` Tell user that you had defaulted value.  It will give user an idea of new parameters added.
: dfvs 1949 getmsg write_err itoa write_err ""  to " write_err itoa write_err ;
: dfvf 1949 getmsg write_err itoa write_err ""  to " write_err ftoa write_err ;
` <default> <loc>  dgx <value>
` <default> <loc>  ddgx
: dgi dup param? 1 = if swap drop get_integer else swap dup rot 2dup dfvs set_integer endif ;
: dgf dup param? 2 = if fdrop get_float else fdup dup fdup dfvf set_float endif  ;
: ddgf dgf fdrop ; ` default drop
: ddgi dgi drop  ;

: dgs dup param? 3 = if swap drop gs else swap dup rot set_string endif  ;

` returns the serial number if set otherwise returns the k-board serial number (requires 4.38j).
` 100001 = set OEM Model
` 100002 = Set OEM Serial
` 100005 = Set Baud Rate
: get_oem_serial 100002 get_string dup not if drop get_serial mcitoa endif ;
: set_oem_serial 100002 set_string ;
: dsp_oem_serial get_oem_serial s. ;
: get_oem_model  100001 get_string dup not if drop 0 oem_string not if "" Newing Hall" endif endif ;
: get_oem_serial_num
  ` Looks backwards until it does not find a number. If the string is empty at the end, it replaces it with "00000"
  get_oem_serial dup slen dup bury + 1- swap
    1 swap 1- 1 step dup b@ dup ascii 0 >= swap ascii 9 <= land not if 1+ break else 1- endif endstep
    ` check slen to see if string is empty, if so, replace with "00000".
    dup slen 0 = if drop "" 00000" endif
    ;


256   0 sysallocate ptr pBannerString  ` string to display on pendant while job is running
 42   0 sysallocate ptr pJobName       ` name of currently executing job (empty if unknown)
256 998 sysallocate ptr pTEMP          ` used to generate sub menu strings
256 998 sysallocate ptr pTEMPz         ` used to generate sub menu strings
256   1 sysallocate ptr pMenuTitle     ` Title of the menus.
1100 200 sysallocate ptr wordwrap_msg_buffer  ` buffer to hold word wrapped messages
25 ivar WORDWRAP
: set_wordwrap_size == WORDWRAP ;

false ivar save_kdmintr     ` used for open/close chuck.
false ivar ANSWER?          ` temp var used for various dialogs, etc.
false ivar DNC_LOADING?     ` are we waiting for DNC to Display the directory of files.
    0 ivar EXECUTING?
    0 ivar cepause?         ` was pause caused by CE Safety.
    0 ivar SERVICEMENU?     ` did we enable the Service menu prior to homing.
false ivar bShifted         ` are with in "Shift" mode?  (modifies hotkey behavior)
: kdm_space ""  " kdm_dsp_string ;

"" \\" ptr BACKSLASH
22    ivar FASTKEY    ` KDM20G uses 44, KDM20 uses 22.

/* -- KDM LED Defines -- */
3 ivar LED_SHIFT

/* ********************  LED Manipulation Stuff  ****************** */
0 set_warning
` : write_err dup slen 4 swap write drop ;  ` USED TO SHOW MESSAGES ON SERIAL PORT.
: write_err_num ^.buff true iformat write_err ;
: write_err_fp ^.buff "" %7.4f" fpprintf write_err ;
: write_err_nl  "" \n" write_err ;
ifmissing write_out     : write_out dup slen OUTDVC> w@ swap write drop ;
ifmissing write_out_num : write_out_num ^.buff true iformat write_out ;

/* Error Messages (buffer to save error messages) */
0 ivar ERROR_BUSY?
2000 ivar ERROR_BUF_SIZE
ERROR_BUF_SIZE 200 sysallocate ptr ERROR_BUFFER
ERROR_BUFFER                   ivar ERROR_BUFFER_PTR  ` pointer to last byte.
ERROR_BUFFER ERROR_BUF_SIZE  + ivar ERROR_BUFFER_MAX  ` pointer to last byte.
: ring_error_buffer ` <size> ring_error_buffer
    ` "    Ring Buffer BUF:" ERROR_BUFFER . "  SIZE:" ERROR_BUF_SIZE . nl
    dup ` Size
    dup ERROR_BUFFER + ` <ptr From>
    ERROR_BUFFER       ` <ptr to>
    ERROR_BUFFER_PTR ERROR_BUFFER - 4 pluck - 0 max    ` <count>
    ` " R From:" mover . "   To:" over . "  Count:" dup . nl
    bmove   ` move beginning of buffer out.  <ptr from> <ptr to> <count>
    ERROR_BUFFER_PTR swap - == ERROR_BUFFER_PTR
    0 ERROR_BUFFER_PTR ERROR_BUFFER_MAX ERROR_BUFFER_PTR - 0 max
    ` "   Va:" mover . "   Ptr :" over . "  Count:" dup . nl
    bfill ` <value> <ptr> <count>
;
0 ptr RING_BUFFER_PTR_START
0 ptr RING_BUFFER_PTR_CURR
: Show
    ` Dump the buffer in memory first.
    INDVC> w@ 31 0 ioctl 0x60 and if       ` FIOBUFSTAT
        INDVC> w@ 27 ' RING_BUFFER_PTR_START ptrval ioctl drop  ` this is the start pointer.
        INDVC> w@ 35 ' RING_BUFFER_PTR_CURR  ptrval ioctl drop  ` this is the current pointer.
        RING_BUFFER_PTR_CURR RING_BUFFER_PTR_START > if 
            RING_BUFFER_PTR_START RING_BUFFER_PTR_CURR RING_BUFFER_PTR_START - type
        endif
    endif
    nl ERROR_BUFFER s. 
;
0 ivar ADD_ERROR_SIZE
: AddErrorMsgCore ` <string> AddErrorMsgCore
    ERROR_BUSY? if drop :exit endif
    1 == ERROR_BUSY?
    dup slen == ADD_ERROR_SIZE
    ` check if enough room in error buffer, if not, ring the buffer.
    ADD_ERROR_SIZE ERROR_BUFFER_PTR + ERROR_BUFFER_MAX > if ADD_ERROR_SIZE 100 + ring_error_buffer endif
    /* ptr */ ERROR_BUFFER_PTR ADD_ERROR_SIZE 0 max
    bmove
    ERROR_BUFFER_PTR ADD_ERROR_SIZE + ERROR_BUFFER_MAX min == ERROR_BUFFER_PTR
    0 == ERROR_BUSY?
    ;
: AddErrorMsg AddErrorMsgCore ;
: AddErrorNum ` <num> AddErrorNum
    ERROR_BUSY? if drop :exit endif
    itoa AddErrorMsgCore "" ) " AddErrorMsgCore ;
: AddErrorNL "" \n" AddErrorMsgCore ;
: AddErrorFP ` <fp num> AddErrorFP
    ftoa AddErrorMsgCore ""  " AddErrorMsgCore ;
: AddErrorInt ` <int num> AddErrorInt
    itoa AddErrorMsgCore ""  " AddErrorMsgCore ;
: write_err dup AddErrorMsgCore write_err ;


0 ivar SYS_MSG? ` 1 = job file, 2=other.

` replaced v2.60 slow way to kill kdm key buffer
` : eat_kdm loop kdm_peekkey 0 >= while kdm_getkey drop repeat ;
: eat_kdm ; `  KDMDVC> w@ 19 0 ioctl drop KDMDVC> w@ rdchk drop ;  ` don't know if the rdchk is needed, but can't hurt.
` kill the kdm input queue when enabling the hot keys
: kill_inque SYS_MSG? 2 and if "" Before Kill\n" write_err endif  INDVC>  w@ 19 0 ioctl drop INDVC> w@ rdchk drop SYS_MSG? 2 and if "" After Kill\n" write_err endif ;
: ko drop ;
: kdm_bell drop ; ` 27 ko 1 max 3 min select => 84 => 76 => 81 endselect ko ;  ` ESC T, L, Q
: kdm_keyintr dup if eat_kdm endif SYS_MSG? 2 = if "" \n\007kdm_keyintr\n" write_err endif kdm_keyintr ;
1 set_warning
: led_on    1 swap kdm_led ;
: led_off   0 swap kdm_led ;
: led_blink 2 swap kdm_led ;
: ack_blink 2 led_on 200 #delay 2 led_off 200 #delay ;

: blinks 1 swap 1 step ack_blink 50 #delay endstep ;
: gen_error_blink       ` <on> <off> delays
	1 10 1 step
        2 led_on over #delay 2 led_off dup #delay
	endstep 2drop ;

0 set_warning
: kon SYS_MSG? 2 = if "" \n\007kon\n" write_err endif kon ;
: koff SYS_MSG? 2 = if "" \n\007koff\n" write_err endif koff ; 
1 set_warning
	
` changed begining 8 kdm_set_intr to 0 kdm_keyintr - removed eat_kdm because kdm_keyintr does it
: duty_error            ` <percent>
    koff dup 180 100 i*/ 100 rot - 180 100 i*/ gen_error_blink kon ;
: error_blink 80 duty_error ;   ` removed eat_kdm because duty_error calls kdm_keyintr calls eat_kdm
: error2_blink 3 duty_error ;   ` removed eat_kdm because duty_error calls kdm_keyintr calls eat_kdm

"" Newing-Hall|APEX 3D" 29 dgs drop  ` use '|' to center messages

` 1020 hex 120000 decimal 29 or kdm_init        ` Initialize the pendant
` 1 kdm_banner
1 ivar BOOTING?

` Suite 4 required macros.
ifmissing set_machine_fault : set_machine_fault == MACHINE_FAULT ;
ifmissing set_machine_state : set_machine_state drop ;
ifmissing clr_machine_state : clr_machine_state drop ;
ifmissing eth_endjob        : eth_endjob drop ;
ifmissing get_ethpause      0 ivar get_ethpause `  get_ethpause is used to send pause commands via Job Console.
ifmissing get_ethstate      : get_ethstate 0 ;
` machine state
` 2,1 plot init
` 4 means RUNNING JOB
` 16384 in key scan routine
` 32768 internal KDM GETKEY
: Suite_39? 8 eth_intf drop 2 < ;


word CopyLine word truncate

256 998 sysallocate ptr pMENU_STR    ` used to generate sub menu strings
256 998 sysallocate ptr pMENU_TEMP        ` used to generate sub menu strings
20 ivar MENU_LENGTH  ` limit to 20 characters, otherwise the menu may show up blank.
: menuFmake pMENU_STR s! pMENU_TEMP fformat pMENU_STR s+! pMENU_STR MENU_LENGTH truncate ;
: menuImake swap pMENU_STR s! pMENU_TEMP 1 iformat pMENU_STR s+! pMENU_STR MENU_LENGTH truncate ;
: menuONOFFmake swap pMENU_STR s! if 1282 getmsg else 1283 getmsg endif pMENU_STR s+! pMENU_STR MENU_LENGTH truncate ;

LANGUAGE_FILE file_size 0 > #ifdef LANGUAGE_FILE load #endif  ` Load the Language File if it exists.
` Menu Items
` \0236 = Up-Arrow, \0237 = Down-Arrow
 800 defmsg" Main Menu"
 840 defmsg" OK"                                       ` Button on some dialog boxes.
 841 defmsg" Attention"                                ` Title of some dialog boxes.
 
1000 defmsg" Cut Speed"          ` 20
1001 defmsg" Move X Y Axes"      ` 20
1002 defmsg" Jog X Y Axes"       ` 20
1003 defmsg" Clear Home"         ` 20
1004 defmsg" Display Job Time"   ` 20
1005 defmsg" Z Delta"            ` 20
1006 defmsg" Z Lift Height"      ` 20
1007 defmsg" Z Cut Depth/Delta"  ` 20
1008 defmsg" Z Axis Speed"       ` 20
1009 defmsg" Select Interface"   ` 20
1010 defmsg" Parking"            ` 20
1011 defmsg" Define Preset Home" ` 20
1012 defmsg" Load Preset Home"   ` 20
1013 defmsg" Purge Job"          ` 20
1014 defmsg" Run Self Test"      ` 20
1015 defmsg" Batching"           ` 20
1016 defmsg" Set Dwell Up"       ` 20
1017 defmsg" Set Dwell Down"     ` 20
1018 defmsg" Cyl Diameter"       ` 20
1019 defmsg" Spindle Speed"      ` 20
1020 defmsg" Spindle Speed"      ` 20  (same as 1019 except with Up-Arrow)
1021 defmsg" Pos After Datum"    ` 20
1022 defmsg" Pocket Milling"     ` 20
1023 defmsg" Configuration Menu" ` 20
1024 defmsg" Display Units"
1025 defmsg" Pos After Datum"    ` 20  (same as 1021 except with Up-Arrow)
1026 defmsg" Pocket Milling"     ` 20  (same as 1022 except with Down-Arrow)
1027 defmsg" X Limit "
1028 defmsg" Y Limit "
1029 defmsg" Z Limit "

1030 defmsg" Enter the Z Lift Height." ` Exact 20 (in Z Lift height menu)
1031 defmsg" Z-Axis Speed?"              ` Exact 20 (in Z axis Speed menu)
1032 defmsg" Home cleared."              ` Full (After Clear Home menu)
1033 defmsg" Cut Depth?"                 ` Exact 20 (in Z Cut Depth menu)
1034 defmsg" Depth Set."                 ` Full  (After Setting Z Cut Depth)
1035 defmsg" Depth Not Set."             ` Full  (After Cancelling from Setting Z Cut Depth)
1036 defmsg" Cut Speed?"                 ` Full (in Cut Speed Menu)
1037 defmsg" Enter the Spindle Speed?"   `      (in Spindle Speed menu)
1038 defmsg" MP Depth Increment?"        ` Exact 20
1039 defmsg"   Select Interface"         ` 20
1040 defmsg" Park at End of Job?"        ` 20 (in menu parking)
1041 defmsg" Pocket Milling Mode?"       ` 20 (in menu pocket milling)
1042 defmsg" Purge Replay Buffer?"       ` 20 (in menu Purge Replay)
1043 defmsg" Run Self-Test?"             ` 20
1044 defmsg" Enter the time it takes for the pneumatic spindle to fully retract out of the material." 
1045 defmsg" Enter the time it takes for the pneumatic spindle to achieve is full cutting depth."    
1046 defmsg" Enter the Batch Count."   
1047 defmsg" Batch Complete."            ` Full
1048 defmsg" <ENTER> or <CANCEL>"        ` 20 (in menu Move)

` Datumming
1050 defmsg" Finding X Datum..."         ` Full
1051 defmsg" Finding X Origin..."        ` Full
1052 defmsg" Finding Y Datum..."         ` Full
1053 defmsg" Finding Y Origin..."        ` Full
1054 defmsg" Finding Z Datum..."         ` Full
1055 defmsg" Finding Z Origin..."        ` Full
1056 defmsg" Datumming Canceled..."      ` Full

` VST Restart
1057 defmsg" VST Restart Here?\n\rPen = "     ` 30  (pen number will be appended to end of message)
1058 defmsg" Start, Cancel, Enter  or Jog then VST" ` Full
1059 defmsg" Location not found."              ` Full
1060 defmsg" Searching ...."                   ` Full  (When searching for point)
1061 defmsg" Cancel or Jog then VST/Start"     ` Full  (VST Start)

` Job Time
1062 defmsg" Current Job Time:"                ` 20 (Job time when paused)
1063 defmsg"  The Last Job Took:"              ` 20 (Job time)
1064 defmsg" A Really Long Time!"              ` 20 (When the Job time exceeds the 1000 hours)

` Cylindrical Switching
1065 defmsg" Switching To Flat X"              ` Full  (When switching to Flat X Mode)
1066 defmsg" Switching To Cyl X"               ` Full  (When switching to Cylindrical X Mode)
1067 defmsg" Not Allowed in Cylindrical Mode." ` Full (When trying to load/save home when in Cylindrical Mode)
1068 defmsg" Enter Cylinder Diameter"
1069 defmsg" Invalid Diameter Use"

` Misc.
1070 defmsg" Press START to Continue."         ` Full (Programmed Pause)
1071 defmsg" Please Insert Tool "              ` 18   (Manual Tool Change)
1072 defmsg" Surface Set."                     ` Full (After setting Surface)
1073 defmsg" Surface Not Set."                 ` Full (After cancelling from Setting Surface)
1074 defmsg" Lifting..."                       ` Full (After Setting Surface or Depth, when lifting)
1075 defmsg" Home Set."                        ` Full
1076 defmsg" Home Not Set."                    ` Full
1077 defmsg" Going Home...."                   ` Full
1078 defmsg" Spindle Speed: "                  ` Exact 15
1079 defmsg" Machine Requires Datumming"       ` Full
1080 defmsg" Please Wait...  "                 ` 20   (When booting, keypad message)
1081 defmsg" Please Set Home."                 ` Full
1082 defmsg" Spindle Off."                     ` Full
1083 defmsg" Spindle On."                      ` Full
1084 defmsg" Auxiliary 1 On."                  ` Full
1085 defmsg" Auxiliary 1 Off."                 ` Full
1086 defmsg" Auxiliary 2 On."                  ` Full
1087 defmsg" Auxiliary 2 Off."                 ` Full
1088 defmsg" Turning Drives On."               ` Full
1089 defmsg" Press START to run job."         ` FULL
1090 defmsg" Press START to Go;  Cancel to Abort." ` Full (At start of Job)
1091 defmsg" Press START ["                    ` Exact 13 (in Batch mode, Batch number is between [] and is 3 digits
1092 defmsg" ] or  Cancel to Abort."           ` Continued from message 1091

1093 defmsg" Positions not saved"              ` Full (when finding home)
1094 defmsg" Datum Now?"                       ` 20
1095 defmsg" Auxiliaries\n\rRestored"
1096 defmsg" Solenoid Test\n\rPress Aux1/Aux2"
1097 defmsg" Reps:"                             ` 5
1098 defmsg" Preset"
1099 defmsg" Home "

` Job Server DNC Messages
1100 defmsg" Host Not Responding!"             ` Full
1101 defmsg" Connecting to Host.."             ` Full
1102 defmsg" Job: "                             ` short, leave room for file name
1103 defmsg" Option not allowed  during Pause Mode" ` Full
1104 defmsg"  mins  "                           ` 5
1105 defmsg"  secs"                             ` 4
1106 defmsg" Loading..."                       ` Full (when starting Job Server)
1107 defmsg" Set"                       ` for use with the next lines, set surface or home
1108 defmsg" Surface"
1109 defmsg" Home "
1110 defmsg" Enter"                      ` 10 used only with the next line
1111 defmsg" to Save"                   ` 10 used with previous line
1112 defmsg" Pause Code Detected  ENTER To Continue"  ` full
1113 defmsg" CANCEL To Return"
1114 defmsg" Password: "
1116 defmsg" Enabled"
1117 defmsg" Disabled"
1118 defmsg" Enabled"
1119 defmsg" Disabled"
1120 defmsg" Enabled"
1121 defmsg" Disabled"
1122 defmsg" Enabled"
1123 defmsg" Disabled"
1124 defmsg" DNC Restart for VST"
1125 defmsg" Digitize"              ` 20 Digitize menu item

` local DNC messages
1140 defmsg" Loading Local DNC"      ` 20    Displayed when starting local DNC mode.
1141 defmsg" No Local Files"         ` 20
1142 defmsg" Saving...           "   ` 20    when saving Local DNC file.
1143 defmsg" Error Writing File, out of room."      ` Full
1144 defmsg" End of Job not FoundFile not saved."   ` Full
1145 defmsg" Could not open Temp file.  Try again." ` Full
1146 defmsg" Too Many Files,     delete one first." ` Full
1147 defmsg" Delete Job?"            ` 20
1148 defmsg" Select DNC Mode"        ` 20
1149 defmsg" < Load Job from PC >"
1150 defmsg" DNC_Mode"               ` 10 utility toggle local/remote DNC

` Ethernet Submenus
1212 defmsg" Ethernet Settings"
1213 defmsg" Ethernet Settings"   ` 20  (same as 1212 except with Up-Arrow)
1214 defmsg" Specify IP"
1215 defmsg" Display IP"
1216 defmsg" Display Host"
1217 defmsg" Ethernet Status"  	 ` 20 (end of line)
1218 defmsg" Ethernet Info"      ` Title of dialog box
1219 defmsg" Activate DHCP"
1220 defmsg" Change"             ` Button Text for Changing IP
1221 defmsg" Cancel"             ` Button Text for Canceling the Specify IP.

1250 defmsg" Drive Temperature"                      ` 20 (Motor Drive Temperature MENU for RPC)
1251 defmsg" Paused...           Drives Overtemp."   ` 20 (Pausd because Motor Drives Over temp)
1252 defmsg" Cooling down to"                        ` 20 Drives overtemp cooling down to.

` More Misc
1253 defmsg" Cut Speed "
1254 defmsg" Global"
1255 defmsg" Individual"
1256 defmsg" Left Spindle : "
1257 defmsg" Right Spindle: "
1258 defmsg" Both Spindles: "

` Dynamic Homes
1260 defmsg" Dynamic Home"  ` 20 Dynamic Home menu
1261 defmsg" Select Corners"
1262 defmsg" First"
1263 defmsg" Second"
1264 defmsg" Corner"
1265 defmsg" Top Left"
1266 defmsg" Top Right"
1267 defmsg" Bottom Left"
1268 defmsg" Bottom Right"
1269 defmsg" Center"

1271 defmsg" Depth:"     ` Multi-Pass Jobs, current depth.
1272 defmsg" Left:"      ` Multi-Pass Jobs, Passes Remaining
1273 defmsg" Passes:"    ` Multi-Pass Jobs, Passes

1275 defmsg" YES"                    ` 3     Various Places. (same length as NO)
1276 defmsg" NO "                    ` 3     Various Places. (same length as YES)
1277 defmsg" msec"                   ` Millisecond designation.
1278 defmsg" in."                    ` inches        
1279 defmsg" mm"                     ` metric

1280 defmsg" Display Colors"
1281 defmsg" Select Color Scheme"
1282 defmsg" ON "
1283 defmsg" OFF"

1285 defmsg" Move To"           ` Move X Y axes dialog
1286 defmsg" Curr Pos"          ` Move X Y Axes dialog

1287 defmsg" Limits Config"     ` Configuration Limits Config

1290 defmsg8" Not allowed during motion"

1300 defmsg8" Cut\nSpeed"       ` Cut Speed Display on KDM8g
1301 defmsg8" Z Cut\nDepth"     ` Z Cut Depth Display on KDM8g
1302 defmsg8" Z Lift\nHeight"   ` Z Lift Height Display on KDM8g
1303 defmsg8" Z Cut\nDelta"
1304 defmsg8" Jog Spindle to Surface and press Digitize key."
1305 defmsg8" Executing..."   ` Executing Job
1306 defmsg8" Complete..."    ` Job complete, end_plot
1307 defmsg8" OK"             ` OK Button
1308 defmsg8" Cancel"         ` Cancel Button
1309 defmsg8" Move"           ` Move Button
1310 defmsg8" Jog to set position after datum, press Enter to save."
1311 defmsg8"  \nRPM"             ` RPM Display on KDM8g

` Dynamic Home Select Corners
1312 defmsg8" Jog to Second Corner, press Enter." ` Dynamic Home, setting up second corner.
1313 defmsg8" Jog to First Corner, press Enter."  ` Dynamic Home, setting up first corner.

` Parking 
1315 defmsg8" Go Home"   
1316 defmsg8" Park at edge of plot"
1317 defmsg8" Do not park"


` Dispense Mode
1320 defmsg8" Dispense Mode:"  ` Dispense mode menu
1321 defmsg8" On Time      :"  ` Dispense mode On Time
1322 defmsg8" Enter Dispense ON time"
1323 defmsg8" Off Time     :"  ` Dispense mode Off Time
1324 defmsg8" Enter Dispense OFF time"

` Pre set Homes
1330 defmsg8" Select Preset Home # to define"
1331 defmsg8" Jog to location, press Set Home."
1332 defmsg8" Select Preset Home # to load, press Set Home"

1508 defmsg" IP already in use.  Choose different IP " ` FULL  Duplicate IP detected when changing IP.
1509 defmsg" Invalid IP.         Choose different IP " ` FULL  Invalid IP Entered when changing IP.
1510 defmsg" Invalid Subnet Mask. The Subnet Mask has to be contiguous." 

` Error messages
1901 defmsg" System Interrupt:"                                  ` 20
1902 defmsg" Power Fail."                                        ` 40  (terminal only)
1903 defmsg" Out of bounds\n\rAxis:"                             ` Full
1904 defmsg" Framing Error"                                      ` Full
1905 defmsg" Host Overflow"                                      ` Full
1906 defmsg" Limit System Short Circuit Detect"                  ` Full
1907 defmsg" Drive System Short Circuit On XY"                   ` Full
1908 defmsg" Drive System Short Circuit On ZQ"                   ` Full
1909 defmsg" Missing or Loose Motor Cable"                       ` Full
1910 defmsg" Pull Out E-Stop"                                    ` Full
1911 defmsg" Drives Not Enabled!"                                ` Full
1912 defmsg" Machine Not Datummed!"                              ` Full
1913 defmsg" Limit Still Active."                                ` Full
1914 defmsg" \n Overtravel Detect"                               ` Full (in limit_detect)
1915 defmsg" ERROR:              INVALID FIRMWARE"
1916 defmsg" No Replay File Available."                          ` full
1917 defmsg"  Error "                           ` 6, end of line
1918 defmsg" occurred in  Job!"                                 ` 20
1919 defmsg" Cyl Mode Canceled  "                               ` 20
1920 defmsg" Job Purged."                                       ` 20
1921 defmsg" DUPLICATE CONT IP!  "                          ` 20
1922 defmsg" CONFLICT w/ EXTERNAL IP"                       ` 20
1923 defmsg" No cylindrical option available."              ` Full

1926 defmsg" Limit System Short Circuit Detect"                  ` Full
1927 defmsg" Drive System Slave Short Circuit On XY"             ` Full
1928 defmsg" Drive System Slave  Short Circuit On ZQ"            ` Full
1929 defmsg" Missing or Loose    Motor Cable on Slave"           ` Full
1930 defmsg" Pull Out E-Stop     on Slave"                       ` Full



1949 defmsg" \n\007Defaulting Parameter "
` 1950 - 1999 used for Digitize


` used to execute macros that are defined in modules.  It will only execute the macro if it exists.
` <string (macro name)> macro_exec
: macro_exec PATH> find if exec endif ;
: macro_exec_chk PATH> find if exec 0 else 1 endif ;    ` if executed, return 0 else return 1 for not executed.

/* ******** FIRMWARE CHECK ************ */
: firmware_check2
  ` call base implementation to verify internal checksum (if it exists)....
  ifexists firmware_check 0 firmware_check
  ifmissing firmware_check 0
  if "" Bad Flash Checksum" write_err endif
  
  mcif_rev_level pFIRMWARE_REQUIRED scomp 0 > if
    "" \n\007ERROR: Firmware Upgrade Needed" write_err
    "" \nVersion Installed: " write_err mcif_rev_level write_err
    "" \nVersion Required : " write_err pFIRMWARE_REQUIRED write_err write_err_nl
    1915 getmsg kdm_dsp_line error2_blink ` invalid firmware
  endif ;
firmware_check2

0 ivar KBOARD?
0 ivar RPC?
0 ivar DBOARD
: get_board
    board_info? 2drop 2drop
    dup 5 =  == KBOARD?
    9 > == RPC?
    162 port_input? == DBOARD
    ;

get_board

` General utility functions
: msd millisecond_delay ;
: second 1000 * msd ;
: second_kdm 500 * get_rtc_clk +
	loop dup get_rtc_clk < KDMDVC> w@ rdchk or until
	repeat drop ;
: load_params dup load_axis_params load_jog_params ;
: dsp_serial get_serial dup 65535 = if drop " UNSET" else . endif ;
: s nl " istk: " stk nl " fstk: " fstk ;
: kdm_cursor -999 kdm_set_pos ;
: msd_kdm
    KDMDVC> w@ 19 0 ioctl drop  ` clear buffer first.
    2 / get_rtc_clk +
    loop dup get_rtc_clk < KDMDVC> w@ rdchk or until
    repeat drop ;


` System control flash parameters
` other default values
-12800.0  1 ddgf   ` X axis resolution
 12800.0  2 ddgf   ` Y axis resolution
-12800.0  3 ddgf   ` Z axis resolution
   -15.0  5 ddgf   ` X negative stroke
   -13.7  6 ddgf   ` Y negative stroke
   -1.00  7 ddgf   ` Z negative stroke
   15.00  9 ddgf   ` X table size
   13.70 10 ddgf   ` Y table size
    1.00 11 ddgf   ` Z stroke
    0.00 13 ddgf   ` X limit offset
    0.40 14 ddgf   ` Y limit offset
   -0.05 15 ddgf   ` Z limit offset

  0.001 22 ddgf    ` set_res
   2    24 dgi  ivar CYCLE_MODE      ` 1 = Machine+pendant; 2 = Pendant only; 3 = Automatic
   0.25 25 ddgf   ` vertex angle
   
   7    27 dgi  ==   LIMIT_MASK      ` 0 when no limits
   3            ivar NUM_AXES        ` always 3 for LMCI

  16    30 dgi  ivar SPINDLE_CODE
   0.01 31 dgf  fvar Z_DEPTH         ` cut depth
   0    32 dgi  ivar AUX1_CODE
   0    33 dgi  ivar AUX2_CODE
 257    34 ddgi     ` AUX1_MODE and AUX2_MODE (default to AUX1_MODE=1[job] and AUX2_MODE=1[job])   

   0    35 dgi  ivar AUX_DOWN_DELAY
   0    36 dgi  ivar AUX_UP_DELAY
   2.0  37 dgf  fvar XYDN_FEED       ` cut speed  (Cut speed for Spindle 1, Spindle 1, Both are set at 140, 141, 142)
   0.25 38 dgf  fvar ZDN_FEED        ` Z plunge speed
   2.00 39 dgf  fvar ZUP_FEED        ` Z lift speed
   0.10 40 dgf  fvar Z_LIFT          ` Z lift position
   1.0  41 dgf  fvar TIMESCALE       ` 1. for seconds, 60. for minutes
  15.0  42 dgf  fvar XYDN_ACCEL      ` cut acceleration
1000.0  43 ddgf     ` HPGL XY Scale
1000.0  44 ddgf     ` HPGL Z Scale
  -1.0  45 ddgf     ` hi_speed
   0.1  46 ddgf     ` lo_speed
  -0.5  47 ddgf     ` hi_speed Z
   1    48 dgi  ivar ?PARK           ` 1 to enable, 0 to disable, 2 = go home
30000   49 ddgi     ` max spindle speed
 2000   50 dgi  ivar SPINDLE_DELAY
    0   51 dgi  ivar PEN_DOWN_DELAY
    0   52 dgi  ivar PEN_UP_DELAY

0    55 dgi ivar CONFIG_BITS     ` set for normally closed limit switches
 1  1 ' CONFIG_BITS bvar ?MANUAL_TOOL        ` 1
 2  2 ' CONFIG_BITS bvar ?NC_LIMITS          ` 2
 3  3 ' CONFIG_BITS bvar ?PRESERVE_HOME      ` 4
 4  4 ' CONFIG_BITS bvar ?PNEUM_Z1           ` 8
 5  5 ' CONFIG_BITS bvar ?PNEUM_Z2            ` 0x00010 16
 6  6 ' CONFIG_BITS bvar ?CONTROLLED_Z        ` 0x00020 32
 7  7 ' CONFIG_BITS bvar ?INDEXING            ` 0x00040 64    4th axis is indexing (X Y Z - in Flat, - Y Z XC in cylindrical)
 8  8 ' CONFIG_BITS bvar ?FOLLOW_X            ` 0x00080 128   have Z follow X (X Y X - in Flat, - Y X XC in cylindrical)
 9  9 ' CONFIG_BITS bvar ?FOLLOW_Y            ` 0x00100 256   have Z follow Y (X Y Y - in Flat, - Y Y XC in cylindrical)
10 10 ' CONFIG_BITS bvar ?SOL1_LINK           ` 0x00200 512   is solenoid 1 linked to cylindrical mode.
11 11 ' CONFIG_BITS bvar ?USE_FEEDRATE        ` 0x00400 1024  flag to use VS as SF
12 12 ' CONFIG_BITS bvar ?BACK_TALK           ` 0x00800 2048  If True Then don't turn on batch in uCito jobs
13 13 ' CONFIG_BITS bvar ?CYL_TRANS           ` 0x01000 4096  If true then switching to Cyl asks for Diameter and uses it.
14 14 ' CONFIG_BITS bvar ?HOME_Y_FRST         ` 0x02000 8192  If true then home Y axis first.
15 15 ' CONFIG_BITS bvar ?SHOW_SPINDLE        ` 0x04000 16384 If true then show spindle speed menu
16 16 ' CONFIG_BITS bvar ?DATUM               ` 0x08000 32768 If true then find_limts before running job.
17 17 ' CONFIG_BITS bvar ?PRG_AUX_CTRL        ` 0x10000 65536 If true then spindle_on is not called in start_plot
18 18 ' CONFIG_BITS bvar ?DISPENSE_ENABLE     ` 0x20000       If true then spindle_on is not called in start_plot
19 19 ' CONFIG_BITS bvar ?IGNORE_SD           ` 0x40000       Ignore HPGL SD command in job file.
20 20 ' CONFIG_BITS bvar ?IGNORE_SF           ` 0x80000       Ignore HPGL SF command in job file.
21 21 ' CONFIG_BITS bvar ?INDIVIDUAL_CUTSPEED ` 0x100000      set=individual cut speed.
 
 
 ` 0    57 dgi ivar UNITS               ` 0 for english, 1 for metric (MOVED TO TOP OF FILE)
10.0 58 dgf fvar CYL_VMAX               ` Max velocity used when in X Cyl mode
     3 60 ddgi                          ` self test mode.
     0 67 ddgi                          ` reverse delay for reverse fraction (509,519...) in milliseconds
  0.10 68 ddgf                          ` restart tolerance
  0.00 80 ddgf                          ` second spindle X offset
  0.00 81 ddgf                          ` second spindle Y offset
  0.01 61 dgf  fvar ALLOWED_ERROR       ` test_origin error allowance
  1    63 dgi  ivar ?FEEDOVER           ` 1 to enable, 0 to disable
  0    62 dgi  ivar START_MASK
  1    69 dgi  ivar BOOT_MODE           ` 0 = ucito, 1 = hpgl, 2 = cnc
 15    70 dgi  ivar DRIVE_ENABLE_MASK   ` bitmask of what drives to enable (default to X and Y only)
  0    82 dgi  ivar DIGITIZE_INPUT      ` v3.61 Lim 6 = 32, if 0, digitize menu will not show up.
  
  0    96 dgi  ivar DISPLAY_UNITS   ` 0 = inches, 1 = metric.

` 0    98 dgi ivar SLAVE_M54?     ` Is there a second M54 connected.
0 99 dgi ivar DISPLAY_OPTIONS                ` Display Options 1= Time, 2=Z Delta, 4
1 1 ' DISPLAY_OPTIONS bvar DISPLAY_TIME?     `    1 powerup to zero, do we display time when running a job. (1=yes, 0=no)
2 2 ' DISPLAY_OPTIONS bvar DISPLAY_DELTA?    `    2 Do we display Z Delta if Multipass is turned on during a job
3 3 ' DISPLAY_OPTIONS bvar DISPLAY_CUTSPEED? `    4 Do we display Cut Speed on main screen.
4 4 ' DISPLAY_OPTIONS bvar DISPLAY_ZDEPTH?   `    8 Do we display Cut Depth on main screen
5 5 ' DISPLAY_OPTIONS bvar DISPLAY_ZLIFT?    `   16 Do we display Lift Height on main screen
6 6 ' DISPLAY_OPTIONS bvar DISPLAY_RPM?      `   32 Do we display Spindle RPM
7 7 ' DISPLAY_OPTIONS bvar DISPLAY_FRO?      `   64 Do we display Feedrate override.
8 8 ' DISPLAY_OPTIONS bvar DISPLAY_PREVIEW?  `  128 Do we display the preview of the job.

0 == DISPLAY_TIME?   ` Don't display until we are ready. 
0 == DISPLAY_DELTA?  ` Don't display until we are ready.

   0 ivar PREV_JOB_TIME
-1.0 fvar PREV_Z_DEPTH_PASS
  -1 ivar PREV_MP_PASSES
  
DISPLAY_PREVIEW? ivar SHOW_PREVIEW_JOB
0 ivar HAVE_SAVE_REGION?
        
300   100 dgi  ivar SWITCH_X_DELAY  ` delay to be used when switching X using HPGL port 120
    0 104 dgi  ivar INVERT_Z?       ` invert Z axis for CNC jobs.
    0 105 dgi  ivar BUMP_CONNECTION
    0 106 dgi  ivar PARK_MODE_CYL   ` at end of job, switch to XY, park, then at start of job, switch to cyl.
  0.0 107 ddgf     ` XPark Location
  0.0 108 ddgf     ` YPark Location
  
    ` 110 - 129 preset homes
    ` 130 - Cycl X soft home
    ` 131 - Cycl Y soft home

 XYDN_FEED 140 ddgf ` Spindle 1 speed
 XYDN_FEED 141 ddgf ` Spindle 2 speed
 XYDN_FEED 142 ddgf ` Spindle Both speed
 
   4.00 170 ddgf     ` Default Cylindrical Diameter for Cylindrical Mode Translation
"" in." 200 dgs drop ` Units string
   0    202 ddgi     ` Disable Local Replay (0=replay available, b1=Disable Local Replay, b2=Disable DNC Replay)
   0    207 dgi ivar LocalDNC?         ` 0=Normal Remote JobServer, 1=Local DNC mode?,  2 is Elab replay mode
   0.0  215 ddgf     ` X Digitize Scanner Offset
   0.0  216 ddgf     ` Y Digitize Scanner Offset


 12800.    fvar CYL_SCALE  ` V2.91 hardwire scale for now

` If not a controlled Z machine, do not allow them to display the Cut Depth or Lift Height
?CONTROLLED_Z not #ifdef
    0 == DISPLAY_ZDEPTH?
    0 == DISPLAY_ZLIFT?
#endif


101 ivar PORT1
  0 ivar PORT2
124 ivar PWMREG1
125 ivar PWMREG2
123 ivar PWMREG3
` see below for variable updates

0 ivar PWM1VAL
0 ivar PWM2VAL
0 ivar PWM3VAL

` ?SOL1_LINK can only be used if ControlledZ is set, then delete this macro as it should not be used again....
: clear_sol_link
    ?SOL1_LINK if ?CONTROLLED_Z not if
       CONFIG_BITS 512 - 55 set_integer   false == ?SOL1_LINK
       "" \nParameter 'Link Solenoid 1 to Cyl' Disabled,\nBecause CONTROLLED_Z Parameter Not Set!\n " write_err
       endif 
    endif ;
clear_sol_link             ` call the cleanup routine above
remove clear_sol_link      ` remove the macro so the space isn't wasted

  0 ivar DNC_AUTORUN     ` V3.43 for VST in remote DNC
  1 ivar ?AUTO_SPINDLE


 
 
` default rate parameters

	0 401 ddgi     ` password
 0.10 500 ddgf     ` X Min Vel
 4.00 501 ddgf     ` X Max Vel
50.00 502 ddgf     ` X accel
 1.00 503 ddgf     ` X vertex accel
 2.00 505 ddgf     ` X Jog Max Vel
30.00 506 ddgf     ` X Jog Max Accel
 0.10 507 ddgf     ` X Jog Min Vel
134184961 508 ddgi ` joystick (not used)
 0.60 509 ddgf     ` X Reverse Fraction

 0.10 510 ddgf     ` Y Min Vel
 4.00 511 ddgf     ` Y Max Vel
60.00 512 ddgf     ` Y accel
 1.00 513 ddgf     ` Y vertex accel
 2.00 515 ddgf     ` Y Jog Max Vel
30.00 516 ddgf     ` Y Jog Max Accel
 0.10 517 ddgf     ` Y Jog Min Vel
134184961 518 ddgi ` joystick (not used)
 0.6 519 ddgf     ` Y Reverse Fraction

 0.10 520 ddgf     ` Z Min Vel
 1.00 521 ddgf     ` Z Max Vel
20.00 522 ddgf     ` Z accel
30.00 523 ddgf     ` Z vertex accel
 1.00 525 ddgf     ` Z Jog Max Vel
 2.00 526 ddgf     ` Z Jog Max Accel
 0.10 527 ddgf     ` Z Jog Min Vel
134184961 528 ddgi ` joystick (not used)
 1.00 529 ddgf     ` Z Reverse Fraction
0 1399 dgi ivar etcx

` Axis control flash parameters
501 gf fvar XYUP_FEED       ` slew speed
XYDN_ACCEL 0.8 f* fvar XYDN3_ACCEL

128 ivar RUSH_CURRENT       ` 255 scale = 2.35 amps
32  ivar MAINTAIN_CURRENT    ` 32 = 300mA
18 ivar SOL1_CODE
20 ivar SOL2_CODE

` Device control variables
0   ivar SPINDLE_ON?    ` spindle start
0   ivar CYL_MODE?      ` are we in Cylindrical mode
4   ivar ESTOP_BIT      ` estop (halt) line
48  ivar DEVICE1_PMASK  ` port 1: iso's and aux's
23  ivar DEVICE2_PMASK  ` port 2: iso's and aux's
0   ivar DEVICE1_PBITS  ` used during pausing
0   ivar DEVICE2_PBITS  ` used during pausing
48  ivar DEVICE1_ALLOFF ` all stuff off
63  ivar DEVICE2_ALLOFF ` all stuff off

1000 ivar iSPINDLE_SPEED
 0   ivar SPINDLE_SCALE
 0   ivar SPINDLE_DIR
250. fvar VOLTAGE_SCALE	` for spindle speed

` Axis control variables
0.0 fvar X_HOME         ` user soft home location
0.0 fvar Y_HOME
0.0 fvar X_SAVE         ` for multipass, pd location
0.0 fvar Y_SAVE
0.0 fvar VPXHome        ` Temp X soft home postion (for use with virtual port #1000)
0.0 fvar VPYHome        ` Temp Y soft home postion (for use with virtual port #1000)
0.0 fvar VPZHome        ` Temp Z soft home postion (for use with virtual port #1000)
0.0 fvar X_TOOL_OFFSET
0.0 fvar Y_TOOL_OFFSET

` Dual soft_home support
0.0 fvar X_HOME_FLAT
0.0 fvar X_HOME_CYL
0.0 fvar Y_HOME_FLAT
0.0 fvar Y_HOME_CYL

0   ivar X_FLAT_POS   ` position of X before switching to cylindrical
0   ivar X_CYL_POS    ` position of X before switching to Flat

` Job time variables
0   ivar START_TIME
0   ivar END_TIME
0.0 fvar JOB_TIME        ` job time in minutes
0   ivar LAPSE_TIME      ` used to save how much time lapsed during pause, etc.
-1  ivar REPS            ` how many times the job has ran.  if -1, then do not show reps.
0   ivar AFTERJOB_TIME   ` counter used to display time after a job has completed.
50  ivar iRTC_TIME       ` set_rtc_time update in msec.
0.0 fvar RTC_TIME        ` time in seconds
0   ivar RTC_SECOND_TIMER  ` Check once a second.
0   ivar RTC_SECOND_DELAY  ` how many clicks
-1  ivar JOB_TOOL_NUMBER   ` 1=Left, 2=Right, 3=Both
-1  ivar JOB_HOME_NUMBER

3000 ivar DNC_TIMEOUT     ` time in clicks for DNC Timeout.

` Miscellaneous variables
-1  ivar PEN#             ` Logical Pen number
-1  ivar USE_PEN          ` Physical Pen numer
-1  ivar PEN_OVERRIDE     ` override pen number for JSS
0   ivar PEN_ACTIVE?
0   ivar ?PENDLY
  0 ivar xlang      ` keep track of Job source language from xlate.
  0 ivar AUTORUN?   ` are we in auto run mode looking for CYCLE_START input.
  0 ivar JOBBASIS?    ` where did this job come from 0 = sent, 1=replay, 2=dnc or ldcn
  0 ivar SpecialMenus?  ` These are menus that use menu_add instead of submenu_add and need to be reset in menu_exit.
  
` Batch Operation variables  
  0 ivar BATCHRUN?  ` are we in batch run mode (rtc_proc flag).
  0 ivar #BATCH_NUM

` Job Boundaries
  0.0 fvar BOUND_MIN_X  ` Job Boundaries (set from Job Console)
  0.0 fvar BOUND_MAX_X
  0.0 fvar BOUND_MIN_Y
  0.0 fvar BOUND_MAX_Y
  0.0 fvar BOUND_MIN_Z
  0.0 fvar BOUND_MAX_Z
  

` Dynamic Home
  0.0 fvar DYNAM_HOME_X1
  0.0 fvar DYNAM_HOME_Y1
  9 gf fvar DYNAM_HOME_X2
 10 gf fvar DYNAM_HOME_Y2
  

/* DNC Stuff */
false ivar DNCJOB_AVAILABLE? ` was at least one job ran through DNC since we rebooted.
false ivar bDNCActive       ` is DNC currently active on the host?
false ivar DNC_JOB?         ` was this job sent from DNC?
0   ivar iDNCHaltCode     ` the halt code to be returned to DNC from end plot (pause, estop, normal, etc)
false ivar in_dnc?
false ivar in_ldnc?
0     ivar iBANNER_FUNC   ` 0=normal, 1=pause, 2=executing, 3=, 4=Pause, Drive overtemp
true ivar FIRST_DATUM
0 ivar ESTOP?             ` did the master ESTOP?
0 ivar SHRT_BITS          ` IN ESTOP this is used to grab drive short error status before the moff clears it
0 ivar IN_RESTART_HERE    ` USED to tell if pause was pressed while waiting for 'VST Restart Here?' question
0 ivar SSTOP_CALLED       ` used by check_for_faults to determine if a software estop or a hardware estop ocurred
0 ivar NO_CLR_RPL
0 ivar POCKET_MILLING?
0 ivar PD_OCCURED?
true ivar SLEW_MODE?
0 ivar PAUSE_CANCEL_ONLY?  ` tell pause_detect to just cancel and get out. Used for menu items that move.
0 ivar IN_CYCLE_START?

0   ivar STATUSBITS
1 1 ' STATUSBITS bvar ?DRIVE_ON
2 2 ' STATUSBITS bvar ?HOMESET          ` SoftHomeSet for Flat X
3 3 ' STATUSBITS bvar ?DATUMMED
4 4 ' STATUSBITS bvar ?HOMESET_CYL      ` SoftHomeSet for Cylindrical X

0   ivar idle_menu
0.  fvar Z_SURFACE
0.  fvar Z_PAUSE_DIST
0   ivar #PF_ERRS
0   ivar ?SPINDLE_POWERUP
ifmissing ANSWER? false ivar ANSWER?
0   ivar OPERATE_MODE            ` (0=normal,1=set surface,2=VST,3=set home)
0   ivar ?JOG_Z
0   ivar SELECT_KEY
1.  fvar VS_PERCENT              ` Percentage of cut speed set by VS in set_up_feedrate
0   ivar iIStackDepth            ` depth of integer stack at job start
0   ivar iFStackDepth            ` depth of floating point stack at job start

0 ivar LOADING_LDNC?
0 ivar SaveLDNC


` Menu Variables
0 ivar CONFIG_MENU#
0 ivar DYNAMIC_HOME_MENU#   



` Prox Restart
-1 ivar ToolProx                 ` Tool number when Prox restarting.
-1 ivar SheetProx                ` Sheet number when Prox restarting.
 0 ivar InProxHeader             ` Are we executing the Prox Restart header?

` MultiPass variables, per contour
0  ivar MP_BUFFPTR               ` Pointer to starting pos in motion buffer
0  ivar MP_PASSES                ` Number of MP_BITESIZE passes needed to reach depth
0. fvar MP_BITESIZE              ` Largest Z plunge to make per pass

` MultiPass variables, per Job.
0. fvar MPJ_BITESIZE             ` Largest Z plunge to make per pass
0  ivar MPJ_PASSES               ` Number of MPJ_BITESIZE passes needed to reach depth.
0  ivar MPJ_RUN?                 ` are we in Multi-Pass Job mode (rtc_proc flag).
0. fvar MPJ_Z_DEPTH              ` current Z depth for this pass
0  ivar MP_TOTAL_PASSES          ` total number of passes for MP_PASSES and MPJ_PASSES

Z_DEPTH fvar Z_DEPTH_PASS

` Testing Solenoids
0 ivar TEST_SOLS

false ivar bUCito3D              ` in 3D mode for uCito interpreter - JSS sends ucito_2d so this needs to be here.

` Homing variables
46 gf fvar Lo_speed
45 gf fvar Hi_speed
47 gf fvar Hi_speedZ
1 ivar LOWX 2 ivar LOWY 4 ivar LOWZ 8 ivar LOWXC
etcx 1 and #ifdef 2 == LOWX 1 == LOWY #endif
LOWX ivar switch_x_mask

0 set_warning
: warm_boot
    ` Newing-Hall just wants it to reboot after changing parameters using machine parameters.
    COLD  
    [ 0 ] #ifdef
    27 gi == LIMIT_MASK      ` 0 when no limits
    24 gi == CYCLE_MODE      ` 1 = Machine+pendant; 2 = Pendant only; 3 = Automatic
    30 gi == SPINDLE_CODE
    31 gf == Z_DEPTH         ` cut depth
    32 gi == AUX1_CODE
    33 gi == AUX2_CODE
    35 gi == AUX_DOWN_DELAY
    36 gi == AUX_UP_DELAY
    37 gf == XYDN_FEED       ` cut speed
    38 gf == ZDN_FEED        ` Z plunge speed
    39 gf == ZUP_FEED        ` Z lift speed
    40 gf == Z_LIFT          ` Z lift position
    41 gf == TIMESCALE       ` 1. for seconds, 60. for minutes
    42 gf == XYDN_ACCEL      ` cut acceleration
    48 gi == ?PARK           ` 1 to enable, 0 to disable, 2 = go home
    50 gi == SPINDLE_DELAY
    51 gi == PEN_DOWN_DELAY
    52 gi == PEN_UP_DELAY
    55 gi == CONFIG_BITS     ` set for normally closed limit switches
    57 gi == UNITS           ` 0 for english, 1 for metric
    58 gf == CYL_VMAX        ` Max velocity used when in X Cyl mode
    61 gf == ALLOWED_ERROR   ` test_origin error allowance
    62 gi == START_MASK
    63 gi == ?FEEDOVER       ` 1 to enable, 0 to disable
    69 gi == BOOT_MODE       ` 0 = ucito, 1 = hpgl, 2 = cnc
    70 gi == DRIVE_ENABLE_MASK ` bitmask of what drives to enable (default to X and Y only)
    82 gi == DIGITIZE_INPUT  ` v3.61 Lim 6 = 32, if 0, digitize menu will not show up.
    96 gi == DISPLAY_UNITS   ` 0 = inches, 1 = metric.
    ` 98 gi == SLAVE_M54?      ` Is there a second M54 connected.
    100 gi == SWITCH_X_DELAY  ` delay to be used when switching X using HPGL port 120
    105 gi == BUMP_CONNECTION
    106 gi == PARK_MODE_CYL    
    207 gi == LocalDNC?         ` 0=Normal Remote JobServer, 1=Local DNC mode?,  2 is Elab replay mode
    501 gf == XYUP_FEED       ` slew speed
    #endif
;
1 set_warning

RPC? #ifdef
15  == DEVICE1_PMASK  ` port 1: iso's and aux's
0   == DEVICE2_PMASK  ` port 2: iso's and aux's
15  == DEVICE1_ALLOFF ` all stuff off
#endif

80 101 sysallocate ptr JobName       ` string to display on pendant while job is running
80 101 sysallocate ptr TempJobName  
0 JobName !  ` init jobname

0 set_warning
: echo_on
    OUTDVC> w@            ` save device on stack
    4 OUTDVC> w! echo_on
    11 OUTDVC> w! echo_on
    /* stack */ OUTDVC> w!
;
: batch_off echo_on batch_off ;

: echo_off
    OUTDVC> w@            ` save device on stack
    4 OUTDVC> w! echo_off
    11 OUTDVC> w! echo_off
    /* stack */ OUTDVC> w!
;
: batch batch echo_off ;
1 set_warning

0 ivar alt_eth_mode
0 ivar is_serial?
: alt_ethernet
    :exit ` NOT USED ON RPC353
    is_serial? if :exit endif
    alt_eth_mode not if
        SYS_MSG? 2 and if "" \007Switch to Alt. Ethernet mode.\n" write_err endif
        1 == alt_eth_mode
        ifexists get_socket_info 1 3 0 get_socket_info         ` enable alt_eth
        -1 = if drop endif
        echo_on
    else
        SYS_MSG? 2 and if "" \007Already in Alt. Ethernet mode.\n" write_err endif
    endif
;
: norm_ethernet
    :exit ` NOT USED ON RPC353
    is_serial? if :exit endif
    alt_eth_mode if
        SYS_MSG? 2 and if  "" \007Switch to Normal Ethernet mode.\n" write_err endif
        0 == alt_eth_mode
        ifexists get_socket_info 0 3 0 get_socket_info         ` disable alt_eth
        -1 = if drop endif
        echo_on
    else
        SYS_MSG? 2 and if  "" \007Already in Normal Ethernet mode.\n" write_err endif
    endif
;
INDVC> ivar STUFFDVC>
: in INDVC> == STUFFDVC> ;
: err ERRDVC> == STUFFDVC> ;
: stuff_it
`    0 3 0 get_socket_info -1 = if drop endif ` out of mode
    ` STUFFDVC> w@ 23 rot ioctl drop
    11 23 rot ioctl drop 
`    alt_ethernet                  ` back in if enabled
;

/*  Variables to store elapsed tool time, time only involves moves through material */
0. fvar TOOL_TIME1
0. fvar TOOL_TIME2
` ---------------------------------------------------------------------------------------------------------------------
`               MACRO: upload_tool_time
`         DESCRIPTION: Display elapsed tool time value for each tool and reset - JSS calls after end of job detected
`     STACKS ON ENTRY: * Not Used *
`      STACKS ON EXIT: * Not Used *
` ---------------------------------------------------------------------------------------------------------------------
: upload_tool_time
    nl
    " #3 Defined Tools" nl
    " Tool #0," JOB_TIME 60.0 f* round ftoi . nl  ` send job time in seconds.
    " Tool #1," TOOL_TIME1 round ftoi . 0. == TOOL_TIME1 nl
    " Tool #2," TOOL_TIME2 round ftoi . 0. == TOOL_TIME2 nl
    " @" nl
;
: pen_time_update       ` used to increment the tool_time counters - it knows what pen you are using
/* Needs a floating point value on stack for time and only one time at a time */
        PEN# 1+ select                  ` figure out which pen to apply to (v2.97, add 1+ to pen#)
            => TOOL_TIME1 f+ == TOOL_TIME1                  ` add to tool 1
            => TOOL_TIME2 f+ == TOOL_TIME2                  ` add to tool 2
            default=> fdup TOOL_TIME1 f+ == TOOL_TIME1      ` add same value to both tools
                        TOOL_TIME2 f+ == TOOL_TIME2
        endselect
;

 120.0 fvar fKDMTimeOut       ` number of seconds to wait for input 
 120.0 fvar fKDMTimeOutValue  ` save current timeout value ( used in my_kdm_getkey )
 
 
false ivar JOGGING?
0 set_warning
: kdm_jog 1 == JOGGING? kdm_jog 0 == JOGGING? ;
1 set_warning


/* kdm20 G support stuff */

` SEMA MASK
`    2  =  RTC Proc
`    4  =  Knife Display (used when jogging knife via key func 1)
`    8  =  Pause Menu

` RESOURCE INFO
` RESOURCE 1  (0)splash screen, (1)Small logo, (2)Medium Logo
` RESOURCE 2 large english font
` RESOURCE 6 rounded buttons for menu's and icons

/* --- Handles (Firmware) --- */
`  200  = Menu Title
`  201+ = Menus
`  250  = Scroll Bar
`  251  = Scroll Bar Slider(1) (use 2 so it has a line in the middle)
`  252  = Scroll Bar Slider(2)
`  500  = DNC Title
`  500+ = DNC files
`  700  = Preview Job Title
`  710  = Preview Job Size
`  720  = Preview File Date (current not used)
`  730  = Search string
`  740  = "search starting with ->"

/* --- Handles (Init) --- */
`   32   = Shift Icon  (iShiftIcon)
` 1030   = Status bar
` 1040   = Warning Box
` 1050   = Material Library Window line 1 (also Group Number)
` 1051   = Material Library Window line 2
` 1052   = Material Library Window line 3
` 1053   = Material Library Window line 4
` 1058   = Pause Line 1
` 1059   = Pause Line 2

` 1060   = Dialog Box Title (also Group number)
` 1061-79= Dialog Line 1-8
` 1080   = Select Dialogs
` 1111   = Z1 LED
` 1112   = Z2 LED
` 1113   = Z3 LED

` 1707   = Network Icon (btNetwork)
` 3990-4100 = Tool Configuration display. (4000=Group ID of Tool Configuration)
` 5000   = PS3000 & Chuck Status
` 6000   = Manual Chuck display
` 10000+ = iSubmenus


0 ivar iTaskBar
0 ivar iShiftIcon
0 ivar ishift
0 ivar CUR_MENU

  6 ivar btNetworkResource  ` Resource File location
 21 ivar btNetworkIdx       ` index into resource file
 30 ivar btShiftIdx
292 ivar btNetworkXpos
216 ivar btNetworkYpos ` Move up so the search for DNC Files does not overwrite the icon.
ifmissing cBlack        0 ivar cBlack
ifmissing cDLG_Gray    80 ivar cDLG_Gray
ifmissing cDLG_Hilite 171 ivar cDLG_Hilite

5 ivar btShiftXpos
0 ivar btShiftYpos

1707 ivar btNetwork

KDM20G? KDM12G? or KDM8G? or ivar GRAPHICAL_KDM?

GRAPHICAL_KDM? #ifdef
ifmissing glcd "" \007Firmware does not support keypad type!" write_err 0 == GRAPHICAL_KDM? 20 == KEYPAD_TYPE ` change back to type 20.
#endif


` menu stuff------------------------------------------------------

GRAPHICAL_KDM? #ifdef

0 set_warning
1000 101 sysallocate ptr CLIST
0 ivar CLIST_CTRL
: check_clist ` <ctrl number> check_clist <0=found> 
    == CLIST_CTRL
    0 998 2 step CLIST I + w@ CLIST_CTRL = if 0 == CLIST_CTRL break endif endstep
    CLIST_CTRL if 0 998 2 step CLIST I + w@ 0 = if CLIST_CTRL CLIST I + w! break endif endstep endif 
    CLIST_CTRL
;
: remove_clist
    == CLIST_CTRL
    0 998 2 step CLIST I + w@ CLIST_CTRL = if CLIST I + w! break endif endstep
;
` : glcd_create_control  dup check_clist if glcd_create_control else " Dup Control number " dup . nl endif ;
` : glcd_destroy_control dup remove_clist glcd_destroy_control ;

: glcd_draw_control over 0 < over 0 < or if " Draw Out of Bounds: " 3 repl . sp. over . sp. dup . nl 2drop drop else glcd_draw_control endif ;
1 set_warning

"" \\" == BACKSLASH  ` replace backslash with proper one.
44     == FASTKEY    ` change from 22 to 44.

/* --- COLOR THEMES --- */
      0 1900 dgi 0 max 10 min == COLOR_SCHEME
    124 1901 dgi ivar cHILITE  ` Hi-lite color
    125 1902 dgi ivar cTITLES  ` color of titles  
    133 1903 dgi   == BGCOLOR  ` BackGround Color
    138 1904 dgi ivar cWINDOW_COLOR      
cYELLOW 1905 dgi   == cTEXT_COLOR
cYELLOW 1906 dgi ivar cBG_TEXT_COLOR  ` color for text displayed on background.

   22 ivar cLTGRAY  ` light grey color for border. (was 60)
   23 ivar cSHADOW  ` Shadow color. (was 23)
   

0 #ifdef /* -- Original Blue-Green colors -- */
                  ` <background> <border>  <surf>  <letters>
: HeaderMenuColors  cTRANSPARENT  BGCOLOR  BGCOLOR      cWHITE ; ` Menu Header
: ActiveMenuColors  BGCOLOR       cWHITE   140          cRED   ; ` Active
: NormalMenuColors  BGCOLOR       cWHITE   cBLUE        cWHITE ; ` Normal
: SBarColors        cTRANSPARENT  cWHITE   cBLUE    cWHITE ; ` Normal Scroll Bar color
: SBarSliderColors  cTRANSPARENT  cWHITE   140      cWHITE ;
#endif
: HeaderMenuColors  cTRANSPARENT  cLTGRAY  cTITLES      cBG_TEXT_COLOR ; ` Menu Header
: ActiveMenuColors  cTRANSPARENT  cLTGRAY  cHILITE      cBLACK ; ` Active
: NormalMenuColors  cTRANSPARENT  cLTGRAY  cWHITE       cBLACK ; ` normal
: SBarColors        cTRANSPARENT  cBLACK   cDLG_Gray    cBLACK ; ` Normal Scroll Bar color
: SBarSliderColors  cTRANSPARENT  cLTGRAY  cDLG_Hilite  cLTGray ;

: DisabledMenuColors          80  80       80           80     ; ` Disabled colors

: menu_title
    pMenuTitle
;

0 set_warning
` Replace menu config with static 8 lines menus.
: menu_config_firm menu_config ; ` so we can call the firmware version directly.
` Replace menu config with static 8 lines menus.
: menu_config ` <Rows> <Cols> <Start On> <Item Length> menu_config
    ` 2drop 2drop
    ` 8 1 2 20
    drop ` drop item length
    bury 2drop
    ` if paused, the menu would start on row 3, intercept and put on row 4.
    dup 3 = if 6 1 2 20 menu_config endif  ` Pause, leave bottom two rows free to display stuff.
    dup 2 = if 7 1 2 20 menu_config endif  ` Leave last line blank to display material.
    dup 1 = if 8 1 2 20 menu_config endif
    drop
;
1 set_warning

` end menu stuff-----------------------------------------------------

` 2000 General control used for many text displays.
2001 ivar TIME_BOX_CTRL
2002 ivar FRO_BOX_CTRL   ` FRO (currently not used)
2004 ivar FEED_BOX_CTRL  ` Cut Speed
2006 ivar ZDEPTH_CTRL    ` Z Cut Depth
2008 ivar ZLIFT_CTRL
2010 ivar ZDELTA_CTRL
2012 ivar PASSES_CTRL
2014 ivar RPM_BOX_CTRL
2016 ivar DEPTH_CTRL      ` current depth during multi-pass job.
2020 ivar XCOORD_CTRL
2021 ivar YCOORD_CTRL
2022 ivar ZCOORD_CTRL

2023 ivar SPINDLE_ID_CTRL
2024 ivar HOME_CTRL1
2025 ivar HOME_CTRL2 

` Event Queue ID
0 ivar FRO_RTC_ID    

0 ivar FRO_SHOWN? 
0 ivar FEED_SHOWN? 
0 ivar ZDEPTH_SHOWN?
0 ivar ZDELTA_SHOWN?
0 ivar ZLIFT_SHOWN?
0 ivar RPM_SHOWN?
0 ivar TIME_SHOWN?
0 ivar XYZ_SHOWN?
0 ivar PASSES_SHOWN?

8 ivar X_OPTION_LOC  ` X location to display cut/speed, z cut depth, etc
8 ivar CUTSPEED_X    ` X location of Cut Speed box
8 ivar ZDEPTH_X      ` X location of Z Depth
8 ivar ZLIFT_X       ` X location of Z Lift Height
8 ivar RPM_X         ` X location of Spindle RPM.
78 ivar ZDELTA_X     ` X location of Z Delta
8 ivar FRO_X         ` X location of FRO

` 	case 1: uf_eventqueue_list(); break;
`	case 2: uf_eventqueue_insert(); break; // <'func><mode 0=one-shot, 1=period><period.> 2 eventqueue <id>
`	case 3: uf_eventqueue_remove(); break; // <id> 3 eventqueue
`	case 4: uf_eventqueue_period(); break; // <id><period.> 4 eventqueue

` Called by firmware before Preview.
: blank_display
    BGCOLOR glcd_bg BGCOLOR glcd_fg 0 0 320 240 glcd_box  ` "" CL 0 100 glcd 0 swap 1 step drop endstep 
    0 == FRO_SHOWN?    FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID
    0 == FEED_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID  
    0 == ZDEPTH_SHOWN?
    0 == ZDELTA_SHOWN?
    0 == ZLIFT_SHOWN?
    0 == RPM_SHOWN?
    0 == TIME_SHOWN?
    0 == XYZ_SHOWN?
    0 == PASSES_SHOWN?
;

: small_font  0 1 glcd_set_font_chain ;
: normal_font 2 1 glcd_set_font_chain ;   ` This is the glcd_text Font.
: small_control_font   0 1 glcd_set_controls_font_chain ;  ` This is the Menu Font.
: normal_control_font  2 1 glcd_set_controls_font_chain ;  ` This is the Menu Font.

: kdm20g_pump
    ` The following will "pump" the keypad buffer so kdm_scankey will see if a key was pressed.
    0 glcd_sema drop
;

: key_shift
    bShifted if iShiftIcon cBLUE cBLUE 0x600 glcd_control_colors drop else iShiftIcon BGCOLOR 80 0x600 glcd_control_colors drop endif 
;
: make_shift_icon
    iShiftIcon if
        iShiftIcon btShiftXpos btShiftYpos glcd_draw_control drop
    else
        32 glcd_create_control
        0 btNetworkResource btShiftIdx glcd_control_resource 
        BGCOLOR BGCOLOR BGCOLOR 80
        0xF00 glcd_control_colors
        btShiftXpos btShiftYpos glcd_draw_control == iShiftIcon
        key_shift
    endif
;
0 ivar iLastKey

/* --- used for isubmenu stuff --- */
10000 ivar ISUBMENU_GROUP  ` This is used for the code numbers. The isubmenus will use codes from 10000+
: make_isubmenu ` <string> <code>
    ISUBMENU_GROUP +  ` This will put us on the 2nd line (code numbers start with 10000).
    glcd_create_control ` <code> on stack
    /* code */ 0 btNetworkResource 31 glcd_control_resource ` <code> on stack
    ` <bg> <border> <surf> <letters>  < ANID >
    ` BGCOLOR cWHITE   140     cRED     0xF000 glcd_control_colors ` <code> on stack (Active color)
    ` BGCOLOR cWHITE  cBLUE  cWHITE     0x0F00 glcd_control_colors ` <code> on stack (Normal color)
    ActiveMenuColors NormalMenuColors 0xFF00 glcd_control_colors
    4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    ISUBMENU_GROUP 1+ glcd_control_group  ` The isubmenus have 2 groups. Group 0=title + extra, Group 1=just the menus
    swap 4 -1 glcd_control_text drop
;
: make_isubmenu_title ` <string>
    ISUBMENU_GROUP 1-    ` This will put us on the 2nd line (code numbers start with 10000).
    glcd_create_control ` <code> on stack
    ` /* code */ 0 btNetworkResource 31 glcd_control_resource ` <code> on stack
    249 24 glcd_control_extents
    ` <bg> <border> <surf> <letters>  < ANID >
    HeaderMenuColors 0x0F00 glcd_control_colors ` <code> on stack (Normal color)
    ` 4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    ISUBMENU_GROUP glcd_control_group
    swap -1 -1 glcd_control_text drop
;
: show_isubmenu_cursor  ISUBMENU_GROUP + glcd_activate_control drop ;
: hide_isubmenu_cursor  ISUBMENU_GROUP + glcd_deactivate_control drop ;
: delete_isubmenu       ISUBMENU_GROUP + glcd_destroy_control drop ;
: delete_isubmenu_group ISUBMENU_GROUP + glcd_destroy_group drop ;
: delete_isubmenu_title ISUBMENU_GROUP 1- glcd_destroy_control drop ;
: show_isubmenu ` <code> <line> show_isubmenu
    ` This will display the menu starting at Y=0.
    swap ISUBMENU_GROUP + swap 2 swap 1- 24 * glcd_draw_control drop ` each submenu is 24 pixels apart.
;
: show_isubmenu_title  ISUBMENU_GROUP 1- 1 0 glcd_draw_control drop ;

: SetPauseMsg ` <msg> SetPauseMsg
    ifexists  vlen8 dup 40 vlen8
    ifmissing vlen8 dup slen 40 min
    kdm_dsp_line 
;
/* -- Dialog Control -- */
` Commands :  <text> <title> DLG_ShowText  ` fills dialog with text and sets the title.
`             <title> Dlg_SetTitle         ` Sets the title.
`             <text> <line #> DLG_SetText  ` Set a left justified single line (Lines are 1-8)

` 1060   = Dialog Box Title (also Group number)
` 1061-68= Dialog Line 1-8

512 666 sysallocate ptr pDialogMsg 

 24 ivar FONT_HEIGHT
 20 ivar DLG_XPOS  ` X and Y location of upper left corner of dialog.
  4 ivar DLG_YPOS
  8 ivar DLG_LINES ` number of text line in the dialog box (don't make larger than 12 becuase of the limit of control numbers)
280 ivar DLG_WIDTH ` width of dialog box (320 -20 for borders).
  1 ivar DLG_GETNUM_LINES  ` This gets update to the number of lines in the dialog box
 18 ivar DLG_SB_WIDTH ` with of scroll bar.
  
: set_dlg_width == DLG_WIDTH 320 DLG_WIDTH - 2 / == DLG_XPOS
    DLG_WIDTH 24 8 *  1 dlg_config ` <width>    <height>   1 dlg_config   set the width and height of the dialog boxes
    DLG_XPOS DLG_YPOS 2 dlg_config ` <x corner> <y corner> 2 dlg_config   specifies the location of the dialog boxes.
;  
word CopyLineTrim word CopyLineTrimColon 
word AddWordWrapMsg word InitWordWrap

0 ivar DLG_HANDLE
: DLG_SetTitle 1060 swap  -1 -1 glcd_control_text drop ; ` Center Text for Title.
: DLG_SetText
    1 max DLG_LINES min 1060 + swap
    ` look to see if any character is a bell character.
    dup 0 swap slen 1- 0 swap 1 step over I + b@ 7 = if 1 or break endif endstep
    1 = if 4 4 glcd_control_text glcd_activate_control drop :exit endif   ` Red
    4 4 glcd_control_text glcd_deactivate_control drop ` Normal
;
: DLG_Title  ` <title> DLG_Title
    /* <code> */ DLG_WIDTH 1+ FONT_HEIGHT glcd_control_extents ` add in 16 for size of Scroll bar
    ` /* <code> */ 4 glcd_control_set_option  ` <code> on stack (Left Justify)
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ HeaderMenuColors 0xF00 glcd_control_colors
;
: DLG_Line ` <text> <line #> DLG_Line
    /* <code> */ DLG_WIDTH DLG_SB_WIDTH - FONT_HEIGHT glcd_control_extents
    /* <code> */ 4 glcd_control_set_option  ` <code> on stack (Left Justify)
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT cWHITE cWHITE cRED     ` activate color
                 cTRANSPARENT cWHITE cWHITE cBLACK   0xFF00 glcd_control_colors  ` Normal color.
;

10 ivar DLG_BarSize
 0 ivar DLG_BarPos
10 ivar DLG_BarMax
0 ivar DLG_ScrollArea

0 ivar DLG_page
0 ivar DLG_begin
0 ivar DLG_end
0 ivar DLG_idx


: DLG_ShowBar ` <max> <pos> DLG_ShowBar
        ` 3992 glcd_deactivate_control drop ` if we deactivate the control, it will re-draw it for us. (This may change so don't use it). 
    3992 DLG_XPOS DLG_WIDTH + DLG_SB_WIDTH - DLG_YPOS FONT_HEIGHT 2* + glcd_draw_control drop
    3990 DLG_XPOS DLG_WIDTH + 2 + DLG_SB_WIDTH - ` DLG_LINES 2- itof 24.0 f*
    ` DLG_page DLG_begin - itof DLG_end DLG_begin - itof 1.0 fmax f/
    DLG_page itof DLG_GETNUM_LINES DLG_Lines - itof 1.0 fmax f/
    DLG_ScrollArea itof f* ftoi FONT_HEIGHT 2* + DLG_YPOS +
    DLG_BarMax min glcd_draw_control drop
    
    /* --
    3992 DLG_XPOS DLG_WIDTH + DLG_YPOS 24 2 * + glcd_draw_control drop
    3990 DLG_XPOS DLG_WIDTH + 3 + ` DLG_LINES 2- itof 24.0 f*
    ` DLG_page DLG_begin - itof DLG_end DLG_begin - itof 1.0 fmax f/
    DLG_page itof DLG_GETNUM_LINES itof 1.0 fmax f/
    DLG_LINES itof 24.0 f* f* ftoi
    DLG_YPOS 24 2 * + +
    DLG_BarMax min glcd_draw_control drop
    -- */
;
: CreateDialog
    DLG_HANDLE not if
        ` cSHADOW glcd_fg cSHADOW glcd_bg DLG_XPOS 3 + DLG_YPOS 3 + 250 10 + 3 + 24 9 * 3 + glcd_box  ` Shadow under box.
        ` create larger border around dialog to make it look nice.
        ` cLTGRAY glcd_fg cLTGRAY glcd_bg DLG_XPOS DLG_YPOS DLG_WIDTH 3 + 24 9 * 1+ glcd_box

        ` Create Scroll Bar
        3992 glcd_create_control 1060 glcd_control_group
        DLG_SB_WIDTH FONT_HEIGHT DLG_LINES 2- * glcd_control_extents
        SBarColors 0xF00 glcd_control_colors
        DLG_XPOS DLG_WIDTH + DLG_SB_WIDTH - DLG_YPOS FONT_HEIGHT 2 * + glcd_draw_control drop

        3993 glcd_create_control 1060 glcd_control_group
        DLG_SB_WIDTH FONT_HEIGHT glcd_control_extents
        SBarColors 0xF00 glcd_control_colors
        4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
        "" ^" 4 -1 glcd_control_text
        DLG_XPOS DLG_WIDTH + DLG_SB_WIDTH - DLG_YPOS FONT_HEIGHT + glcd_draw_control drop

        3994 glcd_create_control 1060 glcd_control_group
        DLG_SB_WIDTH FONT_HEIGHT 1+ glcd_control_extents  ` add one
        SBarColors 0xF00 glcd_control_colors
        4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
        "" v" 4 -1 glcd_control_text
        DLG_XPOS DLG_WIDTH + DLG_SB_WIDTH - DLG_YPOS FONT_HEIGHT DLG_LINES * + glcd_draw_control drop

        ` Slider part of Scroll bar.
        3990 glcd_create_control 1060 glcd_control_group
        DLG_SB_WIDTH 4 - FONT_HEIGHT itof DLG_LINES 2- itof f* DLG_LINES 2- itof
        DLG_GETNUM_LINES DLG_LINES 2- max itof f/ f* ftoi dup == DLG_BarMax glcd_control_extents
        DLG_LINES 2- FONT_HEIGHT * DLG_BarMax - 0 max == DLG_ScrollArea        
        ` " size = " DLG_BarMax . "  Area=" DLG_ScrollArea . nl 
        DLG_ScrollArea DLG_YPOS + FONT_HEIGHT 2* +  == DLG_BarMax ` calculate the maximum location we can put the scroll bar slider.
        SBarSliderColors 0xF00 glcd_control_colors drop

        ` Create Title
        1060 glcd_create_control 1060 glcd_control_group DLG_Title ` <code>
        DLG_XPOS 1- DLG_YPOS glcd_draw_control drop

        ` Border around text lines.
        3995 glcd_create_control 1060 glcd_control_group
        /* <code> */ DLG_WIDTH DLG_SB_WIDTH - FONT_HEIGHT DLG_LINES * 2+ glcd_control_extents
        /* <code> */ cGRAY cGRAY cGRAY cTRANSPARENT 0xF00 glcd_control_colors
        DLG_XPOS 1- DLG_YPOS FONT_HEIGHT + glcd_draw_control drop

        ` Create 8 Text Lines below the title.
        1 DLG_Lines 1 step
            1060 I + glcd_create_control 1060 glcd_control_group
            DLG_Line ` <code>
            DLG_XPOS I FONT_HEIGHT * DLG_YPOS + glcd_draw_control drop
        endstep

        1060 == DLG_HANDLE ` set handle number to first window handle. Used as flag to indicate box is created.
    endif
;
word clear_display
: DestroyDialog
    SYS_MSG? 2 and if "" Destroy Dialog\n" write_err endif 
    1060 glcd_destroy_group drop
    DLG_HANDLE if
        clear_display ` have to clear display to get rid of scroll bar.
        menu_status? not if kdm_dsp_rev endif 
    endif
    0 == DLG_HANDLE
    ` -1 kdm_stroke
;
: DLG_ShowPage
   ` Calculate Scroll Bar size
    ` DLG_end DLG_begin - WORDWRAP / ` bar size
    ` DLG_page DLG_begin - WORDWRAP /
    DLG_ShowBar ` current position
    ` step through and display the page.
    1 == DLG_idx
    ` " Page " DLG_Page . nl
    DLG_Page DLG_Page DLG_LINES 1- + 1 step
        wordwrap_msg_buffer I WORDWRAP * + CopyLineTrim dup DLG_idx DLG_SetText
        
        ` If the line contains a \007, it will be RED in color (done in DLG_SetText)
        ` If the line begins with \005, then put in a horizontal line.
        b@ 5 = if
            cGRAY glcd_fg  ` set the foreground color.
        else
            cWHITE glcd_fg  ` set the foreground color.
        endif
        DLG_idx 1 > if ` do not do if first line 
            DLG_XPOS 1+ DLG_idx 24 * DLG_YPOS + DLG_XPOS DLG_WIDTH + DLG_SB_WIDTH - 2- over glcd_line
        endif
        
        DLG_idx 1+ == DLG_idx
    endstep
 ;
0 ivar DLG_updn_value
ifmissing key_time_dly 0 ivar key_time_dly
: DLG_letgo_check
    == DLG_updn_value
    ` The following will highlight which scroll bar arrow is pressed. 
    ` DLG_updn_value 0 < if 3993 else 3994 endif glcd_activate_control drop 
    ` by changing the time, the lost break key still shows up but not as often.
    100 == key_time_dly
    DLG_page DLG_updn_value + DLG_GETNUM_LINES DLG_LINES - min 0 max == DLG_Page 
    DLG_ShowPage
    kdm20g_pump
    loop
        0 kdm_scankey -1 <> if 1 kdm_scankey 128 and until endif ` look for break key.
        key_time_dly 1- == key_time_dly 3 millisecond_delay
        key_time_dly 0 <= if
            5 == key_time_dly
            DLG_page DLG_updn_value + DLG_GETNUM_LINES DLG_LINES - min 0 max == DLG_Page 
            DLG_ShowPage
        endif
    repeat 
    ` The following will un-highlight which scroll bar arrow is pressed. 
    ` DLG_updn_value 0 < if 3993 else 3994 endif glcd_deactivate_control drop 
;

word DLG_MsgBox word service_menu
0 ivar SERVICE_KEYS
: DLG_ShowText ` <text> <title> DLG_ShowText <key pressed> ` fills dialog with text.
    0 kdm_cursor  ` turn off cursor
    swap
    ` dup dup == DLG_begin == DLG_page ` set page to beginning of pointer.
    ` dup slen + == DLG_end ` get end of buffer.

    ` make sure it is word wrapped at the default 20 characters.
    InitWordWrap AddWordWrapMsg
    wordwrap_msg_buffer slen WORDWRAP / == DLG_GETNUM_LINES

    0 == DLG_Page

    CreateDialog
    DLG_SetTitle ` <title> DLG_SetTitle
    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    DLG_ShowPage
    loop
        0 kdm_scankey -1 <> if
            1 kdm_scankey
            dup 12 = over 13 = or if break endif ` exit on enter or exit.
            dup 37 = over 43 = or if break endif
            dup 11 = if break endif              ` used in info_ip to refresh display
            dup 70 = if break endif
            dup 40 = if break endif              ` . or home key.
            dup 65 = if DLG_lines neg DLG_LetGo_Check endif ` Zup
            dup 25 = if -1 DLG_LetGo_Check  endif
            dup 66 = if DLG_lines DLG_LetGo_Check  endif ` Zdn
                24 = if  1 DLG_LetGo_Check  endif
        endif
        kdm20g_pump
    repeat
    save_kdmintr if kon endif
    DestroyDialog
;
/* -- End Dialog Control -- */
/* -- DLG_GetNum Dialog -- */
20 200 sysallocate ptr pNumBuf
20 200 sysallocate ptr pNumBufDsp
pNumBuf ptr pNumBufMax
` 0 = Integer
` 1 = Floating point
` Bit 2 = We have a decimal digit
` Bit 4 = Show under bar.
0 ivar bFVAR_NUM         ` is the number we are entering a floating point number
4 ivar bFVAR_PREC
-1 ivar PASSED_IN_NUMBER
9 ivar MAX_DIGITS_ALLOWED
0  ivar STOP_ON_3 ` Automatically go on after 3 digits are entered, used for Ethernet Info.
` Only allow 9 digits because ftoi can only convert 9.
: AddNumBuf pNumBufMax pNumBuf MAX_DIGITS_ALLOWED + < if pNumBufMax b! pNumBufMax 1+ pNumBuf MAX_DIGITS_ALLOWED + min == pNumBufMax else drop endif ;
: SubNumBuf pNumBufMax 1- pNumBuf max 0 swap b! pNumBufMax 1- pNumBuf max == pNumBufMax ;
: AddMinusNumBuf pNumBuf pNumBufMax = if ascii - AddNumBuf endif ;
: AddPointNumBuf
    2 ~and== bFVAR_NUM
    pNumBuf pNumBufMax 1 step
        I b@ ascii . = if 2 or== bFVAR_NUM break endif
    endstep
    bFVAR_NUM 2 and not if ascii . AddNumBuf endif ;
: EnterGetNum ` <number> <control id> EnterGetNum <number> <0/-1>
    bFVAR_NUM 1 and if
        fdup bFVAR_PREC select => ftoa.1 => ftoa.2 => ftoa.3 => ftoa.4 default=> ftoa.units endselect pNumBuf s!
    else
        over itoa pNumBuf s!
    endif
    dup pNumBuf bFVAR_NUM 4 and if pNumBufDsp s! "" _" pNumBufDsp s+! pNumBufDsp endif
    -1 -1 glcd_control_text drop
    0 pNumBuf 20 bfill ` clear buffer.
    pNumBuf == pNumBufMax
    loop
        PASSED_IN_NUMBER -1 <> if PASSED_IN_NUMBER else kdm_getkey endif
            -1 == PASSED_IN_NUMBER
            dup == iLastKey
            dup 0 >= over 9 <= land if dup 48 + AddNumBuf endif
            dup 11 = if AddMinusNumBuf endif
            bFVAR_NUM 1 and if dup 40 = if AddPointNumBuf endif endif
            dup 15 = if SubNumBuf endif  ` backspace
            dup 58 = if drop 1 break endif ` START key, linked to OK button.
            dup 43 = if drop 0 break endif ` Cylinder, linked to CANCEL button.
            dup 12 = if drop 1 break endif
                13 = if 0 break endif
            dup pNumBuf pNumBufDsp s! "" _" pNumBufDsp s+! pNumBufDsp -1 -1 glcd_control_text drop
            STOP_ON_3 if pNumBufMax pNumBuf 3 + = if 1 break endif endif
    repeat
    9 == MAX_DIGITS_ALLOWED
    swap drop ` drop control number.
    if  ` check if enter pressed. If so, drop orignal number and convert new number.
        pNumBuf pNumBufMax = if 0 :exit endif
        bFVAR_NUM 1 and if fdrop else drop endif ` drop original number.
        pNumBuf strtof dup if 2 swap 1 step fdrop endstep else drop 0.0 endif
        bFVAR_NUM 1 and not if ftoi endif
        0
    else
        -1 ` return -1 to indicate user pressed EXIT
    endif
;
: DLG_GetNum ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
    0 kdm_cursor
    dlg_get_number
;
/* -- DLG_Select -- */
0 ivar RESOURCE_VER
: DLG_Select_Radio ` <X> <Y> <"Text"> <control #> DLG_Select_Radio
    dup 1+ swap
    glcd_create_control 1060 glcd_control_group
    RESOURCE_VER 5 < if
        ` <bg> <border> <surf> <letters>  < ANID >
        cTRANSPARENT cBLACK  cYELLOW  cBLACK                             ` <code> on stack (Active color)
        cTRANSPARENT cBLACK  cLTGRAY  cLTGRAY 
        cTRANSPARENT     90  cLTGRAY      90
        0xFF0F glcd_control_colors ` <code> on stack (Normal color)
        18 20 glcd_control_extents
        "" X" -1 -1 glcd_control_text
        5 repl 5 repl 2 + glcd_draw_control drop
    else
        cTRANSPARENT cBLACK cBLACK                            ` <code> on stack (Active color)
        cTRANSPARENT cLGRAY cBLACK 
        cTRANSPARENT cLGRAY     90  ` disable color
        0xDD0D glcd_control_colors ` <code> on stack (Normal color)
        0 6 34 glcd_control_resource  ` Resource 34 = Radio button (only avaialble in V5 resource file.
        5 repl 5 repl 5 + glcd_draw_control drop
    endif

    glcd_create_control 1060 glcd_control_group ` <code> on stack
    4 repl DLG_WIDTH swap - 21 - 24 glcd_control_extents
    ` DLG_WIDTH 30 -  24 glcd_control_extents
    ` /* code */ 0 btNetworkResource 10 glcd_control_resource ` <code> on stack
    ` <bg> <border> <surf> <letters>  < ANID >
    ` cTRANSPARENT   140    140     cRED   0xF000 glcd_control_colors ` <code> on stack (Active color)
    cTRANSPARENT cHILITE cHILITE cBLACK 
    cTRANSPARENT cLGRAY cLGRAY cBLACK 
    cTRANSPARENT cLGRAY cLGRAY 90  ` 90 = disabled color 
    0xFF0F glcd_control_colors ` <code> on stack (Normal color)
    4 glcd_control_set_option ` <code> on stack (Left Justify)
    swap 0 -1 glcd_control_text
    bury swap 20 + swap glcd_draw_control drop
;
: DLG_Select_Button ` <X> <Y> <"Text"> <control #> DLG_Select_Button
    glcd_create_control 1060 glcd_control_group ` <code> on stack
    over slen 6 >= if  ` if string is longer than 6 characters, use resource 10 instead of 6.
        /* code */ 0 btNetworkResource 10 glcd_control_resource ` <code> on stack
    else
        /* code */ 0 btNetworkResource 6 glcd_control_resource ` <code> on stack
    endif
    ` <bg> <border> <surf> <letters>  < ANID >
    cTRANSPARENT cLTGRAY  cYELLOW  cBLACK                             ` <code> on stack (Active color)
    cTRANSPARENT cLTGRAY  cSILVER  cBLACK  0xFF00 glcd_control_colors ` <code> on stack (Normal color)
    swap -1 -1 glcd_control_text
    bury glcd_draw_control drop
;

: DLG_Select_Title
    1060 glcd_create_control 1060 glcd_control_group
    /* <code> */ DLG_WIDTH 24 glcd_control_extents
    /* <code> */ HeaderMenuColors 0xF00 glcd_control_colors
    swap CopyLineTrimColon -1 -1 glcd_control_text
    DLG_XPOS DLG_YPOS glcd_draw_control drop
;
: DLG_Select_Line ` used to add a message line to the DLG_Select and DLG_Select3.
    glcd_create_control 1060 glcd_control_group
    /* <code> */ DLG_WIDTH 24 glcd_control_extents
    /* <code> */ cTRANSPARENT cLGray cLGray cBLACK 0xF00 glcd_control_colors
    wordwrap_msg_buffer I WORDWRAP * + CopyLineTrim -1 -1 glcd_control_text
    DLG_XPOS DLG_YPOS 24 I 1+ * + glcd_draw_control drop
;
` DLG_Select
`   " Question"
`   xxx  - Button 1    (If selected, 1 will be returned)
`   xxx  - Button 0    (If selected, 0 will be returned)
: DLG_Select ` <"button 0"> <"button 1"> <"Question"> <"Title"> <default answer> DLG_Select <0=OK, -1=Cancel>
    == ANSWER?
    0 kdm_cursor

    ` Create Title
    DLG_Select_Title

    ` Create message
    ` make sure it is word wrapped at the default 22 characters.
    InitWordWrap AddWordWrapMsg
    wordwrap_msg_buffer slen WORDWRAP / 1+ == DLG_GETNUM_LINES
    0 DLG_GETNUM_LINES 1+ 1 step
        1061 I + DLG_Select_Line ` Uses wordwrap_msg_buffer to add lines.
    endstep

    DLG_XPOS  20 + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + rot 1080 DLG_Select_Radio
    DLG_XPOS  20 + DLG_YPOS 2 DLG_GETNUM_LINES + 24 * + rot 1082 DLG_Select_Radio
    1060 == DLG_HANDLE ` set handle number to first window handle. Used as flag to indicate box is created.

    ` Show default one as active.
    ANSWER? if 1080 glcd_activate_control drop else 1082 glcd_activate_control drop endif

    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop ANSWER?  0 break endif  ` enter key - drop old value and exit loop
         dup  13 = if drop ANSWER? -1 break endif  ` cancel key
         dup  25 = if 1080 glcd_activate_control drop 1082 glcd_deactivate_control drop 1 == ANSWER? endif
         dup  24 = if 1082 glcd_activate_control drop 1080 glcd_deactivate_control drop 0 == ANSWER? endif
         drop
      endif
    repeat
    save_kdmintr if kon endif
    1060 glcd_destroy_group drop
    0 == DLG_HANDLE
    1 kdm_cursor
;
: DLG_Select3 ` <"button 0"> <"button 1"> <"button 2"> <"Question"> <"Title"> <default answer> DLG_Select <status 0=OK, -1=Cancel>
    == ANSWER?
    0 kdm_cursor

    ` Create Title
    DLG_Select_Title

    ` Create message
    ` make sure it is word wrapped at the default 22 characters.
    InitWordWrap AddWordWrapMsg
    wordwrap_msg_buffer slen WORDWRAP / 1+ == DLG_GETNUM_LINES
    0 DLG_GETNUM_LINES 2+ 1 step
        1061 I + DLG_Select_Line ` Uses wordwrap_msg_buffer to add lines.
    endstep

    DLG_XPOS  20 + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + rot 1080 DLG_Select_Radio
    DLG_XPOS  20 + DLG_YPOS 2 DLG_GETNUM_LINES + 24 * + rot 1082 DLG_Select_Radio
    DLG_XPOS  20 + DLG_YPOS 3 DLG_GETNUM_LINES + 24 * + rot 1084 DLG_Select_Radio
    1060 == DLG_HANDLE ` set handle number to first window handle. Used as flag to indicate box is created.

    ` Show default one as active.
    ` ANSWER? if 1063 glcd_activate_control drop else 1064 glcd_activate_control drop endif

    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop ANSWER?  0 break endif  ` enter key - drop old value and exit loop
         dup  13 = if drop ANSWER? -1 break endif  ` cancel key
         dup  25 = if ANSWER? 1- 0 max == ANSWER? endif
         dup  24 = if ANSWER? 1+ 2 min == ANSWER? endif
         drop
         ANSWER? 1+ 1 max 3 min select
            => 1080 glcd_activate_control   drop 1082 glcd_deactivate_control drop 1084 glcd_deactivate_control drop
            => 1080 glcd_deactivate_control drop 1082 glcd_activate_control   drop 1084 glcd_deactivate_control drop
            => 1080 glcd_deactivate_control drop 1082 glcd_deactivate_control drop 1084 glcd_activate_control drop
         endselect
      endif
    repeat
    save_kdmintr if kon endif
    1060 glcd_destroy_group drop
    0 == DLG_HANDLE
    1 kdm_cursor
;
0 ivar 13pressed?
: DLG_YesNoEx ` <mode> <"Question"> <"Title"> DLG_YesNo <0=OK, -1=Cancel>
`               <mode> 0=Yes/No, 1=Continue only, 2=Cancel only, 3=Continue/Cancel
    1 == ANSWER?
    0 kdm_cursor

    ` Create Title
    DLG_Select_Title

    ` Create message
    ` make sure it is word wrapped at the default 22 characters.
    InitWordWrap AddWordWrapMsg
    wordwrap_msg_buffer slen WORDWRAP / 1+ == DLG_GETNUM_LINES
    0 DLG_GETNUM_LINES 1 step
        1061 I + DLG_Select_Line ` Uses wordwrap_msg_buffer to add lines.
    endstep

    ` <MODE> 0=Yes/No, 1=Continue only, 2=Cancel only, 3=Continue/Cancel
    dup 0 = if
        ` DLG Button is 72 pixels wide (6 characters).
        DLG_XPOS DLG_WIDTH 2 / 80 - + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + 3 - 1275 getmsg 1080 DLG_Select_Button ` Yes
        DLG_XPOS DLG_WIDTH 2 / 8  + + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + 3 - 1276 getmsg CopyLineTrim 1082 Dlg_Select_Button ` NO
    endif
    dup 1 and if
        dup 2 and if 112 == 13pressed? else 52 == 13pressed? endif ` cheat and use 13pressed variable for X location.
        ` DLG Button is 104 pixels wide (8 characters).
        DLG_XPOS DLG_WIDTH 2 / 13pressed? - + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + 3 - 1091 getmsg 1080 DLG_Select_Button ` "" Continue"
    endif
    dup 2 and if
        dup 1 and if -8 == 13pressed? else 52 == 13pressed? endif ` cheat and use 13pressed variable for X location.
        ` DLG Button is 104 pixels wide (8 characters).
        DLG_XPOS DLG_WIDTH 2 / 13pressed? - + DLG_YPOS 1 DLG_GETNUM_LINES + 24 * + 3 - 1308 getmsg 1082 DLG_Select_Button ` "" Cancel"
    endif
    drop
    1060 == DLG_HANDLE ` set handle number to first window handle. Used as flag to indicate box is created.

    ` Show default one as active.
    ANSWER? if 1080 glcd_activate_control drop else 1082 glcd_activate_control drop endif

    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    0 == 13pressed?  ` make sure 13 is pressed and released.
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop ANSWER?  0 break endif  ` enter key break - drop old value and exit loop
         dup  13 = if drop 26 1 == 13pressed? endif  ` cancel key, change to right arrow.
         dup  13 128 + = 13pressed? land if drop ANSWER? -1 break endif  ` cancel key break, get out.
         dup  15 = over 84 = or if 1080 glcd_activate_control drop 1082 glcd_deactivate_control drop 1 == ANSWER? endif
         dup  26 = over 86 = or if 1082 glcd_activate_control drop 1080 glcd_deactivate_control drop 0 == ANSWER? endif
         drop
      endif
    repeat
    save_kdmintr if kon endif
    1060 glcd_destroy_group drop
    0 == DLG_HANDLE
    1 kdm_cursor
;
: DLG_YesNo 0 bury DLG_YesNoEx ; ` <"Question"> <"Title"> DLG_YesNo <0=OK, -1=Cancel>

` [ [ <size> ] <"button text"> <"message"> <"title"> ] <mode> dlg_message_box <code>
: DLG_DisplayMsgBox ` [ <size> <"button text"> <"message"> <"title"> ] <mode> DLG_DisplayMsgBox <code>
    0 kdm_cursor
    dup -1 = if dlg_message_box /* clear_display kdm_dsp_rev */ else swap CopyLineTrimColon swap dlg_message_box endif 
;
` <delay> <"message"> <"title"> 0 DLG_MsgBox
` <delay> <"button text"> <"message"> <"title"> 1 DLG_MsgBox
` <delay> <size in chars> <"default number"> <"message"> <"title"> 3 DLG_MsgBox
0 ivar DLG_BUTTON_HANDLE
: DLG_MsgBox
    DLG_DisplayMsgBox == DLG_BUTTON_HANDLE
    ` if delay == -1, wait for key press.
    ` if delay == -2, display but do not destroy.
    ` if delay > 0, this is the number of milliseconds to display message.
    dup -1 = if
        drop
        kdm_intr? == save_kdmintr
        koff ` have to turn off hot keys so kdm_scankey works.
        500 millisecond_delay
        loop 0 kdm_scankey -1 <> if 1 kdm_scankey drop else break endif repeat
        loop
          0 kdm_scankey -1 <> if
             1 kdm_scankey 128 and not if
                DLG_BUTTON_HANDLE glcd_activate_control drop  ` highlight when a key is pressed.
             else
                break  ` exit out on release.
             endif
          endif
        repeat
        save_kdmintr if kon endif
        -1 DLG_DisplayMsgBox
    else dup -2 = if drop else millisecond_delay -1 DLG_DisplayMsgBox endif endif
;

: LED_Control ` <X> <Y> <"Text"> <control #> LED_Control
    dup 1+ swap
    glcd_create_control 5000 glcd_control_group

    ` <bg> <border> <surf> <letters>  < ANID >
    cTRANSPARENT cBLACK  cLGREEN   cBLACK                            ` <code> on stack (Active color)
    cTRANSPARENT cBLACK  cLTGRAY  cLTGRAY 0xFF00 glcd_control_colors ` <code> on stack (Normal color)
    18 10 glcd_control_extents
    5 repl 5 repl 6 + glcd_draw_control drop

    glcd_create_control 5000 glcd_control_group ` <code> on stack
    DLG_WIDTH 30 -  24 glcd_control_extents
    ` /* code */ 0 btNetworkResource 10 glcd_control_resource ` <code> on stack
    ` <bg> <border> <surf> <letters>  < ANID >
    ` cTRANSPARENT   140    140     cRED   0xF000 glcd_control_colors ` <code> on stack (Active color)
    cTRANSPARENT dup dup cBLACK 0x0F00 glcd_control_colors ` <code> on stack (Normal color)
    4 glcd_control_set_option ` <code> on stack (Left Justify)
    swap 0 -1 glcd_control_text
    bury swap 22 + swap glcd_draw_control drop
;
0 set_warning
: kdm_led
    LED_SHIFT = if
        iShiftIcon 255 rot if cWhite cWhite else cBLACK cBLACK endif cBlue 0xF00 glcd_control_colors drop
    else drop  ` don't care about other LED
    endif
;
1 set_warning

0 ptr gui_conx_chg
false ivar conx_status
false ivar conx_link_fail

: safe_execute dup if exec else drop endif ;


: toolbar_conx_chg
    btNetwork conx_status if glcd_activate_control else glcd_deactivate_control endif
    conx_link_fail        if glcd_disable_control else glcd_enable_control endif
    drop
 ;

: make_conx
    btNetwork glcd_create_control
    0 btNetworkResource btNetworkIdx glcd_control_resource
    BGCOLOR cBLACK = if
        BGCOLOR BGCOLOR cBLUE   cBLUE   /* */ BGCOLOR 96   96   cBLUE
    else
        ` BGCOLOR BGCOLOR cYELLOW cYELLOW /* */ BGCOLOR cRED cRED cYELLOW
        ` Use color of task bar.
        cBLUE cBLUE cYELLOW cYELLOW /* */ BGCOLOR cRED cRED cYELLOW
    endif
    BGCOLOR cRED cRED 48 0xff0f glcd_control_colors
    drop ` display soon in clear display btNetworkXpos btNetworkYpos glcd_draw_control drop
    ' toolbar_conx_chg dup == gui_conx_chg safe_execute
;

: ErrorMsgEx   ` <wait> <Error Number> ErrorMsg
    "" \n\007" write_err dup 100 < if 1900 + endif getmsg
    dup write_err
    ` <delay> <size> <"button text"> <"message"> <"title"> <mode> DLG_MsgBox
    swap dup -1 = if drop -1 swap 840 getmsg swap 841 getmsg 1 DLG_MsgBox ` "" OK", "" Message"
                else swap 841 getmsg 0 DLG_MsgBox endif ` "" OK", "" Message"
;


200 0 sysallocate ptr pMsg
200 0 sysallocate ptr pMsgStr
: TimeToStr 60 /mod swap 60 /mod swap dup  ` Time in Seconds
     if itoa pMsg s! "" :" pMsg s+! 1.0 else "" " pMsg s! drop -1.0 endif
     dup 10 < if "" 0" pMsg s+! endif dup 0 = fdup 0.0 f< land if fdrop -2.0 endif itoa pMsg s+! "" :" pMsg s+!
     dup 10 < if "" 0" pMsg s+! endif itoa pMsg s+! fdup 0.0 f< if -1.1 f< if ""  seconds" else ""  minutes" endif else fdrop ""  hours" endif pMsg s+! pMsg ;
: TimeToStrRaw 
     60 /mod swap 60 /mod swap  ` Time in Seconds
     ` Use the floating point stack as a flag. 1.0=hours were output, -1.0=No hours.
     dup if itoa pMsg s! "" :" pMsg s+! 1.0 else "" " pMsg s! drop -1.0 endif
     ` if > 0.0, then the hours spot was output so add in extra 0 if we need to.
     0.0 f> if dup 10 < if "" 0" pMsg s+! endif endif  itoa pMsg s+! "" :" pMsg s+!
     ` seconds field is last, always add in preceeding 0 if < 10.
     dup 10 < if "" 0" pMsg s+! endif itoa pMsg s+! pMsg ; 
     
: TimeToHrs 60 /mod swap 60 /mod swap dup  ` Time in Seconds
     if "" " pMsg s!
        dup 100 < if  ""  " pMsg s+! endif
        dup  10 < if  ""  " pMsg s+! endif
        itoa pMsg s+! "" :" pMsg s+! 1.0
     else ""     " pMsg s! drop -1.0
     endif
     dup 10 < if fdup 0.0 f< if ""  " else "" 0" endif pMsg s+! endif itoa pMsg s+!
     drop ` drop seconds...   "" :" pMsg s+! dup 10 < if "" 0" pMsg s+! endif itoa pMsg s+!
     0.0 f< if ""  mins" else ""  hrs" endif pMsg s+! pMsg ;

20 ivar COPY_SIZE
512 100 sysallocate ptr pTempStr
pTempStr ptr COPY_PTR
: CopyLine ` <ptr> CopyLine <ptr>
    ` <buf> <maxlen> vlen8 -> <len>
    ifexists vlen8 dup WORDWRAP vlen8
    ifmissing vlen8 dup slen WORDWRAP min
    dup bury pTempStr swap bmove pTempStr + 0 swap b! pTempStr
;
: copy_string ` <ptr> <dst> <size> copy_string
    == COPY_SIZE
    == COPY_PTR
    ` <buf> <maxlen> vlen8 -> <len>
    ifexists vlen8 dup COPY_SIZE vlen8
    ifmissing vlen8 dup slen COPY_SIZE min
    dup bury COPY_PTR swap bmove COPY_PTR + 0 swap b!
;
: add_spaces ` <ptr> <spaces> add_spaces
    1 swap 1 step ""  " over s+! endstep drop ;
    
: center_string ` <ptr> <size> center_string <ptr>   NOTE -- This also truncates the string
    == COPY_SIZE
    == COPY_PTR
    "" " pTempStr s!
    COPY_SIZE  ` leave original size on stack.
    ifexists vlen8 COPY_PTR COPY_SIZE vlen8 
    ifmissing vlen8 COPY_PTR slen COPY_SIZE min
    COPY_SIZE - neg == COPY_SIZE
    pTempStr COPY_SIZE 2 / add_spaces COPY_PTR pTempStr s+! pTempStr COPY_SIZE dup 2 / swap 1 and if 1+ endif add_spaces
    pTempStr swap truncate ` swap in original size.
    ` replace any CR or NL with spaces.
    pTempStr 2dup slen + 1 step
        I b@ 10 = if 32 I b! endif 
        I b@ 13 = if 32 I b! endif 
    endstep
    ` nl " (" pTempStr s. " )" nl  DEBUG 
;
ifmissing sn! : sn! copy_string ;
: truncate ` <ptr> <size> truncate <ptr>
    ` <buf> <maxlen> vlen8 -> <len>
    ifexists vlen8 over swap vlen8 over + 0 swap b!
    ifmissing vlen8 over slen min over + 0 swap b!
;
: CopyLinetrim  ` trims off trailing whitespace.
    CopyLine drop
    1 pTempStr slen 1 step
        pTempStr dup slen I - + b@ 32 <> if pTempStr dup slen I - 1+ truncate drop break endif
    endstep
    pTempStr
;
: CopyLineTrimColon ` Trims off spaces and colons from end of string.
    CopyLine drop
    1 pTempStr slen 1 step
        pTempStr dup slen I - + b@ 
            dup 32 <> 
            over ascii : <> land 
            over 159 <> land  ` up arrow
            over 158 <> land  ` down arrow
            swap ascii - <> land 
            if pTempStr dup slen I - 1+ truncate drop break endif
    endstep
    pTempStr
;


/* Scroll Message (up to 20 lines) */
1100 200 sysallocate ptr scroll_buffer
scroll_buffer ivar scroll_max  ` pointer to last byte.
` Secondary buffer to hold info until we need to copy it into scroll_buffer
1100 200 sysallocate ptr scroll_buffer2
scroll_buffer2 ivar scroll_max2  ` pointer to last byte.

scroll_buffer ivar scroll_page
0 ivar last_space  ` location of last non-space character when scanning input.
4 ivar scroll_lines
GRAPHICAL_KDM? #ifdef
8 == scroll_lines
: Scroll_message_kdm20g ` <title> scroll_message_kdm20g <key pressed>
    scroll_buffer == scroll_page
    scroll_max scroll_buffer = if drop 13 :exit endif  ` nothing to show (send back 13)
    fKDMTimeOut kdm_time_out ` set timeout to normal before kdm_getkey.
    scroll_buffer scroll_max truncate drop
    scroll_buffer swap DLG_ShowText  ` <text> <title> DLG_ShowText <key pressed>
;
#endif
8 ivar MAX_KDM_LINES
word kdm_lines
: Scroll_message
    scroll_buffer == scroll_page
    scroll_max scroll_buffer = if :exit endif  ` nothing to show.
    fKDMTimeOut kdm_time_out ` set timeout to normal before kdm_getkey.
    scroll_buffer scroll_max truncate drop
    [ GRAPHICAL_KDM? ] #ifdef scroll_lines kdm_lines #endif ` expand out to 8 lines
    loop
        ` step through and display the page.
        ` " buffer " scroll_buffer . "  max " scroll_max . "  Page " scroll_page . nl
        kdm_clear
        ` scroll_page dup 79 + scroll_max 1- min 1 step I b@ KDMDVC> w@ fwchar endstep
        0 scroll_lines 20 * 20 step scroll_page I + CopyLine kdm_dsp_string endstep
        kdm_getkey
            dup 12 = if drop break endif ` exit on enter or exit.
            dup 13 = if drop break endif
            dup 65 = if scroll_page 80 - scroll_buffer max == scroll_page endif ` Zup
            dup 25 = if scroll_page 20 - scroll_buffer max == scroll_page endif
            dup 66 = if scroll_page 80 + dup scroll_max >= if drop scroll_page endif == scroll_page endif ` Zdn
                24 = if scroll_page 20 + dup scroll_max >= if drop scroll_page endif == scroll_page endif
    repeat
    [ GRAPHICAL_KDM? ] #ifdef MAX_KDM_LINES kdm_lines #endif ` expand out to 8 lines
;
: init_scroll_buffer scroll_buffer == scroll_max 0 scroll_max 1000 bfill ;
: InitScrollMessage  init_scroll_buffer ; ` Use same name as plasma.
: incr_scroll_max scroll_max + scroll_buffer 1000 + min == scroll_max ;
: add_scroll_char  ` <char> add_scroll_char
    scroll_max b!  ` add byte to scroll buffer
    1 incr_scroll_max  ` make sure we do not go out of bounds.
;
: pad_scroll ` pad message with spaces out to next complete line.
    1 20 scroll_max scroll_buffer - 20 mod dup not if drop 2drop :exit endif - 1 step 32 add_scroll_char endstep ;
: AddScrollMsg ` <string> AddScrollMsg
    ` <ptr> <dst> <cnt> copy_string
    scroll_max over slen scroll_buffer 1000 + scroll_max - min dup incr_scroll_max copy_string
;
: AddScrollMsgPad AddScrollMsg pad_scroll ;
: AddScrollSpace 32 add_scroll_char ;
: AddScrollNL "" \n" AddScrollMsg ;
: AddScrollNum ` <num> <width> AddScrollNum
    scroll_max false rot 0 0 aiformat slen incr_scroll_max
;
: AddScrollNumHex ` <num> <width> AddScrollNumHex (converts number to hex)
    scroll_max false rot 0 0 hiformat slen incr_scroll_max
;
/* --- Secondary buffer commands --- */
: InitScrollMessage2 scroll_buffer2 == scroll_max2 0 scroll_max2 1000 bfill ;
: AddScroll2 scroll_buffer2 AddScrollMsg InitScrollMessage2 ;
: incr_scroll_max2 scroll_max2 + scroll_buffer2 1000 + min == scroll_max2 ;
: add_scroll_char2  ` <char> add_scroll_char
    scroll_max2 b!  ` add byte to scroll buffer
    1 incr_scroll_max2   ` make sure we do not go out of bounds.
;
: pad_scroll2 ` pad message with spaces out to next complete line.
    1 20 scroll_max2 scroll_buffer2 - 20 mod dup not if drop 2drop :exit endif - 1 step 32 add_scroll_char2 endstep ;
: AddScrollMsg2 ` <string> AddScrollMsg
    ` <ptr> <dst> <cnt> copy_string
    scroll_max2 over slen scroll_buffer2 1000 + scroll_max2 - min dup incr_scroll_max2 copy_string
;
: AddScrollMsgPad2 AddScrollMsg2 pad_scroll2 ;
: AddScrollNL2 "" \n" AddScrollMsg2 ;
: AddScrollNum2 ` <num> <width> AddScrollNum
    scroll_max2 false rot 0 0 aiformat slen incr_scroll_max2
;
: AddScrollNumHex2 ` <num> <width> AddScrollNumHex (converts number to hex)
    scroll_max2 false rot 0 0 hiformat slen incr_scroll_max2
;
` : tstscroll InitScrollMessage getmsg AddScrollMsg Scroll_Message ;
/* --- Word Wrapping Buffer --- */
wordwrap_msg_buffer ivar wordwrap_msg_max  ` pointer to last byte.
: InitWordWrap wordwrap_msg_buffer == wordwrap_msg_max 0 wordwrap_msg_buffer 1000 bfill ;
: incr_wordwrap_msg_max wordwrap_msg_max + wordwrap_msg_buffer 1000 + min == wordwrap_msg_max ;
: PadWordWrapMsg ` pad message with spaces out to next complete line.
    1 WORDWRAP wordwrap_msg_max wordwrap_msg_buffer - WORDWRAP mod dup not if drop 2drop :exit endif - 1
    step 32 wordwrap_msg_max b! 1 incr_wordwrap_msg_max endstep ;
: AddWordWrapMsgCore ` <string> <len> AddWordWrapMsgCore
    0 swap 1- 1 step
        dup I + b@ dup 10 = if drop PadWordWrapMsg else wordwrap_msg_max b! 1 incr_wordwrap_msg_max endif
    endstep
    drop
;
pTEMP ptr pTEMP2
0 ivar SKIP_SPACES
: CheckForPadAdd
    wordwrap_msg_max wordwrap_msg_buffer - WORDWRAP mod  ` get how much room we have left on this line.
    dup 0 = if 1 == SKIP_SPACES endif
    pTEMP2 pTEMP - + 1- dup WORDWRAP > if PadWordWrapMsg drop else 
                           ` if the line length = WORDWRAP, then they are a perfect fit on the line. 
                           ` In this case, back up the last space we put in the pTEMP2 buffer.
                            WORDWRAP = pTEMP2 1- pTEMP max b@ 32 = land if pTEMP2 1- pTEMP max == pTEMP2 endif
                        endif
    pTEMP pTEMP2 pTEMP - AddWordWrapMsgCore
;
` AddWordWrapMsg will add messages to the scroll buffer making sure they word wrap.
: AddWordWrapMsg ` <string> AddWordWrapMsg
    pTEMP == pTEMP2
    0 == SKIP_SPACES
    dup slen 1- 0 swap 1 step
        dup I + b@    
        dup 32 = SKIP_SPACES land if
            ` we just completed a line, skip any leading spaces for the start of the next line.
            drop 
        else
            dup pTEMP2 b! pTEMP2 1+ == pTEMP2
            dup 10 = swap 32 = or if CheckForPadAdd pTEMP == pTEMP2 else 0 == SKIP_SPACES endif ` space encountered. check if token fits on line.
        endif
    endstep
    0 pTEMP2 b! pTEMP2 1+ == pTEMP2
    pTEMP pTEMP2 <> if CheckForPadAdd endif
    drop
;
: word_wrap_string
    InitWordWrap
    AddWordWrapMsg
    wordwrap_msg_buffer
;


` 2000 Group id
` 2001 Jog

: make_combo_box
    glcd_create_control
    0 btNetworkResource 56 glcd_control_resource
    BGCOLOR cTRANSPARENT cWHITE cTEAL 0xF00 glcd_control_colors
    4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    4 pluck 4 -1 glcd_control_text  ` Center Text for Title.
    bury glcd_draw_control drop
;

: make_group_box_dlg ` <"Text"> <X> <Y> <width> <height> <control number> make_group_box_dlg
    1+ glcd_create_control
    /* <code> */ bury glcd_control_extents  
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT cBLACK cTRANSPARENT cTRANSPARENT 0xF00 glcd_control_colors
    2000 glcd_control_group
    bury 2dup 5 pluck bury glcd_draw_control 
    
    1- glcd_create_control
    4 pluck dup slen 2+ 12 * 24 4 pluck bury glcd_control_extents 
    BGCOLOR cTRANSPARENT cLGRAY cBLACK 0xF00 glcd_control_colors
    2000 glcd_control_group
    swap -1 -1 glcd_control_text
    bury swap 5 + swap 12 - glcd_draw_control drop 
;    
: make_group_box ` <"Text"> <X> <Y> <width> <height> <control number> make_group_box
    1+ glcd_create_control
    /* <code> */ bury glcd_control_extents  
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT cTITLES cTRANSPARENT cTRANSPARENT 0xF00 glcd_control_colors
    2000 glcd_control_group
    bury 2dup 5 pluck bury glcd_draw_control 
    
    1- glcd_create_control
    4 pluck dup slen 2+ 12 * 24 4 pluck bury glcd_control_extents 
    BGCOLOR cTRANSPARENT BGCOLOR cBG_TEXT_COLOR 0xF00 glcd_control_colors
    2000 glcd_control_group
    swap -1 -1 glcd_control_text
    bury swap 5 + swap 12 - glcd_draw_control drop 
;    
: make_left_text_dlg ` "" Text" <x> <y> <xsize> <ysize> <code> make_left_text_dlg
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT cLGRAY cLGRAY cBG_TEXT_COLOR 0xF00 glcd_control_colors
    2000 glcd_control_group
    4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    4 pluck 4 -1 glcd_control_text  ` Center Text for Title.
    bury glcd_draw_control drop
;
: make_left_text ` "" Text" <x> <y> <xsize> <ysize> <code> make_left_text_dlg
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT BGCOLOR BGCOLOR cBG_TEXT_COLOR 0xF00 glcd_control_colors
    2000 glcd_control_group
    4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    4 pluck 4 -1 glcd_control_text  ` Center Text for Title.
    bury glcd_draw_control drop
;
: make_center_text_dlg ` "" Text" <x> <y> <xsize> <ysize> <code> make_center_text_dlg
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cTRANSPARENT cTRANSPARENT cBLACK
    cTRANSPARENT cTRANSPARENT cTRANSPARENT 90 0xF0F glcd_control_colors ` Disabled color = 90.
    2000 glcd_control_group
    ` 4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    4 pluck -1 -1 glcd_control_text  ` Center Text for Title.
    bury glcd_draw_control drop 
;
: make_center_text ` "" Text" <x> <y> <xsize> <ysize> <code> make_center_text
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cTRANSPARENT cTRANSPARENT cBG_TEXT_COLOR
    cTRANSPARENT cTRANSPARENT cTRANSPARENT 90 0xF0F glcd_control_colors ` Disabled color = 90.
    2000 glcd_control_group
    ` 4 glcd_control_set_option ` <code> on stack (Left Justify, needed with GLCD firmware)
    4 pluck -1 -1 glcd_control_text  ` Center Text for Title.
    bury glcd_draw_control drop 
;
: make_box
    /* <code> */ glcd_create_control  2000 glcd_control_group glcd_control_insensitive ` do not allow touch events
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cWHITE 120 cTEXT_COLOR 0xF00 glcd_control_colors
    bury glcd_control_extents  
    bury glcd_draw_control drop 
;
: make_sunken_box ` <x> <y> <xsize> <ysize> <code> make_sunken_box
    SYS_MSG? 64 and if "" make_sunken_box\n" write_err endif
    2000 glcd_create_control
    4 repl 4 + 4 repl 4 + glcd_control_extents
    cTRANSPARENT 20 cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 2 - 6 repl 2- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 2 + 4 repl 2 + glcd_control_extents
    cTRANSPARENT 20 cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 1 - 6 repl 1- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 1+ 4 repl 1+ glcd_control_extents
    cTRANSPARENT cDLG_GRAY cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 2+ 4 repl 2+ glcd_control_extents
    cTRANSPARENT cDLG_GRAY cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl glcd_draw_control drop
    
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cYELLOW cWINDOW_COLOR cBLACK 
    /* <code> */ cTRANSPARENT cWINDOW_COLOR cWINDOW_COLOR cTEXT_COLOR 0xFF00 glcd_control_colors
    2000 glcd_control_group
    bury glcd_draw_control drop 
;
: make_sunken_2line_box ` <x> <y> <xsize> <ysize> <code> make_sunken_box
    2000 glcd_create_control
    4 repl 4 + 4 repl 4 + glcd_control_extents
    cTRANSPARENT 20 cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 2 - 6 repl 2- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 2 + 4 repl 2 + glcd_control_extents
    cTRANSPARENT 20 cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 1 - 6 repl 1- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 1+ 4 repl 1+ glcd_control_extents
    cTRANSPARENT cDLG_GRAY cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 2+ 4 repl 2+ glcd_control_extents
    cTRANSPARENT cDLG_GRAY cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl glcd_draw_control drop
    
    swap 2/ swap 
    
    /* <code> */ glcd_create_control
    /* <code> */ mover mover /* <x> <y> */ glcd_control_extents  
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cWINDOW_COLOR cWINDOW_COLOR cBLACK 
    /* <code> */ cTRANSPARENT cWINDOW_COLOR cWINDOW_COLOR cTEXT_COLOR 0xFF00 glcd_control_colors
    2000 glcd_control_group
    5 repl 5 repl glcd_draw_control 
    
    
    1+ 
    /* <code> */ glcd_create_control
    /* <code> */ swap bury 3 repl swap bury /* <x> <y> */ glcd_control_extents  
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cWINDOW_COLOR cWINDOW_COLOR cBLACK 
    /* <code> */ cTRANSPARENT cWINDOW_COLOR cWINDOW_COLOR cTEXT_COLOR 0xFF00 glcd_control_colors
    2000 glcd_control_group
    bury + swap bury glcd_draw_control drop 
;

: make_sunken_box_dlg ` <x> <y> <xsize> <ysize> <code> make_sunken_box
    2000 glcd_create_control
    4 repl 1+ 4 repl 1+ glcd_control_extents
    cTRANSPARENT 80 cLGRAY cBLACK 0xF00 glcd_control_colors
    6 repl 1- 6 repl 1- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 1+ 4 repl 1+ glcd_control_extents
    cTRANSPARENT cWHITE cWHITE cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl glcd_draw_control drop
    
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    cTRANSPARENT cHILITE cHILITE cBLACK 
    cTRANSPARENT 120         120         cBLACK
    cTRANSPARENT 120         120         90
    0xFF0F glcd_control_colors
    1060 glcd_control_group
    bury glcd_draw_control drop 
;
: make_led_box ` "" Text" <x> <y> <xsize> <ysize> <code> make_led_box
    2000 glcd_create_control
    4 repl 1+ 4 repl 1+ glcd_control_extents
    cTRANSPARENT 80 cDLG_GRAY cBLACK 0xF00 glcd_control_colors
    6 repl 1- 6 repl 1- glcd_draw_control drop
    
    2000 glcd_create_control
    4 repl 1+ 4 repl glcd_control_extents
    cTRANSPARENT 127 cDLG_GRAY cBLACK 0xF00 glcd_control_colors
    6 repl 6 repl 1+ glcd_draw_control drop
    
    /* <code> */ glcd_create_control
    /* <code> */ bury /* <x> <y> */ glcd_control_extents  ` whole width of display
    ` Color <Background> <Border> <Surface> <Forground>
    /* <code> */ cTRANSPARENT BGCOLOR cRED cBLACK cTRANSPARENT BGCOLOR cWHITE cBLACK 0xFF00 glcd_control_colors
    2000 glcd_control_group
    bury glcd_draw_control drop 
;
200 200 sysallocate ptr PARSE_STR_1
0 ptr PARSE_STR_2   ` second string
: parse_title_strings
    ` Search for the \n and make two strings.
    PARSE_STR_1 s!
    PARSE_STR_1 PARSE_STR_1 slen + dup 0 swap b! == PARSE_STR_2
    PARSE_STR_1 dup PARSE_STR_1 slen + 1 step 
        I b@ 10 = I b@ 124 = or if 0 I b! I 1+ == PARSE_STR_2 break endif
    endstep
    ` nl
    ` " String 1  (" PARSE_STR_BUF s. " )" nl PARSE_STR_BUF 10 bdump 
    ` " String 2  (" PARSE_STR_2 s. " )" nl PARSE_STR_2 10 bdump
;    

: set_fro_box small_control_font FRO_BOX_CTRL 4 get_current_fro? itoa -1 -1 glcd_control_text drop normal_control_font ;     ` <"Text:"> set_fro_box

word make_feed_box
: set_feed_box ` <Cut Speed> set_feed_box
    DISPLAY_CUTSPEED? not if fdrop :exit endif 
    make_feed_box small_control_font ftoa.1 FEED_BOX_CTRL swap -1 -1 glcd_control_text drop normal_control_font ;     ` <float feedrate> set_feed_box

` Setup as an event queue.
: FRO_Display_Handler
    DISPLAY_CUTSPEED? if 
        FEED_SHOWN? if XYDN_FEED TIMESCALE f* 0 get_current_fro? f* set_feed_box endif
    endif
    DISPLAY_FRO? if 
        FRO_SHOWN? if set_fro_box endif
    endif
;

: make_fro_box
    DISPLAY_FRO? not if :exit endif
    FRO_SHOWN? if :exit endif
    1 == FRO_SHOWN?
    small_control_font 
    "" Feed"   FRO_X 118 60 12 2000 make_center_text
    "" %"      FRO_X 130 60 12 2000 make_center_text
               FRO_X 147 60 18 FRO_BOX_CTRL make_sunken_box 
    normal_control_font
    FRO_RTC_ID 0 = if ' FRO_Display_Handler 1 0.1 2 eventqueue == FRO_RTC_ID endif
    SYS_MSG? 2 and if " make_fro_box\n" endif
;
: hide_fro_box
    0 == FRO_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID
;


: make_feed_box
    DISPLAY_CUTSPEED? not if :exit endif 
    FEED_SHOWN? if :exit endif
    SaveLDNC if :exit endif ` can't figure out where this is getting called so block here.
    1 == FEED_SHOWN? 
    small_control_font
    1300 getmsg parse_title_strings  ` "" Cut\nSpeed"
    PARSE_STR_1 CUTSPEED_X 118 60 12 2000 make_center_text 
    PARSE_STR_2 CUTSPEED_X 130 60 12 2000 make_center_text 
                CUTSPEED_X 147 60 18 FEED_BOX_CTRL make_sunken_box 
    normal_control_font 
    FRO_RTC_ID 0 = if ' FRO_Display_Handler 1 0.1 2 eventqueue == FRO_RTC_ID endif
    SYS_MSG? 2 and if "" make_feed_box\n" write_err endif
;
: hide_feed_box
    0 == FEED_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID
;

: make_zdepth_box 
    DISPLAY_ZDEPTH? not if :exit endif 
    ZDEPTH_SHOWN? if :exit endif 
    1 == ZDEPTH_SHOWN? 
    small_control_font 
    1301 getmsg parse_title_strings ` "" Z Cut\nDepth" 
    PARSE_STR_1 ZDEPTH_X 118 60 12 2000 make_center_text 
    PARSE_STR_2 ZDEPTH_X 130 60 12 2000 make_center_text 
                ZDEPTH_X 147 60 18 ZDEPTH_CTRL make_sunken_box 
    normal_control_font ;
: set_zdepth_box ` <Z Depth> set_zdepth_box
    DISPLAY_ZDEPTH? not if fdrop :exit endif 
    make_zdepth_box small_control_font ftoa.units ZDEPTH_CTRL swap -1 -1 glcd_control_text drop normal_control_font ;     ` <"Text:"> set_feed_box

` Z Lift Height box
: make_zlift_box 
    DISPLAY_ZLIFT? not if :exit endif
    DISPLAY_DELTA? if :exit endif ` These end up in the same location so display Z Delta instead of Z Lift.
    ZLIFT_SHOWN? if :exit endif
    MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or if :exit endif      
    1 == ZLIFT_SHOWN? 
    small_control_font 
    1302 getmsg parse_title_strings ` "" Z Lift\nHeight" 
    PARSE_STR_1 ZLIFT_X 118 60 12 2000 make_center_text 
    PARSE_STR_2 ZLIFT_X 130 60 12 2000 make_center_text 
                ZLIFT_X 147 60 18 ZLIFT_CTRL make_sunken_box 
    normal_control_font ;
: set_zlift_box ` <Z Lift> set_zlift_box
    DISPLAY_ZLIFT? not if fdrop :exit endif 
    DISPLAY_DELTA? if fdrop :exit endif ` These end up in the same location so display Z Delta instead of Z Lift.
    MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or if fdrop :exit endif      
    make_zlift_box small_control_font ftoa.units ZLIFT_CTRL swap -1 -1 glcd_control_text drop normal_control_font ; 
: hide_zlift_box
    ZLIFT_CTRL glcd_destroy_control drop 
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    ZLIFT_X 2- 118 65 50 glcd_box  ` This erases part of the screen
    0 == ZLIFT_SHOWN? 
;
word hide_xyz_box
: make_time_box
    ` SYS_MSG? 2 and if " make_time_box " DISPLAY_TIME? . nl endif 
    DISPLAY_TIME? not if :exit endif 
    TIME_SHOWN? if :exit endif
    SYS_MSG? 64 and if "" make_time_box\n" write_err endif
    hide_xyz_box  ` don't show both at same time    
    "" Time"  8  6 130 24 2000 make_center_text
              8 30 130 24 TIME_BOX_CTRL make_sunken_box
    1 == TIME_SHOWN?
   ;
               
: set_time_box
    DISPLAY_TIME? not if drop :exit endif
    make_time_box
    TIME_BOX_CTRL swap -1 -1 glcd_control_text drop ;     ` <"Text:"> set_time_box
: hide_time_box
    SYS_MSG? 64 and if "" hide_time_box\n" write_err endif
    TIME_BOX_CTRL glcd_destroy_control drop 
    TIME_SHOWN? not if :exit endif
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    ` This also Hides the Passes and Depth box
    0 0 140 56 glcd_box  ` This erases part of the screen
    0 == TIME_SHOWN?
;
70 ivar X_OPTION_DIST
: make_zdelta_box
    ` DISPLAY_DELTA? not if :exit endif 
    ZDELTA_SHOWN? if :exit endif
    ZLIFT_SHOWN? if hide_zlift_box endif
    ZDELTA_X ZDEPTH_X = if ZDELTA_X X_OPTION_DIST + == ZDELTA_X endif ` Move ZDelta over if we have too. 
    1 == ZDELTA_SHOWN? 
    small_control_font 
    1303 getmsg parse_title_strings ` "" Z Cut\nDelta" 
    PARSE_STR_1 ZDELTA_X 118 60 12 2000 make_center_text 
    PARSE_STR_2 ZDELTA_X 130 60 12 2000 make_center_text 
                ZDELTA_X 147 60 18 ZDELTA_CTRL make_sunken_box 
    normal_control_font ;
: set_zdelta_box ` <Z Depth> set_zdepth_box
    ` DISPLAY_DELTA? not if fdrop :exit endif 
    make_zdelta_box small_control_font ftoa.units ZDELTA_CTRL swap -1 -1 glcd_control_text drop normal_control_font ;     ` <"Text:"> set_zdelta_box

/* -- Depth during multi-pass job -- */    
: make_depth_box
   DISPLAY_DELTA? not if :exit endif
   1271 getmsg  180 58 130 24 2000 make_center_text  ` "" Depth:"
                180 82 130 24 DEPTH_CTRL make_sunken_box 
;
: set_depth_box
    DISPLAY_DELTA? not if drop :exit endif
    make_depth_box
    ftoa.units DEPTH_CTRL swap -1 -1 glcd_control_text drop ;
: hide_depth_box 
    DEPTH_CTRL glcd_destroy_control drop
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    178 58 142 52 glcd_box  ` This erases part of the screen
;
/* -- Number of passes during a multi-pass job -- */
: make_passes_box 
   DISPLAY_DELTA? not if :exit endif
   1273 getmsg  180  6 130 24 2000 make_center_text  ` "" Passes:"
                180 30 130 24 PASSES_CTRL make_sunken_box
   1 == PASSES_SHOWN?
;
: set_passes_box
    DISPLAY_DELTA? not if drop :exit endif
    make_passes_box
    PASSES_CTRL swap -1 -1 glcd_control_text drop ;
: hide_passes_box
    PASSES_SHOWN? not if :exit endif
    PASSES_CTRL glcd_destroy_control drop
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    178 5 140 52 glcd_box  ` This erases part of the screen
    0 == PASSES_SHOWN?
;
/* -- Spindle RPM -- */
: make_rpm_box
    DISPLAY_RPM? not if :exit endif
    SPINDLE_CODE not if :exit endif ` if spindle is not configured, don't display box
    RPM_SHOWN? if :exit endif 
    1 == RPM_SHOWN? 
    small_control_font
    1311 getmsg parse_title_strings  ` "" RPM"
    PARSE_STR_1 RPM_X 118 60 12 2000 make_center_text 
    PARSE_STR_2 RPM_X 130 60 12 2000 make_center_text 
                RPM_X 147 60 18 RPM_BOX_CTRL make_sunken_box 
    normal_control_font ;
: set_rpm_box ` <Cut Speed> set_feed_box
    DISPLAY_RPM? not if drop :exit endif
    SPINDLE_CODE not if drop :exit endif ` if spindle is not configured, don't display box
    make_rpm_box small_control_font itoa RPM_BOX_CTRL swap -1 -1 glcd_control_text drop normal_control_font ;     ` <float feedrate> set_rpm_box

: make_xyz_box
    SYS_MSG? 64 and if "" make_xyz_box\n" write_err endif
    hide_time_box    
    "" X"   5   6  30 24 2000 make_center_text
    "" Y"   5  40  30 24 2000 make_center_text
           38   7 100 24 XCOORD_CTRL make_sunken_box ` X 
           38  41 100 24 YCOORD_CTRL make_sunken_box ` Y 
    1 == XYZ_SHOWN?
;
 0 ivar LAST_XY_DISPLAY
80 ivar JOG_UPDATE_TIME 
: update_xyz_box
    get_rtc_clk LAST_XY_DISPLAY - JOG_UPDATE_TIME < if :exit endif  ` only update every 80 msec.
    get_rtc_clk == LAST_XY_DISPLAY
    get_soft_home?                  ` get current value of soft homes
    ` f2drop fdrop     
    2 get_pos? fswap f- ftoa.units ZCOORD_CTRL swap -1 -1 glcd_control_text drop
    1 get_pos? fswap f- ftoa.units YCOORD_CTRL swap -1 -1 glcd_control_text drop
    0 get_pos? fswap f- ftoa.units XCOORD_CTRL swap -1 -1 glcd_control_text drop
;
' update_xyz_box 15 glcd
: refresh_xyz_box 0 == LAST_XY_DISPLAY update_xyz_box ;
: update_xyz_box_when_moving
    loop
        mpg_active? 15 and while 
        update_xyz_box
    repeat
    refresh_xyz_box 
;
: hide_xyz_box
    XCOORD_CTRL glcd_destroy_control drop ` X
    YCOORD_CTRL glcd_destroy_control drop ` Y
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    0 0 142 80 glcd_box  ` This erases part of the screen
    0 == TIME_SHOWN? 
    0 == XYZ_SHOWN?
;
: show_z_box
    XYZ_SHOWN? if 
        hide_xyz_box 
    else 
        XCOORD_CTRL glcd_destroy_control drop ` X
        YCOORD_CTRL glcd_destroy_control drop ` Y
    endif
    hide_time_box 
    "" Z"   5   6  30 24 2000 make_center_text
           38   7 100 24 ZCOORD_CTRL make_sunken_box ` Z
    refresh_xyz_box
    ` 13  22 kdm_key_table ` map the Z key to exit so we can get out of jogging
;
: hide_z_box
    ZCOORD_CTRL glcd_destroy_control drop ` Z
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    0 0 142 80 glcd_box  ` This erases part of the screen
    0 == TIME_SHOWN? 
    0 == XYZ_SHOWN?
    make_xyz_box
    refresh_xyz_box
    ` 44 22 kdm_key_table ` map the Z key to exit so we can get out of jogging
;


word kdm_lines
: make_idle_screen
    SYS_MSG? 64 and if "" make_idle_screen\n" write_err endif
    ` 2000 glcd_destroy_group drop
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    3 kdm_lines
    0 == FRO_SHOWN?     FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == FEED_SHOWN?    FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == ZDEPTH_SHOWN?
    0 == ZDELTA_SHOWN? 
    0 == ZLIFT_SHOWN?
    0 == RPM_SHOWN?
    0 == TIME_SHOWN?
    0 == XYZ_SHOWN?
    0 == PASSES_SHOWN?
    
    0 0 320 168 glcd_box  ` This erases part of the screen 
    hide_time_box ` just in case it was shown
    hide_passes_box
    hide_depth_box
    make_xyz_box
    8 == X_OPTION_LOC  ` location to place display option
    DISPLAY_CUTSPEED? if 
        X_OPTION_LOC == CUTSPEED_X  ` location to display feed box.
        make_feed_box   XYDN_FEED TIMESCALE f* 0 get_current_fro? f* set_feed_box
        X_OPTION_LOC X_OPTION_DIST + == X_OPTION_LOC  ` move over for next option
    endif
    DISPLAY_FRO? if 
        X_OPTION_LOC == FRO_X  ` location to display feed box.
        make_fro_box  set_fro_box
        X_OPTION_LOC X_OPTION_DIST + == X_OPTION_LOC  ` move over for next option
    endif
    ?CONTROLLED_Z if
        DISPLAY_ZDEPTH? if
            X_OPTION_LOC == ZDEPTH_X
            make_zdepth_box
            Z_DEPTH set_zdepth_box
            X_OPTION_LOC X_OPTION_DIST + == X_OPTION_LOC  ` move over for next option
        endif
        DISPLAY_DELTA? if 
            X_OPTION_LOC == ZDELTA_X  ` this vale is display when running job, mark where it will be displayed.
            X_OPTION_LOC X_OPTION_DIST + == X_OPTION_LOC  ` move over for next option
            ` MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or if
                make_zdelta_box
                MP_BITESIZE MPJ_BITESIZE fmax set_zdelta_box
            ` endif
        endif
        DISPLAY_ZLIFT? if
            X_OPTION_LOC == ZLIFT_X
            make_zlift_box
            Z_LIFT set_zlift_box
            X_OPTION_LOC X_OPTION_DIST + == X_OPTION_LOC  ` move over for next option
        endif
    endif
    SPINDLE_CODE if
        DISPLAY_RPM? if 
            ` X_OPTION_LOC == RPM_X
            248 == RPM_X  ` hard-code to corner.
            make_rpm_box
            iSPINDLE_SPEED set_rpm_box
        endif
    endif
    BOOTING? not if 
        refresh_xyz_box
        1 1 320 145 - 5 glcd_resource  ` smaller resource if RPM's are displayed. 
        ` DISPLAY_RPM? X_OPTION_LOC 200 > or if 
        `     1 1 320 145 - 5 glcd_resource  ` smaller resource if RPM's are displayed. 
        ` else
        `     1 2 320 167 - 0 glcd_resource  
        ` endif
    endif 
;
0 ivar PRE_JOB_INFO_LOC
: show_pre_job_info  ` <0/1> show_pre_job_info
    if   1 == PRE_JOB_INFO_LOC
    else 0 == PRE_JOB_INFO_LOC
    endif
    
    JOB_TOOL_NUMBER -1 <> if
        small_control_font
        PRE_JOB_INFO_LOC if
        ` This is when we are showing the job on the job prevew screen.
            "" Spindle" 242 30 60 18 2000 make_center_text 
                        242 50 60 26 SPINDLE_ID_CTRL make_sunken_box
        else
            "" Spindle" 8 63 60 18 2000 make_center_text 
                        8 82 60 26 SPINDLE_ID_CTRL make_sunken_box
        endif
        normal_control_font
        SPINDLE_ID_CTRL JOB_TOOL_NUMBER select => "" Left" => "" Right" => "" Both" default=> JOB_TOOL_NUMBER itoa endselect -1 -1 glcd_control_text drop
    endif
    
    ` HOME #
    ` UPPERLEFT   = 1
    ` CENTER      = 2
    ` UPPER RIGHT = 3
    ` LOWER LEFT  = 4
    ` LOWER RIGHT = 5

    JOB_HOME_NUMBER -1 <> if 
        small_control_font
        PRE_JOB_INFO_LOC if
            ` This is when we are showing the job on the job prevew screen.
            "" Home"    242  90 60 18 2000 make_center_text
                        JOB_HOME_NUMBER 2 = if
                            ` Check for Center and only make 1 control
                            242 110 60 26 HOME_CTRL1 make_sunken_box  
                        else
                            242 110 60 26 HOME_CTRL1 make_sunken_2line_box  ` this makes 2 controls
                        endif
        else
            ` This is showing the job on the Run Screen
            "" Home"    78 63 60 18 2000 make_center_text
                        JOB_HOME_NUMBER 2 = if 
                            ` check for Center and only make 1 control
                            78 82 60 26 HOME_CTRL1 make_sunken_box  
                        else
                            78 82 60 26 HOME_CTRL1 make_sunken_2line_box  ` this makes 2 controls
                        endif
        endif
        JOB_HOME_NUMBER select
            => HOME_CTRL1 "" Upper" -1 -1 glcd_control_text drop 
               HOME_CTRL2 "" Left"  -1 -1 glcd_control_text drop
            => HOME_CTRL1 "" Center" -1 -1 glcd_control_text drop
            => HOME_CTRL1 "" Upper" -1 -1 glcd_control_text drop 
               HOME_CTRL2 "" Right"  -1 -1 glcd_control_text drop
            => HOME_CTRL1 "" Lower" -1 -1 glcd_control_text drop 
               HOME_CTRL2 "" Left"  -1 -1 glcd_control_text drop
            => HOME_CTRL1 "" Lower" -1 -1 glcd_control_text drop 
               HOME_CTRL2 "" Right"  -1 -1 glcd_control_text drop
            default=> HOME_CTRL1 JOB_HOME_NUMBER itoa -1 -1 glcd_control_text drop
         endselect
         normal_control_font
    endif
;
: hide_pre_job_info
    HOME_CTRL1      glcd_destroy_control drop 
    SPINDLE_ID_CTRL glcd_destroy_control drop
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    ` This also Hides the Passes and Depth box
    6 60 140 55 glcd_box  ` This erases part of the screen
;
: make_run_screen
    ` 2000 glcd_destroy_group drop
    SYS_MSG? 64 and if "" make_run_screen\n" write_err endif
    BGCOLOR glcd_bg BGCOLOR glcd_fg
    0 0 320 180 glcd_box 
    0 == ZDEPTH_SHOWN?
    0 == ZDELTA_SHOWN? 
    0 == ZLIFT_SHOWN? 
    0 == FRO_SHOWN?    FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == FEED_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == RPM_SHOWN?
    0 == XYZ_SHOWN?
    0 == TIME_SHOWN?
    
    3 kdm_lines
    ` make_shift_icon
    make_time_box 0 TimeToStrRaw set_time_box
    make_feed_box
    make_fro_box
    ` do not display logo if we are displaying number of passes.
    DISPLAY_ZDEPTH? not if 
        MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or not if
            1 1 320 145 - 5 glcd_resource  ` smaller resource if RPM's are displayed. 
            ` DISPLAY_RPM? X_OPTION_LOC 200 > or if 
            `     1 1 320 145 - 5 glcd_resource  ` smaller resource if RPM's are displayed.
            ` else
            `     1 2 320 167 - 0 glcd_resource ` display logo
            ` endif
        endif
    endif
    ?CONTROLLED_Z if
        make_zdepth_box
        make_zlift_box
        DISPLAY_DELTA? if 
            MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or if
                make_zdelta_box  
            endif
        endif
        make_passes_box
    endif
    248 == RPM_X  ` hard-code RPM display to corner.
    make_rpm_box
    EXECUTING? if
        ` clear variables so the screen is updated.
        -1.0 == PREV_Z_DEPTH_PASS
          -1 == PREV_MP_PASSES
           0 == PREV_JOB_TIME
    endif
    
    0 show_pre_job_info
    
    ` [ SHOW_PREVIEW_JOB ] #ifdef   
        HAVE_SAVE_REGION? if
           glcd_restore_region drop ` copy the screen where we drew the image.
        endif
    ` #endif
 
;

0 ivar SAVE_TEXT_COLOR
: disable_multipass_option
    6016 glcd_disable_control drop  ` "" Delta"
    6018 glcd_disable_control drop  ` Delta value
    6020 glcd_disable_control drop 6021 glcd_disable_control drop  ` By Job
    6022 glcd_disable_control drop 6023 glcd_disable_control drop  ` By Contour
;
: enable_multipass_option
    6016 glcd_enable_control drop  ` "" Delta"
    6018 glcd_enable_control drop  ` Delta value
    6020 glcd_enable_control drop 6021 glcd_enable_control drop  ` By Job
    6022 glcd_enable_control drop 6023 glcd_enable_control drop  ` By Contour
;
0 ivar ACTIVE_CONTROL
0 ivar MP_BY_JOB?
0 ivar MP_ENABLED?
0.0 fvar TEMP_Z_DEPTH ` temp value in case the user presses CANCEL. 
0.0 fvar TEMP_Z_DELTA
: show_active_cut_depth_control ` < control > show_active_cut_depth_control
    ACTIVE_CONTROL 1 max 7 min select
    => 6011 glcd_deactivate_control drop  ` Z Depth
    => 6014 glcd_deactivate_control drop  ` Multi-pass
    => 6018 glcd_deactivate_control drop  ` Z Delta
    => 6021 glcd_deactivate_control drop  ` By Job
    => 6023 glcd_deactivate_control drop  ` By Contour
    => 6025 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` SAVE button
    => 6027 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect
    
    == ACTIVE_CONTROL
    ACTIVE_CONTROL 1 max 7 min select
    => 6011 glcd_activate_control drop  ` Z Depth
    => 6014 glcd_activate_control drop  ` Multi-pass
    => 6018 glcd_activate_control drop  ` Z Delta
    => 6021 glcd_activate_control drop  ` By Job
    => 6023 glcd_activate_control drop  ` By Contour
    => 6025 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` SAVE button
    => 6027 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect
;
: change_cut_depth_dialog_value
    ACTIVE_CONTROL 1 max 7 min select
    => 5 == bFVAR_NUM Z_DEPTH 6011 EnterGetNum 0 = if == TEMP_Z_DEPTH else fdrop endif ` Z Depth
    => MP_ENABLED? not == MP_ENABLED? 
    => 5 == bFVAR_NUM MP_BITESIZE MPJ_BITESIZE fmax 6018 EnterGetNum 0 = if == TEMP_Z_DELTA else fdrop endif ` Z Delta
    => 6021 glcd_activate_control drop 6023 glcd_deactivate_control drop  1 == MP_BY_JOB? ` By Job
    => 6023 glcd_activate_control drop 6021 glcd_deactivate_control drop  0 == MP_BY_JOB? ` By Contour
    => 6025 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` SAVE button
    => 6027 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect    
;
: update_cut_depth_dialog
    6011 TEMP_Z_DEPTH ftoa.units -1 -1 glcd_control_text drop                
    6018 TEMP_Z_DELTA ftoa.units -1 -1 glcd_control_text drop
    MP_ENABLED? if
        enable_multipass_option
        6014 "" X" -1 -1 glcd_control_text drop    
    else
        6014 "" " -1 -1 glcd_control_text drop     
        disable_multipass_option
    endif
    MP_BY_JOB? if
        6020 glcd_activate_control drop    ` By Job
        6022 glcd_deactivate_control drop  ` By Contour
    else
        6020 glcd_deactivate_control drop    ` By Job
        6022 glcd_activate_control drop  ` By Contour
    endif
    
;
: cut_depth_dialog_handle_keys
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         -1 == iLastKey
         dup  58 = if 6 show_active_cut_depth_control endif ` Start KEY, force ENTER key
         dup  186 = over 171 = or over 141 = or if drop 1 break endif     ` get out on key release so the button shows hi-lighted first.
         dup  43 = over 13 = or if 7 show_active_cut_depth_control endif ` force CANCEL key
         dup  12 = if ACTIVE_CONTROL 6 >= if drop 1 break endif -1 == PASSED_IN_NUMBER change_cut_depth_dialog_value endif  ` enter key - drop old value and exit loop
         dup  25 = over 15 = or if ACTIVE_CONTROL 1- 1 max MP_ENABLED? not if dup 5 = if drop 2 endif endif show_active_cut_depth_control endif
         dup  24 = over 26 = or if ACTIVE_CONTROL 1+ 7 min MP_ENABLED? not if dup 3 = if drop 6 endif endif show_active_cut_depth_control endif
         dup  11 = if dup == PASSED_IN_NUMBER change_cut_depth_dialog_value endif ` minus sign
         dup  40 = if dup == PASSED_IN_NUMBER change_cut_depth_dialog_value endif ` decimal pt
         dup  0 >= over 9 <= land if dup == PASSED_IN_NUMBER change_cut_depth_dialog_value endif  
         drop
         iLastKey 58 = if 6 show_active_cut_depth_control endif
         iLastKey 43 = if 7 show_active_cut_depth_control endif 
         update_cut_depth_dialog
      endif
    repeat
;
: make_cut_depth_dialog
    normal_control_font
    InitScrollMessage
    2 fprec
    AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL
    -2 scroll_buffer 1007 getmsg 0 DLG_MsgBox ` "" Z Cut Depth"
    cTEXT_COLOR == SAVE_TEXT_COLOR
    cBLACK == cTEXT_COLOR
    "" Z Depth"  DLG_XPOS   5 + DLG_YPOS 40 + mover slen 2 + 12 * 20 6010 make_center_text_dlg
                 DLG_XPOS 105 + DLG_YPOS 40 + 80 20 6011 make_sunken_box_dlg
    6010 2001 glcd_control_group drop ` change group control number
    
    ` spaces at front are for check box.
    ""   Multi-Pass" DLG_XPOS 10 + DLG_YPOS 90 + DLG_WIDTH 20 - 70 6012 make_group_box_dlg
    small_control_font
    DLG_XPOS 25 + DLG_YPOS 82 + 15 15 6014 make_sunken_box_dlg
    ` Use 6014 "" X" 8 2 glcd_control_text drop to set to on.
    6012 2001 glcd_control_group drop ` change group control number
    6013 2001 glcd_control_group drop ` change group control number
    
    normal_control_font
    "" Z Delta"  DLG_XPOS 20 + DLG_YPOS 110 + mover slen 12 * 20 6016 make_center_text_dlg
                 DLG_XPOS 20 + DLG_YPOS 132 + 80 20 6018 make_sunken_box_dlg
    6016 2001 glcd_control_group drop ` change group control number
    
    ` <X> <Y> <"Text"> <control #> DLG_Select_Radio
    DLG_XPOS 145 + DLG_YPOS 102 + "" By Job"     6020 DLG_Select_Radio
    DLG_XPOS 145 + DLG_YPOS 130 + "" By Contour" 6022 DLG_Select_Radio
    
    ` <X> <Y> <"Text"> <control #> DLG_Select_Button
    DLG_XPOS  12 + DLG_YPOS 180 + 1307 getmsg 6025 DLG_Select_Button ` ""   OK  "
    DLG_XPOS 180 + DLG_YPOS 180 + 1308 getmsg 6027 DLG_Select_Button ` "" Cancel"
    
    SAVE_TEXT_COLOR == cTEXT_COLOR
    
    MP_BITESIZE MPJ_BITESIZE fmax == TEMP_Z_DELTA
    Z_DEPTH == TEMP_Z_DEPTH
    
    ` find out if multi-pass is by job or not.
    MPJ_BITESIZE 0.0 f> if 1 == MP_BY_JOB? else 0 == MP_BY_JOB? endif
    TEMP_Z_DELTA 0.00001 f> if 1 == MP_ENABLED? else 0 == MP_ENABLED? endif

    ` <x> <y> <xsize> <ysize> <code> make_sunken_box
    ` <"text"> <X> <Y> <width> <height> <control number> make_group_box
    update_cut_depth_dialog
    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    1 == ACTIVE_CONTROL
    1 show_active_cut_depth_control
    
    cut_depth_dialog_handle_keys
    
    save_kdmintr if kon endif
    
    1 = if ` ENTER Pressed
        ACTIVE_CONTROL 6 = if
            TEMP_Z_DEPTH == Z_DEPTH
            MP_ENABLED? if
                MP_BY_JOB? if TEMP_Z_DELTA == MPJ_BITESIZE 0.0 == MP_BITESIZE 
                else    0.0 == MPJ_BITESIZE TEMP_Z_DELTA == MP_BITESIZE 
                endif
            else
                0.0 == MP_BITESIZE
                0.0 == MPJ_BITESIZE
            endif
        endif ` OK button
        ACTIVE_CONTROL 7 = if endif ` CANCEL button
    else   ` Cancel Pressed
        ACTIVE_CONTROL 6 = if endif ` OK button
        ACTIVE_CONTROL 7 = if endif ` CANCEL button
    endif
    -1 DLG_DisplayMsgBox
    1060 glcd_destroy_group drop ` main dialog controls
    2001 glcd_destroy_group drop
;
    

: kdm_lines ` <number of lines> kdm_lines
    cWINDOW_COLOR cTEXT_COLOR glcd_window_colors drop
    kdm_clear
    MAX_KDM_LINES min  ` do not allow more than 3.
    ` clear the display first by creating a box the size of the original display.
    BGCOLOR glcd_fg BGCOLOR glcd_bg 0 240 kdm_config? swap drop 18 * - 320 kdm_config? drop 18 * glcd_box
    dup dup 25 kdm_config  ` because of the size of the display, we can have 25 characters across.
    10 over 18 * 240 - neg  9 - /* 177 */ 300 4 pluck 18 * glcd_set_window drop  
     8 over 18 * 240 - neg 11 - /* 175 */ 302 4 pluck 18 * 4 +  2000 make_sunken_box
;
: kdm_erase_line 0 swap pos 1 kdm_config? swap drop 1 step kdm_space endstep ;
` kdm_dsp_status display on inverted message on the bottom of the kdm text screen.
: kdm_dsp_status ` <color number> kdm_dsp_status
    0 kdm_config? drop 1- pos ` only a 3 line display.
    ` 1=Blue, 2=Green, 3=Yellow, 4=Red
    0 max 4 min 1+ select => cWINDOW_COLOR cWHITE => cBLUE cWHITE => cGREEN cWHITE => cYELLOW cBLACK => cRED cWHITE endselect glcd_window_colors drop
    25 center_string kdm_dsp_string
    cWINDOW_COLOR cTEXT_COLOR glcd_window_colors drop ` put colors back
;
` kdm_dsp_message display a message at the bottom of the screen for the specified amount of time. If the time is -1 then it will not erase. 
` Mainly used when in a menu and you want to display a single line message to the user. Limited by 25 characters.
: kdm_dsp_message ` <timeout> <"msg"> <color> kdm_dsp_message
    BGCOLOR glcd_bg
    0 max 4 min 1+ select => cWHITE => cBLUE => cGREEN => cYELLOW => cRED endselect glcd_fg
    25 center_string dup 10 220 glcd_text
    swap dup 0 >= if msd else 2drop :exit endif
    BGCOLOR glcd_fg 10 220 glcd_text
;
100   1 sysallocate ptr pCmdBuffer
: erase_display
    BGCOLOR glcd_bg BGCOLOR glcd_fg 0 0 320 240 glcd_box
    ` "" CL " pCmdBuffer s! BGCOLOR pTEMP 0 iformat pCmdBuffer s+! pCmdBuffer 100 glcd 0 swap 1 step drop endstep
    BGCOLOR BGCOLOR glcd_window_colors drop
    0 == FRO_SHOWN?    FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == FEED_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == ZDEPTH_SHOWN?
    0 == ZDELTA_SHOWN? 
    0 == ZLIFT_SHOWN?
    0 == RPM_SHOWN?
    0 == TIME_SHOWN?
    0 == XYZ_SHOWN?
    0 == PASSES_SHOWN?
    8 == X_OPTION_LOC  ` X location of cut/speed, z cut depth, etc.
;
` Called by firmware after DNC Preview.
: clear_display
    ` glcd <return codes> [ code 1 ] ... [ code n ] <ptr>
    ` 131 is cBLUE
   `  BGCOLOR cBLUE = if "" CL 131" else "" CL 0" endif 100 glcd 0 swap 1 step drop endstep
    SYS_MSG? 64 and if "" clear_display\n" write_err endif
    erase_display ` "" CL " pCmdBuffer s! BGCOLOR pTEMP 0 iformat pCmdBuffer s+! pCmdBuffer 100 glcd 0 swap 1 step drop endstep
    BGCOLOR cWHITE glcd_window_colors drop
    ` <code> <state> <bg> <surface> <border> <bg> glcd_control_color
    0 4 BGCOLOR dup 2dup glcd_control_color drop ` setting the destroy color.
    menu_status? not if make_idle_screen endif 
    
    ` make_shift_icon
    ` make_conx                         ` creates the connection icon.
    ` Show Connection Icon
    ` btNetwork if
        ` Use color of task bar (cBLUE)
    `    btNetwork cBLUE cBLUE   cYELLOW cYELLOW
    `              cBLUE cRED    cRED    cYELLOW
    `              cBLUE cRED    cRED    48      0xff0f glcd_control_colors
    `              btnetworkxpos btnetworkypos glcd_draw_control drop
    ` endif
;
: change_color
    HeaderMenuColors  bury swap 0 gmenu_color_change drop
    ActiveMenuColors  bury swap 1 gmenu_color_change drop
    NormalMenuColors  bury swap 2 gmenu_color_change drop
    cBG_TEXT_COLOR cTITLES cBLACK 3 dlg_config  ` Dialog box colors.
    erase_display ` "" CL " pCmdBuffer s! BGCOLOR pTEMP 0 iformat pCmdBuffer s+! pCmdBuffer 100 glcd 0 swap 1 step drop endstep
    BGCOLOR cWHITE glcd_window_colors drop
    ` <code> <state> <bg> <surface> <border> <bg> glcd_control_color
    0 4 BGCOLOR dup 2dup glcd_control_color drop ` setting the destroy color.
    make_idle_screen
;
: config_colors
    dup 
    0 max 10 min 1+ select
    => ` Default (ocean)
                124 == cHILITE  ` Hi-lite color
                125 == cTITLES  ` color of titles  
                133 == BGCOLOR  ` BackGround Color
                138 == cWINDOW_COLOR      
            cYELLOW == cTEXT_COLOR
            cYELLOW == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 1 (sky)
                159 == cHILITE  ` Hi-lite color
              cNAVY == cTITLES  ` color of titles  
              cBLUE == BGCOLOR  ` BackGround Color
              cNAVY == cWINDOW_COLOR      
             cWHITE == cTEXT_COLOR
             cWHITE == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 2 (cardinal)
                253 == cHILITE  ` Hi-lite color
            cMaroon == cTITLES  ` color of titles  
                208 == BGCOLOR  ` BackGround Color
             cBLACK == cWINDOW_COLOR      
             cWHITE == cTEXT_COLOR
             cWHITE == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 3 (mint)
                190 == cHILITE  ` Hi-lite color
             cGREEN == cTITLES  ` color of titles  
                153 == BGCOLOR  ` BackGround Color 
             cBLACK == cWINDOW_COLOR      
             cWHITE == cTEXT_COLOR
             cWHITE == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 4 (night)
                190 == cHILITE  ` Hi-lite color
               cRED == cTITLES  ` color of titles  
             cBLACK == BGCOLOR  ` BackGround Color 
             cWHITE == cWINDOW_COLOR      
             cBLACK == cTEXT_COLOR
             cWHITE == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 5 (Gold)
                233 == cHILITE  ` Hi-lite color
                144 == cTITLES  ` color of titles  
                212 == BGCOLOR  ` BackGround Color 
                196 == cWINDOW_COLOR      
                144 == cTEXT_COLOR
             cWHITE == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 6 (Silver)
                233 == cHILITE  ` Hi-lite color
                159 == cTITLES  ` color of titles  
                 64 == BGCOLOR  ` BackGround Color 
             cWHITE == cWINDOW_COLOR      
             cBLACK == cTEXT_COLOR
             cBLACK == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 7 (Pine)
                253 == cHILITE  ` Hi-lite color
                136 == cTITLES  ` color of titles  
                132 == BGCOLOR  ` BackGround Color 
                254 == cWINDOW_COLOR      
            cBLACK  == cTEXT_COLOR
            cYELLOW == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 8 (mauve)
                219 == cHILITE  ` Hi-lite color
                151 == cTITLES  ` color of titles  
                145 == BGCOLOR  ` BackGround Color 
                167 == cWINDOW_COLOR      
             cBLACK == cTEXT_COLOR
                247 == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 9 (coral)
                203 == cHILITE  ` Hi-lite color
                135 == cTITLES  ` color of titles  
                129 == BGCOLOR  ` BackGround Color 
                212 == cWINDOW_COLOR      
                221 == cTEXT_COLOR
                171 == cBG_TEXT_COLOR  ` text color for text displayed on background.
    => ` Color Scheme 10 (custom)
         COLOR_SCHEME 10 <> if 
                124 1901 dgi == cHILITE  ` Hi-lite color
                125 1902 dgi == cTITLES  ` color of titles  
                133 1903 dgi == BGCOLOR  ` BackGround Color
                138 1904 dgi == cWINDOW_COLOR      
            cYELLOW 1905 dgi == cTEXT_COLOR
            cYELLOW 1906 dgi == cBG_TEXT_COLOR  ` text color for text displayed on background.
         endif
    endselect
    == COLOR_SCHEME
    change_color
;
: base_config_kdm
    COLOR_SCHEME config_colors
    
    glcd_clear_controls drop
    BGCOLOR glcd_fg BGCOLOR glcd_bg 0 0 320 240  glcd_box
    0 == iShiftIcon
    0 == iTaskBar
    
    LANGUAGE_FILE file_size 0 > if
        10 2 300 60 glcd_set_window drop
    else
        ` <X loc> <Y loc> <width> <height> glcd_set_window --> <status>
        `  Creates a region to display "keypad like" text items. <width> and <height> are in screen pixels
        `  the number of rows and columns will be determined by the maximum extents of the appropriate font chain.
        ` 0 0 240 72 glcd_set_window drop
        ` 2 1 glcd_set_window_font_chain ` This is the Text Window font.
        2 1 glcd_set_window_font_chain ` This is the Text Window font.
        ` 2 3 0 3 glcd_set_window_font_chain ` This is the Text Window font.
    endif
    2 1 glcd_set_window_font_chain    ` This is the Text Window font.
    2 1 glcd_set_controls_font_chain  ` This is the Menu Font.
    2 1 glcd_set_font_chain           ` This is the glcd_text Font.
    
    /* -- Menu Colors -- (if you change these, change make_isubmenu too) */
    ` <letters> <backgrounds> <border> <0,1,2> gmenu_color_change  0=header, 1=active, 2=normal.

    /* -- Original Blue,Green Colors -- */
    ` cWHITE  BGCOLOR BGCOLOR 0 gmenu_color_change  ` Header
    ` cRED    140     cWHITE  1 gmenu_color_change  ` Active
    ` cWHITE  cBLUE   cWHITE  2 gmenu_color_change  ` Normal

   `  cWHITE  cBLUE   cWHITE  3 gmenu_color_change  ` Disabled (use menu_add_disabled or submenu_add_disabled)

    HeaderMenuColors  bury swap 0 gmenu_color_change drop
    ActiveMenuColors  bury swap 1 gmenu_color_change drop
    NormalMenuColors  bury swap 2 gmenu_color_change drop
    
    cYELLOW cTITLES cBLACK 3 dlg_config  ` Dialog box colors.
    2 1  12 dlg_config   ` default control font chain
    2 1  14 dlg_config   ` font for dialog box body text 
    0 1  15 dlg_config   ` font for dialog box button text
      20 19 dlg_config   ` Dialog body line spacing in pixels  
    

    ` 110 cWHITE cBLACK 7 dnc_cmd ` set the DNC normal color
    `  50    110 cBLACK 8 dnc_cmd ` set the DNC Active Color

    0 224 0 140 glcd_set_palette    ` Change palette slightly to get better color.
    ` 8 63 64 126 glcd_set_palette
    0 100 100 125 glcd_set_palette    ` Title color, darker TEAL color
    110 230 230 124 glcd_set_palette  ` Menu Hi-lite color
    
    3 kdm_lines
;

: conx_chg 
    dup -1 <= if 
        drop
        menu_status? if menu_leave endif ` get out of menu if current in menu 
        base_config_kdm
        clear_display
        make_idle_screen
        -1 kdm_stroke
    else 
        == conx_status gui_conx_chg safe_execute 
    endif 
;
0 set_warning
` Careful, there are two of these macro defined in this init file.
: menu_exit /* clear_display */
    SYS_MSG? 64 and if 
        "" menu_exit EXECUTING? " write_err EXECUTING? write_err_num 
        ""  SaveLDNC " write_err SaveLDNC write_err_num
        ""  LOADING_LDNC? " write_err LOADING_LDNC? write_err_num
        ""  menu_status " write_err menu_status? write_err_num
        write_err_nl 
        endif 
    20 millisecond_delay 
    EXECUTING? 1 and not menu_status? not land IN_CYCLE_START? not land SaveLDNC not land if 
        make_idle_screen 
    else 
        EXECUTING? if
            make_run_screen
        endif 
    endif
    menu_status? not IN_CYCLE_START? not land LOADING_LDNC? not land SaveLDNC not land if kdm_dsp_rev endif   
    ifexists menu_exit menu_exit
    0 == LOADING_LDNC?
;
1 set_warning
/* dnc stuff  */
` JNS Responds to the S8 commands via Port23 in the following format
` <FileCount><FileStartIndex><~ FolderRelativeToDNCRoot~><0> dnc_begin
` <ModifiedTime><FileSize> 101 jc_msg <FileNameDisplayString>|<FilePathRelativeToDNCRoot>
` <FileEndIndex><Flags><0> dnc_end  (If (Flags&0x01) there are more files in the folder)
: jc_msg dup 101 = if drop false == DNC_LOADING? dnc_file
       else  100 = if shape_file else drop fdrop clear_eol endif
       endif
;
3 led_on    ` BOOT LOCATION 1

: config_kdm  ` KDM20G
    ` KEYPAD_TYPE 0x350000 kdm_init   ` just to enable channel, enable JOG ADV, USE LINE
    ` KEYPAD_TYPE 0x310000 kdm_init     ` just to enable channel, enable JOG ADV, USE LINE
    
   ` These need to be fixed in the KDM ROM
   ?CONTROLLED_Z if 
       28 22 kdm_key_table  ` Z Jog
   else
       44 22 kdm_key_table  ` Z Jog
   endif
   44 12 kdm_key_table
   ` 44 10 kdm_key_table  ` FAST key
   ` 12 12 kdm_key_table  ` Enter key

    7 1 2 20 menu_config
    
    base_config_kdm

    ` Grab the version of the Resource file
    btNetworkResource resource_info dup -1 <> if == RESOURCE_VER drop drop else drop endif

    koff
    12 kdm_menu_enter_key             ` start the menu
    13 kdm_menu_exit_key              ` causes the menu to exit
    12 kdm_menu_exec_key              ` execute menu item at cursor location
    erase_display
    clear_display
    
    300 set_dlg_width

    ` <mode> <cmd 4=scroll bar> glcd_menu_util  <mode 0=no scroll bar, 1=scroll bar when needed, 2=scroll bar always>
    1 4 glcd_menu_util  drop  ` Show Scroll bar if necessary. (The scroll bar color follows the Menu Header color)

;
` config_kdm
KDM20G? #ifdef
` 0 0
 2  1 kdm_key_table `  1  1  
 3  2 kdm_key_table `  2 24
` 3 3
 5  4 kdm_key_table ` 4 15
 6  5 kdm_key_table ` 5 5
` 6 26
 8  7 kdm_key_table ` 7 7
 9  8 kdm_key_table ` 8 25
24  9 kdm_key_table ` 9 9
12 10 kdm_key_table ` 10 12
` 11 14
` 12 44
 0 13 kdm_key_table ` 13 11
13 14 kdm_key_table ` 14 40
` 15 21
26 16 kdm_key_table ` 16 43
 7 17 kdm_key_table ` 17 38
58 18 kdm_key_table ` 18 37 (start key)
` 19 39
` 20 20
` 21 21
11 22 kdm_key_table ` 22 28
` 23 23
` 24 24
` 25 60
` 26 61
` 27 62
` 28 63
` 29 64
` 30 65
15 31 kdm_key_table ` 31 66
` 32 45
` 33 46
` 34 47
` 35 48
` 36 49
` 37 58
 4 38 kdm_key_table ` 38 59
 1 39 kdm_key_table ` 39 70
` 40 71
` 41 72
25 42 kdm_key_table ` 42 73
28 43 kdm_key_table ` 43 74  (jog Z)
` 44 30
` 45 31
` 46 32
` 47 33
` 48 34
` 49 35
#endif

#endif
/* **** end KDM20G */

word find_limits
word key_func6
word DNCEndOfJob
word DNCStart
word self_test
word slew_mode

5 led_on    ` BOOT LOCATION 2

` Application utility functions
: vs vocabsearch ;
: AltChannelOpen 173 wchar wchar ;                ` accepts [Channel#] on ISP
: AltChannelClose 172 wchar ;
: inch_to_mm UNITS if 25.4 f* endif ;
: mm_to_inch UNITS if 25.4 f/ endif ;
: units_decpt UNITS if 2 else 3 endif ;
: units_str 200 get_string ; ` "" mm,   in."
3.97887 inch_to_mm fvar CYL_FACTOR       ` the cylindrical factor in inches

: chk_motion?       mpg_active? 0x1FFFF and ;  ` doing motion
: chk_any_motion?   mpg_active? 0x30000 and ;  ` any type of motion enabled
: chk_pause_motion? mpg_active? 0x20000 and ;
: chk_pause?        host_mode?  0x0100 and ;   ` see if in pause_wait
: clr_pause_flag    host_mode?  0x0100 1com and host_mode ;
: in_hpgl?          hpgl_mode?  0x8000 and ;
: in_cnc?           cnc_mode?   0x8000 and ;

: in_cito? in_hpgl? in_cnc? or not ;
: trace_macro nl nl " Executing: " 1+ s. s ;
: in_hpgl3d? in_hpgl? hpgl_mode? 2 and land ;
: in_cnc3d? in_cnc? cnc_mode? 2 and land ;
: in_3d? in_hpgl3d? in_cnc3d? or bUCito3D if 1 else 0 endif or ;   ` added bUCito3d to track 3d in uCito jobs
: 3AX? NUM_AXES 3 = ;
: 3zero 3AX? if 0. endif ;
` etcx #ifdef
` 0 set_warning
` : restart? 8 restart_cmd dup "" State = " write_err write_err_num "" \n" write_err ;
` : restart_cmd dup "" Restart cmd = "  write_err write_err_num  "" \n" write_err restart_cmd ;
` 1 set_warning
` #endif
` etcx not #ifdef
: restart? 8 restart_cmd ;
` #endif
: num_ok dup if 2 = if 0 else 1 endif endif ;
: limits? 109 port_input? ;
: limits_valid? ?NC_LIMITS ;

: coords_2d? coords? fdrop ;
: coord_Z? coords? fbury f2drop ;

: VPSoftHome VPXHome X_HOME X_TOOL_OFFSET f- f+
             VPYHome Y_HOME Y_TOOL_OFFSET f- f+
             VPZHome Z_SURFACE               f+ set_soft_home ;
` do not zero surface, keep as is (2.32).  As of 2.15, it zeroed surface.
: do_set_home X_HOME X_TOOL_OFFSET f- Y_HOME Y_TOOL_OFFSET f- Z_SURFACE set_soft_home
    0.0 == VPXHome 0.0 == VPYHome 0.0 == VPZHome ;
: ssf_3d == Y_HOME == X_HOME do_set_home ;
: #set_home
    CYL_MODE? if      ` Check if in Cylindrical or Flat and set the appropriate flag
        1 == ?HOMESET_CYL
    else
        1 == ?HOMESET
    endif
    0. 0. 0. set_soft_home
    coords_2d?
    ssf_3d
;
: #clr_home
    CYL_MODE? if      ` Check if in Cylindrical or Flat and reset the appropriate flag
        0 == ?HOMESET_CYL
    else
        0 == ?HOMESET
    endif
    0. 0. ssf_3d
;
0 set_warning
: set_soft_home fdrop ssf_3d ;
: .soft_home? get_soft_home? frot f. sp. fswap f. sp. f. nl ;
1 set_warning
: z_limit Z_SURFACE fneg fmax ;
true ivar checkstack?
: stack_check
    checkstack? if
    ` check for potential stack problems on every pendown...
        #istk 1- iIStackDepth <> if nl "" ->WARNING: Possible IStack error (depth " dup AddErrorMsg s. #istk 1- dup AddErrorNum . "" )" dup s. AddErrorMsg endif
        #fstk iFStackDepth <> if nl "" ->WARNING: Possible FStack error (depth " dup AddErrorMsg s. #fstk dup AddErrorNum . "" )" dup s. AddErrorMsg endif
        stk_check                                           ` firmware command to warn of pending stack overflows
    endif
;


  0 ivar LaxisX
  1 ivar LaxisY
  2 ivar LaxisZ
  3 ivar LaxisC

0 ivar DriveX
1 ivar DriveY
2 ivar DriveZ
3 ivar DriveC

: estop_on           103 1 0 pset_bits 100 msd ;   ` need delay for everything to stabilize
: estop_on_no_delay  103 1 0 pset_bits ;  ` This no delay one is used for the start_motion version because of jogging.
: sdl show_drive_laxis ;

: irron     106 256 0 pset_bits ;
: irroff    106 0 256 pset_bits ;
: fanon     120 128 0 pset_bits ;
: fanoff    120 0 128 pset_bits ;
irron

: pulse_enable                              `  Dual X pulse enable.
    1 max 3 min select
        =>  0 DriveX drive_map 15 DriveC drive_map ` 1st X on
        => 15 DriveX drive_map  0 DriveC drive_map ` 2nd X on = Z
        =>  0 DriveX drive_map  0 DriveC drive_map ` both on
    endselect
;

: Mot3x   LaxisX DriveZ drive_map ;
: Mot3y   LaxisY DriveZ drive_map ;
: Mot3z   LaxisZ DriveZ drive_map ;
: Mot3on  get_drive_enable 4 or drive_enable ;
: Mot3off get_drive_enable 4 1com and drive_enable ;

` Fourth Axis Controls
: Mot4x    LaxisX DriveC drive_map ;
: Mot4y    LaxisY DriveC drive_map ;
: Mot4z    LaxisZ DriveC drive_map ;
: Mot4on   get_drive_enable 8 or drive_enable ;
: Mot4off  get_drive_enable 8 1com and drive_enable ;

: Mot1FP   4 0 drive_power ;                ` Drive 1 at full current - Manual power control
: Mot1HP   2 0 drive_power ;                ` Drive 1 at 1/2 current - Manual power control
: Mot1QP   1 0 drive_power ;                ` Drive 1 at 1/4 current - Manual power control
: Mot1A    7 0 drive_power ;                ` Drive 1 utilizing AUTOMATIC current reduction

: Mot2FP   4 1 drive_power ;                ` Drive 2 at full current - Manual power control
: Mot2HP   2 1 drive_power ;                ` Drive 2 at 1/2 current - Manual power control
: Mot2QP   1 1 drive_power ;                ` Drive 2 at 1/4 current - Manual power control
: Mot2A    7 1 drive_power ;                ` Drive 2 utilizing AUTOMATIC current reduction

: Mot3FP   4 2 drive_power ;                ` Drive 3 at full current - Manual power control
: Mot3HP   2 2 drive_power ;                ` Drive 3 at 1/2 current - Manual power control
: Mot3QP   1 2 drive_power ;                ` Drive 3 at 1/4 current - Manual power control
: Mot3A    7 2 drive_power ;                ` Drive 3 utilizing AUTOMATIC current reduction

: Mot4FP   4 3 drive_power ;                ` Drive 4 at full current - Manual power control
: Mot4HP   2 3 drive_power ;                ` Drive 4 at 1/2 current - Manual power control
: Mot4QP   1 3 drive_power ;                ` Drive 4 at 1/4 current - Manual power control
: Mot4A    7 3 drive_power ;                ` Drive 4 utilizing AUTOMATIC current reduction


` Quarter or Full power
: monQP Mot1QP Mot2FP Mot3QP Mot4QP ;
: monFP Mot1FP Mot2FP Mot3FP Mot4FP ;

: all_drives_off  0 7 1 step 15 I drive_map endstep ;
all_drives_off
1 pulse_enable
LaxisY DriveY drive_map
mot3z

4. 390 dgf fvar VCur1                       ` logic X Currents expressed in Amps
4. 391 dgf fvar VCur2                       ` xb
4. 392 dgf fvar VCur3                       ` y
4. 393 dgf fvar VCur4                       ` Z

ifexists build_motor_phase 16 0 build_motor_phase                      ` set to 64 level micro-stepping.
ifexists build_motor_phase 16 1 build_motor_phase
ifexists build_motor_phase 16 2 build_motor_phase
ifexists build_motor_phase 16 3 build_motor_phase

ifexists motor_phase_download VCur1 DriveX  motor_phase_download . sp.    ` Set the Drive Current.
ifexists motor_phase_download VCur2 DriveY  motor_phase_download . sp.
ifexists motor_phase_download VCur3 DriveZ  motor_phase_download . sp.
ifexists motor_phase_download VCur4 DriveC  motor_phase_download . sp.                            ` M2564

` <drive> shm
: shm
    ifmissing get_motor_phase drop :exit
    0 63 1 step
        I 16 mod 0 = if nl endif
        ifexists get_motor_phase I over get_motor_phase 5 fill.
    endstep
    drop
;

3 ivar DRIVE_FAULT_MASK
/* **** RPC Section **** */
word check_for_faults
word start_motion
word end_motion
: mon                                                               ` M2564
    0 set_drive_fault_mask              ` clr mask to remove potential estop
    estop_on
    enable_motion disable_motion
    111 port_input? 0x108 and if ` This is the check for the missing motor cable and Drive Fault
        ` "" Check Halt Line kdm_dsp_line 2000 msd
        check_for_faults
        dup nl s. nl word_wrap_string kdm_dsp_line
        10 duty_error ` 200 msd
        :exit
    endif
    Mot3FP  LaxisZ DriveZ drive_map 
    Mot4FP  ` Mot4x                ` Fourth motor optional alternate X
    DRIVE_ENABLE_MASK drive_enable      ` turn on XYZR
    ?FOLLOW_X if LaxisX DriveZ drive_map endif  ` if following X turn on follow x circuit, turn off y&z
    ?FOLLOW_Y if LaxisY DriveZ drive_map endif  ` if following Y
    monQP
    DRIVE_FAULT_MASK DRIVE_ENABLE_MASK and set_drive_fault_mask   ` now enable drive fault interrupts
    ?DISPENSE_ENABLE not if
      PWMREG3 RUSH_CURRENT 0 pset_bits    ` turn on solenoid 3 : main power relay on MILLGRAV
      40 #delay
      PWMREG3 MAINTAIN_CURRENT dup 1com RUSH_CURRENT and pset_bits
    endif
    1 == ?DRIVE_ON
    start_motion 2 delay end_motion ` Workaround an issue where interrupts aren't enabled until the buffer gets flushed.
    ;                            ` initially turn on at Quarter Power

: moff 0 drive_enable                                      ` M2564 
    0 == ?DRIVE_ON
    ;

: cyl_on
    ` Normal Cylindrical setup
        15 DriveX drive_map  ` Unmap X
    LaxisX DriveC drive_map  ` Normal Cylindral axis
    
    ?FOLLOW_X if 
        LaxisX DriveZ drive_map  ` Map Z to X axis if option is enabled. 
    endif 
    ?FOLLOW_Y if
        LaxisY DriveZ drive_map ` Map Y to Z
    endif
    update_pos ;
: cyl_off 
    LaxisX DriveX drive_map
    LaxisY DriveY drive_map
    LaxisZ DriveZ drive_map 
    15 DriveC drive_map 
    ?FOLLOW_X if LaxisX DriveZ drive_map endif 
    ?FOLLOW_Y if LaxisY DriveZ drive_map endif 
    update_pos ;

: pi port_input? "   0x" h. ;
: getLimits 109 port_input? ;               ` read the limit inputs.
: getLimitsRT 116 port_input? ;             ` read the limit inputs (non-latched).

: CtoF 1.8 f* 32. f+ ;                      ` conversion from Celsius to Fahrenheit.
: fault_input? get_drive_fault DRIVE_FAULT_MASK and ;
: inverter_fault_input? 0 ;

: show_temp UNITS if f. "  DegC" else CtoF f. "  DegF" endif nl ;
: stat nl
  ` if booting, remap outdvc so we see what is going on.
  ` BOOTING? if ERRDVC> w@ OUTDVC> wxchg == saved_errdvc endif
   ` " Out Device " LOUTDVC> w@ . nl 
   ` " In Device " LINDVC> w@ . nl 
    " System Port   0 ="  0 pi 0 port_input?
        dup  8 and if "  -pause-" endif
        dup 32 and if "  -halt3-" endif
        dup 64 and if "  -halt-"  endif
        dup 65536 and if "  -ESTOP SUPPRESS-" endif
        drop nl
    " Limit Mask  109 =  0x" 109 pget_bits h. "    Port 110 =  0x" 110 pget_bits h. nl
    " Limits Port 109 =" 109 pi "    Port 110 =" 110 pi nl
    " Pause  Port 116 =" 116 pi 116 port_input?
        dup 32768 and if "  -DR OVERTEMP-" endif
        drop nl
    " Faults Port 111 =" 111 pi 111 port_input?
        dup  1 and if "  -LimitLat-" endif
        dup  2 and if "  -pause-" endif
        dup  4 and if "  -halt-" endif
        dup  8 and if "  -drivefault=0x" 219 port_input? h. " -" endif    ` get additional 564 drive fault info
        dup 0x10 and if "  -driveHaltTemp-" endif
        dup 0x20 and if "  -UnderVoltageHalt-" endif
        dup 0x40 and if "  -OverVoltageHalt-" endif
        ifexists get_estop_enable_mask dup  256 and get_estop_enable_mask 1 and land if " -EstopExt-" endif
        ifexists get_estop_enable_mask dup  512 and get_estop_enable_mask 2 and land if " -EstopKDM-" endif
        ifexists get_estop_enable_mask dup 1024 and get_estop_enable_mask 4 and land if " -EstopInt-" endif
        dup 0x0800 and if "  -EstopRelayOff-" endif
        dup 0x1000 and if "  -DriveFault58-" endif
        drop nl
    " System Port 112 =" 112 pi 112 port_input?
        dup 1024 and if "  -FanOn-" endif
        dup 2048 and if "  -Drives UNLOCKED-" endif
        dup 4096 and if "  -InRush Limited-" endif
        dup 8192 and if "  -QPI Stale-" endif
        drop nl
    " Config Port 155 =" 155 pi sp. 155 port_input?
        dup 0x0010 and if " -nCE.S-" endif
        dup 0x0040 and if " -qdir7-" endif
        dup 0x0080 and if " -qdir8-" endif
        dup 0x0200 and if " -FCOE-" endif
        dup 0x2000 and if " -GFLG-" endif
        dup 0x4000 and if " -GYX-" endif
            0x8000 and if " -LOCK-" endif
        nl
    2 fprec
    " Motor Faults    =  0x" fault_input? h. "    drives enabled = " get_drive_enable . nl
    " Motion Active   =  "   mpg_active? . nl 
    " I/O  Voltage    " 4 get_sys_voltage f. "  vDC" nl
    " High Voltage    " 7 get_sys_voltage f. "  vDC" nl
    ` " PCB Temp        " 0 get_pcb_temp show_temp
    " M Drive 1 Temp  " 0 get_drive_temp show_temp
    " M Drive 3 Temp  " 2 get_drive_temp show_temp
    ` BOOTING? if saved_errdvc OUTDVC> w! endif
;

/* End Motor Control Utilities */

/* job mon stuff */
: jm_setup
    ascii T  "" Time"  0 jm_add_axis drop
             "" LINE"  1 jm_define_srcptr drop  ` This is needed so the yellow highlight is shown in JC.
    ascii X  ""     X" 2 jm_add_axis drop
    ascii Y  ""     Y" 3 jm_add_axis drop
    ascii Z  ""     Z" 4 jm_add_axis drop
    ifexists jm_refresh 400 jm_refresh  ` how often to refresh in milliseconds.
    jm_flush
    ;

192 100 sysallocate ptr outstr
512 103 sysallocate ptr MP_PATH
0 ivar insize
0 ptr  inptr
0 ivar inidx
` <ptr> <max chars> get_input_string <ptr>   (reads curr_line_ptr until it finds 10 or max chars)
: get_input_string
    191 min == insize ` limit to max size of array.
    == inptr
    0 == inidx  ` index into string
    loop
`        inptr inidx + b@ dup 10 = if drop break else outstr inidx + b! endif ` if 10 or 0, get out of loop
        inptr inidx + b@ dup dup 10 = swap 0 = or if drop break else outstr inidx + b! endif ` if 10 or 0, get out of loop
        inidx 1+ dup insize >= if drop break else == inidx endif
    repeat
    0 outstr inidx + b! ` always end with 0
    outstr  ` return ptr to string on stack.
    ;
: jm_init2
    dup MP_PATH s! deallocate ` save away filename for possible previewing
    ifexists jm_init  MP_PATH jm_init drop
    ;
: jm_path
    curr_line_ptr 1+ 256 get_input_string
    MP_PATH s!
    clear_eol
    ifexists jm_init  MP_PATH jm_init drop
    ;
0 set_warning
: post_job_table 
    "" \nJOB_TIME " write_out  
    JOB_TIME 60.0 f* ftoa.2 write_out ` in seconds 
    "" \n" write_out     
    ` " TOOLT_001 "  TOOL_TIME1 f. 0. == TOOL_TIME1 nl
    ` " TOOLT_002 "  TOOL_TIME2 f. 0. == TOOL_TIME2 nl
    post_job_table
  ;
1 set_warning


/* ******* idle processing ******* */
0 ivar #end_time
0 ivar IDLE_STATE
0 ivar TOOL_IDLE_STATE
: stop_idle  0x7FFFFFFF == #end_time 0 == IDLE_STATE ;
: start_idle == IDLE_STATE           0 == #end_time ;

: time_advance  500. f* ftoi get_rtc_clk + == #end_time ;
: advance time_advance	IDLE_STATE 1+ == IDLE_STATE ;
: idle_proc 
    get_rtc_clk #end_time > if
        IDLE_STATE if
            IDLE_STATE 1 min 8 max select
            => 2 led_on  0.3 advance        ` pattern one at 1
            => 2 led_off 0.2 advance
            => 0.6 advance 1 == IDLE_STATE
            => 2 led_on  0.18 advance       ` pattern two at 4
            => 2 led_off 0.15 advance
            => 2 led_on  0.18 advance
            => 2 led_off 0.15 advance
            => 0.6 advance 4 == IDLE_STATE
            endselect
        endif
	endif
	` Add an update to the jogging display. This is needed when we use the Z Jog key. 
	` If we don't have this, then the last jog update is not displayed. 
	` This is partially becuase the update_xyz_box display only displays every 80 msec.
	JOGGING? if 
	    update_xyz_box
	endif
	
	0 ;

: tool_change_idle_proc get_rtc_clk #end_time >
	if TOOL_IDLE_STATE
		if  TOOL_IDLE_STATE 1 and
			if 2 led_on else 2 led_off endif
			0.4 time_advance TOOL_IDLE_STATE 1- == TOOL_IDLE_STATE
        else 2 led_off 0.7 time_advance PEN# 1+ 2* == TOOL_IDLE_STATE
		endif
	endif ;

: chk_passwd
    1114 getmsg kdm_dsp_line ` "" Password: "
    0 kdm_getnum drop 401 gi = ;
ifmissing kdm_check_password : kdm_check_password chk_passwd ;

: powerfail_detect
	?SPINDLE_POWERUP not if
		#PF_ERRS 1+ == #PF_ERRS nl
        3 = if 1902 getmsg s. error2_blink disable_motion  ` 1902 "" Power Fail. "
                   3 == iDNCHaltCode
                   DNCEndOfJob   ` certain errors bypass our end plot so we need do this here as well
        else " Power Glitch # " #PF_ERRS . endif
	else drop
	endif ;

: fpad. ftoa dup slen 10 swap - spaces s. sp. ;
: ipad. itoa dup slen 10 swap - spaces s. sp. ;
: g&d get_pos? fpad. ;  ` get & display
: g&i get_pos? ipad. ;  ` get & display integer

: p0 0 g&d ;    : p1 1 g&d ;    : p2 2 g&d ;
: d0 128 g&i ;  : d1 129 g&i ;  : d2 130 g&i ;
: pall
    4 fprec
    nl " L-Axis  :          X          Y          Z"
    nl " position: " p0 p1 p2
    nl " pulses  : " d0 d1 d2
    nl " coords  : " coords? frot fpad. fswap fpad. fpad.
    nl " softhome: " get_soft_home? frot fpad. fswap fpad. fpad.
;

: axis_name 1+
	select
        => ""  X"
        => ""  Y"
        => ""  Z"
        => ""  R"
        default=> "" -"
	endselect ;
: .axis axis_name dup s. kdm_dsp_string ;

: lim_name 1+ dup 8 < if
    select
		=> ""  X"
		=> ""  Y"
		=> ""  Z"
		=> ""  Xc"
        => ""  U"
		=> ""  W"
        => ""  Over"
        default=> "" Unk"
	endselect
	else drop "" "
	endif ;
: .lim_name lim_name s. ;

: drive_fault_msg 1+
    select 
        => "" X(Phase A) "
        => "" X(Phase B) "
        => "" Y(Phase A) "
        => "" Y(Phase B) "
        => "" Z(Phase A) "
        => "" Z(Phase B) "
        => "" R(Phase A) "
        => "" R(Phase B) "
        default=> "" UNK"
    endselect
;

: .ips
    LIMIT_MASK if
        " Lims=" limits? LIMIT_MASK and
		0 7 1 step dup 1 and if I .lim_name endif 2/ endstep drop
		1 port_input? 1 and if " -Latched " limits_on endif
    else " No Datums Defined. "
	endif ;

: .ipsl
    loop
        nl " Limit:" limits? LIMIT_MASK and
        0 7 1 step dup 1 and if I .lim_name endif 2/ endstep drop
        1 second ?terminal until
    repeat ;

: my_cancel ` do everything cancel does except don't ouput {6}H6{6}
    stop_motion  ` call before all_off, it clears the semaphores. 
    all_off limits_ref  ` pulse LATCHCLR\
    update_pos
    fKDMTimeOut kdm_time_out    
;
    
` -----------------------------------------------------------------------------
`   MACRO: wait_for_ack
`  Description: whenever an error occurs, wait for acknowledgement from user.
` -----------------------------------------------------------------------------
: wait_for_ack kdm_getkey drop  ;

: calc_job_time
    get_rtc_elapsed == END_TIME     ` capture time at end of job
	START_TIME END_TIME < if
        END_TIME START_TIME -
	else
        0xFFFFFFFF START_TIME - END_TIME +
	endif
	itof 1000. f/ 60. f/ == JOB_TIME ;   ` job time in minutes


40 ' calc_job_time sysallocate ptr pTime
: pad_string ` <ptr> <pad length> pad_string   pad message with spaces out to next complete line.
    1 swap mover slen 20 mod dup not if drop 2drop :exit endif - 1
    step dup ""  " swap s+! endstep
;

0 ivar LocalDNCMenus?  ` are we viewing local dnc menus.
: display_elapsed_time  ` v3.03 added to display time when running job.
    `                v---- may not be needed if LDNC menu not active during job
    menu_status? LocalDNCMenus? not land if :exit endif  ` menu_status? 0=not in menu, 1=in main menu, 2=in submenu.
    DISPLAY_TIME? if 
        JOB_TIME 60.0 f* rftoi dup PREV_JOB_TIME <> if dup == PREV_JOB_TIME TimeToStrRaw set_time_box else drop endif
    endif
    ;
: display_zdelta 
    `                v---- may not be needed if LDNC menu not active during job
    menu_status? LocalDNCMenus? not land if :exit endif  ` menu_status? 0=not in menu, 1=in main menu, 2=in submenu.
    DISPLAY_DELTA? not if :exit endif
    ` Only update if changed.
    PREV_Z_DEPTH_PASS Z_DEPTH_PASS f- fabs 0.0001 f> if
        Z_DEPTH_PASS == PREV_Z_DEPTH_PASS
        Z_DEPTH_PASS set_depth_box
    endif
    
    MP_TOTAL_PASSES MPJ_PASSES 0 > if MPJ_PASSES 1- else MP_PASSES 1+ endif -
    dup PREV_MP_PASSES <> if
        SYS_MSG? 64 and if "" display Z Delta Passes Box\n" write_err endif 
        dup == PREV_MP_PASSES
        itoa pTime s!
        ""  of " pTime s+!
        MP_TOTAL_PASSES itoa pTime s+!   
        pTime set_passes_box
        
    else drop endif 
    ;
: display_reps
    REPS 0 < if :exit endif  ` do not display if -1.
    0 2 pos  1097 getmsg  kdm_dsp_string  ` "" Reps:"
    REPS pTemp 0 iformat kdm_dsp_string
;
` From the Job name, we want to obtain the number of REPS.
` Also, if the name is > than 16 chars, shorten the name in the middle.
0 ivar jnptr  ` ptr to end of job name.
: ParseJobName
    JobName slen 1- JobName + == jnptr
    -1 == REPS  ` always start off with -1 because we use it as a flag.
    loop
        jnptr JobName <= if break endif
        jnptr b@
        dup ascii ) = if 0 jnptr b! endif ` replace ')' with 0.
        dup ascii ( = if jnptr 1+ strtof if ftoi == REPS endif 0 jnptr b! endif
            ascii . = if 0 jnptr 4 + b! break endif  ` found ., start of extention.
        jnptr 1- == jnptr
    repeat
    jnptr JobName - 12 > if
        0 JobName jnptr JobName - 0 max 12 min + b! ` shorten job name if we need to.
        "" ." JobName s+!
        jnptr 1+ JobName s+! ` add extension.
    endif
;
: ReplayJob
    ` param 202 0=normal, b1=replay buffer disabled, b2=replay using DNC disabled.
    202 gi 3 and 3 = if :exit endif
    INDVC> w@ 31 0 ioctl 96 and 96 = 202 gi 1 and not land if  ` Check for valid job to replay.
        1 == JOBBASIS?  ` mark job as being replayed
        REPS 1+ 2 max == REPS ` increment reps because we just replayed job.
        in_cito? if
            ` put in delay so that end_plot can finish before RTC_PROC runs the next job.
            "" 200 msd execute_file drop\n" stuff_it
        else
            execute_file drop ` pushes a string into the input device
        endif
    else
        DNCJOB_AVAILABLE? if  ` don't check if available, just call replay.
            202 gi 2 and not if
                2 DNCStart  ` have DNC Restart job.
                :exit  ` exit here to avoid refreshing display.
            endif
        else
            bell 1916 getmsg dup s. word_wrap_string kdm_dsp_line ` "" No Replay File      Available."
            2 second_kdm
        endif
        -1 kdm_stroke
    endif
;
: ReplayDNC     ` used for VST in DNC
    0 == DNC_AUTORUN    ` clear the DNC auto run
    1 == iDNCHaltCode DNCEndOfJob   ` tell DNC that we cannot continue
    200 msd
    2 DNCStart  ` have DNC Restart job.
    ;
etcx 1 > #ifdef
0 ivar PREV_FRO_PORT
: rtc_fro_display
    4 get_current_fro? dup PREV_FRO_PORT <> if
        == PREV_FRO_PORT
        0 1 pos "" Feed:" kdm_dsp_string PREV_FRO_PORT kdm_dspnum
    else drop endif
;
#endif
0 ivar SAVE_REPS
: rtc_proc   ` M2.88
`   [ etcx 3 > ] #ifdef "" in rtc_proc:\n" write_err #endif
    RTC_SECOND_TIMER 1- == RTC_SECOND_TIMER  ` decrement by 2 so it happens every 500 msec.

   0 port_input? 64 and not if  ` do not check if halt line in.
       MPJ_PASSES MPJ_RUN? land if  ` Look for Multi-Pass Job and replay if we need to.
            0 == MPJ_RUN? 
            MPJ_PASSES -99 = if 
                0 == MPJ_PASSES
                #BATCH_NUM BATCHRUN? land not if ` do not delete job if batching. 
                    INDVC> w@ 31 0 ioctl [ hex ] 060 [ decimal ] and       ` FIOBUFSTAT
                    if INDVC> w@ 37 0 ioctl drop  ` FIOKILSAVEBUF
                        [ etcx 1 > ] #ifdef "" Purge Job.\n" write_err #endif
                    endif
                endif
            else
                REPS == SAVE_REPS ` special case, don't update REPS
                ReplayJob ` this updates REPS
                SAVE_REPS == REPS  ` put back.
            endif
        else
           #BATCH_NUM BATCHRUN? land if
                0 == BATCHRUN? ` 0. set_rtc_time ` v3.03 rtc proc runs all the time.
                #BATCH_NUM -99 =
                if 0 == #BATCH_NUM
                    INDVC> w@ 31 0 ioctl [ hex ] 060 [ decimal ] and       ` FIOBUFSTAT
                    if INDVC> w@ 37 0 ioctl drop  ` FIOKILSAVEBUF
                        [ etcx 1 > ] #ifdef "" Purge Job.\n" write_err #endif
                    endif
                else
                    MPJ_BITESIZE 0.0 f> if ` check if running multi-pass job 
                        Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
                        MPJ_BITESIZE f/ ftoi 1+ == MPJ_PASSES       ` calc # MP_BITESIZE passes needed to reach cut depth, add one because they are subtracted in end_plot
                        MPJ_PASSES == MP_TOTAL_PASSES               ` save total passes for display only.
                        MPJ_BITESIZE Z_DEPTH fmin == MPJ_Z_DEPTH
                    endif 
                    ReplayJob
                endif
           else
                AUTORUN? if  ` v3.03 do we check for autorun?
                    START_MASK if                              ` check for cycle_start input
                        limits? START_MASK and not if   ` bit low, connection wired means START
                          0 == AUTORUN? ` 0. set_rtc_time
                          [ etcx 1 > ] #ifdef "" Run Job\n" write_err #endif
                          ReplayJob
                        endif
                    endif
                endif
                DNC_AUTORUN 2 =  if     ` V3.43 fix rDNC VST
                    mpg_active? not if
                        4 == DNC_AUTORUN        ` mark running
                        INDVC> w@ 23 "" \nReplayDNC\n" ioctl drop      ` start up appropriate parser (ucito/hpgl/cnc)
                    else
                          [ etcx 1 > ] #ifdef "" #" write_err #endif
                    endif
                endif
            endif
       endif
   endif
   iBANNER_FUNC 2 = if ` v3.03 update time display, iBANNER_FUNC 2= executing.
       /* Do once every 1/2 second */
       DISPLAY_TIME? if  
           ` only recalc if doing motion.  This way we can keep the display up for 10 seconds after job ends.
           chk_any_motion? if calc_job_time endif
           display_elapsed_time
           DISPLAY_DELTA? if display_reps endif
       endif
       DISPLAY_DELTA? if 
           display_zdelta
       endif
       RTC_SECOND_TIMER 0 <= if
           RTC_SECOND_DELAY == RTC_SECOND_TIMER
       endif
   else
      ` count down AFTERJOB_TIME (set in end_plot), then when finished counting down, refresh display.
      AFTERJOB_TIME 0 > if
`         " AJT = " AFTERJOB_TIME . nl
         AFTERJOB_TIME 1- dup == AFTERJOB_TIME 0 <= if menu_status? not LocalDNCMenus? or bDNCActive not land if make_idle_screen -1 kdm_stroke /* kdm_dsp_rev */ endif endif
      endif
   endif

   ` DEBUG, display fro when executing
   [ 0 ] #ifdef
      iBANNER_FUNC 2 = if rtc_fro_display endif
   #endif
`   [ etcx 3 > ] #ifdef "" exit.\n" write_err #endif
;

: hw_estop?
    111 port_input? ESTOP_BIT and
;

` used to detect what type of estop condition has occurred and what message to display
: check_for_faults
    SYS_MSG? 2 and if " -- Check_for_faults --\n" endif
   ` ESTOP_BIT should be 4 (111:4), EStop_2, Pin 21 on HM2 DB25 Male.
    111 port_input? ESTOP_BIT and == ESTOP?   ` added in case F/W version of estop_detect called (on powerup) for loose wire
    111 port_input? 0x100 and if ` Wired to External Estop (EStop_Input_3, Pin 13 on HF-1 DB25 Female)
        1909 getmsg ` "" Missing or Loose Motor Cable"
        :exit
    endif
    111 port_input? 8 and if ` Drive Fault bit
        ` Find out which drive
        InitScrollMessage
        "" Motor Drive Fault" AddScrollMsg AddScrollNL
        219 port_input? 0 7 1 step dup 1 and if I drive_fault_msg AddScrollMsg endif 2/ endstep drop
        scroll_buffer  ` Return Buffer.
        :exit
    endif
    InitScrollMessage
    111 port_input? 
        dup   0x10 and if "" Drive Over Temp."     AddScrollMsg AddScrollNL endif
        dup   0x20 and if "" Halt: Under Voltage"  AddScrollMsg AddScrollNL endif
        dup   0x40 and if "" Halt: Over Voltage"   AddScrollMsg AddScrollNL endif
        dup  0x100 and get_estop_enable_mask 1 and land if 1909 getmsg AddScrollMsg AddScrollNL  endif ` "" Missing or Loose Motor Cable"
        dup  0x200 and get_estop_enable_mask 2 and land if "" Halt: Estop KDM" AddScrollMsg AddScrollNL endif
        dup  0x400 and get_estop_enable_mask 4 and land if 1910 getmsg AddScrollMsg AddScrollNL endif   ` "" Pull out Estop"
        dup 0x1000 and if "" Drive 5,6 Fault"      AddScrollMsg AddScrollNL endif
        drop
   
    ESTOP? not SSTOP_CALLED land if  ` SSTOP_CALLED if someone presses the F6 key in MM. 
        "" Emergency Stop!" AddScrollMsg AddScrollNL
        0 == SSTOP_CALLED
    endif

    scroll_buffer

;
: faults check_for_faults write_err ;

ifmissing check_arp : check_arp drop 0 ;
: check_ip
    0 check_arp if 1 check_arp
            if 1921 getmsg kdm_dsp_line kdm_dspnum ` "" DUPLICATE CONT IP!  "
            else 1922 getmsg kdm_dsp_line ` "" CONFLICT w/ EXTERNAL IP"
            endif
            kdm_getkey drop
    endif
    ;
word set_display_units
: power_up
    8 units_decpt kdm_float_size        ` mm is .xx, in is .xxx set for display defaults (DECIMALS) is either 2 or 3.
    limits_off      ` special for M50

    LIMIT_MASK not if 0 set_machine_fault 1 == ?DATUMMED endif

    110 129 1 step 0.0 I ddgf endstep ` default unassigned pre-set homes to 0.0
    0.0 130 ddgf                      ` default unassigned Cyl soft_home values
    0.0 131 ddgf                      ` default unassigned Cyl soft_home values

    202 gi 3 and 3 = if  ` if replay is disabled, disable the START_MASK so rtc_proc will not replay job
        0 == START_MASK
    endif
    
    ` don't have it display the letters when jogging.
    0 0 assign_jog_letter 
    0 1 assign_jog_letter 
    0 2 assign_jog_letter 


    ` REMOVED section for setting softhome if PRESERVED
    ` Preserved homes will be set at the first attempt to go home in key_func2

    ?CONTROLLED_Z not if     ` if we do not have a 3rd axis, zero out lift and depth
        0.0 == Z_LIFT
        0.0 == Z_DEPTH
    endif
    111 port_input? ESTOP_BIT and           ` check halt line
    if
        ERRDVC> w@ outfile                  ` disable message suppression
        check_for_faults                    ` determines what message to display
        dup s. nl word_wrap_string kdm_dsp_line              ` Display line determined above
        10 duty_error                       ` blink lights
        ` 200 msd                           ` wait removed as Duty_error waits
        outfile drop                        ` restore message suppression
	else 
         9 kdm_banner  ` v3.03 change from 1 to 9 so banner func gets called
    endif
    DISPLAY_UNITS set_display_units         ` change over to metric if set.
    check_ip   ` look for duplicate IP
    ` -1 kdm_stroke
    iRTC_TIME itof 1000. f/ fdup == RTC_TIME set_rtc_time    ` start the rtc_proc running.
    1.0 RTC_TIME f/ ftoi == RTC_SECOND_DELAY  ` how many clicks
    
    BUMP_CONNECTION if                      ` do we allow new telnet connections to bump existing ones
        9 eth_intf not if  "" \nOpen Connect not implemented.\n" write_err endif
    endif
    ;

/* PRE-SET HOME Routines  */
` Preset home positions number from 1 to 9
` Flash saved normal home position has PREHOME set to 0

0 ivar PREHOME   ` preset home number (9 allowed flash locations 110-128 for X and Y)


` displays the preset home position based on PREHOME
: dsp_pre_home
    3 kdm_integer_size
    0 0 pos "" X " kdm_dsp_string PREHOME 2 * 110 + gf units_decpt kdm_dspfnum
    0 1 pos "" Y " kdm_dsp_string PREHOME 2 * 111 + gf units_decpt kdm_dspfnum
    12 0 pos
    1098 getmsg kdm_dsp_string ` "" Preset"
    12 1 pos
    1099 getmsg kdm_dsp_string PREHOME kdm_dspnum ` "" Home "
    8 kdm_integer_size
;
: set_pre_home
    [ etcx 1 > ] #ifdef "" set_pre_home " write_err ?PRESERVE_HOME write_err_num write_err_nl #endif
    ?PRESERVE_HOME if
        CYL_MODE? if          ` If in Cylindrical set the Cyl home not the Flat home
            0 get_pos? 130 set_float
            1 get_pos? 131 set_float
        else                                ` Set the Flat home, not cyl home
            0 get_pos? PREHOME 2 * 110 + set_float
            1 get_pos? PREHOME 2 * 111 + set_float
        endif
    endif
    ` if we are in a menu and just pressing the set home key, display message at bottom of menu.
    ` Otherise, operate mode could = 3 meaning we are in the Define Preset Home menu and we want to use kdm_dsp_status instead.
    menu_status? OPERATE_MODE 0 = land if 
        ` if we are actively showing a menu, display a message below the menu and keep the menu up.
        500 1075 getmsg 1 kdm_dsp_message  ` display message for 500 msec.  ` "" Home Set.""  
    else
        cls dsp_pre_home
        1075 getmsg 1 kdm_dsp_status 600 msd  ` "" Home Set."
    endif
    #set_home ack_blink

;
: select_pre_home
    == SELECT_KEY    ` this could either be ENTER if in DEFINE or SET HOME if in LOAD
    1 == PREHOME
    dsp_pre_home
    loop
		kdm_getkey
        dup SELECT_KEY = if drop PREHOME break endif   ` enter, put preset home position on stack
        dup 25 = if PREHOME 1+ 9 min == PREHOME endif
        dup 24 = if PREHOME 1- 1 max == PREHOME endif
        dup 13 = swap 14 = or if -1 break endif  ` cancel, put -1 on stack
        dsp_pre_home
	repeat
;
/* ************************************* */
/* Pens map to Tools and Heads.          */
/* Heads map to spindle and lubr codes.  */
/* ************************************* */
: code_to_bits /* code */
    dup 11 > if 11 - select
          /* 12 */  => 101 4
          /* 13 */  => 101 8
          /* 14 */  => 1 1
          /* 15 */  => 1 2
          /* 16 */  => 101 1
          /* 17 */  => 101 2
          /* 18 */  => PWMREG1 MAINTAIN_CURRENT
          /* 19 */  => 1 4
          /* 20 */  => PWMREG2 MAINTAIN_CURRENT
                    default=> 1 0 
          endselect
    else 1 0
    endif
    0 ;
128 ivar SOL1_BIT ` hardcode these. They are used to determine if solenoids are on during pause.
256 ivar SOL2_BIT

` AUX1_MODE? and AUX2_MODE?
`       0 = Manual               
`       1 = Job
`       2 = PD/PU
`       4 = Left Tool
`       5 = Right Tool


: AUX1_MODE? AUX1_CODE dup if drop 34 gi 255 and endif ;
: AUX2_MODE? AUX2_CODE dup if drop 34 gi 8 shrv 255 and endif ;

: spindle_on
    chk_motion? not if :exit endif
    SPINDLE_ON? not SPINDLE_CODE land if
        1 == SPINDLE_ON? 1 == ?SPINDLE_POWERUP
        4 led_on
        SPINDLE_CODE code_to_bits set_bits
        SPINDLE_DELAY 100 max delay wait_plot
        check_power if #PF_ERRS 1+ == #PF_ERRS endif
        0 == ?SPINDLE_POWERUP   ` flash read-out checks power
    endif
    ` if the aux is setup for Job Mode, turn it on too.
    AUX1_MODE? 1 = if AUX1_CODE code_to_bits set_bits 5 led_on endif  
    AUX2_MODE? 1 = if AUX2_CODE code_to_bits set_bits 3 led_on endif ;

: force_spindle_off
    0 == SPINDLE_ON? SPINDLE_CODE code_to_bits swap pset_bits 4 led_off
	;

: spindle_off
    SPINDLE_ON? if
        0 == SPINDLE_ON? SPINDLE_CODE code_to_bits swap set_bits 4 led_off
    endif
    AUX1_MODE? 1 = if AUX1_CODE code_to_bits swap set_bits 5 led_off endif
    AUX2_MODE? 1 = if AUX2_CODE code_to_bits swap set_bits 3 led_off endif
    flush_plot ;

0 ivar SOLTYPE
` <code> <0/1> solenoid_on
`    1 = pset_bits
`    0 = set_bits
: solenoid_on
    == SOLTYPE
        SOL1_CODE = if PWMREG1 else PWMREG2 endif dup    ` starts at port PWMREG1 for solenoid 1
        RUSH_CURRENT 0
        SOLTYPE if pset_bits else set_bits endif
        MAINTAIN_CURRENT dup 1com RUSH_CURRENT and
        SOLTYPE if 40 #delay pset_bits else 40 delay set_bits endif
;
` <code> <0/1> solenoid_off
`    1 = pset_bits
`    0 = set_bits
: solenoid_off
    == SOLTYPE
` RPCX       dup
        SOL1_CODE = if PWMREG1 else PWMREG2 endif           ` starts at port PWMREG1 for solenoid 1
        0 255                                       ` set the clear value
        SOLTYPE if pset_bits else set_bits endif    ` use immediate or buffered method
` RPCX       code_to_bits swap dup 2* or                 ` use old method if M50 and if M54 just in case...
` RPCX   SOLTYPE if pset_bits else set_bits endif        ` use immediate or buffered method
;


: end_motion finish_motion
    monQP   ` place motors at Quarter Power
;

: drive_err
     ` 1911 "" Drives Not Enabled!"
    -2 1911 ErrorMsgEx  ` 1911 "" Drives Not Enabled!"
    error2_blink
    -1 DLG_DisplayMsgBox
    menu_status? not if 
        make_idle_screen 
        -1 kdm_stroke 
    endif 
    ;

: datum_err
    -2 1912 ErrorMsgEx ` 1912 "" Machine Not         Datummed!" 
    error_blink
    -1 DLG_DisplayMsgBox
    menu_status? not if 
        make_idle_screen 
        -1 kdm_stroke 
    endif 
    ;
    
: cyl_err
    -2 1067 ErrorMsgEx ` "" Not allowed in cylindrical mode. 
    error_blink
    -1 DLG_DisplayMsgBox
    menu_status? not if 
        make_idle_screen 
        -1 kdm_stroke 
    endif 
    ;

: home_err
    2000 1081 ErrorMsgEx ` 1081 "" Please Set Home."
    menu_status? not if 
        make_idle_screen 
        -1 kdm_stroke 
    endif 
    ;

: in_motion_err  ` called for menu items when in motion.
    500 1290 getmsg 3 kdm_dsp_message ` "" Not allowed during motion"
;
: xchk
   limits_valid? limits? LIMIT_MASK and land if
        .ips 2000 1913 ErrorMsgEx    ` "" Limit Still Active."
        1 :exit
	endif
    MACHINE_FAULT LIMIT_MASK land ?DATUM not land if
        bell datum_err 1 :exit
	else
        0 set_machine_fault
        1 == ?DATUMMED
	endif
    ?DATUM not if
        CYL_MODE? if          `  Check if in Cylindrical or Flat mode and error on appropriate home
            ?HOMESET_CYL not if                 `  Flat mode bit flag
                bell home_err 1 :exit
            endif
        else
            ?HOMESET not if             `  Cylindrical mode bit flag
                bell home_err 1 :exit
           endif
        endif
    endif
    0 ;

: .dsp_error
   select
     => "" Token"
     => "" ISP Stack"
     => "" FSP Stack"
     => "" PF Glitch"
     => "" Pwr Fail"
     => "" Parameter"
     default=> "" Unknown"
   endselect
   dup s. dup AddErrorMsg ""   Error\n" dup s. AddErrorMsg
   kdm_dsp_line
   ;
0 set_warning
hex
: get_errors get_errors 40000 1com and ;   ` suppress eth error on NON-kboards
decimal
1 set_warning

: dsp_errors
    0 get_errors
    if 1 get_errors dup ` get original, and clear, make copy
       1 6 1 step	` only step over known errors
          dup 1 and
          if I .dsp_error
            1917 getmsg kdm_dsp_string  ` ""  Error "
            0 1 pos 1918 getmsg dup AddErrorMsg kdm_dsp_string  ` " occurred in  Job!"
            wait_for_ack
          endif  2/
       endstep ` leave shifted down on stack
	   if 1917 getmsg kdm_dsp_line   ` advanced errors only if non-zero
                dup kdm_dspnum   ` make copy and display
                dup AddErrorNum 
	            0 1 pos 1918 getmsg dup AddErrorMsg kdm_dsp_string  ` " occurred in  Job!"
				wait_for_ack
       endif
       drop ` delete working copy
       -1 kdm_stroke
    endif
   ;
 
/* --- Keypad Graphics Preview --- */
` <low x> <low y> <high X> <high Y> graph_set_window `  fraction of screen
` <xlow.> <ylow.> <high.> <yhigh.> graph_set_user	 ` user units
` <set> <clr> set_graph_box  (BOX_SIZE_ONLY=0x01,  BOX_GRAPH_2D=0x02,  BOX_PENDOWNWARD=0x10,  BOX_PENDOWN=0x20)

` The job format that we would like would be
` ZO4081,<X min extent of job in HPGL units> ;
` ZO4082,<Y min extent of job in HPGL units> ;
` ZO4083,<X max extent of job in HPGL units> ;
` ZO4084,<Y max extent of job in HPGL units> ;

0 ivar PREVIEW_JOB_RUN  ` This is a count down. 2=Get bounds, 1=start Graph, 0=run job. Set in hpgl_set_port_ex
ifmissing get_graph_box : get_graph_box 0 ; 0 == SHOW_PREVIEW_JOB  

: start_bounds_box
    cWHITE glcd_bg cBLACK glcd_fg 
    145 5 170 155 glcd_box
    ""  --- Preview ---" 150 15 glcd_text
    small_font
    "" Calculating Size..." 150 35 glcd_text
    normal_font

    1 15 set_graph_box    ` turn on BOUNDS checking ONLY
    7 range_checking      ` turn on user range checking
    SYS_MSG? 4 and if " Start Bounds, mode is " get_graph_box . nl endif
;   
: start_graph_box
    BOUND_MAX_X fabs 0.001 f> BOUND_MAX_Y fabs 0.001 f> or if
        X_HOME BOUND_MIN_X f+   Y_HOME BOUND_MIN_Y f+ 
        X_HOME BOUND_MAX_X f+   Y_HOME BOUND_MAX_Y f+
        SYS_MSG? 4 and if "" Port Bounds: " write_err 0 3 1 step 4 I - frepl write_err_fp ""  " write_err endstep write_err_nl endif
        graph_set_user
    endif

    ` 0.41 0.03 0.98 0.625 graph_set_window
    0.5 0.44 0.90 0.97 graph_set_window
    cWHITE glcd_bg cBLACK glcd_fg 
    145 5 170 155 glcd_box
    cBLACK set_graph_box_color
    2 15 set_graph_box
    7 range_checking
    0 == HAVE_SAVE_REGION?  ` we don't have one yet.
    SYS_MSG? 4 and if "" Start Graph, mode is " write_err get_graph_box write_err_num write_err_nl endif
;
: end_graph_box
    SYS_MSG? 4 and if "" End Graph, mode is " write_err get_graph_box write_err_num write_err_nl endif
    get_graph_box 1 = if
        BOUND_MAX_X fabs 0.001 f> BOUND_MAX_Y fabs 0.001 f> or if
            X_HOME BOUND_MIN_X f+   Y_HOME BOUND_MIN_Y f+ 
            X_HOME BOUND_MAX_X f+   Y_HOME BOUND_MAX_Y f+
            SYS_MSG? 4 and if " Port Bounds: " 0 3 1 step 4 I - frepl f. sp. endstep nl endif  
        else
            2 pcoords? fdrop ` drop off Z axis
            3 pcoords? fdrop ` drop off Z axis
            SYS_MSG? 4 and if " Calc Bounds: " 0 3 1 step 4 I - frepl f. sp. endstep nl endif  
        endif
        graph_set_user
        0 == HAVE_SAVE_REGION?  ` we don't have one yet.
        ` 2 15 set_graph_box      ` switch to graphics
        ` clear_display
    else 
        ` get_graph_box 2 = if
            145 5 170 155 glcd_save_region drop ` copy the screen where we drew the image.
            1 == HAVE_SAVE_REGION?
        ` endif
        0 15 set_graph_box
    endif
    ;
: start_motion
    estop_on_no_delay            ` new on M2564
    111 port_input? ESTOP_BIT and if     ` check halt line for motion
        check_for_faults
        dup s. nl word_wrap_string kdm_dsp_line
        10 duty_error 200 msd
        :exit
	endif
	?DRIVE_ON not if drive_err :exit endif
    monFP    ` turn motor on FULL Power
    LIMIT_MASK 64 and if limits_on endif ` turn on overtravel limit detect
	enable_motion ;

` 0 ivar pd_cnt
word switch_to_cyl
word switch_to_flat
word switch_x
: start_plot
    SYS_MSG? 2 and if  "" \n\007into Start Plot\n" write_err /* s nl */ endif
`     0 == pd_cnt
    0 == AUTORUN? 0 == BATCHRUN? 0 == MPJ_RUN? ` M3.03 always run. M2.88 turn off rtc processing
    
    xchk if
        2 led_off
        end_motion                      ` clear any motion that is executing.
        my_cancel                       ` make sure that replay is killed if job was being transmitted
        5 == iDNCHaltCode DNCEndOfJob   ` tell DNC that we cannot continue
        make_idle_screen
        -1 kdm_stroke :exit             ` clear pendant and exit
    endif
    
    
    MPJ_BITESIZE 0.0 f> if
        SYS_MSG? if " JOBBASIS?: " JOBBASIS? . nl endif 
        MPJ_PASSES MP_TOTAL_PASSES < JOBBASIS? 1 = land if ` 0 = sent, 1 = replay, 2 = DNC.
            2 == iBANNER_FUNC         ` mark that we are executing a job.
            true == EXECUTING?
            kdm_dsp_rev               ` update display before enabling rtc_proc.
            start_motion
            ` ?FEEDOVER if 0 set_override 5 set_override endif  ` M2.90 turn on analog feedrate, but not be on yet
            slew_mode
            7 range_checking                ` enable and reset used range
            4 set_machine_state 8 clr_machine_state ` in job, out of kdm
            0 == iDNCHaltCode     ` the halt code to be returned to DNC from endplot (pause, estop, normal, etc)
            0 == PD_OCCURED?      ` show that we have not seen a pendown.
            3 2 host_check              ` Set Frame and Overflow error checking on during jobs.
            MPJ_Z_DEPTH == Z_DEPTH_PASS
            2 led_on   ` make start key solid.            
            36 kdm_pause_key
            SYS_MSG? 2 and if " r Z_DEPTH: " Z_DEPTH_PASS f. nl endif
            99 gi == DISPLAY_OPTIONS  ` Reset the display options
            SYS_MSG? 2 and if " MPJ start_plot leave\n" endif
            :exit
        endif
    endif
    
    
    0.0 == JOB_TIME
    JOBBASIS? 0 = if 1305 getmsg JobName s! -1 == REPS endif  ` if job was sent, we do not know it's name. ` "" Executing ..."
    1 get_errors  drop     ` clear out errors.
	limits_valid? LIMIT_MASK land if limits_on endif
	
    ?DATUM restart? not land if find_limits -1 kdm_stroke endif         ` SAW home before starting if BIT 16 set
    
    
    ` If LEFT spindle and Left Spindle is Pneumatic, don't ask to set surface.
    ` Or if RIGHT spindle and Right Spindle is Pneumatic, don't ask to set surface.
    JOB_TOOL_NUMBER 1 = ?PNEUM_Z1 land  
    JOB_TOOL_NUMBER 2 = ?PNEUM_Z2 land or not if 
        ?CONTROLLED_Z if   ` check to set surface if controlled Z
            0. Z_SURFACE f= if 
                end_motion koff key_func6 ` kon ` Don't turn key func on in start_plot
            endif
        endif
    endif
    2 == iBANNER_FUNC         ` mark that we are executing a job.
    true == EXECUTING?
    99 gi 1 and if 1 == DISPLAY_TIME? endif 
    make_run_screen
    0 == DISPLAY_TIME?        iRTC_TIME 2* msd ` this will be set later.
    kdm_dsp_rev               ` update display before enabling rtc_proc.
	start_motion
	
    slew_mode 2 set_override        ` Make sure feedrate override is off.
	
	PARK_MODE_CYL 1 and if
        ` 0. 0. coord_Z? ualine wait_plot ` move back home
        0.0 coords_2d? fswap fdrop coord_Z? ualine wait_plot
        ?CYL_TRANS if                           ` Check the Cylindrical Mode Translation flag
            1 170 gf 1000. f* ftoi switch_x                                ` switch to Cyl with a diameter
        else
            switch_to_cyl                                                  ` just switch to Cyl without diameter
        endif
        kdm_dsp_rev
	endif
	
    chk_motion? if
        restart? if 2 led_blink else 2 led_on endif
        ?MANUAL_TOOL if 0 == PEN# 0 == USE_PEN endif
        ` moved spindle_on outside of check because they want it always to turn on. Manual uses Pen 0 only!!!
        ` SPINDLE always get turned on!!!  removed SPINDLE_RUN variable from init
        ` move V2.82  spindle_on
        ?PRG_AUX_CTRL not if spindle_on endif ` v2.94 added (if Program Aux Control is checked, don't turn on spindle)
		36 kdm_pause_key
    endif
    1. == VS_PERCENT                ` Always start the job with a clean percent that can be modified later
    POCKET_MILLING? if 0 get_pos? 1 get_pos? 0.005 umaline wait_plot endif  ` 2.83 added pocket milling.

    Z_DEPTH == Z_DEPTH_PASS         ` reset cut depth in case mpj_passes changed it.
    -1.0 == PREV_Z_DEPTH_PASS       ` reset so rtc proc will update display.
    -1   == PREV_MP_PASSES          ` reset so rtc proc will update display.
    MPJ_BITESIZE 0.0 f> if
        SYS_MSG? 2 and if "" JOBBASIS?: " write_err JOBBASIS? write_err_num write_err_nl endif 
        MPJ_PASSES MP_TOTAL_PASSES = JOBBASIS? 1 <> or if ` 0 = sent, 1 = replay, 2 = DNC.
            Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
            MPJ_BITESIZE f/ ftoi 1+ == MPJ_PASSES       ` calc # MP_BITESIZE passes needed to reach cut depth, add one because they are subtracted in end_plot
            MPJ_PASSES == MP_TOTAL_PASSES               ` save total passes for display only.
            MPJ_BITESIZE Z_DEPTH fmin == MPJ_Z_DEPTH
            get_rtc_elapsed == START_TIME  ` get start time here so it does not include spindle rampup.
        endif
        MPJ_Z_DEPTH == Z_DEPTH_PASS
        SYS_MSG? 2 and if " Z_DEPTH: " Z_DEPTH_PASS f. nl endif
        99 gi 2 and sign == DISPLAY_DELTA?  ` use 'sign' because the value can only be 0 and 1.
        DISPLAY_DELTA? if 
            make_zdelta_box
            MP_BITESIZE MPJ_BITESIZE fmax set_zdelta_box
        endif
    else
        get_rtc_elapsed == START_TIME  ` get start time here so it does not include spindle rampup.
    endif
    
    7 range_checking                ` enable and reset used range
    4 set_machine_state 8 clr_machine_state ` in job, out of kdm
    0 == iDNCHaltCode     ` the halt code to be returned to DNC from endplot (pause, estop, normal, etc)
    0 == PD_OCCURED?      ` show that we have not seen a pendown.
    99 gi 1 and == DISPLAY_TIME?    ` do we display the job time?
    ` 99 gi 2 and sign == DISPLAY_DELTA?  ` don't do this here, wait until pendown.
    3 2 host_check              ` Set Frame and Overflow error checking on during jobs.
    #istk == iIStackDepth       ` set stack depth for stack error checking.
    #fstk == iFStackDepth      ` capture time at start of job
    in_cito? in_ldnc? not land if "" start_plot" start_program endif
    SYS_MSG? if batch_off endif 
    ;
word setup_boot_mode
0 ivar do_replay?
: end_plot
    do_replay? if 2 == do_replay? endif
    in_cito? in_ldnc? not land if "" end_plot" end_program endif
    ?DISPENSE_ENABLE if PWMREG3 0 255 pset_bits endif   ` turn off solenoid 3
	wait_plot
    0 == JOBBASIS? ` mark next job coming from being sent.
    
    SYS_MSG? 2 and if "" In end_plot\n" write_err endif
   
    SYS_MSG? 4 and if " End plot graph box mode " get_graph_box . nl endif
    get_graph_box 15 and PREVIEW_JOB_RUN 15 = or if
        spindle_off wait_plot 2 led_off
        0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2 * msd
        0. == X_TOOL_OFFSET 0. == Y_TOOL_OFFSET do_set_home
        slew_mode   end_motion
        0 set_override  ` disable feedrate override.
        -1 kdm_pause_key
        -1 == PEN_OVERRIDE                ` override pen number for JSS
        -1 == PEN# -1 == USE_PEN 
        false == EXECUTING?
        get_graph_box 15 and PREVIEW_JOB_RUN 15 <> land if 
            end_graph_box
            ReplayJob
        endif
        :exit
    endif
    
    
    MPJ_PASSES 0 > if  
        MPJ_PASSES 1- == MPJ_PASSES
        SYS_MSG? if " MPJ_PASSES decrement: " MPJ_PASSES . nl endif
        MPJ_PASSES 0 = if 
            -99 == MPJ_PASSES ` signal end of batch
             0 == MPJ_RUN?
        else
             1 == MPJ_RUN? ` only if still in batching should we replay
             MPJ_Z_DEPTH MPJ_BITESIZE f+ Z_DEPTH fmin == MPJ_Z_DEPTH
             end_motion  ` start_plot will enable it again.
             0 set_override  ` disable feedrate override.
             :exit ` bail out here to run next job.
        endif
    endif
    
    calc_job_time
    ` quit updating display through rtc_proc.  This is because if -1 kdm_stroke is called, it could screw up display.
    0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2 * msd
    ` 2.26 reset soft home here just incase VPSoft home moved it.
    0. == X_TOOL_OFFSET 0. == Y_TOOL_OFFSET do_set_home
    POCKET_MILLING? if 0 get_pos? 1 get_pos? 0.005 umaline wait_plot ` 2.83 added pocket milling.
        0. 10 gf 0.001 f- 2 get_pos? umaline wait_plot   ` move close to home before finding home
        ` find_limits  (if we datum, then we have to set home).
    endif

    spindle_off wait_plot 2 led_off
    
    PARK_MODE_CYL 1 and if
        switch_to_flat 
        monFP   ` make sure we are at full power for this move.
        SWITCH_X_DELAY #delay  `  solenoid commands are immediate so this needs to be immediate
        slew_mode
        PARK_MODE_CYL 2 and if  
            POCKET_MILLING? not if ?CONTROLLED_Z if coords_2d? Z_LIFT fneg z_limit ualine endif endif
            wait_plot
            107 gf -99999.0 f- fabs 0.0001 f< if 0 get_pos? else 107 gf endif 5 gf fmax 9 gf fmin 
            108 gf -99999.0 f- fabs 0.0001 f< if 1 get_pos? else 108 gf endif 6 gf fmax 10 gf fmin 
            2 get_pos? umaline wait_plot
        endif
        kdm_dsp_rev ` re-display because it shows switching to flat.
    endif

    ?PARK 1 = if  ` park at edge of plot
        get_soft_home? f2drop 3 pcoords? fdrop fswap fdrop
        SYS_MSG? 2 and if "" Park Coords " AddErrorMsg fdup AddErrorFp AddErrorNL endif
        fdup -9999. f=          ` pcoords returns -9999. if no bounds
        if " No Park Home." f2drop
        else 2 get_pos? umaline
        endif
    else ?PARK 2 = if    ` go home
         POCKET_MILLING? not if ?CONTROLLED_Z if coords_2d? Z_LIFT fneg z_limit ualine endif endif
         wait_plot
         0. 0. coord_Z? ualine
         endif
    endif

    restart? if 0 restart_cmd
        1059 getmsg  kdm_dsp_line   ` 1059 "" Location not found."
        true kdm_keyintr
        stop_idle
        error_blink
        kill_inque  ` INDVC> w@ 19 0 ioctl INDVC> w@ rdchk 2drop ` clears replay status
        9 == iDNCHaltCode
        1
    else
        dsp_errors
        0
    endif
    slew_mode  
    end_motion
    
    0 set_override  ` disable feedrate override.

    -1 kdm_pause_key
    -1 == PEN_OVERRIDE                ` override pen number for JSS
    -1 == PEN# -1 == USE_PEN 0. == X_TOOL_OFFSET 0. == Y_TOOL_OFFSET do_set_home
    1 2 host_check                      ` turn Frame error checking off, but leave overflow
    ` turn echo back on (now that buffer is empty) if back_talk allows it
    ?BACK_TALK not in_cito? land if  batch_off  endif
    1. == VS_PERCENT        ` clear vs percent for next job.
    DNC_AUTORUN 4 <> if       ` V3.43 don't send end of job if end_plot is somehow reached (job too long to kill inque)
        ` if we are in HPGL or CNC mode, assume job did not come from Suite 4 so don't send end of job code.
        PREVIEW_JOB_RUN 15 <> if 
            in_cito? in_ldnc? not land if DNCEndOfJob endif
        endif
    endif
    
    0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? 0 == iBANNER_FUNC ` don't show display if out of a job.
    
    
    EXECUTING? not if drop :exit endif  ` if we we not executing a job, exit here so the time display is not shown.
    false == EXECUTING?
    
    -1 == JOB_TOOL_NUMBER  ` displayed in Cycle Start if set.
    -1 == JOB_HOME_NUMBER
     0 == HAVE_SAVE_REGION?
    0.0 == BOUND_MIN_X
    0.0 == BOUND_MIN_Y
    0.0 == BOUND_MAX_X
    0.0 == BOUND_MAX_Y
    
	` look at ways to auto-replay
	#BATCH_NUM if  
	    #BATCH_NUM 1- == #BATCH_NUM
        [ etcx 1 > ] #ifdef "" batch decrement.\n" write_err #endif
		#BATCH_NUM 0 = if -99 == #BATCH_NUM ` signal end of batch
             1047 getmsg  kdm_dsp_line 200 msd ` 1047 "" Batch Complete."
		endif

        1 == BATCHRUN? ` 0.05 set_rtc_time  ` only if still in batching should we replay
    else
        START_MASK if 1 == AUTORUN? endif      ` enable checking for cycle_start input
        1102 getmsg kdm_dsp_line ` "" Job: " 
        1306 getmsg kdm_dsp_string ` "" Complete..."
	endif
	
`    [ etcx ] #ifdef s #endif
    10000 iRTC_TIME / 1+ == AFTERJOB_TIME  ` turn off display after 10 seconds (10000 msec).
    99 gi 0 = if 1 == AFTERJOB_TIME else 1 == DISPLAY_TIME? display_elapsed_time 0 == DISPLAY_TIME? endif  ` if we are not showing time, have rtc_proc update display immediately.
    /* from restart? */ LocalDNCMenus? or in_ldnc? or if 1 == AFTERJOB_TIME endif
    ` -1 kdm_stroke ` do not refresh display now, leave the time up until AFTERJOB_TIME expires.
`    bDNCActive not if setup_boot_mode endif
    in_ldnc? if
        iRTC_TIME 2* msd  ` give rtc_proc time to finish before lauching the LocalDNCMenu
        "" \n1 LocalDNCMenu\n" stuff_it 0 == in_ldnc?  ` restart local DNC menu if job was started in local DNC
        ' setup_boot_mode 0 0.5  2 eventqueue drop
    endif
`    pd_cnt 213 = not if
`        4 kdm_integer_size
`        "" Bad PD count :" kdm_dsp_line pd_cnt kdm_dspnum kdm_getkey drop
`    endif
	;

0 ivar vst_cancel
: all_off
    0 == do_replay?
    0 == in_ldnc?
    SYS_MSG? 2 and if "" all_off\n" write_err endif
    PORT1 0 DEVICE1_ALLOFF pset_bits 0 == DEVICE1_PBITS
    PORT2 if PORT2 0 DEVICE2_ALLOFF pset_bits 0 == DEVICE2_PBITS endif
    SOL1_CODE 1 solenoid_off ` M2.59
    SOL2_CODE 1 solenoid_off
    0  == ?SPINDLE_POWERUP  0 == SPINDLE_ON?
    ?DISPENSE_ENABLE if PWMREG3 0 255 pset_bits endif   ` turn off solenoid 3
    slew_mode 0 set_override        ` disable feedrate override
    -1 kdm_pause_key
    calc_job_time
    2 led_off 3 led_off 4 led_off 5 led_off
    0  == IN_RESTART_HERE    ` set flag off so cancel will act normally
    1. == VS_PERCENT    ` clear vs for next job.
    -1 == PEN_OVERRIDE -1 == PEN# -1 == USE_PEN 0. == X_TOOL_OFFSET 0. == Y_TOOL_OFFSET do_set_home
    0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2* msd ` don't show time when outside a job. v3.04 give time for last one to finish
    0 == AFTERJOB_TIME
    iBANNER_FUNC 3 <> if        ` V3.43 skip if DNC Restart
        0 == iBANNER_FUNC  9 kdm_banner  ` v3.03 change from 1 to 9
        false == EXECUTING?
        ` kdm_dsp_rev  don't do here.
    endif
    0 == PD_OCCURED?      ` show that we have not seen a pendown.
    1 2 host_check ` turn off framing error detection but leave parity error detection
    true == checkstack?     ` incase it was turned off and we errored during motion turn it back on
    0 == JOBBASIS?   ` mark next job as coming being sent.
    0 == MPJ_PASSES
    0 == PAUSE_CANCEL_ONLY?
    -1 == JOB_TOOL_NUMBER  ` displayed in Cycle Start if set.
    -1 == JOB_HOME_NUMBER 
     0 == HAVE_SAVE_REGION?
     0 == IN_CYCLE_START?
     0 == SaveLDNC
     0.0 == BOUND_MIN_X
    0.0 == BOUND_MIN_Y
    0.0 == BOUND_MAX_X
    0.0 == BOUND_MAX_Y
    0 15 set_graph_box  
    -1 clr_machine_state
    12 kdm_menu_enter_key                   ` re-enable the menu key.
    13 kdm_menu_exit_key
    12 kdm_menu_exec_key
    monQP
    ?BACK_TALK not in_cito? land if  batch_off  endif
	` M2.92 don't auto-replay if in batch mode
    ` v3.03 run rtc_proc all of the time.  ` M2.88 enable checking for cycle_start input
    #BATCH_NUM not START_MASK land if 1 == AUTORUN? /* 0.1 set_rtc_time */ endif
    vst_cancel not if setup_boot_mode endif
    make_idle_screen
	;
	
0 set_warning
512 ivar WEB_OC
: estop_detect
    "" In estop_detect\n" write_err
    menu_status? if menu_leave endif ` So Estop in a menu looks better
    clear_display ` Clear up display artifacts before we draw anything
    COLOR_SCHEME config_colors ` Reset font colors in case we changed them 
    keypad_dispatcher 1 kill_task ` Restart the keypad thread  
    keypad_dispatcher2 1 kill_task ` Restart the 2nd keypad thread   
    0 == TEST_SOLS ` In case they estop while testing Aux's
    stop_motion  ` call before all_off, it clears the semaphores. 
    stat
    moff 0 == ?DRIVE_ON
    PWMREG3 0 255 pset_bits   ` turn off solenoid 3
    clr_pause_flag   ` clr pause
    LIMIT_MASK if 2 set_machine_fault 0 == ?DATUMMED endif
    ` 0 == ?HOMESET         ` do not reset soft home
`    estop_detect           ` did call ini version here, but it flashed the displasy a lot so well do most of it here
    all_off
    limits_ref 
    menu_status? if menu_leave endif 
    0 port_input? 64 and if "" \n\007Emergency Stop Detected."
    else                    "" \n\007Emergency Stop Requested."
    endif write_err
    ifexists pv_fault? 0 pv_onoff
    3 set_machine_fault     ` kdm_error_msg
    fault_input? 112 port_input? WEB_OC and not land if
        "" \nMotor Fault" write_err
    endif
    
    ` 0 exec_detect           ` end of ini version of estop_detect
    
    ` display the message early, before the DNCEndOfJob because that will delay.
    check_for_faults        ` determines what message to display
    dup nl nl s. nl word_wrap_string kdm_dsp_line

    stop_idle               ` added to reset idle_proc - which may be set.
    4 == iDNCHaltCode       ` let DNC know the job is no longer running
    DNCEndOfJob             ` certain errors bypass our end_plot so we need do this here as well
    check_for_faults        ` determines what message to display
    dup nl nl s. nl word_wrap_string kdm_dsp_line
    loop 111 port_input? 0x400 and if 25 msd else 1 until endif repeat ` Don't leave estop_detect while the estop switch is active.
    -1 kdm_stroke ` Redraw main screen so there is an immediate response to releasing estop switch.
    10 duty_error ` 200 msd    
    " out estop_detect\n"
    ;

` -----------------------------------------------------------------------------
`               MACRO: sstop_detect
`         DESCRIPTION: controller receives estop char from MX will call firmware
`                      instead of init estop so put this here so init is called
` -----------------------------------------------------------------------------
: sstop_detect
    [ etcx ] #ifdef
    "" \007Press K to kill current process, any other key or wait 5 seconds to ESTOP." write_out
    kill_inque
    0 loop INDVC> w@ rdchk until 1+ dup 500 > until 10 msd repeat
    500 <= if INDVC> w@ frchar 32 or ascii k = if kon -1 kdm_stroke task_Port23 1 kill_task :exit endif endif
    #endif
    1 == SSTOP_CALLED
    estop_detect
;

` -----------------------------------------------------------------------------
`               MACRO: limit_detect
`         DESCRIPTION: called by firmware for a limit detect
` -----------------------------------------------------------------------------
: limit_detect
   2 == iDNCHaltCode
   my_cancel kill_inque
   moff 0 == ?DRIVE_ON
   ?DISPENSE_ENABLE not if PWMREG3 0 255 pset_bits endif   ` make sure MillGrav motor drive is disabled
   bell 1914 getmsg  dup kdm_dsp_line s.  ` 1914 "" \n Overtravel Detect"
   error_blink
   limits_off
   2 set_machine_fault
   0 == ?DATUMMED
   kdm_getkey drop    ` wait for acknowledgement
   -1 kdm_stroke
   DNCEndOfJob                     ` certain errors bypass our end_plot so we need do this here as well
   ;

0 ivar obounds? ` menu_move needs to know if obounds was called so it can break its loop
: obounds_detect
    COLOR_SCHEME config_colors ` Reset font colors in case we changed them 
    menu_status? if menu_leave endif ` So Estop in a menu looks better
    7 == iDNCHaltCode
    stop_idle
    2001 glcd_destroy_group drop ` In case obounds is genereated from menu_move, kill the move XY dialog
    1 == obounds? ` To tell the menu_move loop to exit.
    my_cancel kill_inque
    force_spindle_off
    nl bell 1903 getmsg dup s. kdm_dsp_line    ` 1903 "" \nOut of bounds       Axis:"
	.axis "   Position =" f. nl
    error_blink
	kdm_getkey drop
    0 == obounds? ` make sure it's cleared
`    6 second
    DNCEndOfJob                ` certain errors bypass our end_plot so we need do this here as well
	;

: MACHINE_INFO
	2 fprec
    " MODULE INI_INIT -3 " ^NH_INI_VER s. nl
	MACHINE_INFO
	4 fprec
;

1 set_warning

: commerr_detect
    wait_plot stop_idle               ` wait until motion ceases, then set the idle state off
    my_cancel                         ` cancel so the replay flag is reset and cancel calls all_off
    force_spindle_off                 ` for spindle off
    in_cito? if batch_off endif       ` pmc
	nl bell commerr_status? 1 = if
        1904 getmsg ` 1904 "" Framing Error"
	else
        1905 getmsg ` 1905 "" Host Overflow"
	endif
	dup s. kdm_dsp_line nl
	kdm_getkey drop
    kill_inque ` INDVC> w@ 19 0 ioctl drop   ` clear input queue
    6 == iDNCHaltCode DNCEndOfJob
	-1 kdm_stroke ;

KBOARD? #ifdef
: spindle_speed     ` sets spindle speed, <mode> <rpm> passed on stack
    1000 max 49 gi dup rot min dup == iSPINDLE_SPEED
    itof itof f/ VOLTAGE_SCALE f*
    3 ftoi dup 1com 4 pluck if set_bits else pset_bits endif  ` PORT3 then uses <mode>
    ;
#endif
RPC? #ifdef
: spindle_speed    ` sets spindle speed, <mode> <rpm> passed on stack
    1000 max 49 gi dup rot min dup == iSPINDLE_SPEED
    itof itof 1.0 fmax f/ 10.0 f* 1 set_ana_voltage
    drop ;
#endif
0 iSPINDLE_SPEED spindle_speed

: real_time_spindle_speed
    == SPINDLE_DIR 100 == SPINDLE_SCALE
    ` 1078 getmsg  kdm_dsp_line    ` 1078 "" Spindle Speed: "
    loop
        iSPINDLE_SPEED SPINDLE_SCALE
        SPINDLE_DIR if + else - endif 0 swap spindle_speed
        iSPINDLE_SPEED set_rpm_box ` 15 0 kdm_set_pos kdm_dspnum
        100 #delay 0 kdm_scankey -1 <> if
            1 kdm_scankey
            dup2 152 = swap 153 = or if drop break endif    ` arrow key break
            dup 44 = if 1000 == SPINDLE_SCALE endif         ` fast key make
               172 = if 100  == SPINDLE_SCALE endif         ` fast key break
        endif
    repeat
    ;

: real_time_feed_rate
    drop ;      ` (to be implemented on future product)

` <float> calc_cyl_vel -> <adjusted float if needed>
` mod for vmin, vmax, vaccel for the X axis in Cyl_translation and in Cyl mode
: calc_cyl_vel        ` takes float and leaves modified float, otherwise just leaves original float
    ?CYL_TRANS if
        170 gf f*
        CYL_FACTOR f/ ` 4-(eng) or 101.6-(met) (or cyl_factor) is the base, as if the job was being run flat
    endif
;

: cyl_mode_speeds
    ?CYL_TRANS if
        ` modify each axis param for Cyl Mode Translation, so speed adjusts with scale.
        500 gf calc_cyl_vel CYL_VMAX calc_cyl_vel 502 gf calc_cyl_vel 503 gf 0. 0 set_axis_params
        507 gf calc_cyl_vel 505 gf calc_cyl_vel 506 gf calc_cyl_vel  0 set_jog_params             ` Slew velocitites
    else
        ` do it the old way for JLS backward compatibility
        500 gf CYL_VMAX 502 gf 503 gf 0. 0 set_axis_params
    endif
    ;

: slew_mode
    CYL_MODE? if      ` if in Cylind
       cyl_mode_speeds
    else
        0 load_axis_params      ` overwrite the sucker
    endif
    1 load_axis_params
    2 load_axis_params 
   XYUP_FEED feedrate
   true == SLEW_MODE? ;

: machine_mode
    in_3d? if
        CYL_MODE? if cyl_mode_speeds
        else 500 gf 501 gf XYDN3_ACCEL 503 gf 0. 0 set_axis_params
        endif
        510 gf 511 gf XYDN3_ACCEL 513 gf 0. 1 set_axis_params
        520 gf ZDN_FEED 522 gf 523 gf 0. 2 set_axis_params
	else
        CYL_MODE? if cyl_mode_speeds
        else 500 gf 501 gf XYDN_ACCEL 503 gf 0. 0 set_axis_params
        endif
        510 gf 511 gf XYDN_ACCEL  513 gf 0. 1 set_axis_params
    endif
    false == SLEW_MODE? ;

: pause_start_z
    SYS_MSG? 2 and if "" Pause Start Z\n" write_err endif
    ?CONTROLLED_Z not if :exit endif    ` do not move if not controlled Z
    2 get_pos? Z_SURFACE f- Z_LIFT f+ fdup 0.0 f> if
        2 get_pos? fmin == Z_PAUSE_DIST
		ZUP_FEED feedrate
		SYS_MSG? 2 and if "" Before Move Z " write_err Z_PAUSE_DIST ftoa write_err "" \n" write_err endif
		0. 0. Z_PAUSE_DIST fneg uline 
		SYS_MSG? 2 and if "" Before wait_plot\n" write_err endif
		wait_plot
		SYS_MSG? 2 and if "" After Move Z\n" write_err endif
		XYUP_FEED feedrate
		?PENDLY 256 or == ?PENDLY
	else fdrop endif ;

: pause_end_z
    SYS_MSG? 2 and if "" Pause End Z\n" write_err endif
    ?CONTROLLED_Z not if :exit endif  ` do not move if not controlled Z
    ?PENDLY 256 and if
        ZDN_FEED feedrate 1 pcoords? ualine wait_plot
		?PENDLY 255 and == ?PENDLY
	endif ;

: update_main_screen
    display_elapsed_time
    display_zdelta
    display_reps
    XYDN_FEED TIMESCALE f* 0 get_current_fro? f* set_feed_box
    ?CONTROLLED_Z if 
        Z_DEPTH set_zdepth_box 
        Z_LIFT set_zlift_box
        DISPLAY_DELTA? if 
            MP_BITESIZE 0.0 f> MPJ_BITESIZE 0.0 f> or if 
                MP_BITESIZE MPJ_BITESIZE fmax set_zdelta_box
            endif
        endif
    endif
    iSPINDLE_SPEED set_rpm_box
;

: kdm_banner_func drop 2drop
    SYS_MSG? 2 and if "" kdm_banner_func (" write_err iBANNER_FUNC write_err_num "" )\n" write_err endif
	iBANNER_FUNC 1+ select
    /* 0 */ =>  29 get_string parse_title_strings
                PARSE_STR_1 slen 25 > if PARSE_STR_1 kdm_dsp_line else
                    PARSE_STR_1 25 center_string         kdm_dsp_line
                    PARSE_STR_2 25 center_string 0 1 pos kdm_dsp_string
                endif
                ` kdm_dsp_line `  ""     Newing-Hall           APEX 3D"
                111 port_input? ESTOP_BIT and if
                    check_for_faults
                    4 kdm_dsp_status  ` show message returned from check_for_faults
                else
                    ?DRIVE_ON not if 1911 getmsg 3 kdm_dsp_status   ` "" Drives not Enabled!"     
                    else ?DATUMMED not if 1912 getmsg 3 kdm_dsp_status endif ` "" Machine not Datummed"
                    endif
                endif
                XYDN_FEED TIMESCALE f* 0 get_current_fro? f* set_feed_box  ` this will show the current speec.
                ?CONTROLLED_Z if 
                    Z_DEPTH set_zdepth_box
                    Z_LIFT  set_zlift_box
                endif
                refresh_xyz_box
                TEST_SOLS if 0 1 pos 1096 getmsg kdm_dsp_string endif ` "" Solenoid Test Press Aux1/Aux2"

    /* 1 */ =>  1058 getmsg word_wrap_string kdm_dsp_line update_main_screen ` 1058 "" Start, Cancel, Enter  or Jog then VST"
    /* 2 */ =>  0 == iBANNER_FUNC iRTC_TIME 2 * msd ` v3.04 keep rtc_proc from display when this is trying to display
                1102 getmsg kdm_dsp_line JobName kdm_dsp_string ` "" Job:"
                update_main_screen
                2 == iBANNER_FUNC
    /* 3 */ => 1124 getmsg kdm_dsp_line ` "" DNC Restart for VST" 
    /* 4 */ => 1251 getmsg kdm_dsp_line ` "" Paused... Drives Overtemp"
    default=> kdm_dsp_rev
	endselect
	
    0 == AFTERJOB_TIME   ` just incase someone refreshes the display before rtc_proc does.
    0 kdm_cursor  ` turn cursor off

    ` XXX DEBUG
    ` 0 1 pos 110 gf 3 kdm_dspfnum 11 1 pos 111 gf 3 kdm_dspfnum
	;

` ---------------------------------------------------------------------------------------------------------------------
` MACRO..........: Pause_menu
` DESCRIPTION....: Handles the Pause menu
` STACKS ON ENTRY: * NOT USED *
` STACKS ON EXIT.: * NOT USED *
` ---------------------------------------------------------------------------------------------------------------------
` : pp_continue
` `    1095 getmsg kdm_dsp_line  ` " Motion Resumed"
`     host_mode? [ hex ] FFFFFEFF [ decimal ] and host_mode
` -2 ;

` : pp_cancel 1096 getmsg kdm_dsp_line  ` " Motion Cancelled"
`     all_off
`     stop_motion  ` kill all motion
`     update_pos
`     LocalDNC? 1 and if "" leave" write_err leave endif
` `    kill_inque
`     host_mode? [ hex ] FFFFFEFF [ decimal ] and host_mode
` -2 ;
word main_menu word SetMenuTitle
: menu_init
    
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    SYS_MSG? 2 and if "" menu_init\n" write_err endif
    chk_pause? if
`        -9 kdm_menu_exit_key
`        2 2 1 10 menu_config
    endif
    800 SetMenuTitle  ` "" Main Menu" KDM20G
    erase_display
    
    SpecialMenus? if ` This is needed for the new individual cut speed menus.
        menu_reset
        main_menu
        0 == SpecialMenus?
    endif
;

` word pause_main_menu
` : pp_menu
`     [ etcx 1 > ] #ifdef "" pp_menu\n" write_err #endif
`     pause_main_menu
`     1 start_submenu
`     13 kdm_menu_exit_key                      ` to allow the EXIT key to get out of this submenu during pause.
`     0
` ;

word main_menu
` : pause_menu
`     [ etcx 1 > ] #ifdef "" into pause_menu\n" write_err #endif
`     2 2 1 10 menu_config    ` start on 3rd row.
`     menu_reset   ` clear out main menu so we can replace it with the following.
`     ' pp_continue "" Continue" menu_add  ` Continue
`     ' pp_cancel   "" Cancel"   menu_add  ` Cancel
`     ' pp_menu     "" Menu"     menu_add  ` Menu
`     -9 kdm_menu_exit_key  ` do not allow exit using exit key because it will exit the menu.
`     512 kdm_stroke  ` start this menu
`     host_mode? 256 or host_mode
`     loop                        ` loop here until we leave the menu.
`         host_mode? 256 and while
`     repeat
`     [ etcx 1 > ] #ifdef "" done pausing\n" write_err #endif
`     13 kdm_menu_exit_key  ` re-instate menu exit key
`     menu_status? if 13 kdm_stroke endif        ` to leave menu incase user pressed HOT KEY to resume job.
`     menu_reset            ` reset menu to clear out pause menu
`     main_menu             ` load up regular menus
` ;
: check_drive_overtemp ` <returns 0=OK, 1=Overtemp>
    0
    [ RPC? ] #ifdef
        getLimitsRT 0x8000 and if
            0 get_drive_temp 90.0 f< if  ` check for < 90.0 deg celsius
                0 0 set_pause_masks
                drop 0 :exit
            else
                drop 1 :exit  ` return 1 for overtemp
            endif
        else
            drop 0 :exit ` reutrn 0 for NOT overtemp.
        endif
    #endif
;
0 ivar DR_OVERTEMP?
0 ivar DR_OVERTEMP_DSP
: pause_wait
       SYS_MSG? 2 and if "" pause_wait\n" write_err endif
`    in_hpgl? in_cnc? or
`    if [ etcx 1 > ] #ifdef "" HPGL/CNC\n" write_err #endif
        2 led_blink
        1 == iBANNER_FUNC iRTC_TIME 2 * msd  ` "" Start, Cancel, Enter  or Jog then VST"  

        0 == DR_OVERTEMP?
        0 == DR_OVERTEMP_DSP  ` 0 = show message, 1 = show temp.
        check_drive_overtemp if get_rtc_clk == DR_OVERTEMP? 4 == iBANNER_FUNC endif

        9 kdm_banner
        LocalDNCMenus? if kdm_dsp_rev else -1 kdm_stroke endif
        clr_ethpause ` be sure to clear before we start looking for it.
        -1 kdm_pause_key ` disable pause key. 

        host_mode? 256 or host_mode
        loop
            chk_pause? while
            get_ethpause 2 = if  ` cancel button in JC
                clr_pause_flag
                0 == AUTORUN? 0 == BATCHRUN? 0 == MPJ_RUN?   ` make sure auto-replay is off
                2 led_off my_cancel
                vst_cancel not if alt_ethernet endif
            endif
            get_ethpause 1 = if  ` Continue button in JC
                check_drive_overtemp not if
                    clr_pause_flag
                    2 led_on ` cont
                endif
            endif
            DR_OVERTEMP? if
                ` if drives are overtemp, the periodically check if OK.
                get_rtc_clk DR_OVERTEMP? - abs 1000 > if
                    check_drive_overtemp if
                        get_rtc_clk == DR_OVERTEMP? ` reset flag to check again in 2 seconds.
                        DR_OVERTEMP_DSP 0 = if
                            1250 getmsg kdm_dsp_line  ` "" Drive Temperature"
                            5 1 pos 0 get_drive_temp UNITS if  1 kdm_dspfnum ""  DegC" kdm_dsp_string else CtoF  1 kdm_dspfnum ""  DegF" kdm_dsp_string endif
                        endif
                        DR_OVERTEMP_DSP 1 = if
                            LocalDNCMenus? if kdm_dsp_rev else -1 kdm_stroke endif
                        endif
                        DR_OVERTEMP_DSP 2 = if
                            1252 getmsg kdm_dsp_line  ` "" Cooling down to"
                            5 1 pos 90.0 UNITS if 1 kdm_dspfnum ""  DegC" kdm_dsp_string else CtoF  1 kdm_dspfnum ""  DegF" kdm_dsp_string endif
                        endif
                        DR_OVERTEMP_DSP 1+ dup 2 > if drop 0 endif == DR_OVERTEMP_DSP
                    else
                        1 == iBANNER_FUNC
                        LocalDNCMenus? if kdm_dsp_rev else -1 kdm_stroke endif
                        0 == DR_OVERTEMP? ` clear flag, not longer hot.
                    endif
                endif
            endif
        repeat
        ` MOVE FOLLOWING TWO LINES TO END OF PAUSE_DETECT
        ` 2 == iBANNER_FUNC ` v3.03 put back to executing banner.
        ` 99 gi 1 and == DISPLAY_TIME? ` reset variable
`    else pause_detect
`    endif
` latest
`    2 led_blink
`    pause_menu
` Original
`    in_hpgl? in_cnc? or
`    if 2 led_blink
`       1 == iBANNER_FUNC iRTC_TIME msd 9 kdm_banner -1 kdm_stroke
`       host_mode? 256 or host_mode
`       loop chk_pause? while repeat
`       2 == iBANNER_FUNC ` v3.03 put back to executing banner.
`    else pause_detect
`    endif
    SYS_MSG? 2 and if "" Out of pause_wait\n" write_err endif
;
word restart_auto_core
: pause_vst
    SYS_MSG? 2 and if "" Entering pause_vst\n" write_err endif
    koff      ` turn kdm off
    1061 getmsg word_wrap_string kdm_dsp_line ` "" Cancel or Jog then VST/Start"
    -1 kdm_pause_key ` disable pause key. 
    loop
        0 kdm_scankey -1 <> if
            1 kdm_scankey SYS_MSG? 2 and if " Key " dup . nl endif  
            dup dup dup 40 = swap 0 = or over 58 = or    ` VST key pressed
            if  clr_pause_flag
                1060 getmsg kdm_dsp_line ` "" Searching ...." 
                false == in_dnc?        ` fool cycle_start into thinking we are not in dnc
                IN_RESTART_HERE if          ` out of restart waiting to begin point
                    [ etcx 1 > ] #ifdef "" VST started in pause_vst by Restart_Here?\n" write_err #endif
                    0 == IN_RESTART_HERE    ` clear restart_here flag because we are restarting search
                else                        ` was in restart so we can use the restart_cmd
                    [ etcx 1 > ] #ifdef "" VST started in pause_vst from Searching...\n" write_err #endif
                    0 restart_cmd  0 get_pos? 1 get_pos? 2 get_pos? 500 msd
                    kill_inque ` INDVC> w@ 19 0 ioctl INDVC> w@ rdchk 2drop ` clears replay status
                endif
                0 led_off               ` turn off pause led
                in_ldnc? 1 == vst_cancel my_cancel 0 == vst_cancel /* saved above */ == in_ldnc?
                ' restart_auto_core 0 0.75 2 eventqueue drop  ` start 750 msec later.
                break
            else dup 13 =
                if  disable_motion                ` Cancel pressed - turn off motion and accesories
                    0 == IN_RESTART_HERE          ` clear restart_here flag in case it was set
                    0 led_off                     ` turn off pause led
                    stop_idle
                    my_cancel                     ` Do a true cancel instead of all_off to reset replay bits
                    1 == iDNCHaltCode DNCEndOfJob ` tell DNC we cancelled out
                    break
                else dup 25 = over 26 = or over 24 = mover 15 = or or   ` check if arrow key pressed
                    if  0 restart_cmd           ` say we aren't in restart so it will allow pulses to the motors
                        7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
                        0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2* msd ` cancelled, do not display time.
                        hide_time_box  make_xyz_box hide_pre_job_info
                        SYS_MSG? 2 and if "" Allow User to Jog " write_err dup write_err_num endif
                        2 kdm_jog drop          ` allow user to jog
                        drop 
                        SYS_MSG? 2 and if "" Out\n" write_err endif 
                        ` reset display after jog
                        1061 getmsg word_wrap_string kdm_dsp_line ` "" Cancel or Jog then VST/Start" 
                    endif
                endif
            endif
            
        endif
    repeat
    kon
    SYS_MSG? 2 and if "" out of pause_vst\n" write_err endif
;
0 ivar temptime
: update_start_time  ` updates the start time by the lapsed time to give us a new start time.
    get_rtc_elapsed == temptime
    LAPSE_TIME temptime < if
        temptime LAPSE_TIME -
    else
        0xFFFFFFFF LAPSE_TIME - temptime +
    endif
    START_TIME + == START_TIME
;

0 ivar PAUSE_CALLED?

0 set_warning
: pause_detect
    ` 0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME msd ` do not update display when paused.
    " Pause\n" stat
    koff ` Don't think we need to allow funcs in pause, and they are causing trouble.
    1 == PAUSE_CALLED?
    menu_status? if menu_leave endif ` So Estop in a menu looks better
    0 led_on 2 led_blink
    JOGGING? if 0.05 kdm_time_out endif
    restart? IN_RESTART_HERE or if
        pause_vst
        ` 99 gi == DISPLAY_OPTIONS ` Reset display options from flash
        fKDMTimeOut kdm_time_out   
        kon
        :exit
    endif
    ?DATUMMED not if
        1056 getmsg word_wrap_string kdm_dsp_line 500 msd ` "" Datumming Canceled..."  
        0 led_off 2 led_off
        my_cancel   
        kon
        :exit
    endif
    PAUSE_CANCEL_ONLY? if ` Used for menu items that move the machine. 
        0 led_off 2 led_off
        my_cancel    
        kon
        :exit
    endif
    get_rtc_elapsed == LAPSE_TIME  ` save time we paused.
    PORT1 pget_bits DEVICE1_PMASK and dup
        == DEVICE1_PBITS PORT1 0 rot pset_bits     ` turn off spindle and aux's
    PORT2 if PORT2 pget_bits DEVICE2_PMASK and dup
        == DEVICE2_PBITS PORT2 0 rot pset_bits     ` turn off spindle and aux's
    endif
    ` because we use virtual ports, save them in device2 so we know to turn them on when leaving.
    PWMREG1 pget_bits if DEVICE2_PBITS SOL1_BIT or == DEVICE2_PBITS SOL1_CODE 1 solenoid_off endif
    PWMREG2 pget_bits if DEVICE2_PBITS SOL2_BIT or == DEVICE2_PBITS SOL2_CODE 1 solenoid_off endif
    
    0 == SPINDLE_ON? 4 led_off  ` turn off spindle led
    5 led_off 3 led_off  ` turn off Aux Leds.
    
    enable_motion
	pause_start_z
    true kdm_keyintr         ` set the keypad on
    pause_wait               ` do pause_wait then continue
    false kdm_keyintr         ` set the keypad off so keyfuncs don't cause threading issues. 
	0 led_off
    chk_any_motion? not idle_menu or if
          SYS_MSG? 2 and if "" Did Pause/Cancel\n" write_err endif
          ?AUTO_RESTART not LocalDNC? 1 and not land if
            kill_inque 
          endif
          DNC_AUTORUN 1 = if                ` V3.43 DNC VST
               kill_inque  ` INDVC> w@ 19 0 ioctl drop      `  kill input que so count is zero
               SYS_MSG? 2 and if "" prompt dnc autorun to 2\n" write_err endif
               2 == DNC_AUTORUN    ` promote dnc auto run as now ready to run
               3 == iBANNER_FUNC   -1 kdm_stroke
               fKDMTimeOut kdm_time_out       
               kon
               :exit
          endif
          eat_kdm
          update_start_time  ` adjust start time
          0 == ?PENDLY
          0 == iBANNER_FUNC 
          false == EXECUTING? 
          0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2* msd ` cancelled, do not display time.
          1 == iDNCHaltCode DNCEndOfJob
          
          ` v5.13 add the following because the above kill_inque could remove the SP0 that the firmware put in the buffer.
          in_hpgl? if 11 23 "" ;SP0;" ioctl drop endif  `  make sure to tell the HPGL parser to quit.
          
          make_idle_screen -1 kdm_stroke
          stop_motion all_off
          SYS_MSG? 2 and if "" Pause/Cancel exit\n" write_err endif
          fKDMTimeOut kdm_time_out   
          kon    
          :exit         ` exit in cancel mode
    endif
    false kdm_keyintr        ` set the keypad off
    monFP 500 msd ` Just in case they jog while in pause, since jogging sets monQP when done. JRC    
	1 pcoords? fdrop coord_Z? ualine wait_plot ` return to XY
    2 led_on  ` turn on start led
    ` when turning on solenoids, clear the bits mask so that the following pset bits to not change it
    SPINDLE_CODE code_to_bits drop swap PORT1 = if DEVICE1_PBITS else DEVICE2_PBITS endif
    and if SPINDLE_CODE code_to_bits pset_bits SPINDLE_DELAY #delay 1 == SPINDLE_ON? 4 led_on endif  ` spin up spindle, set flag
    
    DEVICE2_PBITS SOL1_BIT and if 
        DEVICE2_PBITS SOL1_BIT 1com and == DEVICE2_PBITS 
        SOL1_CODE 1 solenoid_on
        ` check if this is the spindle
        [ RPC? ] #ifdef
            SPINDLE_CODE code_to_bits 2drop PWMREG1 = if SPINDLE_DELAY #delay 1 == SPINDLE_ON? 4 led_on endif
        #endif
    endif
    DEVICE2_PBITS SOL2_BIT and if 
        DEVICE2_PBITS SOL2_BIT 1com and == DEVICE2_PBITS 
        SOL2_CODE 1 solenoid_on 
        ` check if this is the spindle
        [ RPC? ] #ifdef
            SPINDLE_CODE code_to_bits 2drop PWMREG2 = if SPINDLE_DELAY #delay 1 == SPINDLE_ON? 4 led_on endif
        #endif
    endif
    
    
    PORT1 DEVICE1_PBITS 0 pset_bits  ` turn on Aux's
    ` See if we need to turn on LEDs to.
    AUX1_MODE? 1 = if AUX1_CODE code_to_bits drop swap drop DEVICE1_PBITS and if 5 led_on endif endif 
    AUX2_MODE? 1 = if AUX2_CODE code_to_bits drop swap drop DEVICE1_PBITS and if 3 led_on endif endif 
    
    PORT2 if PORT2 DEVICE2_PBITS 0 pset_bits endif ` turn on aux's
    PEN_DOWN_DELAY #delay           ` pause for spindle
    pause_end_z
    eat_kdm
    true kdm_keyintr
    36 kdm_pause_key  ` enable the pause key. 
    SYS_MSG? 2 and if "" Exit Pause\n" write_err endif
    update_start_time  ` adjust start time
    
    2 == iBANNER_FUNC ` v3.03 put back to executing banner.
    99 gi 1 and == DISPLAY_TIME? ` reset variable
    0 show_pre_job_info
    kdm_dsp_rev  ` refresh display before enabling rtc_proc
    fKDMTimeOut kdm_time_out    
    kon ` Turn keyy funcs back on now
    ` 99 gi == DISPLAY_OPTIONS ` Reset display options from flash
	;
1 set_warning
: switch_to_flat
    1065 getmsg word_wrap_string kdm_dsp_line     ` "" Switching To Flat X"
    X_HOME == X_HOME_CYL Y_HOME == Y_HOME_CYL
    ` Have to put back because it could have been changed in switch_to_cyl
    1 gf 2 gf 3 gf set_scale
    0 load_axis_params
    0 load_jog_params
    6 led_off
    ?INDEXING if        ` If indexing then enable first driver only
        ` [ RPC? ] #ifdef 15 DriveC drive_map update_pos #endif
        1 pulse_enable
    else
        ` For RPD, the following does a drive map.
        cyl_off  ` bit is looked at to determine if in cyclindrical or not
    endif
    0 == CYL_MODE?

    X_HOME_FLAT Y_HOME_FLAT ssf_3d
    
    LIMIT_MASK LOWX and if 5 gf  9 gf 0 set_range else 9 gf fneg 9 gf 0 set_range endif ` change range of X Axis only
    500 msd
;

: switch_to_cyl
    1066 getmsg word_wrap_string kdm_dsp_line  ` "" Switching To Cyl X"
    X_HOME == X_HOME_FLAT Y_HOME == Y_HOME_FLAT
    CYL_SCALE UNITS if 25.4 f/ endif  2 gf 3 gf  set_scale  ` v3.01
    6 led_on
    ?INDEXING if        ` If indexing then enable second driver only
        ` [ RPC? ] #ifdef LaxisX DriveC drive_map update_pos #endif
        2 pulse_enable
    else
        cyl_on          ` bit is looked at to determin if in cyclindrical or not
    endif
    1 == CYL_MODE?
    cyl_mode_speeds

    X_HOME_CYL Y_HOME_CYL ssf_3d
    9 gf 4.0 f* fneg 9 gf 4.0 f* 0 set_range      ` change range of X axis only
    500 msd
   ;

` <DIAM> adjust_diam => <no_data>   ---  This takes the give diameter and set's the X axis using it.
: adjust_diam
    itof 1000.0 f/                 ` comes in as an integer so convert to float
    CYL_FACTOR fswap f/ CYL_SCALE UNITS if 25.4 f/ endif f*    ` v3.01 Take the magic number and setup the X, Y, and Z scales
    2 gf 3 gf set_scale       ` Leaves nothing on the stack
;

` < mode > < data > switch_x   (mode = 0 for commanded, mode 1 = toggle)
: switch_x
    wait_plot
    dup 0 = if  ` switch to flat
          make_idle_screen 
          CYL_MODE? if
              switch_to_flat
          endif
          drop drop  ` drop diameter, drop mode
          ?SOL1_LINK if SOL1_CODE 1 solenoid_on endif  ` if solenoid 1 is linked to cylindrical mode immediately on
    else
            make_idle_screen 
            CYL_MODE? not if  ` don't switch if already switched
                switch_to_cyl
            endif
            swap if   ` do we adjust for diameter
                adjust_diam     ` this needs the diameter as an integer on the stack
            else drop endif     ` else drop diameter
            ?SOL1_LINK if       ` if soloenoid 1 is linked to cylindrical mode
                SOL1_CODE 1 solenoid_off   ` IMMEDIATELY turn off solenoid
            endif
    endif
        ?DRIVE_ON if    ` if drives were on, turn them back on
            ?INDEXING not if 300 #delay mon 200 #delay endif 1 == ?DRIVE_ON  ` no need to do mon if using fourth driver
        endif
        SWITCH_X_DELAY #delay  `  solenoid commands are immediate so this needs to be immediate
;
: port_pause
    wait_plot   ` wait for job to finish last stroke
    1070 getmsg  kdm_dsp_line  ` 1070 "" Press START to      Continue."
    PORT1 pget_bits DEVICE1_PMASK and dup
        == DEVICE1_PBITS PORT1 0 rot pset_bits     ` turn off spindle and aux's
    PORT2 if PORT2 pget_bits DEVICE2_PMASK and dup
        == DEVICE2_PBITS PORT2 0 rot pset_bits     ` turn off spindle and aux's
    endif
    ` because we use virtual ports, save them in device2 so we know to turn them on when leaving.
    PWMREG1 pget_bits if DEVICE2_PBITS SOL1_BIT or == DEVICE2_PBITS SOL1_CODE 1 solenoid_off endif
    PWMREG2 pget_bits if DEVICE2_PBITS SOL2_BIT or == DEVICE2_PBITS SOL2_CODE 1 solenoid_off endif
	pause_start_z
    2 led_blink
    loop kdm_getkey 58 = until repeat    ` wait for start key
    2 led_on

    ` when turning on solenoids, clear the bits mask so that the following pset bits to not change it
    DEVICE2_PBITS SOL1_BIT and if DEVICE2_PBITS SOL1_BIT 1com and == DEVICE2_PBITS SOL1_CODE 1 solenoid_on endif
    DEVICE2_PBITS SOL2_BIT and if DEVICE2_PBITS SOL2_BIT 1com and == DEVICE2_PBITS SOL2_CODE 1 solenoid_on endif
    PORT1 DEVICE1_PBITS 0 pset_bits     ` turn on aux's
    PORT2 if PORT2 DEVICE2_PBITS 0 pset_bits endif    ` turn on aux's
    SPINDLE_DELAY #delay            ` turn on spindle
    pause_end_z

    -1 kdm_stroke
;

: clear_ptr [ hex ]
	800000 hpgl_mode [ decimal ] ;
: same_spot coords_2d? Y_SAVE f- fabs 0.01 inch_to_mm f<
	X_SAVE f- fabs 0.01 inch_to_mm f< land
	not if	coord_Z?									` save current Z
            ?CONTROLLED_Z if
                ZUP_FEED feedrate
                coords_2d? Z_LIFT fneg z_limit ualine       ` Lift Z
            endif
			XYUP_FEED feedrate
            X_SAVE Y_SAVE coord_Z? ualine
            ZUP_FEED feedrate
			X_SAVE Y_SAVE frot ualine					` go fast to old depth
	endif ;

0 ivar iTempVar
: manual_tool_change
    ` see if we shouldn't be here.
    restart? chk_motion? not or if :exit endif
    SPINDLE_ON?            ` save on stack spindle state
	spindle_off
	` wait for start button
    false kdm_keyintr
    PEN# 1+ 2* == TOOL_IDLE_STATE
	0 == #end_time
    ` 1071 "" Please Insert Tool "
    1071 getmsg  == iTempVar iTempVar kdm_dsp_line PEN# 1+ kdm_dspnum
	loop
		tool_change_idle_proc
		kdm_peekkey 0 >=
		if kdm_getkey dup
            58 = if drop 2 led_on  1 break       ` Start
            else
                dup 13 = if drop            ` exit key was pressed
                    0 == iDNCHaltCode       ` let DNC know the job is no longer running
                    DNCEndOfJob
                    end_motion my_cancel 0 break
                else 6 = if     ` set_surface key was pressed
                        1 == OPERATE_MODE
                        0 range_checking
                        ` 7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
                        show_z_box
                        8 4 kdm_jog 6 = if    ` pass in 6 key to change display
                            2 get_pos? 1 1072 getmsg ` 1072 "" Surface Set."
                        else
                            0 1073 getmsg ` 1073 "" Surface Not Set."
                        endif
                        kdm_dsp_line 1 second
                        hide_z_box
                        1074 getmsg  kdm_dsp_line  ` 1074 "" Lifting..."
                        if == Z_SURFACE X_HOME Y_HOME 0. set_soft_home endif    ` uses Z_SURFACE
                        0. 0. coord_Z? Z_SURFACE Z_LIFT fmin f+ fneg uline wait_plot
                        0 == OPERATE_MODE
                        iTempVar kdm_dsp_line PEN# 1+ kdm_dspnum
                        3 range_checking
                    endif
                endif    ` Cancel -- all_off replaced w/ cancel so incoming jobs cleared
			endif
		endif
	repeat
    true kdm_keyintr
    kdm_dsp_rev
`    -1 kdm_stroke
	drop  ` status not used
    if spindle_on endif   ` if spindle was on, turn it back on
	;

` added for support of JSS
: ucito_2d false == bUCito3D ;  ` currently not supported by translator
: ucito_3d true == bUCito3D ;

0 ivar BASE_DELAY

0 ivar SOL3_ACTIVE?
120 ivar SOL3_CURRENT
-100 ivar SOL3_ON_DELAY
100 ivar SOL3_OFF_DELAY
500 ivar PEN3_DOWN_DELAY
300 ivar PEN3_UP_DELAY

: penup 
    ` [ SHOW_PREVIEW_JOB ] #ifdef    
        get_graph_box 15 and if
            drop
            fp false == PEN_ACTIVE?
            0x00 0x30 set_graph_box
            :exit
        endif
    ` #endif
    
    chk_motion? not if drop :exit endif  ` V3.10 drop pen and exit, Don't DO ANYTHING.
    POCKET_MILLING? PD_OCCURED? not land if drop :exit endif  ` if pocket milling and pd has not occured, just exit.

    ` don't check the pen number if controlled+Pneum manual or pen2 won't come up
    ?MANUAL_TOOL not ?PNEUM_Z2 ?PNEUM_Z1 or and if 0 = else drop 1 endif
    ?CONTROLLED_Z land if    ` if controlled Z and PEN = # 1
        in_3d? not if
            MP_PASSES 1- == MP_PASSES                       ` dec number of passes to make
            SYS_MSG? 2 and if " Passes " MP_PASSES . nl endif 
            MP_PASSES 0 >= if                               ` Still more passes needed??
            ` Z_DEPTH Z_DEPTH_PASS f- 0.0001 f> Z_DEPTH_PASS 0.00001 f> land if 
                same_spot                                   ` move to PD spot if nec
                DISPLAY_DELTA? if wait_plot endif           ` we need a wait plot here just for the display to be correct.
                ZDN_FEED feedrate                           ` set plunge speed
                coords_2d? coord_Z? MP_BITESIZE f+          ` Z increment, OR...
                Z_DEPTH fmin fdup == Z_DEPTH_PASS ualine    ` Plunge to depth, save Z_DEPTH_PASS for Display.
                XYDN_FEED VS_PERCENT f* feedrate            ` set cut speed
                SYS_MSG? 2 and if 
                    " FEED    : " get_feedrate f. nl 
                    " SRC PTR : " MP_BUFFPTR . nl  
                endif 
                INDVC> w@ 36 ' MP_BUFFPTR ptrval ioctl drop         ` Reposition motion buffer to start pointer
                clear_ptr :exit
            else                                            ` no more passes needed
                MP_PASSES -1 = DISPLAY_DELTA? land if wait_plot endif           ` we need a wait plot here just for the display to be correct.
                2 set_override ` Don't override the penup z speed.
                ZUP_FEED feedrate
                coords_2d? Z_LIFT fneg z_limit ualine       ` Lift Z
                3 set_override ` Now turn overrides back on. 
            endif
        endif
    endif

    SOL3_ACTIVE? if
        SOL2_CODE if SOL2_CODE 0 solenoid_off endif
        SOL3_OFF_DELAY 0 <
        if " Negative OFF Not implemented yet."
            PWMREG3 0 255 set_bits
            PEN3_UP_DELAY delay
        else
            SOL3_OFF_DELAY abs delay
            PWMREG3 0 255 set_bits
            PEN3_UP_DELAY SOL3_OFF_DELAY - 0 max delay
        endif
    else
        0   ` leave initial delay
        ?PNEUM_Z1 if SOL1_CODE if SOL1_CODE 0 solenoid_off PEN_UP_DELAY max endif endif
        ?PNEUM_Z2 if SOL2_CODE if SOL2_CODE 0 solenoid_off PEN_UP_DELAY max endif endif
        AUX1_MODE? 2 = if AUX1_CODE code_to_bits swap set_bits AUX_UP_DELAY max endif
        AUX2_MODE? 2 = if AUX2_CODE code_to_bits swap set_bits AUX_UP_DELAY max endif
        /* now look for specific L/R pens */
        AUX1_MODE? 4 = USE_PEN 0 = land  AUX1_MODE? 5 = USE_PEN 1 = land or
            if AUX_UP_DELAY max AUX1_CODE code_to_bits swap set_bits endif
        AUX2_MODE? 4 = USE_PEN 0 = land  AUX2_MODE? 5 = USE_PEN 1 = land or
            if AUX_UP_DELAY max AUX2_CODE code_to_bits swap set_bits endif
        /* <n maxed> */ delay
        PORT2 if PORT2 0 60 set_bits endif       ` even though solenoid_off will clear these - clear them again anyway
    endif
    ?FOLLOW_X ?FOLLOW_Y or not if ` When following x or y, Z speed needs to follow FRO
        2 set_override        ` override feedrate override
    endif
	flush_plot
	slew_mode
    0 == PEN_ACTIVE?
    ;

: pendown
    ` [ SHOW_PREVIEW_JOB ] #ifdef    
        get_graph_box 15 and if
            drop
            0x10 0x30 set_graph_box   
            true == PEN_ACTIVE?
            :exit
        endif
    ` #endif
    stack_check       ` check for possible stack errors
    chk_motion? not if drop :exit endif  ` V3.10 drop pen and exit, Don't DO ANYTHING.
    true == PD_OCCURED?
    PEN_OVERRIDE -1 <> if drop PEN_OVERRIDE endif  ` if PEN_OVERRIDE, use it instead of passed value
    ` SYS_MSG? 2 and if "" Pendown " write_err dup 1+ write_err_num "" ,PEN# " write_err PEN# 1+ write_err_num "" \n" write_err endif
    dup PEN# <> if == PEN#
        ?MANUAL_TOOL SOL3_ACTIVE? not land if
            ?AUTO_SPINDLE if 1 == SPINDLE_ON? endif  ` make it turn the spindle ON afterwards
            manual_tool_change
            0 == USE_PEN
          `  if pen #2 but NOT both (pen # is always 1 less)
        else
            ` sol3 skip spindle, use Pen2 tool offsets
            ?AUTO_SPINDLE SPINDLE_ON? SOL3_ACTIVE? or not land if spindle_on endif  ` make it turn the spindle ON initially
            PEN# 1 = PEN# 0 > SOL3_ACTIVE? land or if
                80 gf == X_TOOl_OFFSET 81 gf == Y_TOOL_OFFSET
            else
                0.0 == X_TOOL_OFFSET 0.0 == Y_TOOL_OFFSET
            endif
            coords? VPSoftHome ualine wait_plot   ` do offset for tool change
            PEN# == USE_PEN
        endif
    else drop
          ?AUTO_SPINDLE SPINDLE_ON? not land if spindle_on endif  ` make it turn the spindle ON initially
    endif   ` end if new pen

    SOL3_ACTIVE? if
        SOL2_CODE if SOL2_CODE 0 solenoid_on endif
        SOL3_ON_DELAY 0 >
        if " Positive ON Not implemented yet."
            PEN3_DOWN_DELAY delay
            PWMREG3 SOL3_CURRENT dup 1com set_bits
        else
            PEN3_DOWN_DELAY SOL3_ON_DELAY + delay   ` on delay is negative
            PWMREG3 SOL3_CURRENT dup 1com set_bits
            SOL3_ON_DELAY abs delay
        endif
        PEN3_DOWN_DELAY ` leave delay for time calc
    else
        BASE_DELAY          ` init delay for FRO change  removed because using H board only
        ?PNEUM_Z1 if SOL1_CODE USE_PEN 1+ 1 and land if SOL1_CODE 0 solenoid_on  PEN_DOWN_DELAY max endif endif
        ?PNEUM_Z2 if SOL2_CODE USE_PEN 1+ 2 and land if SOL2_CODE 0 solenoid_on  PEN_DOWN_DELAY max endif endif
        AUX1_MODE? 2 = if AUX_DOWN_DELAY max AUX1_CODE code_to_bits set_bits endif
        AUX2_MODE? 2 = if AUX_DOWN_DELAY max AUX2_CODE code_to_bits set_bits endif
        /* now look for specific L/R pens */
        AUX1_MODE? 4 = USE_PEN 0 = land  AUX1_MODE? 5 = USE_PEN 1 = land or
            if AUX_DOWN_DELAY max AUX1_CODE code_to_bits set_bits endif
        AUX2_MODE? 4 = USE_PEN 0 = land  AUX2_MODE? 5 = USE_PEN 1 = land or
            if AUX_DOWN_DELAY max AUX2_CODE code_to_bits set_bits endif

        /* <delay's maxed> */ dup delay  ` dup delay for use in next if statement
    endif

    itof 2. f/ .001 f*  ` Take half of the PD delay and add to the tool_time
    pen_time_update    ` Update the tool_time counters with the fp time on the stack
    POCKET_MILLING? if coords_2d? Z_LIFT fneg z_limit ualine endif ` v2.83 move down to lift.
    ?CONTROLLED_Z not if ` Don't enable feedrate override for Controllerd_pneumatic Z 
        3 set_override      ` enable feedrate override
    endif
    ?CONTROLLED_Z USE_PEN 1+ 1 and land if    ` if controlled Z and PEN = # 1
        in_3d? not if
            ZDN_FEED feedrate                               ` set plunge speed
            MP_BITESIZE 0.00001 f> if                       ` do we have a valid bitesize?
                Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
                MP_BITESIZE f/ ftoi == MP_PASSES            ` calc # MP_BITESIZE passes needed to reach cut depth
                coords_2d? == Y_SAVE  == X_SAVE             ` save PD location
                coords_2d?
                Z_DEPTH MP_BITESIZE fmin                    ` plunge to smaller of cut depth or mp bitsize
                MP_PASSES 1+ == MP_TOTAL_PASSES             ` save total passes for display only.
                99 gi 2 and sign == DISPLAY_DELTA?          ` Use 'sign' because the value can only be 0 or 1
            else                                            ` no, (invalid bitesize)
                0 == MP_PASSES                              ` make sure this is our ONLY pass
                coords_2d? Z_DEPTH_PASS                     ` plunge to cut depth
            endif
            fdup == Z_DEPTH_PASS
            ualine
            in_hpgl? if
                hpgl_get_last_cmd? == MP_BUFFPTR
            else
                INDVC> w@ 35 ' MP_BUFFPTR ptrval ioctl drop         ` save pointer to position in motion buffer
            endif
            SYS_MSG? 2 and if " SRC PTR : " MP_BUFFPTR . nl endif 
        endif
    endif
    3 set_override      ` enable feedrate override
	machine_mode
	?INDIVIDUAL_CUTSPEED if
	    PEN# 1+ select 
	    => 140 gf ` Spindle 1 cut feedrate
	    => 141 gf ` Spindle 2 cut feedrate 
	    => 142 gf ` Both      cut feedrate
        default=> XYDN_FEED
        endselect
        fdup == XYDN_FEED 
	else
        XYDN_FEED 
    endif
    VS_PERCENT f* feedrate
    SYS_MSG? 2 and if " PD FEED " get_feedrate f. nl endif 
	1 == PEN_ACTIVE? ;

: na_msg 1103 getmsg kdm_dsp_line ` "" Option not allowed  during Pause Mode"
  750 msd ;

` tool_change added because JSS sends it and it needs to be dealt with
` if toolchange called just drop and do nothing. Added for JSS
: tool_change drop ;

4 led_on   ` BOOT LOCATION 3

: menu_lift_height             ` set tool lift
	chk_motion? if 0 :exit endif
    ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
    units_str      ` Either "" mm" or "" in."  
    1030 getmsg    ` "" Enter the Z Lift Height"
    1006 getmsg  CopyLineTrimColon  ` "" Z Lift Height"
    8 Z_LIFT 9 DLG_GetNum  ` Add 8 to the type so it shows the units string. 
    num_ok if 
        fdrop
    else
        0.0 fmax == Z_LIFT
    endif
    0 ;

: menu_z_speed             ` set z speed
	chk_motion? if 0 :exit endif
    1031 getmsg  kdm_dsp_line   ` 1031 "" Z-Axis Speed?       "
    
    1031 getmsg    ` "" Z-Axis Speed?            "
    1008 getmsg  CopyLineTrimColon  ` "" Z Axis Speed"
    10 ZDN_FEED TIMESCALE f* 1 DLG_GetNum 
    num_ok if 
        fdrop
    else
        TIMESCALE f/    
        521 gf fmin
        0.001 fmax == ZDN_FEED
    endif
    0 ;

: menu_clear_home     ` clear home
    chk_pause? if na_msg 0 :exit endif       ` see if paused
	chk_any_motion? if 0 :exit endif
	#clr_home
	800 1032 getmsg 1003 getmsg 0 DLG_MsgBox ` "" Home Cleared" ` "" Clear Home"
	0 ;

: menu_cut_depth             ` cut depth
	chk_motion? if 0 :exit endif
	
	make_cut_depth_dialog  ` call new routine.	
    chk_pause? if 	
        Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
        MP_BITESIZE f/ ftoi 1+ == MP_TOTAL_PASSES   ` calc # MP_BITESIZE passes needed to reach cut depth
        MP_TOTAL_PASSES Z_DEPTH_PASS 0.001 inch_to_mm f- MP_BITESIZE f/ ftoi - 1- == MP_PASSES ` current depth.
    endif
	0 :exit 
;

0 ivar cutspeed_menu#    
: submenu_spindle1_speed             ` set cut speed
	chk_motion? if 0 :exit endif
	menu_cursor? == cutspeed_menu#
	
    1256 getmsg  ` "" Spindle 1 "
    1000 getmsg  CopyLineTrimColon ` "" Cut Speed "
    10 140 gf TIMESCALE f* 1 DLG_GetNum
    num_ok if 
        fdrop
    else
        TIMESCALE f/ XYUP_FEED fmin 0.050 fmax 140 sf
    endif
    0 ;
: submenu_spindle2_speed             ` set cut speed
	chk_motion? if 0 :exit endif
	menu_cursor? == cutspeed_menu#
    1257 getmsg  ` "" Spindle 2 "
    1000 getmsg  CopyLineTrimColon ` "" Cut Speed "
    10 141 gf TIMESCALE f* 1 DLG_GetNum
    num_ok if 
        fdrop
    else
        TIMESCALE f/ XYUP_FEED fmin 0.050 fmax 141 sf
    endif
    0 ;
: submenu_spindleBoth_speed             ` set cut speed
	chk_motion? if 0 :exit endif
	menu_cursor? == cutspeed_menu#
    1258 getmsg  kdm_dsp_line ` "" Both Spindles"
    
    1258 getmsg  ` "" Both Spindles "
    1000 getmsg  CopyLineTrimColon ` "" Cut Speed "
    10 142 gf TIMESCALE f* 1 DLG_GetNum
    num_ok if 
        fdrop
    else
        TIMESCALE f/ XYUP_FEED fmin 0.050 fmax 142 sf
    endif
    0 ;
    
: menucut_speed
	chk_motion? if 0 :exit endif
	
    ?INDIVIDUAL_CUTSPEED if 
        UNITS if 2 fprec else 3 fprec endif
        0 == cutspeed_menu#
        1000 SetMenuTitle ` "" Cut Speed"
        ' submenu_spindle1_speed     1256 getmsg 140 gf menuFmake submenu_add  ` "" Spindle 1    : "
        ' submenu_spindle2_speed     1257 getmsg 141 gf menuFmake submenu_add  ` "" Spindle 2    : "
        ' submenu_spindleBoth_speed  1258 getmsg 142 gf menuFmake submenu_add  ` "" Both Spindles: "
        cutspeed_menu# 1+ start_submenu
        7 fprec
    else
	    ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
        1036 getmsg    ` "" Cut Speed?              "
        1000 getmsg CopyLineTrimColon  ` "" Cut Speed"
        10 XYDN_FEED TIMESCALE f* 1 DLG_GetNum 
        num_ok if 
            fdrop
        else
            TIMESCALE f/ XYUP_FEED fmin 0.050 fmax == XYDN_FEED
        endif
    endif
    0
;

/* -- Job Time dialog -- (not used) */
30  ivar FILE_RECL          ` Length of 1 file record (bytes)
0   ivar FILE_NUM           ` current file Number
10  ivar FILE_MAX           ` Number of files to save.
0   ivar SAVE_FILE_NUM      ` saveit on occation.

FILE_RECL FILE_MAX * 123 sysallocate ptr FILE_TBL
: FILE_NUM_CHK FILE_NUM 0 max FILE_MAX 1- min FILE_RECL * + FILE_TBL + ;
: isettm: ivar ;: constval FILE_NUM_CHK w!   ;
: fsettm: ivar ;: constval FILE_NUM_CHK !    ;
: ssettm: ivar ;: constval FILE_NUM_CHK s!   ;

: igettm: ivar ;: constval FILE_NUM_CHK w@   ;
: fgettm: ivar ;: constval FILE_NUM_CHK @    ;
: sgettm: ivar ;: constval FILE_NUM_CHK      ;

: FILE_NUM++ FILE_NUM 1+ dup FILE_MAX >= if drop 0 endif == FILE_NUM ;
: FILE_NUM-- FILE_NUM 1- dup 0 < if drop FILE_MAX 1- endif == FILE_NUM ;

0    sgettm: FILE_NAME      ` Get File name that is pointed to by FILE_NUM
20   fgettm: FILE_TIME      ` Get Time that File ran.
24   igettm: FILE_FLAGS     ` Get File Flags (how the job ended)
0    ssettm: >FILE_NAME     ` Set File Name
20   fsettm: >FILE_TIME     ` Set File Time
24   isettm: >FILE_FLAGS    ` Set File Flags

: init_file_times 1 FILE_MAX 1 step -1 >FILE_TIME FILE_NUM++ endstep ;
init_file_times

: DialogJobTimes
    InitScrollMessage
    1 FILE_MAX 1 step
        FILE_TIME 0 > if  ` check if there is a record.
            FILE_NAME AddScrollMsg AddScrollNL
            ""    Time " AddScrollMsg  FILE_TIME TimeToStr AddScrollMsg AddScrollNL 
            ` 60 /mod swap 60 /mod swap
            ` dup if itoa AddScrollMsg "" :" AddScrollMsg else drop ""   " AddScrollMsg endif
            ` itoa AddScrollMsg "" :" AddScrollMsg
            ` itoa AddScrollMsgPad
            FILE_FLAGS 15 and  
            dup if
                1+ 1 max 8 min select
                => ""    "
                => "" Canceled"
                => "" \007System Int."
                => "" \007Power Fail"
                => "" \007E-Stop"
                => "" Canceled"
                => "" Canceled"
                => "" Out of Bounds"
                endselect
                ""    " AddScrollMsg ` Pad out to be in same spot as TIME
                AddScrollMsg AddScrollNL
            else drop endif
        endif
        FILE_NUM--
    endstep
    scroll_buffer slen 0 = if ""    Time " AddScrollMsg 0 TimeToStr AddScrollMsg endif 
    320 set_dlg_width
    0 == DLG_YPOS
    1214 getmsg CopyLineTrimColon Scroll_Message_kdm20g drop ` "" The Last Job Took:"
    280 set_dlg_width
    4 == DLG_YPOS
;
    
: menu_job_time             ` job time
    chk_motion? if 0 :exit endif    ` Showing time of last job while running job would pause motion, so don't allow it
    chk_pause? if 
        calc_job_time       ` see if paused
        1062 getmsg    ` "" Current Job Time:"
    else
        1063 getmsg    ` ""  The Last Job Took:"
    endif
    pMsgStr s! "" \n" pMsgStr s+!  
    JOB_TIME 60.0 f* rftoi TimeToStr pMsgStr s+!
    
    ` <delay> <"button text"> <"message"> <"title"> 1 DLG_MsgBox
    -1 "" OK" pMsgStr 1004 getmsg 1 DLG_MsgBox ` "" Display Job Time"
    0 ;
    
    
0.0 fvar _MOVE_X_POS
0.0 fvar _MOVE_Y_POS
: change_move_dialog_value
    ACTIVE_CONTROL 1 max 4 min select
    => 5 == bFVAR_NUM _MOVE_X_POS 6 == MAX_DIGITS_ALLOWED 6011 EnterGetNum 0 = if == _MOVE_X_POS else fdrop endif ` X
        0 get_range X_HOME f- _MOVE_X_POS fmin == _MOVE_X_POS  ` Don't let them enter values out of bounds.
                    X_HOME f- _MOVE_X_POS fmax == _MOVE_X_POS 
    => 5 == bFVAR_NUM _MOVE_Y_POS 6 == MAX_DIGITS_ALLOWED 6013 EnterGetNum 0 = if == _MOVE_Y_POS else fdrop endif ` Y
        1 get_range Y_HOME f- _MOVE_Y_POS fmin == _MOVE_Y_POS  ` Don't let them enter values out of bounds.
                    Y_HOME f- _MOVE_Y_POS fmax == _MOVE_Y_POS 
    => 6025 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` MOVE button
    => 6027 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect    
;
: show_active_move_control ` < control > show_active_cut_depth_control
    ACTIVE_CONTROL 1 max 4 min select
    => 6011 glcd_deactivate_control drop  ` X
    => 6013 glcd_deactivate_control drop  ` Y
    => 6025 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` MOVE button
    => 6027 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect
    
    == ACTIVE_CONTROL
    ACTIVE_CONTROL 1 max 4 min select
    => 6011 glcd_activate_control drop  ` X
    => 6013 glcd_activate_control drop  ` Y
    => 6025 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` MOVE button
    => 6027 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    endselect
;

: update_move_dialog
    6011 _MOVE_X_POS UNITS if ftoa.2 else ftoa.units endif -1 -1 glcd_control_text drop                
    6013 _MOVE_Y_POS UNITS if ftoa.2 else ftoa.units endif -1 -1 glcd_control_text drop
;

: menu_move             ` move menu
    xchk if -2 :exit endif ` if this fails, return -2 so it gets out of the menu
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    5 == bFVAR_NUM
    
    hide_xyz_box
	
    normal_control_font
    InitScrollMessage
    2 fprec
    AddScrollNL AddScrollNL AddScrollNL AddScrollNL
    -2 scroll_buffer 1001 getmsg 0 DLG_MsgBox  ` "" Move X Y Axes" 
    cTEXT_COLOR == SAVE_TEXT_COLOR
    cBLACK == cTEXT_COLOR
    
    ` <"Text"> <X> <Y> <width> <height> <control number> make_group_box_dlg
    1285 getmsg DLG_XPOS 5 + DLG_YPOS 37 + 135 76 6010 make_group_box_dlg  ` "" Move To"
    
    "" X"  DLG_XPOS  5 + DLG_YPOS 50 + mover slen 2 + 12 * 20 6010 make_center_text_dlg
           DLG_XPOS 42 + DLG_YPOS 50 + 86 20 6011 make_sunken_box_dlg
    6010 2001 glcd_control_group drop ` change group control number
    6011 2001 glcd_control_group drop ` change group control number
           
    "" Y"  DLG_XPOS  5 + DLG_YPOS 80 + mover slen 2 + 12 * 20 6012 make_center_text_dlg
           DLG_XPOS 42 + DLG_YPOS 80 + 86 20 6013 make_sunken_box_dlg
    6012 2001 glcd_control_group drop ` change group control number
    6013 2001 glcd_control_group drop ` change group control number

    
    1286 getmsg DLG_XPOS 160 + DLG_YPOS 37 + 135 76 6015 make_group_box_dlg  ` "" Cur Pos"
    "" X"  DLG_XPOS 160 + DLG_YPOS 50 + mover slen 2 + 12 * 20 6015 make_center_text_dlg
           DLG_XPOS 200 + DLG_YPOS 50 + 86 20 XCOORD_CTRL make_sunken_box_dlg
    6015 2001 glcd_control_group drop ` change group control number
           
    "" Y"  DLG_XPOS 160 + DLG_YPOS 80 + mover slen 2 + 12 * 20 6017 make_center_text_dlg
           DLG_XPOS 200 + DLG_YPOS 80 + 86 20 YCOORD_CTRL make_sunken_box_dlg
    6012 2001 glcd_control_group drop ` change group control number

    ` <X> <Y> <"Text"> <control #> DLG_Select_Button
    DLG_XPOS  12 + DLG_YPOS 120 + 1309 getmsg 6025 DLG_Select_Button  ` "" Move"
    DLG_XPOS 180 + DLG_YPOS 120 + 1308 getmsg 6027 DLG_Select_Button  ` "" Cancel"           
    6025 2001 glcd_control_group drop ` change group control number
    6027 2001 glcd_control_group drop ` change group control number
    
    coords_2d? == _MOVE_Y_POS  == _MOVE_X_POS
    
    3 kdm_lines
    
    update_move_dialog
    refresh_xyz_box
    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    1 == ACTIVE_CONTROL
    1 show_active_move_control
    0 == PAUSE_CALLED? ` so we can bail out of this loop if they hit pause
    loop
    obounds? hw_estop? or PAUSE_CALLED? or if break endif ` kill the loop if we go out of bounds or estop.    
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if ACTIVE_CONTROL 3 = if ` MOVE button. 
                       /* do move */
                       "" Moving..." 2 kdm_dsp_status
                       1 == PAUSE_CANCEL_ONLY? 36 kdm_pause_key
                       start_motion _MOVE_X_POS _MOVE_Y_POS coord_Z? ualine fp 
                       update_xyz_box_when_moving
                       end_motion
                       0 == PAUSE_CANCEL_ONLY? -1 kdm_pause_key
                       coords_2d? == _MOVE_Y_POS  == _MOVE_X_POS
                       update_move_dialog
                       "" " 0 kdm_dsp_status ` clear status bar
                       1 show_active_move_control  ` set back to point at X
                   else 
                       ACTIVE_CONTROL 4 = if  ` Cancel button 
                           drop 
                           break 
                       else 
                           ` -1 == PASSED_IN_NUMBER 
                           ` change_move_dialog_value 
                           ACTIVE_CONTROL 1+ show_active_move_control ` automatically index to next box.
                       endif 
                   endif 
               endif
         dup  13 = if drop break endif ` cancel key
         dup  25 = over 15 = or if ACTIVE_CONTROL 1- 1 max show_active_move_control endif
         dup  24 = over 26 = or if ACTIVE_CONTROL 1+ 4 min show_active_move_control endif
         dup  11 = if ACTIVE_CONTROL 2 <= if dup == PASSED_IN_NUMBER change_move_dialog_value endif endif ` minus sign
         dup  40 = if ACTIVE_CONTROL 2 <= if dup == PASSED_IN_NUMBER change_move_dialog_value endif endif ` decimal pt
         dup  0 >= over 9 <= land if ACTIVE_CONTROL 2 <= if dup == PASSED_IN_NUMBER change_move_dialog_value ACTIVE_CONTROL 1+ show_active_move_control endif endif  
         drop
         update_move_dialog
      endif
    repeat
    SAVE_TEXT_COLOR == cTEXT_COLOR ` Return to custom font color
    save_kdmintr if kon endif
    -1 DLG_DisplayMsgBox
    1060 glcd_destroy_group drop ` main dialog controls
    2001 glcd_destroy_group drop
    erase_display  ` this is to get rid of the kdm_lines display
    0
;
: menu_spindle_speed             ` set spindle speed

    ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
    "" RPM"
    1037 getmsg    ` "" Spindle Speed?"
    1019 getmsg CopyLineTrimColon  ` "" Spindle Speed"
    10 iSPINDLE_SPEED 8 DLG_GetNum 
    num_ok if 
        drop
    else
        1 swap spindle_speed
    endif
    0 ;

: user9             ` set multipass tool increment depth
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    
    
    1038 getmsg  kdm_dsp_line   ` "" MP Depth Increment?  "
	MP_BITESIZE MPJ_BITESIZE fmax units_decpt kdm_getfnum  ` take maximum of both, this way if either is set, it will show last setting.
	3 = if fdrop 0 :exit endif
    fdup 0. f< not if == MP_BITESIZE else fdrop endif
    
    MPJ_BITESIZE 0.0 f<> == ANSWER? ` if MPJ_BITESIZE was previously set, indicate the last one was by job.
    0 kdm_cursor  ` turn cursor off
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop break endif     ` enter key - drop old value and exit loop
         dup  13 = if drop -1 == ANSWER? break endif  ` cancel key
         dup  15 = swap 26 = or if ANSWER? not == ANSWER? endif

         0 1 kdm_set_pos
         ANSWER? if  "" *By Job   By Contour"
         else        ""  By Job  *By Contour"
         endif
         kdm_dsp_string
      endif
    repeat
    1 kdm_cursor    ` turn cursor back on
    ANSWER? -1 = if         ` did we change?
        0.0 == MP_BITESIZE
        0.0 == MPJ_BITESIZE
    else
        ANSWER? if  
            MP_BITESIZE == MPJ_BITESIZE
            0.0 == MP_BITESIZE
        else
            0.0 == MPJ_BITESIZE
        endif
    endif
    300 msd 0 ;
    
0 ivar TEMP_ANSWER?
: menu_select_interface      ` User Interface
    chk_pause? if na_msg 0 :exit endif       ` see if paused
	chk_any_motion? if 0 :exit endif
    menu_cursor? == CONFIG_MENU#
	
    ` in_hpgl? if 1 else in_cnc? if 0 else 1 endif endif == TEMP_ANSWER?
    BOOT_MODE 2 = if 0 == TEMP_ANSWER? else 1 == TEMP_ANSWER? endif
	
    ` <"button 0"> <"button 1"> <"Question"> <"Title"> <default answer> DLG_Select <status 0=OK, -1=Cancel>
    "" G&M"
    "" HPGL" 
    1039 getmsg ` ""   Select Interface"
    1009 getmsg ` ""   Select Interface"
    TEMP_ANSWER? DLG_Select
    dup . sp. over . nl
    not if
        dup
        ` " ANSWER? " TEMP_ANSWER? . nl
        TEMP_ANSWER? <> if         ` did we change?
            == ANSWER? 
            ` exit current mode
            in_cnc? if "" M99" stuff_it
            else  in_hpgl? if "" !ZX" stuff_it endif
            endif
   
            ` " ANSWER? " ANSWER? . nl
            ` start new mode
            ANSWER? if
                1 dup == BOOT_MODE 69 si
                "" hpgl\n" stuff_it
            else
                2 dup == BOOT_MODE 69 si
                "" cnc\n" stuff_it
            endif
        else drop
        endif
    else drop endif
    0
   ;
: user11  ` Jog
    ?DRIVE_ON not if drive_err 0 :exit endif
    chk_motion? if 0 :exit endif
    start_motion
    chk_motion? if 0 :exit endif ` perform again because start_motion will not enable motion if error condition
    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    0 0 kdm_jog drop
    1
     ;
: menupark      ` menu PARKING
    ` host_mode? 256 and if na_msg 0 :exit endif       ` see if paused
    ` chk_any_motion? if 0 :exit endif
    menu_cursor? == CONFIG_MENU#
    
    ` <"button 0"> <"button 1"> <"button 2"> <"Question"> <"Title"> <default answer> DLG_Select <status 0=OK, -1=Cancel>
    1315 getmsg ` "" Go Home"                ` "2"
    1316 getmsg ` "" Park at edge of plot"   ` "1"
    1317 getmsg ` "" Do not park"            ` "0" 
    1040 getmsg ` "" Park at End of Job?"
    1010 getmsg ` "" Parking"
    ?PARK DLG_Select3
    not if == ?PARK ?PARK 48 si else drop endif
    0 ;

: submenudynamichome
    menu_cursor? == DYNAMIC_HOME_MENU#
    
    ?DRIVE_ON not if drive_err 0 :exit endif
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    ?DATUMMED not if datum_err 0 :exit endif                 ` not allowd if machine has not be datummed.
    CYL_MODE? if cyl_err 0 :exit endif  ` Not allowed in cylindrical mode.
    
    make_idle_screen
    5 == OPERATE_MODE     ` used for displaying messages during jogging (see jog_advanced_func)
    
    8 0 kdm_jog           ` Jog to set Top Left home.
    
    0 == OPERATE_MODE
    end_motion
    dup 1 = swap 12 = or if    ` if 1 (SET HOME) or 12 (ENTER)
        update_pos
        0 get_pos? == DYNAM_HOME_X1
        1 get_pos? == DYNAM_HOME_Y1
    else
        0 :exit 
    endif
    
    6 == OPERATE_MODE     ` used for displaying messages during jogging (see jog_advanced_func)
    8 0 kdm_jog           ` Jog to set Top Left home.
    0 == OPERATE_MODE
    end_motion
    dup 1 = swap 12 = or if    ` if 1 (SET HOME) or 12 (ENTER)
        update_pos
        0 get_pos? == DYNAM_HOME_X2
        1 get_pos? == DYNAM_HOME_Y2
    else
        0 :exit 
    endif
    erase_display
    0
;
0 ivar DYNAMIC_HOME_LOC
: submenudynamic_core
   menu_cursor? == DYNAMIC_HOME_MENU#
   ?DRIVE_ON not if drive_err 0 :exit endif
   chk_pause? if na_msg 0 :exit endif       ` see if paused
   chk_any_motion? if 0 :exit endif
   ?DATUMMED not if datum_err 0 :exit endif                 ` not allowd if machine has not be datummed.
   CYL_MODE? if cyl_err 0 :exit endif  ` Not allowed in cylindrical mode.
   
   start_motion XYUP_FEED feedrate
   ` Do not go to lift if pocket milling.
   menu_leave ` leave menu early to avoid the blinking of the screen at the end because of the -2 to exit the menu.
   make_idle_screen
   ?CONTROLLED_Z if
        POCKET_MILLING? if
            0 get_pos? 1 get_pos? 0.005 umaline fp  ` lift to top if pocket milling.
        else
            coords_2d? Z_LIFT fneg z_limit ualine   ` lift Z
        endif
   endif
   wait_plot
   DYNAMIC_HOME_LOC 1 max 5 min select
    => DYNAM_HOME_X1 DYNAM_HOME_X2 fmin DYNAM_HOME_Y1 DYNAM_HOME_Y2 fmax ` Top-Left
    => DYNAM_HOME_X1 DYNAM_HOME_X2 fmax DYNAM_HOME_Y1 DYNAM_HOME_Y2 fmax ` Top-Right
    => DYNAM_HOME_X1 DYNAM_HOME_X2 fmin DYNAM_HOME_Y1 DYNAM_HOME_Y2 fmin ` Bottom-Left
    => DYNAM_HOME_X1 DYNAM_HOME_X2 fmax DYNAM_HOME_Y1 DYNAM_HOME_Y2 fmin ` Bottom-Right
    => DYNAM_HOME_X1 DYNAM_HOME_X2 f+ 2.0 f/ DYNAM_HOME_Y1 DYNAM_HOME_Y2 f+ 2.0 f/  ` Center
   endselect
   1 == PAUSE_CANCEL_ONLY? 36 kdm_pause_key                        ` re-enable pause key
   2 get_pos? umaline fp
   DYNAMIC_HOME_LOC 1 max 5 min select
    => 1265 getmsg kdm_dsp_line  ` "" Top Left "
    => 1266 getmsg kdm_dsp_line  ` "" Top Right "
    => 1267 getmsg kdm_dsp_line  ` "" Bottom Left "
    => 1268 getmsg kdm_dsp_line  ` "" Bottom Right "
    => 1269 getmsg kdm_dsp_line  ` "" Center "
   endselect
   0 1 pos 1077 getmsg  kdm_dsp_string     ` 1077 "" Going Home..."
   update_xyz_box_when_moving
   0 == PAUSE_CANCEL_ONLY?  -1 kdm_pause_key ` done moving, disble pause key.
   wait_plot #set_home ack_blink
   1075 getmsg kdm_dsp_line 200 msd    ` 1075 "" Home Set."
   end_motion
   ` setting preserved home so it remembers it!!!
   ?PRESERVE_HOME if
       0 get_pos? 110 set_float
       1 get_pos? 111 set_float
   endif
   0 == DYNAMIC_HOME_MENU#  ` reset back to 0 because we are exiting with -2 
   -2
;    
: submenudynamic_TopLeft
   1 == DYNAMIC_HOME_LOC ` Top-Left
   submenudynamic_core
;
: submenudynamic_TopRight
   2 == DYNAMIC_HOME_LOC ` Top Right
   submenudynamic_core
;
: submenudynamic_BotLeft
   3 == DYNAMIC_HOME_LOC ` Bottom Left
   submenudynamic_core
;
: submenudynamic_BotRight
   4 == DYNAMIC_HOME_LOC ` Bottom right
   submenudynamic_core
;
: submenudynamic_Center
   5 == DYNAMIC_HOME_LOC ` Center
   submenudynamic_core
;
: menudynamichome
    1260 SetMenuTitle  ` ""  Dynamic Home"
    ' submenudynamichome      1261 getmsg submenu_add  ` "" Select Corners "
    ' submenudynamic_TopLeft  1265 getmsg submenu_add  ` "" Top Left "
    ' submenudynamic_TopRight 1266 getmsg submenu_add  ` "" Top Right "
    ' submenudynamic_BotLeft  1267 getmsg submenu_add  ` "" Bottom Left "
    ' submenudynamic_BotRight 1268 getmsg submenu_add  ` "" Bottom Right "
    ' submenudynamic_Center   1269 getmsg submenu_add  ` "" Center "
    DYNAMIC_HOME_MENU# 1+ start_submenu
    0
;

: menusethome
    ?DRIVE_ON not if drive_err 0 :exit endif
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    ?DATUMMED not if datum_err 0 :exit endif                 ` not allowd if machine has not be datummed.
    CYL_MODE? if cyl_err 0 :exit endif  ` Not allowed in cylindrical mode.
    
    8 kdm_lines
    make_xyz_box refresh_xyz_box
    
    cls
    0 4 pos 1330 getmsg word_wrap_string kdm_dsp_string  ` "" Select Preset Home number to define"
    12 select_pre_home   ` pass in ENTER key for key selection
    -1 <> if
       3 == OPERATE_MODE     ` used for displaying messages during jogging
       monFP                 ` Should be in QP now so bump it up for motion.
       7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
       
       4 kdm_config? drop 1 step I kdm_erase_line endstep  
       0 4 pos 1331 getmsg word_wrap_string kdm_dsp_string ` "" Jot to location, press Set Home"
        
       8 0 kdm_jog
       dup 1 = swap 12 = or if    ` if 1 (SET HOME) or 12 (ENTER)
           cls 
           ?PRESERVE_HOME         ` save on stack
           1 == ?PRESERVE_HOME    ` force to save in flash
           set_pre_home           ` set home to current position
           == ?PRESERVE_HOME      ` reset
           ` setting preserved home so it remembers it!!!
           ?PRESERVE_HOME if
               0 get_pos? 110 set_float
               1 get_pos? 111 set_float
           endif
       endif
       0 == OPERATE_MODE
       end_motion
    endif
    3 kdm_lines
    erase_display ` used to get rid of the kdm_lines
    0
;
: menuloadhome
    ?DRIVE_ON not if drive_err 0 :exit endif
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    ?DATUMMED not if datum_err 0 :exit endif                 ` not allowd if machine has not be datummed.
    CYL_MODE? if cyl_err 0 :exit endif  ` Not allowed in cylindrical mode.
    
    8 kdm_lines
    make_xyz_box refresh_xyz_box
    
    cls
    
    0 4 pos 1332 getmsg word_wrap_string kdm_dsp_string ` "" Select Preset Home number to Load, Press Set Home"  
    1 select_pre_home    ` pass in SET HOME key for selection
    -1 <> if
       1 == PAUSE_CANCEL_ONLY? 36 kdm_pause_key                        ` re-enable pause key
       start_motion XYUP_FEED feedrate
       ` Do not go to lift if pocket milling.
       ?CONTROLLED_Z if
            POCKET_MILLING? if
                0 get_pos? 1 get_pos? 0.005 umaline fp  ` lift to top if pocket milling.
            else
                coords_2d? Z_LIFT fneg z_limit ualine   ` lift Z
            endif
       endif
       wait_plot
       0. 0. ssf_3d ` clear home so display shows we are moving to proper location.
       PREHOME 2 * 110 + gf PREHOME 2 * 111 + gf 2 get_pos? umaline fp
       update_xyz_box_when_moving
       1075 getmsg 1 kdm_dsp_status 600 msd    ` "" Home Set."
       0 == PAUSE_CANCEL_ONLY? -1 kdm_pause_key  
       #set_home ack_blink
       end_motion
       ` setting preserved home so it remembers it!!!
       ?PRESERVE_HOME if
           0 get_pos? 110 set_float
           1 get_pos? 111 set_float
       endif
    endif
    3 kdm_lines
    erase_display ` used to get rid of the kdm_lines
    0
;
: menupocket
    1041 getmsg  kdm_dsp_line  ` 1041 "" Pocket Milling Mode?"   Option to clear replay buffer
    0 kdm_cursor  ` turn cursor off
    ` <"button 0"> <"button 1"> <"Question"> <"Title"> <default answer> DLG_Select <0=OK, -1=Cancel>
    1283 getmsg 1282 getmsg 1041 getmsg 1022 getmsg POCKET_MILLING? DLG_Select  ` "" On ,  OFF, Pocket Milling Mode?, Pocket Milling"
    not if == POCKET_MILLING? else drop endif
    0
;
: purgejob
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    ` "" Purge Job = 1013"
    0 1042 getmsg 1013 getmsg DLG_YesNoEx ` "" Purge Replay Buffer?"  Option to clear replay buffer
    drop 0 = if
        nl " Buffer Not Purged... " nl
    else
       INDVC> w@ 37 0 ioctl drop       `  Kill replay buffer
        nl " Replay Buffer Purged! " nl   ` only sent to terminal
		0 == #BATCH_NUM		` presume we don't want them to accidentally batch a new job
        0 == BATCHRUN?
        0 == MPJ_RUN?
    endif
    0
;
: runselftext       ` Runs self-test macro
    menu_cursor? == CONFIG_MENU#
    chk_pause? if na_msg 0 :exit endif       ` see if paused
    chk_any_motion? if 0 :exit endif
    0 1043 getmsg 1013 getmsg DLG_YesNoEx ` "" Run Self-Test?"
    drop 0 = if
        nl " Self-Test Aborted! " nl
    else
        nl " Self-Test Selected " nl
        menu_leave
        in_hpgl? if "" \n!ZX\n" stuff_it endif
        "" \nself_test\n" stuff_it
    endif
    0
;    

: setdwellup  ` Override parameter for PEN_UP_DELAY NOT SAVED IN FLASH
    ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
    1277 getmsg ` "" msec"
    1044 getmsg    ` "" Dwell Up?              "
    1016 getmsg  CopyLineTrimColon  ` "" Set Dwell Up"
    10 PEN_UP_DELAY 8 DLG_GetNum ` pass in 8 to indicate there is a Units string. 
    num_ok if 
        drop
    else
        == PEN_UP_DELAY
    endif
    0
;

: setdwelldown
    ` <"Message"> <"Title"> <size> <default number> <0=int,1=float> DLG_GetNum <status 0=OK, -1=cancel pressed>
    1277 getmsg ` "" msec"
    1045 getmsg    ` "" Dwell Down?              "
    1017 getmsg CopyLineTrimColon  ` "" Set Dwell Down"
    10 PEN_DOWN_DELAY 8 DLG_GetNum ` pass in 8 to indicate there is a Units string.
    num_ok if 
        drop
    else
        == PEN_DOWN_DELAY
    endif
    0
;

` <none> setcyldiam <true/false>  did it work or get canceled or failed. if in cyl sets scales and axis_params
: setcyldiam
    chk_any_motion? if 0 :exit endif                        ` can't do a set_scale in motion so don't try
    loop                                                    ` loop required to re-ask question if necessary
    
        units_str      ` Either "" mm" or "" in."  
        1068 getmsg    ` "" Enter Cylinder Diameter"
        pDialogMsg s! 
        "" \n" pDialogMsg s+! 
        .25 inch_to_mm ftoa.units pDialogMsg s+! ""  -> " pDialogMsg s+!
        12. inch_to_mm ftoa.units pDialogMsg s+! 
        pDialogMsg
        1018 getmsg  CopyLineTrimColon  ` "" Cyl Diameter"
        8 170 gf 9 DLG_GetNum  ` Add 8 to the type so it shows the units string.
        
        num_ok if 
            fdrop
            0 break
        else
            fdup fdup 12. inch_to_mm f<= fswap .25 inch_to_mm f>= land if  ` make sure value is within restraints
                170 set_float                                   ` set the value to flash
                CYL_MODE? if                      ` check if in Cylindrical mode
                    170 gf 1000. f* ftoi adjust_diam            ` Read the diameter, convert to integer and sets scale
                endif
                1  break                                        ` Leave TRUE on stack, it worked, get out
            else
                fdrop 
            endif
        endif
    repeat
    ` because the user can change this without switching axis, this code must be here to make sure velocities are right
    CYL_MODE? if      ` Only set these if in Cylindrical
        500 gf calc_cyl_vel CYL_VMAX calc_cyl_vel 502 gf calc_cyl_vel 503 gf 0. 0 set_axis_params ` Set Cut velocities
        507 gf calc_cyl_vel 505 gf calc_cyl_vel 506 gf calc_cyl_vel  0 set_jog_params   ` Set jog velocities
    endif

;

` ask user for batch ops
: batchops
    1046 getmsg ` "" Batch Count?" 
    1015 getmsg ` "" Batching"
    10 #BATCH_NUM 0 DLG_GetNum 
    num_ok if 
        drop
    else
        0 == AUTORUN?   ` don't allow auto-run when enableing batch ops
        0 == BATCHRUN?  ` do not enable until end of job.
		200 msd        	` delay ahead in case rtc were to fire
		== #BATCH_NUM
    endif
    0
;
: set_display_units ` <0=normal,1=mm> set_display_units
    == DISPLAY_UNITS
    ` if in metric, set the jog scale according.
    UNITS 0 = DISPLAY_UNITS 1 = land if
        25.4 25.4 25.4 set_jog_scale
    else
        1.0 1.0 1.0 set_jog_scale
    endif
    7 units_decpt kdm_float_size  ` make sure float size is set per units.
;

` 0 ivar datum_menu#

: submenu_units
    menu_cursor? == CONFIG_MENU#
    DISPLAY_UNITS == ANSWER?
    ` <"button 0"> <"button 1"> <"Question"> <"Title"> <default answer> DLG_Select <status 0=OK, -1=Cancel>
    "" Imperial" 
    "" Metric"
    "" " ` 1024 getmsg ` ""   Display Units"
    1024 getmsg ` ""   Display Units"   ` Title 
    ANSWER? DLG_Select
    not if
        dup
        ANSWER? <> if         ` did we change?
            == ANSWER? 
        else drop
        endif
    else drop endif
    ANSWER? if 1 == DISPLAY_UNITS
    else       0 == DISPLAY_UNITS
    endif
    DISPLAY_UNITS set_display_units 
    DISPLAY_UNITS 96 si
    UNITS DISPLAY_UNITS <> if
        20 file_size 0 > if
            1080 getmsg  kdm_dsp_line  ` 1080 ""   Please Wait..."
            20 load
            4000 #delay
        endif
    endif
    -1 kdm_stroke
    0
;

: SubDNCMode
    menu_cursor? == CONFIG_MENU#
    chk_any_motion? if :exit endif
    ` 1148 getmsg kdm_dsp_line      ` 1148 "" Select DNC Mode"
    
    LocalDNC? == ANSWER?
    ` <"button 0"> <"button 1"> <"Question"> <"Title"> <default answer> DLG_Select <status 0=OK, -1=Cancel>
    "" Remote DNC" 
    "" Local  DNC"
    1148 getmsg ` ""   Select DNC Mode"
    1150 getmsg ` ""   DNC Mode"   ` Title 
    ANSWER? DLG_Select
    not if
        dup
        ANSWER? <> if         ` did we change?
            == ANSWER? 
        else drop
        endif
    else drop endif
    LocalDNC? ANSWER? <> if         ` did we change?
        ANSWER? == LocalDNC?
        LocalDNC? 207 si
        alt_ethernet        ` see if we need to change modes and toggle devices
    endif
    0
;

: SubBDNC
    menu_cursor? == CONFIG_MENU#
    chk_any_motion? if :exit endif
    "" Do Replay?" kdm_dsp_line      ` 1148 "" Select DNC Mode"
    do_replay? if 1 else 0 endif == ANSWER?
    0 kdm_cursor
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop break endif     ` enter key - drop old value and exit loop
         dup  13 = if drop do_replay? == ANSWER? break endif  ` cancel key
         dup  15 = if ANSWER? 1- == ANSWER? endif         ` left arrow
              26 = if ANSWER? 1+ == ANSWER? endif         ` right arrow
         ANSWER? 0 max 1 min == ANSWER?

         0 1 pos
         ANSWER? 1+ 1 max 2 min select
         =>  ""    *No      Yes     "
         =>  ""     No     *Yes     "
         endselect
         kdm_dsp_string
      endif
    repeat
    1 kdm_cursor
    ANSWER? == do_replay?
    0
;

: SubAllowAlt
    menu_cursor? == CONFIG_MENU#
    chk_any_motion? if :exit endif
    "" Is Serial?"  kdm_dsp_line      ` 1148 "" Select DNC Mode"
    is_serial? == ANSWER?
    0 kdm_cursor
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         dup  12 = if drop break endif     ` enter key - drop old value and exit loop
         dup  13 = if drop is_serial? == ANSWER? break endif  ` cancel key
         dup  15 = if ANSWER? 1- == ANSWER? endif         ` left arrow
              26 = if ANSWER? 1+ == ANSWER? endif         ` right arrow
         ANSWER? 0 max 1 min == ANSWER?

         0 1 pos
         ANSWER? 1+ 1 max 2 min select
         =>  ""    *No      Yes     "
         =>  ""     No     *Yes     "
         endselect
         kdm_dsp_string
      endif
    repeat
    1 kdm_cursor
    is_serial? ANSWER? <> if         ` did we change?
        ANSWER? if norm_ethernet endif
        ANSWER? == is_serial?
    endif
    0
;
0 ivar tok
100 998 sysallocate ptr ptok_str
: token_err_detect tok not if ptok_str s! 1 == tok else drop endif ;
: subtok ptok_str kdm_dsp_line kdm_getkey drop 0 ;
: subreport 4 eth_intf 0 ;
: submenu_XLim
    menu_cursor? == CONFIG_MENU#
    LIMIT_MASK LOWX and if LIMIT_MASK LOWX 1com and == LIMIT_MASK
                        else LIMIT_MASK LOWX or == LIMIT_MASK endif
    LIMIT_MASK 27 si
    LIMIT_MASK if
        1 set_machine_fault 0 == ?DATUMMED
    else
        0 set_machine_fault 1 == ?DATUMMED
    endif
    0
;

: submenu_YLim
    menu_cursor? == CONFIG_MENU#
    LIMIT_MASK LOWY and if LIMIT_MASK LOWY 1com and == LIMIT_MASK
                      else LIMIT_MASK LOWY or == LIMIT_MASK endif
    LIMIT_MASK 27 si
    LIMIT_MASK if
        1 set_machine_fault 0 == ?DATUMMED
    else
        0 set_machine_fault 1 == ?DATUMMED
    endif
    0
;

: submenu_ZLim
    menu_cursor? == CONFIG_MENU#
    LIMIT_MASK LOWZ and if LIMIT_MASK LOWZ 1com and == LIMIT_MASK
                        else LIMIT_MASK LOWZ or == LIMIT_MASK endif
    LIMIT_MASK 27 si
    LIMIT_MASK if
        1 set_machine_fault 0 == ?DATUMMED
    else
        0 set_machine_fault 1 == ?DATUMMED
    endif
    0
;
: SubDriveTemp
    menu_cursor? == CONFIG_MENU#
    3 kdm_lines
    1250 getmsg kdm_dsp_line ` "" Drive Temperature"
    koff
    0 kdm_cursor
    loop
        0 kdm_scankey -1 <>  if
            1 kdm_scankey 13 = if break endif
        endif
        0 get_drive_temp 1 9 1 step 30 msd 0 get_drive_temp f+ endstep 10.0 f/
        UNITS if
            4 1 pos 1 kdm_dspfnum ""  DegC" kdm_dsp_string
        else
            4 1 pos CtoF 1 kdm_dspfnum ""  DegF" kdm_dsp_string
        endif
    repeat
    kon
    erase_display
    0
;

: submenu_Individual_CutSpeed
    menu_cursor? == CONFIG_MENU#
    ?INDIVIDUAL_CUTSPEED if 0 == ?INDIVIDUAL_CUTSPEED else 1 == ?INDIVIDUAL_CUTSPEED endif
    CONFIG_BITS 55 si
    true == SpecialMenus?
    0
;
` <drive> motor_phjase_test_result -> <A L->R> <A R->L> <B L->R> <B R->L>
1 ivar MOTOR_PHASE_TEST_AVAILABLE
ifmissing motor_phase_test_start 0 == MOTOR_PHASE_TEST_AVAILABLE
MOTOR_PHASE_TEST_AVAILABLE #ifdef
: mpt
  15 motor_phase_test_start " Result is " . nl
    2 fprec
    nl 0 motor_phase_test_result
      nl " Motor 1 - Phase A   L-R   " 4 fpluck f.  "  uS "
      nl " Motor 1 - Phase A   R-L   "  frot  f.  "  uS "
      nl " Motor 1 - Phase B   L-R   "  fswap f.  "  uS "
      nl " Motor 1 - Phase B   R-L   "        f.  "  uS "
    nl 1 motor_phase_test_result
      nl " Motor 2 - Phase A   L-R   " 4 fpluck f.  "  uS "
      nl " Motor 2 - Phase A   R-L   "  frot  f.  "  uS "
      nl " Motor 2 - Phase B   L-R   "  fswap f.  "  uS "
      nl " Motor 2 - Phase B   R-L   "        f.  "  uS "
    nl 2 motor_phase_test_result
      nl " Motor 3 - Phase A   L-R   " 4 fpluck f.  "  uS "
      nl " Motor 3 - Phase A   R-L   "  frot  f.  "  uS "
      nl " Motor 3 - Phase B   L-R   "  fswap f.  "  uS "
      nl " Motor 3 - Phase B   R-L   "        f.  "  uS "
    nl 3 motor_phase_test_result
      nl " Motor 4 - Phase A   L-R   " 4 fpluck f.  "  uS "
      nl " Motor 4 - Phase A   R-L   "  frot  f.  "  uS "
      nl " Motor 4 - Phase B   L-R   "  fswap f.  "  uS "
      nl " Motor 4 - Phase B   R-L   "        f.  "  uS "
;

: AddPhaseTime ftoa.2 AddScrollMsg ""  uS\n" AddScrollMsg ; 
: AddPhaseValues 
  "" Phase A L-R " AddScrollMsg 4 fpluck AddPhaseTime
  "" Phase A R-L " AddScrollMsg frot     AddPhaseTime
  "" Phase B L-R " AddScrollMsg fswap    AddPhaseTime
  "" Phase B R-L " AddScrollMsg AddPhaseTime
;
: show_phases
    15 motor_phase_test_start not if
	    InitScrollMessage
        0 motor_phase_test_result
          "" --- Motor 1 ---\n" AddScrollMsg AddPhaseValues
        1 motor_phase_test_result
          "" --- Motor 2 ---\n" AddScrollMsg  AddPhaseValues
        2 motor_phase_test_result
          "" --- Motor 3 ---\n" AddScrollMsg
          DRIVE_ENABLE_MASK 4 and not if "" (Not Used)\n" AddScrollMsg endif
          AddPhaseValues
        3 motor_phase_test_result
          "" --- Motor 4 ---\n" AddScrollMsg  
          DRIVE_ENABLE_MASK 8 and not if "" (Not Used)\n" AddScrollMsg endif
          AddPhaseValues
        "" Motor Phase Test" scroll_message_kdm20g drop 
    endif
    2 set_machine_fault
    false == ?DRIVE_ON
    false == ?DATUMMED
    false == ?HOMESET_CYL
    false == ?HOMESET
    LIMIT_MASK not if 0 set_machine_fault 1 == ?DATUMMED endif 
   1  ` must return number when its a menu item
   ;
#endif

0 ivar CUSTOM_COLOR
: show_color_scheme_box
    COLOR_SCHEME 0 max 10 min 1+ select
    => ""    Ocean  ->"  ` 0
    => "" <-  Sky   ->"  ` 1
    => "" <-Cardinal->"  ` 2
    => "" <-  Mint  ->"  ` 3
    => "" <- Night  ->"  ` 4
    => "" <-  Gold  ->"  ` 5
    => "" <- Sliver ->"  ` 6
    => "" <-  Pine  ->"  ` 7
    => "" <- Mauve  ->"  ` 8
    => "" <- Coral  ->"  ` 9
    => "" <- Custom   "  ` 10
    endselect 
    -2 swap 1281 getmsg "" Appearance" 1 DLG_MsgBox  ` "" Select color scheme, Display Colors"
    12 cHILITE 0x200 glcd_control_colors drop  ` change hilite color.
    "" Sample Text" kdm_dsp_line
;
: show_color_box
    CUSTOM_COLOR 1900 - 1 max 6 min select
    => ""  HiLight ->" cHILITE
    => "" <- Title ->" cTITLES ` Title
    => "" <-Backgrd->" BGCOLOR  ` BGCOLOR
    => "" <-Window ->" cWINDOW_COLOR ` Window
    => "" <-WinText->" cTEXT_COLOR ` Window Text
    => "" <- Text    " cBG_TEXT_COLOR
    endselect
    init_scroll_buffer
    "" Use Up/Dn to change.\nColor Idx:" AddScrollMsg
    3 AddScrollNum
    
    -2 swap scroll_buffer "" Appearance" 1 DLG_MsgBox  ` "" Select color scheme"
   800 cTITLES 0x200 glcd_control_colors drop  ` change hilite color.
    12 cHILITE 0x200 glcd_control_colors drop  ` change hilite color.
    "" Sample Text" kdm_dsp_line
;
    
: update_window_colors
    3 kdm_lines 
    make_xyz_box refresh_xyz_box 
    0 == FEED_SHOWN?   XYDN_FEED TIMESCALE f* 0 get_current_fro? f* set_feed_box
    0 == ZDEPTH_SHOWN? Z_DEPTH set_zdepth_box
    0 == ZLIFT_SHOWN?  Z_LIFT set_zlift_box
;
: menu_appearance_key_up
    CUSTOM_COLOR if
        CUSTOM_COLOR 1900 - 1 max 6 min select
        => cHILITE 1- 1 max == cHILITE show_color_box
        => cTITLES 1- 1 max == cTITLES show_color_box
        => BGCOLOR 1- 1 max == BGCOLOR COLOR_SCHEME config_colors show_color_box
        => cWINDOW_COLOR 1- 1 max == cWINDOW_COLOR update_window_colors show_color_box
        => cTEXT_COLOR   1- 1 max == cTEXT_COLOR   update_window_colors show_color_box
        => cBG_TEXT_COLOR 1- 1 max == cBG_TEXT_COLOR COLOR_SCHEME config_colors show_color_box
        endselect
    endif
;
: key_up_repeat
    500 == key_time_dly
    menu_appearance_key_up
    loop
        0 kdm_scankey -1 <> if 1 kdm_scankey 128 and until endif ` look for break key.
        key_time_dly 1- == key_time_dly 1 msd
        key_time_dly 0 <= if
            50 == key_time_dly
            menu_appearance_key_up
        endif
        ` hw_pause? if break endif
        kdm20g_pump
    repeat
;
: menu_appearance_key_down
    CUSTOM_COLOR if
        CUSTOM_COLOR 1900 - 1 max 6 min select
        => cHILITE 1+ 254 min == cHILITE show_color_box
        => cTITLES 1+ 254 min == cTITLES show_color_box
        => BGCOLOR 1+ 254 min == BGCOLOR COLOR_SCHEME config_colors show_color_box
        => cWINDOW_COLOR 1+ 254 min == cWINDOW_COLOR update_window_colors show_color_box
        => cTEXT_COLOR   1+ 254 min == cTEXT_COLOR   update_window_colors show_color_box 
        => cBG_TEXT_COLOR 1+ 254 min == cBG_TEXT_COLOR COLOR_SCHEME config_colors show_color_box
        endselect
    endif
;    
: key_down_repeat
    500 == key_time_dly
    menu_appearance_key_down
    loop
        0 kdm_scankey -1 <> if 1 kdm_scankey 128 and until endif ` look for break key.
        key_time_dly 1- == key_time_dly 1 msd
        key_time_dly 0 <= if
            50 == key_time_dly
            menu_appearance_key_down
        endif
        ` hw_pause? if break endif
        kdm20g_pump
    repeat
;

: menu_appearance 
    ` "" Appearance 1280
    menu_cursor? == CONFIG_MENU#
    160 24 4 *  1 dlg_config ` <width>    <height>   1 dlg_config   set the width and height of the dialog boxes
    150  4 2 dlg_config ` <x corner> <y corner> 2 dlg_config   specifies the location of the dialog boxes.
    
    COLOR_SCHEME config_colors
    0 == CUSTOM_COLOR
    show_color_scheme_box    
    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    500 millisecond_delay
    loop 0 kdm_scankey -1 <> if 1 kdm_scankey drop else break endif repeat
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey 
            dup 15 = if CUSTOM_COLOR if CUSTOM_COLOR 1- 1901 max == CUSTOM_COLOR show_color_box else             
                        COLOR_SCHEME 1- 0 max config_colors show_color_scheme_box endif endif
            dup 26 = if CUSTOM_COLOR if CUSTOM_COLOR 1+ 1906 min == CUSTOM_COLOR show_color_box else
                        COLOR_SCHEME 1+ 10 min config_colors show_color_scheme_box endif endif
            dup 24 = if key_down_repeat endif
            dup 25 = if key_up_repeat endif
            dup 12 = if COLOR_SCHEME 10 = if CUSTOM_COLOR if    0 == CUSTOM_COLOR COLOR_SCHEME config_colors show_color_scheme_box else 
                                                             1901 == CUSTOM_COLOR show_color_box endif else drop break endif endif
                13 = if COLOR_SCHEME 10 = CUSTOM_COLOR land if 0 == CUSTOM_COLOR COLOR_SCHEME config_colors show_color_scheme_box else break endif endif 
      endif
    repeat
    save_kdmintr if kon endif
    ` " out" kdm_intr? . nl
    -1 DLG_DisplayMsgBox
    300 set_dlg_width ` reset dialog width, height
    ` <mode> <"Question"> <"Title"> DLG_YesNo <0=OK, -1=Cancel>
    COLOR_SCHEME   1900 gi <>
    COLOR_SCHEME   10 = 
        cHILITE        1901 gi <> 
        cTITLES        1902 gi <> or
        BGCOLOR        1903 gi <> or
        cWINDOW_COLOR  1904 gi <> or 
        cTEXT_COLOR    1905 gi <> or 
        cBG_TEXT_COLOR 1906 gi <> or
        land or ` if custom color and one of the custom colors do not match. 
    if 
        0 "" Save Color Scheme?" 1280 getmsg DLG_YesNoEx
    else
        0 0 ` change so it looks like they pressed cancel. 
    endif
    drop 0 = if
        1900 gi == COLOR_SCHEME
        COLOR_SCHEME 10 = if
            1901 gi == cHILITE
            1902 gi == cTITLES
            1903 gi == BGCOLOR 
            1904 gi == cWINDOW_COLOR
            1905 gi == cTEXT_COLOR 
            1906 gi == cBG_TEXT_COLOR 
        endif
    else
        COLOR_SCHEME 1900 si
        COLOR_SCHEME 10 = if
            cHILITE 1901 si
            cTITLES 1902 si
            BGCOLOR 1903 si
            cWINDOW_COLOR 1904 si
            cTEXT_COLOR 1905 si
            cBG_TEXT_COLOR 1906 si
        endif 
        ifexists glcd_set_splash_bg BGCOLOR glcd_set_splash_bg
        "" Saving Color Scheme..." kdm_dsp_line
        2000 msd
    endif
    COLOR_SCHEME config_colors  ` this resets the colors back.
    clear_display ` Clear the display now that the colors are put back.
    0
;
0 ivar TEMP_LIMIT_MASK
: show_active_limits_control
    == ACTIVE_CONTROL
    6012 glcd_deactivate_control TEMP_LIMIT_MASK LOWX and if "" X" else ""  " endif -1 -1 glcd_control_text drop   
    6016 glcd_deactivate_control TEMP_LIMIT_MASK LOWY and if "" X" else ""  " endif -1 -1 glcd_control_text drop
    6020 glcd_deactivate_control TEMP_LIMIT_MASK LOWZ and if "" X" else ""  " endif -1 -1 glcd_control_text drop
    6025 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` OK button
    6027 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
    
    ACTIVE_CONTROL select => 6012 => 6016 => 6020 => 6025 => 6027 default=> 0 endselect
    dup 6025 < if glcd_activate_control drop
    else cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` SAVE button
    endif
;
: change_limits_control
    ACTIVE_CONTROL select 
        => TEMP_LIMIT_MASK LOWX and if LOWX ~and== TEMP_LIMIT_MASK else LOWX or== TEMP_LIMIT_MASK endif  
        => TEMP_LIMIT_MASK LOWY and if LOWY ~and== TEMP_LIMIT_MASK else LOWY or== TEMP_LIMIT_MASK endif 
        => TEMP_LIMIT_MASK LOWZ and if LOWZ ~and== TEMP_LIMIT_MASK else LOWZ or== TEMP_LIMIT_MASK endif 
        => 
        =>  
        default=> 
    endselect
    ;
word auto_set_range    
: menu_limits_config
    menu_cursor? == CONFIG_MENU# 
    normal_control_font
    InitScrollMessage
    2 fprec
    AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL
    -2 scroll_buffer 1287 getmsg 0 DLG_MsgBox ` "" Limits Config"
    cBG_TEXT_COLOR == SAVE_TEXT_COLOR
    cBLACK == cBG_TEXT_COLOR
    1027 getmsg DLG_XPOS 45 + DLG_YPOS 60 + mover slen 2 + 12 * 20 6010 make_left_text_dlg  ` "" X Limit"
                small_control_font
                DLG_XPOS 25 + DLG_YPOS 60 + 15 15 6012 make_sunken_box_dlg
                normal_control_font
    6010 2001 glcd_control_group drop ` change group control number
    
    1028 getmsg DLG_XPOS 45 + DLG_YPOS 90 + mover slen 2 + 12 * 20 6014 make_left_text_dlg  ` "" Y Limit"
                small_control_font
                DLG_XPOS 25 + DLG_YPOS 90 + 15 15 6016 make_sunken_box_dlg
                normal_control_font
    6014 2001 glcd_control_group drop ` change group control number
    
    1029 getmsg DLG_XPOS 45 + DLG_YPOS 120 + mover slen 2 + 12 * 20 6018 make_left_text_dlg  ` "" Z Limit"
                small_control_font
                DLG_XPOS 25 + DLG_YPOS 120 + 15 15 6020 make_sunken_box_dlg
                normal_control_font
    6018 2001 glcd_control_group drop ` change group control number
    
    ` <X> <Y> <"Text"> <control #> DLG_Select_Button
    DLG_XPOS  12 + DLG_YPOS 160 + 1307 getmsg 6025 DLG_Select_Button ` ""   OK  "
    DLG_XPOS 180 + DLG_YPOS 160 + 1308 getmsg 6027 DLG_Select_Button ` "" Cancel"
    
    SAVE_TEXT_COLOR == cBG_TEXT_COLOR
    
    ` <x> <y> <xsize> <ysize> <code> make_sunken_box
    ` <"text"> <X> <Y> <width> <height> <control number> make_group_box
    kdm_intr? == save_kdmintr
    koff ` have to turn off hot keys so kdm_scankey works.
    LIMIT_MASK == TEMP_LIMIT_MASK
    1 show_active_limits_control
    loop
      0 kdm_scankey -1 <> if
         1 kdm_scankey
         -1 == iLastKey
         dup  58 = if 4 show_active_limits_control endif ` Start KEY, force ENTER key
         dup  186 = over 171 = or over 141 = or if drop 1 break endif     ` get out on key release so the button shows hi-lighted first.
         dup  43 = over 13 = or if 5 show_active_limits_control endif ` force CANCEL key
         dup  12 = if ACTIVE_CONTROL 4 >= if drop 1 break endif change_limits_control ACTIVE_CONTROL show_active_limits_control endif  ` enter key - drop old value and exit loop
         dup  25 = over 15 = or if ACTIVE_CONTROL 1- 1 max show_active_limits_control endif
         dup  24 = over 26 = or if ACTIVE_CONTROL 1+ 5 min show_active_limits_control endif
         drop
         iLastKey 58 = if 4 show_active_limits_control endif
         iLastKey 43 = if 5 show_active_limits_control endif 
      endif
    repeat
    save_kdmintr if kon endif
    
    1 = if ` ENTER Pressed
        ACTIVE_CONTROL 4 = if ` OK Button
            TEMP_LIMIT_MASK == LIMIT_MASK
            LIMIT_MASK 27 si
            LIMIT_MASK if
                1 set_machine_fault 0 == ?DATUMMED
            else
                0 set_machine_fault 1 == ?DATUMMED
            endif
            auto_set_range
        endif ` OK button
    endif
    -1 DLG_DisplayMsgBox
    1060 glcd_destroy_group drop ` main dialog controls
    2001 glcd_destroy_group drop
    0
;

word findoffset 
: menu_configure
    1023 SetMenuTitle  ` "" Configuration"
    ' submenu_units    1024 getmsg submenu_add  ` "" Display Units      "
    ' menu_appearance  1280 getmsg submenu_add  ` "" Display Colors"
    ' SubDNCMode       1150 getmsg submenu_add  ` "" DNC_Mode"
    ' menupark         1010 getmsg submenu_add  ` "" Parking            "
    ' menu_select_interface 1009 getmsg submenu_add  ` "" Select Interface   "
    ' submenu_Individual_CutSpeed 1253 getmsg pMENU_STR s! ?INDIVIDUAL_CUTSPEED if 1255 getmsg else 1254 getmsg endif 
                       pMENU_STR s+! pMENU_STR submenu_add ` "" CutSpeed Global/Individual"
    ' menu_limits_config 1287 getmsg submenu_add                       
    LIMIT_MASK if
        ' findoffset  1021 getmsg  submenu_add  ` "" Pos After Datum    "` used to manually set the offsets
    endif
    ` ' submenu_XLim     1027 getmsg pMENU_STR s! LIMIT_MASK LOWX and if 1120 getmsg else 1121 getmsg endif
    `                    pMENU_STR s+! pMENU_STR submenu_add  ` "" X Limits enabled/disabled "
    ` ' submenu_YLim     1028 getmsg pMENU_STR s! LIMIT_MASK LOWY and if 1118 getmsg else 1119 getmsg endif
    `                    pMENU_STR s+! pMENU_STR submenu_add  ` "" Y Limits enabled/disabled "
    ` ' submenu_ZLim     1029 getmsg pMENU_STR s! LIMIT_MASK LOWZ and if 1122 getmsg else 1123 getmsg endif
    `                    pMENU_STR s+! pMENU_STR submenu_add  ` "" Z Limit enabled/disabled "
    ' runselftext      1014 getmsg submenu_add  ` "" Run Self Test      "` Runs self-test macro
    ' SubDriveTemp     1250 getmsg submenu_add  ` "" Drive Temperature"
    ifexists show_phases ' show_phases      "" Motor Phase Test" submenu_add         ` "" Motor Phase Test"
    CONFIG_MENU# 1+ start_submenu
    0
;
0 ivar DISPENSE_MENU#
: submenu_disp_activate
    menu_cursor? == DISPENSE_MENU#
    SOL3_ACTIVE? not == SOL3_ACTIVE?
    0 ;
: submenu_disp_ondelay  
    menu_cursor? == DISPENSE_MENU#
    1277 getmsg ` "" msec"
    1322 getmsg ` "" Enter Dispense ON time"
    1320 getmsg CopyLineTrimColon ` "" Dispense Mode" 
    10 SOL3_ON_DELAY 8 DLG_GetNum 
    num_ok if 
        drop
    else
        == SOL3_ON_DELAY
    endif
    0 ;
: submenu_disp_offdelay
    menu_cursor? == DISPENSE_MENU#
    1277 getmsg ` "" msec"
    1324 getmsg ` "" Enter Dispense OFF time"
    1320 getmsg CopyLineTrimColon ` "" Dispense Mode" 
    10 SOL3_OFF_DELAY 8 DLG_GetNum 
    num_ok if 
        drop
    else
        == SOL3_OFF_DELAY
    endif
    0 ;

: menu_dispense
    1320 SetMenuTitle ` "" Dispense Mode"
    ' submenu_disp_activate 1320 getmsg SOL3_ACTIVE? menuONOFFmake submenu_add ` "" Dispense Mode :" 
    ' submenu_disp_ondelay  1321 getmsg SOL3_ON_DELAY  menuImake submenu_add ` "" On  Time"
    ' submenu_disp_offdelay 1323 getmsg SOL3_OFF_DELAY menuImake submenu_add ` "" Off Time" 
    DISPENSE_MENU# 1+ start_submenu
    0
    ;

` DIGITIZE_INPUT 
0 #ifdef ` Always disabled    
/* ***************  Digitizing Functions for HPGL *********************** */
`  Requires the Following Macros and Variables to be Defined
`     AC       - two dimension absolute move
`     U        - three dimensional absolute move
`     coords_2d?- retrieve X and Y coordinates
`     coord_Z? - retrieve Z coordinate
`  ***************************************************************
1 ivar DNC?  ` do we use DNC to capture the jobs.

42 998 sysallocate ptr pTEMP_DIG        ` used to generate sub menu strings
42 998 sysallocate ptr pMENU_STR_DIG    ` used to generate sub menu strings

ifmissing num_ok : num_ok dup if 2 = if 0 else 1 endif endif ;
ifmissing msd    : msd millisecond_delay ;
ifmissing AltChannelOpen  : AltChannelOpen 173 wchar wchar ;                  ` accepts [Channel#] on ISP
ifmissing AltChannelClose : AltChannelClose 172 wchar ;
ifmissing get_sample    : get_sample 6 set_scan_params ;
ifmissing menuFmake     : menuFmake pMENU_STR_DIG s! pTEMP_DIG fformat pMENU_STR_DIG s+! pMENU_STR_DIG ;

word AC

: XY_Display
    get_soft_home?                  ` get current value of soft homes
    NUM_AXES 4 >= if fdrop endif
    NUM_AXES 3 >= if fdrop endif    ` drop the Z coord (some components have no Z - the ones that do will add it)
    0 1 pos "" Y " kdm_dsp_string 1 get_pos? fswap f- units_decpt kdm_dspfnum
    0 0 pos "" X " kdm_dsp_string 0 get_pos? fswap f- units_decpt kdm_dspfnum
    ;
: Z_Display ;

true  ivar _DIG2D      ` 2D or 3D mode
1     ivar _TYPE       ` What object are we drawing (Linear, spline, arc)
1     ivar _CURVEPT    ` What curve point number are we on.
true  ivar _PENUP      ` pen is up
0     ivar _SCANMODE   ` are we using the 3D scanner for 2D digitizing.
false ivar _DIG_AUTO_SCAN ` are we currently auto scanning
false ivar _DIG_HELP   ` are we in Help Mode
0     ivar _2DIGMENU   ` which menu was called, 0=2D,1=3D.
false ivar _DIG_START  ` have we pushed the START button

   1101 defmsg" Connecting to host.."   ` Full  When connecting to Job Server
/* Help Messages */
   1950 defmsg" Help: Press Any Key "
   1951 defmsg" Adjust Step Size    "
   1952 defmsg" Go Home             "
   1953 defmsg" Close Contour       "  ` this one will be used to clear the display after help.
   1954 defmsg" Set Home            "
   1955 defmsg" Start Auto Scan     "
   1956 defmsg" Toggle Spline/Linear"
   1957 defmsg" Backup one point    "
   1958 defmsg" Start ARC           "
   1959 defmsg" Not Defined"
   1960 defmsg" Not Defined"
   1961 defmsg" Exiting Help        "
   1962 defmsg" Enter a Point       "
   1963 defmsg" Finish Digitizing   "
   1964 defmsg" Toggle PU/PD state  "
   1965 defmsg" Flush Buffer        "
   1966 defmsg" Backup one point    "
   1967 defmsg" Adjust the Jog Speed"
   1968 defmsg" Pause Auto Scanning "
   1969 defmsg"                     "

   1970 defmsg" Feature Not Enabled "  ` 20 Feature not enabled.
   1971 defmsg" Found Start Contour "  ` 20 Found Start Contour
   1972 defmsg" User Paused         "  ` 20 User Paused
   1973 defmsg" Could not find edge "  ` 20 Could not find edge.
   1974 defmsg" Lost Edge           "  ` 20 Lost Edge
   1975 defmsg" Too Many Points     "  ` 20 Too Many Points
   1976 defmsg" Prev Point Too Close"  ` 20 Prev Point too close.
   1977 defmsg" Help:Press"            ` 10 Help title
   1978 defmsg" any key   "            ` 10 2nd part of help title, pad to 10 chars.
   1979 defmsg" Linear"                `  6 Linear mode (pad to 6 chars)
   1980 defmsg" Spline"                `  6 Spline mode (pad to 6 chars)
   1981 defmsg" Arc   "                `  6 Arc Mode    (pad to 6 chars)
   1982 defmsg" Mid     "              `  8 Mid point of arc (pad to 8 chars)
   1983 defmsg" End     "              `  8 End point of arc (pad to 8 chars)
   1984 defmsg" Point   "              `  8 Bottom line when in Arc mode (pad to 8 chars)
   1985 defmsg" Invalid Arc"           ` 20 Invalid Arc, Error when creating arc.
   1986 defmsg" Invalid Spline"        ` 20 Invalid Spline, Error when creating spline.
   1987 defmsg" Close Contour"         ` 20 Close Contour
   1988 defmsg" Home Set"              ` 20 Home Set (when setting home in digitize mode)
   1989 defmsg" Auto Scanning       "  ` 20 Auto Scanning..."
   1990 defmsg" Scan Rate?"            ` 20 Scan Rate, when entering scan rate.
   1991 defmsg" Scan Step Size?"       ` 20 Scan Step Size, when enter scan step size.
   1992 defmsg" Start Digitize"        ` 20 Start Digitize menu item.
   1993 defmsg" Auto Scan Rate:"       ` 15 Auto Scan Rate: menu item.
   1994 defmsg" Auto Step Size:"       ` 15 Auto Step Size: menu item.
   1995 defmsg" Scan Mode     :"       ` 15 Scan Mode: menu item
   1996 defmsg" Add Corners   :"       ` 15 Add Corners menu item.
   1997 defmsg" Set XY Offsets"        ` 20 Sets the X and Y scanner offsets.

/* 2D Edge Scanning */

` HP4 Driver could define these.
ifmissing LIGHT_PORT 109 ivar LIGHT_PORT  ` M2521
ifmissing LIGHT_BIT   32 ivar LIGHT_BIT


 2.0   inch_to_mm fvar S2D_SCAN_FEED
 0.10  inch_to_mm fvar DOFFSET     ` Step Size
 1.0              fvar BIDIR_MUL
 0.001 inch_to_mm fvar BIDIR_ADD
1       ivar CORNERS        ` add corners
0       ivar LINEMODE       ` Default to Edge
50.0    fvar CORNER_ANGLE
0       ivar s2d_index  ` index number for menus
2000    ivar MID_POINT

` -----------------------------------------------------------------------------
`        MACRO: ARC Routines
`  DESCRIPTION: Handles digitizing Arcs
` -----------------------------------------------------------------------------
88 101 sysallocate ptr cfitptr

: cfitobj: ivar ;: constval cfitptr + fp@ ;
: csetobj: ivar ;: constval cfitptr + fp! ;

0  cfitobj: arc_x1
8  cfitobj: arc_y1
16 cfitobj: arc_x2
24 cfitobj: arc_y2
32 cfitobj: arc_x3
40 cfitobj: arc_y3
48 cfitobj: arc_XC
56 cfitobj: arc_YC
64 cfitobj: arc_RADFIT
72 cfitobj: arc_THETA1
80 cfitobj: arc_THETA3

0  csetobj: >arc_x1
8  csetobj: >arc_y1
16 csetobj: >arc_x2
24 csetobj: >arc_y2
32 csetobj: >arc_x3
40 csetobj: >arc_y3

` <vector_ptr> digit_arc3 --> <status>
` **
` **  load 3 pairs of data into vector.
` **  status is zero if OK, else
` **   -1     no digitize feature
` **   -2     illegal data (co-linear)
` **   -3     illegal data (Y's duplicate)
: top_pos 10 0 pos ;
: bot_pos 13 0 pos ;
` -----------------------------------------------------------------------------
`        MACRO: update_kdm
`  DESCRIPTION: Updates the kdm messages
`   PARAMETERS: none
` -----------------------------------------------------------------------------
: update_kdm
   _DIG_HELP if
        10 0 pos 1977 getmsg kdm_dsp_string  ` "" Help:Press"
        10 1 pos 1978 getmsg kdm_dsp_string  ` "" any key   "
        :exit
    endif
   _CURVEPT 1 > if :exit endif   ` do not update if in middle of SPLINE or ARC

   ` 10 0 pos _DIG2D if "" 2D" else "" 3D" endif kdm_dsp_string
   top_pos _PENUP if "" PU " else "" PD "  endif kdm_dsp_string
   bot_pos _TYPE 1 max 3 min select
                            => 1979 getmsg ` "" Linear"
                            => 1980 getmsg ` "" Spline"
                            => 1981 getmsg ` "" Arc   "
                            endselect kdm_dsp_string  ;
0 set_warning
: dig_msg kdm_dsp_line 1000 msd_kdm kdm_clear XY_display update_kdm ;
1 set_warning
` -----------------------------------------------------------------------------
`        MACRO: up_down
`  DESCRIPTION: Toggle the Pen UP/DOWN
`   PARAMETERS: none
` -----------------------------------------------------------------------------
: up_down
  ` <flag> scan_pen <status>  <flag 0=penup, 1=pendown, 2=no change just return status>
  _PENUP if
       1 scan_pen drop `  pen down
       false
  else
       0 scan_pen drop ` pen up
       true
  endif
  == _PENUP  ;
` -----------------------------------------------------------------------------
`        MACRO: dig_arc
`  DESCRIPTION: do an arc based on 1st middle end point
`   PARAMETERS: none
` -----------------------------------------------------------------------------
: dig_arc
    _DIG_AUTO_SCAN if :exit endif ` don't start arc if in auto.
    _TYPE 2 = if :exit endif  ` in spline mode, don't start arc.
    _TYPE 3 = _CURVEPT 1 = land if ` allow them to toggle back into linear mode if no points set.
        1 == _TYPE
    else
        3 == _TYPE
        _PENUP if up_down endif
    endif
;
: dig_arc_point
    1 kdm_integer_size                ` Arc
    top_pos _CURVEPT 1 max 3 min select
         => 1982 getmsg coords_2d? >arc_y1 >arc_x1  kdm_dsp_string  ` "" Mid     "
         => 1983 getmsg coords_2d? >arc_y2 >arc_x2  kdm_dsp_string  ` "" End     "
         => coords_2d? >arc_y3 >arc_x3
            cfitptr digit_arc3 0 < if 1985 getmsg dig_msg ` "" Invalid Arc"
                              1 == _TYPE 1 == _CURVEPT :exit
            else
                 arc_x3 arc_y3 arc_XC arc_YC arc_THETA1 arc_THETA3 f> if 2 else 3 endif scan_arc
            endif
            1 == _TYPE 0 == _CURVEPT
         endselect
    bot_pos 1984 getmsg kdm_dsp_string ` "" Point   "
    _CURVEPT 1+ == _CURVEPT  ;
` -----------------------------------------------------------------------------
`        MACRO: dig_spline
`  DESCRIPTION: start or end a spline point
`   PARAMETERS: none (uses _TYPE to determine if currently in a spline)
`    start spline   0 scan_spline [0]  ` always returns 0.
`    end spline     1 scan_spline [0 or 1]  1 = Invalid spline, not enough points.
`                                      0 = good.
` -----------------------------------------------------------------------------
: dig_spline
    _DIG_AUTO_SCAN if :exit endif ` don't start auto if in spline.

    _TYPE 3 = if :exit endif   ` in arc mode, don't start spline.
    bot_pos _TYPE 2 = if       ` if already in a spline, end it
        1 == _TYPE  1 scan_spline if 1986 getmsg dig_msg endif ` end spline ` "" Invalid Spline"
    else
        2 == _TYPE  0 scan_spline drop ` start spline
    endif 1 == _CURVEPT
    update_kdm ;
` -----------------------------------------------------------------------------
`        MACRO: dig_close
`  DESCRIPTION: Closes the contour (goes to last PD point)
`   PARAMETERS: none
` -----------------------------------------------------------------------------
: dig_close
    0 3 pos 1987 getmsg kdm_dsp_string ` "" Close Contour"
    3 scan_ctrl  ` returns <x> <y> <flag>  if flag = 0, point is no good
    if AC wait_plot else fdrop fdrop endif
    0 3 pos ""              " kdm_dsp_string
    ;
` -----------------------------------------------------------------------------
`        MACRO: dig_set_home
`  DESCRIPTION: sets the soft home
`   PARAMETERS: none
` -----------------------------------------------------------------------------
0 set_warning
: dig_set_home
    0.0 == X_TOOL_OFFSET
    0.0 == Y_TOOL_OFFSET
    0. 0. 0. set_soft_home
    coords_2d?
    215 gf == X_TOOL_OFFSET
    216 gf == Y_TOOL_OFFSET
    ssf_3d
    1988 getmsg dig_msg ; ` "" Home Set"
1 set_warning
` -----------------------------------------------------------------------------
`        MACRO: dig_exit
`  DESCRIPTION: exit digitizing
`   PARAMETERS: 1 = CANCEL, 0 = EXIT
` -----------------------------------------------------------------------------
: dig_exit
    2 scan_ctrl  ` flush the buffer
    ` always put the pen down before exiting so it outputs a M21
    _DIG_START if 1 scan_pen drop 1 scan_job endif   ` started so output job exit
;
0 set_warning
: dig_start_job
    _DIG_START if  ` already started started
        "" Already in Job" dig_msg
        :exit
    endif
    true == _DIG_START
    DOFFSET 11 set_scan_params                ` specify step size.
    LIGHT_PORT LIGHT_BIT 17 set_scan_params   ` specify location of sensor input
    BIDIR_MUL 18 set_scan_params              ` specify overshoot adjustment multiplier.
    CORNERS 19 set_scan_params                ` do we look for and add in corners
    CORNER_ANGLE 20 set_scan_params           ` if we are puting in corners, what angle specifies a corner.
    BIDIR_ADD 21 set_scan_params              ` specify overshoot adjustment Additive.
    LINEMODE 22 set_scan_params               ` specify line or edge
    1 24 set_scan_params                      ` HPGL output
    ` 1 26 set_scan_params                      ` PD at corners
    ` machine_mode                             ` v1.09 run in machine mode.
    S2D_SCAN_FEED feedrate
    0 scan_job   ` start the job
    ` "" Job Started" dig_msg
;
1 set_warning
` -----------------------------------------------------------------------------
`        MACRO: ins_point
`  DESCRIPTION: Read the current position and insert a point
`               Will check if SPLINE, ARC, or LINEAR and if 3D.
`   PARAMETERS: none  (uses _TYPE to determine type of point)
` -----------------------------------------------------------------------------
: ins_point
    _DIG_START not if dig_start_job :exit endif   ` not started
    ` when we come out of auto, we do not want to set a point
    _DIG_AUTO_SCAN if false == _DIG_AUTO_SCAN
        ` This is a work-around.  If we pressed the EXIT key for HELP, it would exit digitize.  We set
        ` the variable _DIG_AUTO_SCAN to re-enter digitize but we also have to re-display the HELP screen.
        kdm_clear XY_Display Z_Display
        _DIG_HELP if
            ` 0 2 pos 1950 getmsg kdm_dsp_string "" " dig_msg
        endif
        :exit endif
    _DIG_HELP if 1962 getmsg dig_msg :exit endif ` "" Enter a Point"
    _TYPE 1 max 3 min select
    =>
        "" Point Set" dig_msg
       0 get_pos? 1 get_pos? scan_point   ` output point
       _DIG2D not if 0 get_pos? 1 get_pos? /* 2 get_pos? */ scan_point endif
    => 2 kdm_integer_size                ` spline
       10 1 pos "" Point " kdm_dsp_string _CURVEPT kdm_dspnum
       ` bot_pos  "" Set " kdm_dsp_string
       0 get_pos? 1 get_pos? scan_point
       _CURVEPT 1+ == _CURVEPT
    => dig_arc_point
    endselect
    ;
` -----------------------------------------------------------------------------
`        MACRO: dig_auto_scan
`  DESCRIPTION: starts the auto scanning
` -----------------------------------------------------------------------------
: dig_auto_scan
    _DIG_START not if :exit endif   ` not started
    1989 getmsg kdm_dsp_line ` "" Auto Scanning       "
    ` flag used in 2 places, to enable the pause key and to NOT set a point when restart jogging.
    ` ins_point will reset the flag.
    true == _DIG_AUTO_SCAN
    MID_POINT _SCANMODE 28 set_scan_params
    DOFFSET 11 set_scan_params                ` specify step size.
    S2D_SCAN_FEED feedrate

    2 scan_ctrl                       ` flushes the backup buffer.

    0 scan_auto                       ` returns <status> <X> <Y>.

    0 3 pos
    2.0 kdm_time_out
    2+ 1 max 8 min select
          => 1970 getmsg f2drop  kdm_dsp_string 750 msd                         ` "" Feature Not Enabled "
          => 1971 getmsg  AC fp  kdm_dsp_string 750 msd 0 scan_pen drop ` penup ` "" Found Start Contour "
          => 1972 getmsg  AC fp  kdm_dsp_string kdm_getkey drop                 ` "" User Paused         "
          => 1973 getmsg f2drop  kdm_dsp_string kdm_getkey drop                 ` "" Could not find edge "
          => 1974 getmsg  AC fp  kdm_dsp_string kdm_getkey drop                 ` "" Lost Edge           "
          => 1975 getmsg  AC fp  kdm_dsp_string kdm_getkey drop                 ` "" Too Many Points     "
          => 1976 getmsg f2drop  kdm_dsp_string kdm_getkey drop                 ` "" Prev Point Too Close"
          default=> "" Unknown"  kdm_dsp_string 750 msd
    endselect
    60. kdm_time_out
    ` don't refresh here, ins_point will refresh when jogging restarts.
    ` kdm_clear XY_Display Z_Display ` do not use -1 kdm_stroke because we are in a menu.
    ` Because Pen status gets changes by Auto Scan, we have to query the pen status.
    2 scan_pen not == _PENUP    ` query to get status of pen.
;
word s2d_dist
: dig_auto_adjust  ` allow user to adjust the auto step size
    s2d_dist drop
    menu_cursor? == s2d_index ` make sure the menu shows start digitize.
    kdm_clear XY_Display Z_Display
;
: dig_back_up
    1 scan_ctrl ` returns <x> <y> <flag>   <flag> indicates number of points left in backup buffer
    dup if
        4 kdm_integer_size
        0 2 pos "" Backup " kdm_dsp_string
        dup 0 > if "" PD" 0 == _PENUP else "" PU" 1 == _PENUP endif kdm_dsp_string
        ""  Point " kdm_dsp_string abs kdm_dspnum
        AC wait_plot 500 msd
    else drop
        fdrop ftoi 1 max 4 min select
            => "" Backup Empty        "
            => "" At Start Spline     "    ` found start of spline
            => "" At End Spline       "    ` found end of spline
            => "" Backup Empty        "    ` unknown, just show empty
        endselect
        0 3 pos kdm_dsp_string 500 msd
    endif
    0 2 pos 1969 getmsg kdm_dsp_string  ` clear line
;
: dig_flush_buffer
    2 scan_ctrl    ` flush the back up buffer
    "" Buffer Flushed" dig_msg ;
: dig_help
  _DIG_AUTO_SCAN if update_kdm false == _DIG_AUTO_SCAN drop :exit endif
  dup 11 = if  ` if this is the help key...
    drop _DIG_HELP if false == _DIG_HELP kdm_clear XY_Display Z_Display update_kdm :exit endif
    ` 0 1 pos 1950 getmsg kdm_dsp_string "" " dig_msg
    10 0 pos 1977 getmsg kdm_dsp_string    ` "" Help:Press"
    10 1 pos 1978 getmsg kdm_dsp_string    ` "" any key   "

    true == _DIG_HELP
  else
    1 max 19 min 1950 + getmsg dig_msg
  endif
;
0 set_warning
: key_func49  ` the pause key
    scan_pause
;
1 set_warning
` -----------------------------------------------------------------------------
`        MACRO: jog_digitize_func
`  DESCRIPTION: Called for every key press when in digitize mode
`   PARAMETERS: < key > jog_digitize_func
`       RETURN: 0 - to continue to digitize
`               1 - to exit digitizing  (EXIT/CANCEL keys will always exit)
`               2 - to switch to XY Axis Jogging
`               3 - to switch to Z Axis Jogging
` -----------------------------------------------------------------------------
: jog_digitize_func
  SYS_MSG? 2 and if " JD OP=" dup . nl endif 
  _DIG_START not if drop 0 :exit endif
  dup 14 = if drop 13 endif  ` CANCEL remap to EXIT
  dup  0 = if drop 15 endif  ` 0 remap to 15
  dup 40 = if drop 10 endif  ` decimal point remap to 10
  dup 58 = if drop  5 endif  ` START remap to 5
  dup 43 = if drop 14 endif  ` remap to 14
  dup 49 = if drop 18 endif  ` PAUSE Auto Scanning
  _DIG_HELP if dig_help 0 :exit endif
  select
    => dig_auto_adjust 0                                      ` 1 (step size)
    => 0. 0. AC wait_plot 0                                   ` 2 (go home)
    => dig_close 0                                            ` 3 (close contour)
    => dig_set_home 0                                         ` 4 (set home)
    => _TYPE 2 = _TYPE 3 = or if 0 else 1 endif               ` 5 (auto scan)
    => dig_spline 0                                           ` 6 (Spline <-> Linear)
    => dig_back_up 0                                          ` 7 (backup)
    => dig_arc 0                                              ` 8 (arc)
    => 0                                                      ` 9
    => 0                                                      ` decimal point
    => 11 dig_help 0                                          ` +/-  (help)
    => ins_point 0                                            ` Enter  (insert point)
    => dig_exit 0                                             ` Exit   (end of job)
    => up_down 0                                              ` 14 (PU <-> PD)
    => dig_flush_buffer 0                                     ` 15 (flush buffer)
    => dig_back_up 0                                          ` 16 (backup)
    => ` 1 rtJogFast 0                                        ` 17 (Jog speed)
    default=> 0
  endselect
  update_kdm ;

` -----------------------------------------------------------------------------
`        MACRO: Digitize
`  DESCRIPTION: The menu item to start digitizing
`   PARAMETERS: none
` -----------------------------------------------------------------------------
0 ivar 2D_FILENAME
: Digitize
    menu_cursor? == s2d_index
    ` xchk TOOL_CHANGE? or if -1 :exit endif
    "" File Name: " kdm_dsp_line
    5 kdm_integer_size 0 kdm_getnum 8 kdm_integer_size
    dup 1 = swap 3 = or if drop -1 :exit endif
    == 2D_FILENAME
    INDVC> w@ 41 1 ioctl drop           ` turn on handshaking
    DNC? if
        1101 getmsg kdm_dsp_line ` "" Connecting to host..."
        250 msd
        2D_FILENAME 0 >= if
            0 tcp_flush_host
            6 AltChannelOpen                    ` open alt channel to Digitize
            6 wchar ascii S wchar 1 . 6 wchar   ` send start sequence (S0=uCito, S1=HPGL, S2=CNC) to Digitize
            2D_FILENAME 5 fill.                    ` send file name to host (width of 5 chars max)
            AltChannelClose                     ` close channel
            1 tcp_flush_host
            ` VerifyDNCStart -1 = if -1 :exit endif (I don't see and DNC stuff)
        endif
    endif
    true == _DIG2D     ` initialize defaults
    true == _PENUP
    1 == _CURVEPT
    1 == _TYPE
    0 == _DIG_HELP
    false == _DIG_START
    start_motion
    -1 kdm_pause_key                         ` disable pause key
    -9 kdm_menu_enter_key ` remap keys so user cannot screw up digitize
    -9 kdm_menu_exit_key
    -9 kdm_menu_exec_key

    2D_FILENAME 0 >= DNC? land if 6 AltChannelOpen  endif  ` open alt channel to Digitize
    ` 7 units_decpt kdm_float_size
    ` get_rtc_clk == START_TIME                       ` capture time at start of job

    ` Move over by scanner offsets.
    215 gf == X_TOOL_OFFSET
    216 gf == Y_TOOL_OFFSET
    do_set_home
    X_TOOL_OFFSET fneg Y_TOOL_OFFSET fneg 0.0 uline wait_plot

    dig_start_job


    loop
        kdm_clear XY_Display Z_Display
        9 1 kdm_jog  ` pass in 9 key if first time, 9 does nothing.
        dup 58 = if  ` NOTE: This number MUST be the KEY assigned to Auto Scan.
            drop
            kon
            dig_auto_scan
        else
            13 = if
                ` if we exited when in HELP mode, just re-loop around to stay in digitize.
                ` cheat and use _DIG_AUTO_SCAN to keep 12 257 kdm_jog from setting a point.
                _DIG_HELP if true == _DIG_AUTO_SCAN else break endif
            endif  ` else, this is the end
        endif
    repeat
    ` 8 units_decpt kdm_float_size
    end_motion

    0.0 == X_TOOL_OFFSET
    0.0 == Y_TOOL_OFFSET
    do_set_home  ` clear the home.

    ` calc_job_time
    2D_FILENAME 0 >= DNC? land if
        0 tcp_flush_host
        AltChannelClose                     ` Close Digitize Channel
        6 AltChannelOpen                    ` Open Alt Channel to DNC
        6 wchar ascii E wchar 0 . 6 wchar   ` send EOJ sequence to DNC
        AltChannelClose
        1 tcp_flush_host
    endif
    36 kdm_pause_key                        ` re-enable pause key
    12 kdm_menu_enter_key                   ` re-enable the menu key.
    13 kdm_menu_exit_key
    12 kdm_menu_exec_key

    false == _DIG_START
    -1 ;


: scan
    -1 kdm_pause_key                         ` disable pause key
    -9 kdm_menu_enter_key ` remap keys so user cannot screw up digitize
    -9 kdm_menu_exit_key
    -9 kdm_menu_exec_key

    dig_start_job
    start_motion
    dig_set_home
    0.0 0.0 scan_point    ` set first point then move along X 1/2 inch.
    0.5 inch_to_mm 0.0 AC   wait_plot
    dig_auto_scan
    1 scan_pen drop 1 scan_job
    false == _DIG_START  ` clear variable that says we started.
    0.0 0.0 AC  ` move back to starting point.
    end_motion

    36 kdm_pause_key                        ` re-enable pause key
    12 kdm_menu_enter_key                   ` re-enable the menu key.
    13 kdm_menu_exit_key
    12 kdm_menu_exec_key
;

: s2d_rate
    menu_cursor? == s2d_index
    1990 getmsg kdm_dsp_line ` "" Scan Rate?"
    0 1 pos
    S2D_SCAN_FEED units_decpt kdm_getfnum
    num_ok if fdrop 0 :exit endif
    == S2D_SCAN_FEED 0 ;
: s2d_dist
    menu_cursor? == s2d_index
    1991 getmsg kdm_dsp_line ` "" Scan Step Size?"
    0 1 pos
    DOFFSET units_decpt kdm_getfnum
    num_ok if fdrop 0 :exit endif
    == DOFFSET 0 ;
: s2d_line
    menu_cursor? == s2d_index
    LINEMODE if 0 else 1 endif == LINEMODE
    0 ;
: s2d_corners
    menu_cursor? == s2d_index
    CORNERS if 0 else 1 endif == CORNERS
    0 ;
: s2d_set_xyoff
    ` now sitting on limits, allow jogging.
    4 == OPERATE_MODE  ` set mode for display in jog_adv_func
    start_motion
    215 gf fneg 216 gf fneg 0.0 uline wait_plot  ` move back to last offset
    end_motion
    eat_kdm            ` make sure no keystrokes are left waiting to be executed
    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    8 0 kdm_jog        ` jog XY and use 8 for display
    12 = if           ` if enter not pressed then error and exit
        coords_2d? fneg 216 set_float fneg 215 set_float
    endif
    end_motion
    0 ;
: 2D_Dig_Module
  7 1 2 20 menu_config   ` <rows> <cols> <start row> <namewidth> menu_config
  4 fprec
  ' Digitize      1992 getmsg submenu_add                           ` "" Start Digitize"
  ' s2d_rate      1993 getmsg S2D_SCAN_FEED menuFmake  submenu_add  ` "" Auto Scan Rate:"
  ' s2d_dist      1994 getmsg DOFFSET menuFmake submenu_add         ` "" Auto Step Size:"
  ' s2d_line      1995 getmsg pMENU_STR_DIG s!                      ` "" Scan Mode     :"
                  LINEMODE if "" LINE" else "" EDGE" endif pMENU_STR_DIG s+! pMENU_STR_DIG submenu_add
  ' s2d_corners   1996 getmsg pMENU_STR_DIG s!                      ` "" Add Corners   :"
                  CORNERS if "" YES" else "" NO " endif pMENU_STR_DIG s+! pMENU_STR_DIG submenu_add
  ' s2d_set_xyoff 1997 getmsg submenu_add                           ` "" Set XY Offsets"
  s2d_index 1+ start_submenu
  3 fprec
  0 ;         ` needs to be zero to stay in menu
: menu_digitize 2D_Dig_Module ;

#endif

6 led_on    ` BOOT LOCATION 4

0 ivar IP_address
 1   8 ' IP_address bvar IP1
 9  16 ' IP_address bvar IP2
17  24 ' IP_address bvar IP3
25  32 ' IP_address bvar IP4
0 ivar NM_address
 1   8 ' NM_address bvar NM1
 9  16 ' NM_address bvar NM2
17  24 ' NM_address bvar NM3
25  32 ' NM_address bvar NM4
word EthernetInfo
: info_ip_kdm20g
    -1 DLG_DisplayMsgBox ` get rid of info_main
    EthernetInfo 
;
0 ivar USE_DHCP?
0 ivar ETH_DLG_POS
0 ivar ETH_DLG_YPOS
: update_ip_control itoa -1 -1 glcd_control_text drop ;
: update_nm_controls
    NM1 255 < if 0 == NM2 0 == NM3 0 == NM4 endif 
    NM2 255 < if 0 == NM3 0 == NM4 endif
    NM3 255 < if 0 == NM4 endif
    2105 NM1 update_ip_control 
    2106 NM2 update_ip_control 
    2107 NM3 update_ip_control 
    2108 NM4 update_ip_control     
;
: make_ip_dialog
    ` <delay> <"message"> <"title"> 0 DLG_MsgBox
    InitScrollMessage
    2 fprec
    "" S/N:" AddScrollMsg get_oem_serial AddScrollMsgPad
    "" Name:" AddScrollMsg get_oem_model AddScrollMsgPad
    AddScrollNL AddScrollNL AddScrollNL AddScrollNL AddScrollNL 
    AddScrollNL `  "" Use Z keys to change values." AddScrollMsg
    -2 scroll_buffer 1218 getmsg 0 DLG_MsgBox ` "" Ethernet Info"
    DLG_YPOS 20 4 * + == ETH_DLG_YPOS
    "" IP:" DLG_XPOS 5 + ETH_DLG_YPOS 70 22 2100 make_left_text_dlg
    2100 cTRANSPARENT cTRANSPARENT cTRANSPARENT cBLACK 0xF00 glcd_control_colors drop 
    DLG_XPOS  80 + ETH_DLG_YPOS 40 18 2101 make_sunken_box_dlg 
    DLG_XPOS 130 + ETH_DLG_YPOS 40 18 2102 make_sunken_box_dlg 
    DLG_XPOS 180 + ETH_DLG_YPOS 40 18 2103 make_sunken_box_dlg 
    DLG_XPOS 230 + ETH_DLG_YPOS 40 18 2104 make_sunken_box_dlg
    DLG_YPOS 20 5 * + 8 + == ETH_DLG_YPOS
    "" Mask:" DLG_XPOS 5 + ETH_DLG_YPOS 70 22 2115 make_left_text_dlg
    2115 cTRANSPARENT cTRANSPARENT cTRANSPARENT cBLACK 0xF00 glcd_control_colors drop 
    
    DLG_XPOS  80 + ETH_DLG_YPOS 40 18 2105 make_sunken_box_dlg 
    DLG_XPOS 130 + ETH_DLG_YPOS 40 18 2106 make_sunken_box_dlg 
    DLG_XPOS 180 + ETH_DLG_YPOS 40 18 2107 make_sunken_box_dlg 
    DLG_XPOS 230 + ETH_DLG_YPOS 40 18 2108 make_sunken_box_dlg
    
    ` 0 3 pos "" Sevr:" kdm_dsp_string iptostr kdm_dsp_string
    DLG_YPOS 20 7 * + == ETH_DLG_YPOS
    1219 getmsg DLG_XPOS 5 + ETH_DLG_YPOS DLG_WIDTH 70 -  24 2116 make_left_text_dlg ` "" Activate DHCP"
    2116 cTRANSPARENT cTRANSPARENT cTRANSPARENT cBLACK 0xF00 glcd_control_colors drop
    DLG_XPOS 182 + ETH_DLG_YPOS 2+ 40 18 2109 make_sunken_box_dlg
    
    6 0 eth_info if "" Yes" 1 == USE_DHCP? else "" No" 0 == USE_DHCP? endif 2109 swap -1 -1 glcd_control_text drop
    
    ` <X> <Y> <"Text"> <control #> DLG_Select_Button
    DLG_XPOS  12 + DLG_YPOS 195 + 1220 getmsg 2110 DLG_Select_Button ` "" Change"
    DLG_XPOS 180 + DLG_YPOS 195 + 1221 getmsg 2111 DLG_Select_Button ` "" Cancel"

    
    ` small_control_font
    ` 2000 glcd_create_control 2000 glcd_control_group
    ` DLG_WIDTH 2- 24 glcd_control_extents
    ` cTRANSPARENT cTRANSPARENT cTRANSPARENT cBLACK 0xF00 glcd_control_colors
    ` "" Use Z keys to change values." -1 -1 glcd_control_text
    ` DLG_XPOS 1+ DLG_YPOS 20 9 * + glcd_draw_control drop
    ` normal_control_font
    
    
    get_ipi == IP_Address
    get_nmi == NM_Address
    
    2101 IP1 update_ip_control 
    2102 IP2 update_ip_control
    2103 IP3 update_ip_control
    2104 IP4 update_ip_control

    update_nm_controls
;
: ChangeIP
    USE_DHCP? if
        6 0 eth_info not if 1 set_dhcp_server endif 
        1
    else
        6 0 eth_info if 0 set_dhcp_server endif
        NM_address get_nmi <> if
            ` The following code checks to see if the netmask is valid.
            0 1   0 30 1 step
                1 I shlv or dup NM_address = if swap drop 1 swap  break endif 
            endstep  drop
            if 
                NM_Address set_nmi
            else
                -1 DLG_DisplayMsgBox ` remove main dialog
                -1 840 getmsg 1510 getmsg "" Error" 1 Dlg_MsgBox  ` OK, "" Invalid Mask, Correct Mask"
                0 make_ip_dialog :exit
            endif 
        endif  
        IP_address get_ipi <> if
            IP4 255 = if 
                -1 DLG_DisplayMsgBox ` remove main dialog
                -1 840 getmsg 1509 getmsg "" Error" 1 Dlg_MsgBox  ` OK, "" Invalid IP, Choose different IP"
                0
                make_ip_dialog
            else
                IP_address check_arp if
                    -1 DLG_DisplayMsgBox ` remove main dialog
                    -1 840 getmsg 1508 getmsg "" Error" 1 Dlg_MsgBox  ` OK, "" IP already in use.  Choose different IP "
                    0
                    make_ip_dialog
                else
                    IP_address set_ipi IP_address if IP_address 0 eth_intf drop endif
                    1
                endif
            endif
        else 1 endif
    endif
;
0 ivar ETHKEY_BOUNCE
` Macro was getting too large, break off some of the keys.
: EthernetInfo_Keys_0_9
   ETH_DLG_POS 0 >= ETH_DLG_POS 7 <= land if 
        dup == PASSED_IN_NUMBER ` This is the number passed in to EnterGetNum
        1 == STOP_ON_3 ` stops after 3 digits are entered, automatically moves to next box.
        0 == bFVAR_NUM
        ETH_DLG_POS 0 = if IP1 2101 EnterGetNum 0 = if == IP1 2101 IP1 update_ip_control else drop endif endif
        ETH_DLG_POS 1 = if IP2 2102 EnterGetNum 0 = if == IP2 2102 IP2 update_ip_control else drop endif endif
        ETH_DLG_POS 2 = if IP3 2103 EnterGetNum 0 = if == IP3 2103 IP3 update_ip_control else drop endif endif
        ETH_DLG_POS 3 = if IP4 2104 EnterGetNum 0 = if == IP4 2104 IP4 update_ip_control else drop endif endif
        ETH_DLG_POS 4 = if NM1 2105 EnterGetNum 0 = if == NM1 update_nm_controls else drop endif endif 
        ETH_DLG_POS 5 = if NM2 2106 EnterGetNum 0 = if == NM2 update_nm_controls else drop endif endif
        ETH_DLG_POS 6 = if NM3 2107 EnterGetNum 0 = if == NM3 update_nm_controls else drop endif endif
        ETH_DLG_POS 7 = if NM4 2108 EnterGetNum 0 = if == NM4 update_nm_controls else drop endif endif
        0 == STOP_ON_3
        -1 == PASSED_IN_NUMBER
        drop 26 ` change key to Right Arrow.
    endif
 ;
: EthernetInfo
    make_ip_dialog
    0 == iLastKey
    0 == ETH_DLG_POS
    2101 ETH_DLG_POS + glcd_activate_control drop
    koff
    ` false == PAUSE_CALLED?
    loop
        0 kdm_scankey -1 <> get_rtc_clk ETHKEY_BOUNCE - 200 > if iLastKey or endif if
          0 kdm_scankey -1 <> if 1 kdm_scankey get_rtc_clk == ETHKEY_BOUNCE else iLastKey endif 
               dup 65 = over 66 = or not if 
                   ETH_DLG_POS 9 >= if
                      ETH_DLG_POS 9 = if 2110 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` SAVE button
                      else               2111 cTRANSPARENT cLTGRAY cSILVER cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
                      endif
                   else
                      2101 ETH_DLG_POS + glcd_deactivate_control drop
                   endif
               endif 
               dup 24 = if ETH_DLG_POS 8 < if ETH_DLG_POS 4 + 8 min else ETH_DLG_POS 1 + endif 10 min == ETH_DLG_POS endif ` Down
               dup 25 = if ETH_DLG_POS 3 > ETH_DLG_POS 9 < land if ETH_DLG_POS 4 - else ETH_DLG_POS 1- endif 0 max == ETH_DLG_POS endif ` Up
               dup 0 >= over 9 <= land if
                    EthernetInfo_Keys_0_9
               endif
               ETH_DLG_POS 8 <> if 
                   dup 15 = if ETH_DLG_POS 1 - ETH_DLG_POS 3 > if ETH_DLG_POS 8 > if  9 max else 4 max endif else 0 max endif == ETH_DLG_POS endif ` Left
                   dup 26 = if ETH_DLG_POS 1 + ETH_DLG_POS 3 > if ETH_DLG_POS 8 > if 10 min else 7 min endif else 3 min endif == ETH_DLG_POS endif ` Right
               endif
               dup 13 128 + = if drop 12 endif  ` change to 12 so it gets out.               
               dup 14 = if drop break endif
               
               dup 58 = if 9 == ETH_DLG_POS endif ` force CHANGE key
               dup 186 = over 171 = or if drop 12 endif  ` Change key to 12 so it gets out.
               dup 43 = over 13 = or if 10 == ETH_DLG_POS endif ` force CANCEL key

               dup 12 = if 
                    ETH_DLG_POS 8 = if USE_DHCP? not == USE_DHCP? USE_DHCP? if 1275 getmsg else 1276 getmsg endif 2109 swap -1 -1 glcd_control_text drop endif ` "" YES, NO"
                    ETH_DLG_POS 9 = if ChangeIP if drop break endif 0 == ETH_DLG_POS 2101 ETH_DLG_POS + glcd_activate_control drop drop 0 endif
                    ETH_DLG_POS 10 = if drop break endif  
                    endif
               ` dup 12 = if ChangeIP if drop break endif 0 == ETH_DLG_POS 2101 ETH_DLG_POS + glcd_activate_control drop drop 0 endif  
               dup 128 >= if drop 0 else 20 msd endif                
               drop 0 == iLastKey 
               ETH_DLG_POS 9 >= if
                  ETH_DLG_POS 9 = if 2110 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CHANGE button
                  else               2111 cTRANSPARENT cLTGRAY cHILITE cBLACK 0xF00 glcd_control_colors drop  ` CANCEL button
                  endif
               else
                  2101 ETH_DLG_POS + glcd_activate_control drop
               endif
        endif
        kdm20g_pump
        ` PAUSE_CALLED? if break endif
    repeat
    -1 DLG_DisplayMsgBox ` get rid of info_main
    ` make_idle_screen kdm_dsp_rev 
    kon
;
0 ivar eth_menu#

: DisplayIP
    -1 DLG_DisplayMsgBox ` get rid of info_main
    menu_cursor? == eth_menu#
    InitScrollMessage
    2 fprec
    "" S/N:" AddScrollMsg get_oem_serial AddScrollMsg 
    "" \nName:" AddScrollMsg get_oem_model AddScrollMsg 
    "" \nIP  :" AddScrollMsg get_ipi iptostr AddScrollMsg 
    "" \nMask:" AddScrollMsg get_nmi iptostr AddScrollMsg AddScrollNL
    9 7 eth_intf if ` check for possible error, if so, display, if not, check for DHCP
        dup 0 = if "" \nHost:" AddScrollMsg 23 7 eth_intf drop iptostr AddScrollMsg endif
        dup 1 = if 1501 getmsg AddScrollMsgPad endif ` "" No Link Present"
        dup 2 = if 1502 getmsg AddScrollMsgPad endif ` "" No DHCP Server"
            3 = if 1503 getmsg AddScrollMsgPad endif ` "" No Main Connection"
    else
        6 0 eth_info dup if ` check for DHCP enabled, if so, show address of server.
        "" \nSevr:" AddScrollMsg iptostr AddScrollMsg
        else
        drop endif
    endif
    1218 getmsg scroll_message_kdm20g drop ` "" Ethernet Info" 
    ` <RETURN>
    7 fprec
    0
;

: DisplayHost 0 ; ` 0 kdm_cursor info_host kdm_getkey drop 2 == eth_menu# 1 kdm_cursor 0 ;
: SpecifyIP  menu_cursor? == eth_menu# EthernetInfo 0 ;

: elink_show
    menu_cursor? == eth_menu#
    normal_control_font
    InitScrollMessage
    2 fprec
    AddScrollNL AddScrollNL AddScrollNL 
    -2 scroll_buffer 1217 getmsg 0 DLG_MsgBox  ` "" Ethernet Status" 
    cTEXT_COLOR == SAVE_TEXT_COLOR
    cBLACK == cTEXT_COLOR
    "" Transmit"  DLG_XPOS   5 + DLG_YPOS 80 + mover slen 2 + 12 * 20 6010 make_center_text
                  DLG_XPOS 120 + DLG_YPOS 80 + 120 20 6011 make_sunken_box_dlg
        6010 2001 glcd_control_group drop ` change group control number
           
    "" Receive"   DLG_XPOS   5 + DLG_YPOS 110 + mover slen 2 + 12 * 20 6012 make_center_text
                  DLG_XPOS 120 + DLG_YPOS 110 + 120 20 6013 make_sunken_box_dlg
        6012 2001 glcd_control_group drop ` change group control number
        
    "" NO LINK"   DLG_XPOS   5 + DLG_YPOS 40 + mover slen 2 + 12 * 20 6014 make_center_text
    
	loop
		4 eth_intf
		if 
		    ` <bg> <border> <surface> <letters> glcd_control_color    
		    6014 cRED cWHITE 0x0300 glcd_control_colors  
		    "" NO LINK" -1 -1 glcd_control_text drop 
		else
		    6014 cLGRAY cTEXT_COLOR 0x0300 glcd_control_colors
		    "" LINK OK"  -1 -1 glcd_control_text drop
		endif 
		0 kdm_scankey -1 <> if 1 kdm_scankey 127 < if break endif endif
		` ?terminal until
		50 millisecond_delay
		3 eth_intf 
		itoa 6011 swap -1 -1 glcd_control_text drop 
		itoa 6013 swap -1 -1 glcd_control_text drop
		100 millisecond_delay
	repeat
    -1 DLG_DisplayMsgBox
    1060 glcd_destroy_group drop ` main dialog controls
    2001 glcd_destroy_group drop
 0
;
: menu_ethernet
    1212 SetMenuTitle ` "" Ethernet Settings"
    ' SpecifyIP     1214 getmsg submenu_add  ` "" Specify IP"
    ' DisplayIP     1215 getmsg submenu_add  ` "" Display IP"
    ` ' DisplayHost   1216 getmsg submenu_add  ` "" Display Host"
	` ' elink_show	1217 getmsg submenu_add	 ` "" Ethernet Status"
	` Removing Ethernet Status, it's not implemented on the 353
    eth_menu# 1+ start_submenu
    0
;
0 ivar last_dhcp_state
0 ivar show_dhcp_error
: test_dhcp
    9 7 eth_intf if
        1 = if
` add these lines for notification of no link
`            "" No Ethernet Link"
`            kdm_dsp_line 1000 msd -1 kdm_stroke
            1 == is_serial?
            :exit
        endif ` no link, must be serial
    else
        drop ` command not supported
    endif
    6 0 eth_info not if :exit endif ` not DHCP, Don't know if this is required, but it can't hurt
    0 == show_dhcp_error
    get_dhcp_state dup == last_dhcp_state
    if
        loop
            ` get_dhcp_state dup == last_dhcp_state dup 0 = swap 99 = or until
            get_dhcp_state dup == last_dhcp_state dup 0 = swap 90 > or until ` v3.66 change to support new firm
            36 get_rtc_clk 500 / - dup
            25 < show_dhcp_error not land if
                1 == show_dhcp_error
                "" No Reply from DHCP " kdm_dsp_line
            endif
            show_dhcp_error if
                0 1 kdm_set_pos "" Timeout in " kdm_dsp_string
                kdm_dspnum
            else
                drop
            endif
            500 millisecond_delay
        repeat
        show_dhcp_error if
            last_dhcp_state if
                "" Timeout waiting for DHCP Reply"
            else
                "" DHCP server reply   received"
            endif
            kdm_dsp_line 2000 msd -1 kdm_stroke
        endif
    endif
;
#endif
    
word plimit word key_func43
: goX       ` actual move to find X limit and stay there
    LIMIT_MASK switch_x_mask and not if :exit endif  ` don't find x home if not in limit mask
    1050 getmsg kdm_dsp_line         ` 1050 "" Finding X Datum..."
    limits? switch_x_mask and ?NC_LIMITS if not endif if
		Hi_speed 0. 0. velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        switch_x_mask 1 plimit
	endif
	wait_plot
    10 msd
	Lo_speed 0. 0. velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    switch_x_mask 0 plimit
    switch_x_mask 0 plimit
	wait_plot update_pos
	;

: findXlim      ` determind cylindrical and do appropriate homing.
    CYL_MODE? if   ` are we in Cylindrical X mode
      LOWXC == switch_x_mask
      goX
      LOWX == switch_x_mask
    else
      LOWX == switch_x_mask
      goX
      LOWXC == switch_x_mask
    endif
    LIMIT_MASK switch_x_mask and if  ` check if other X mode has limit mask set
        end_motion    ` have to end_motion to switch
        key_func43    ` switch to other X mode
        start_motion
        goX           ` find home for it
        end_motion
        key_func43    ` switch back X
        start_motion
    endif

;
: findYlim      ` used to find Y limit and stay there
    LIMIT_MASK LOWY and not if :exit endif  ` don't find y home if not in limit mask
    1052 getmsg  kdm_dsp_line               ` 1052 "" Finding Y Datum..."
    limits? LOWY and ?NC_LIMITS if not endif if
		0. Hi_speed fneg 0. velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        LOWY 1 plimit
	endif
	wait_plot
    10 msd
	0. Lo_speed fneg 0. velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    LOWY 0 plimit
    LOWY 0 plimit
	wait_plot update_pos

;
: findZlim
    1054 getmsg  kdm_dsp_line  ` 1054 "" Finding Z Datum..."
	0. == Z_SURFACE
    limits? LOWZ and ?NC_LIMITS if not endif if
		0. 0. Hi_speedZ velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        LOWZ 1 plimit
        LOWZ 1 plimit
	endif
	wait_plot
    10 msd
	0. 0. Lo_speed velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    LOWZ 0 plimit
    LOWZ 0 plimit
	wait_plot update_pos
;

: error_findoffset
    -1 kdm_pause_key 
    3 kdm_lines 
    erase_display
    0 load_params 1 load_params 2 load_params
    slew_mode
;
   
` menu item that finds limits then allows user to manually set the offsets.
: findoffset
    ?DRIVE_ON not if drive_err :exit endif
    chk_any_motion? if 0 :exit endif         ` exit if in motion
    LIMIT_MASK not if 0 set_machine_fault 0 :exit endif    ` exit if no limits
    2 set_machine_fault
    0 == ?DATUMMED
    500 gf 501 gf 502 gf 1.5 f* 0. 0. 0 set_axis_params
    510 gf 511 gf 512 gf 1.5 f* 0. 0. 1 set_axis_params
    520 gf 521 gf 522 gf 2.5 f* 0. 0. 2 set_axis_params
    limits_off  0 set_override 
	0 range_checking
	start_motion
    chk_motion? not if error_findoffset 0 :exit endif        ` make sure that motion started
    
    8 kdm_lines
    make_xyz_box refresh_xyz_box
    cls
    
    36 kdm_pause_key

    LIMIT_MASK LOWZ and if findZlim endif ` only find Z if in LIMIT_MASK

    ?HOME_Y_FRST if     ` if flag set to home Y first then do it
        findYlim     ` routine to home Y
        findXlim           ` routine to switch X which homes Either or both X's
    else                ` if not then do X first
        findXlim
        findYlim
    endif
    chk_any_motion? not if error_findoffset 0 :exit endif         ` exit if in motion
    #set_origin     ` set current position to zero
    0. 0. 0. set_soft_home
    ` now sitting on limits, allow jogging.
    4 == OPERATE_MODE  ` set mode for display in jog_adv_func
    eat_kdm            ` make sure no keystrokes are left waiting to be executed
    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    8 0 kdm_jog        ` jog XY and use 8 for display
    12 <> if           ` if enter not pressed then error and exit
        1093 getmsg word_wrap_string kdm_dsp_line 1500 msd  ` "" Positions not saved"
        end_motion
        error_findoffset
        0 :exit
    endif
    LIMIT_MASK LOWZ and if  ` if Z axis then jog on the Z
        eat_kdm            ` make sure no keystrokes are left waiting to be executed
        ` 7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
        show_z_box
        8 4 kdm_jog    ` jog Z and use 8 for display
        12 <> if       ` if enter not pressed then error and exit
            1093 getmsg word_wrap_string kdm_dsp_line 1500 msd     ` "" Positions not saved"
            end_motion   
            error_findoffset
            0 :exit
        endif
        hide_z_box
    endif
    0 == OPERATE_MODE  ` reset display mode
    end_motion         ` quit moving
    ` set positions in flash
    coords? 15 set_float 14 set_float 13 set_float      ` set offsets to new positions.
    
    0 1094 getmsg 1021 getmsg DLG_YesNoEx ` "" Datum Now?"
    drop 0 = if
        1079 getmsg word_wrap_string kdm_dsp_line 1500 msd  ` 1079 "" Machine Requires    Datumming"
    else
        find_limits
    endif
    error_findoffset ` not really an error but it sets the parameters back.
    1          ` leave number on stack for menu
;

: real_time_change          ` change spindle speed & feed rate during job
    ?SHOW_SPINDLE not if drop :exit endif 
    dup 24 = if drop 0 real_time_spindle_speed :exit endif      ` down
    dup 25 = if drop 1 real_time_spindle_speed :exit endif      ` up
    dup 15 = if drop 0 real_time_feed_rate :exit endif          ` left
        26 = if 1 real_time_feed_rate :exit endif ;             ` right

: jog_advanced_func
    SYS_MSG? 4 and if "" JA OP=" write_err OPERATE_MODE write_err_num ""  KY=" write_err dup write_err_num write_err_nl  endif
    ` 8 used for display purposes only
    OPERATE_MODE 1 = if  ` are we setting surface
        dup 8 = if
            drop
            1304 getmsg word_wrap_string kdm_dsp_line ` "" Jog Spindle to Surface and press Digitize key."
            0 :exit 
            ` drop 13 0 kdm_set_pos 1107 getmsg kdm_dsp_string ` "" Set"
            `      13 1 kdm_set_pos 1108 getmsg kdm_dsp_string 0 :exit endif ` "" Surface"
        endif
        dup 6  = if drop 1 :exit endif  ` surface key
    endif
	OPERATE_MODE 2 = if
		dup  0 = if drop 1 :exit endif  ` VST key
		dup 58 = if drop 1 :exit endif  ` START key
	endif
    OPERATE_MODE 3 = if
        dup 1 = if drop 1 :exit endif  ` set home key
    endif
    OPERATE_MODE 4 = if  ` are we setting datum position (Pos After Datum)
        dup 8 = if
            drop 1310 getmsg word_wrap_string kdm_dsp_line ` "" Jog to set position after datum, press Enter to save."
            0 :exit
        endif
            ` drop 13 0 kdm_set_pos 1110 getmsg kdm_dsp_string ` "" Enter"
            `      13 1 kdm_set_pos 1111 getmsg kdm_dsp_string 0 :exit endif ` "" to Save"
    endif
    OPERATE_MODE 5 = if  ` are we setting dynamic home
        dup 8 = if
            drop 1313 getmsg word_wrap_string kdm_dsp_line ` "" Jog to First Corner, press Enter."
            0 :exit
        endif
            ` drop 12 0 kdm_set_pos 1262 getmsg kdm_dsp_string ` "" First"
            `      12 1 kdm_set_pos 1264 getmsg kdm_dsp_string 0 :exit endif ` "" Corner"
    endif
    OPERATE_MODE 6 = if  ` are we setting dynamic home
        dup 8 = if
            drop 1312 getmsg word_wrap_string kdm_dsp_line ` "" Jog to Second Corner, press Enter."
            0 :exit
        endif
            ` drop 12 0 kdm_set_pos 1263 getmsg kdm_dsp_string ` "" Second"
            `      12 1 kdm_set_pos 1264 getmsg kdm_dsp_string 0 :exit endif ` "" Corner"
    endif
    dup 12 = if drop 1 :exit endif  ` enter key
        13 = if 1 :exit endif       ` exit key
    0		` leave zero, stay in jogging
;


: jog_func: ivar ;:     ` X & Y jogging
	chk_motion? if
	    SPINDLE_CODE if 
            constval real_time_change   ` change spindle speed/feed rate
        else drop endif
	else ?DRIVE_ON if
            7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
            chk_pause? if 
                DISPLAY_TIME? if hide_time_box iRTC_TIME 2* msd endif
                hide_pre_job_info
                make_xyz_box
            endif
            
            ` The Job Complete is shown and they start to job. Clear the Job Complete flag first.
            AFTERJOB_TIME 0 > if 
                -1 == AFTERJOB_TIME 
                make_idle_screen -1 kdm_stroke 
            endif
            
            monFP constval 2 kdm_jog drop end_motion
            ` 250 msd -1 kdm_stroke
            refresh_xyz_box
		else drop drive_err
		endif
	endif ;

25 jog_func: key_func25
15 jog_func: key_func15
24 jog_func: key_func24
26 jog_func: key_func26

: restore_user SYS_MSG? 2 and if "" restore_user\n" write_err endif if end_motion endif make_idle_screen -1 kdm_stroke ;

: key_func1                                     ` set home
    menu_status? if :exit endif  ` do not allow if in menu
	?DRIVE_ON not if drive_err :exit endif
	chk_any_motion? if :exit endif
    ?DATUMMED not if datum_err 0 restore_user :exit endif  ` not allowed if machine has not be datummed.
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    0 == PREHOME
    0 == OPERATE_MODE ` make sure mode is correct because this affects where the "Home Set" message is displayed
    set_pre_home
	0 restore_user ;

: key_func2                                     ` go home
    menu_status? if :exit endif  ` do not allow if in menu
	?DRIVE_ON not if drive_err :exit endif
    chk_motion? if :exit endif       ` change from chk_any_motion to allow key during pause
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    chk_pause? not if 
        CYL_MODE? if       ` Check if in Cylindrical or Flat mode
            ?HOMESET_CYL not if          ` In CYL so Check if Cylindrical home has been set and do nothing if it is
                ?PRESERVE_HOME if        ` Check if we are to remember soft_homes between powerups
                    1 == ?HOMESET_CYL    ` Remember them.  In Cyl so set flag to true
                    130 gf 131 gf ssf_3d ` Reset SoftHome for Cyl
                else                     ` Don't remember soft_homes
                    1076 getmsg kdm_dsp_line 500 msd -1 kdm_stroke :exit  ` 1076 "" Home Not Set."
                endif
            endif
        else                             ` In Flat Mode
            ?HOMESET not if              ` In Flat has home been set and if so do nothing
                ?PRESERVE_HOME if        ` Are we supposed to preserve soft_homes?
                    1 == ?HOMESET        ` remember them . In Flat so set flag to true
                    110 gf 111 gf ssf_3d ` Reset SoftHome for Flat
                else                     ` Don't remember soft_homes
                    1076 getmsg  kdm_dsp_line 500 msd -1 kdm_stroke :exit    ` 1076 "" Home Not Set."
                endif
            endif
        endif
    endif
    ?DATUMMED not if datum_err 0 restore_user :exit endif  ` not allowd if machine has not be datummed.
    menu_status? if 
        -1 1077 getmsg 1 kdm_dsp_message  ` 1077 "" Going Home...."
    else
        1077 getmsg kdm_dsp_line        ` 1077 "" Going Home...."
    endif
	chk_pause? not if start_motion 1 == PAUSE_CANCEL_ONLY? 36 kdm_pause_key endif 
	XYUP_FEED feedrate
    ?CONTROLLED_Z if
         POCKET_MILLING? if
             0 get_pos? 1 get_pos? 0.005 umaline     ` lift to top if pocket milling.
         else
             coords_2d? Z_LIFT fneg z_limit ualine   ` lift Z
         endif
    endif
	wait_plot
	0. 0. coord_Z? ualine
	chk_pause? if 
	    wait_plot
	    -1 kdm_stroke
	else
        menu_status? if 0 "" " 1 kdm_dsp_message else fp update_xyz_box_when_moving endif 
        0 == PAUSE_CANCEL_ONLY? -1 kdm_pause_key
        1 restore_user
    endif
	;

: key_func3                                     ` find home
    menu_status? if :exit endif  ` do not allow if in menu
    ?DRIVE_ON not if drive_err :exit endif
	chk_any_motion? if :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    find_limits
    1 restore_user ;

: key_func6                                     ` set surface (Digitize Key)
    menu_status? if :exit endif  ` do not allow if in menu
	?DRIVE_ON not if drive_err :exit endif
    chk_any_motion? if :exit endif
	?CONTROLLED_Z not if :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
	start_motion
    1 == OPERATE_MODE
    ` 7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    show_z_box
    8 4 kdm_jog 6 = if    ` pass in 8 key to change display
        2 get_pos? 1 1072 getmsg ` 1072 "" Surface Set."
	else
        0 1073 getmsg ` 1073 "" Surface Not Set."
    endif
    kdm_dsp_line 1 second
    hide_z_box
    1074 getmsg kdm_dsp_line      ` 1074 "" Lifting..."
	if == Z_SURFACE X_HOME Y_HOME 0. set_soft_home endif    ` uses Z_SURFACE
	0. 0. coord_Z? Z_SURFACE Z_LIFT fmin f+ fneg uline wait_plot
    0 == OPERATE_MODE
	1 restore_user ;


: key_func4
    menu_status? if :exit endif  ` do not allow if in menu
    ?DRIVE_ON not if drive_err :exit endif
    TEST_SOLS not == TEST_SOLS
    TEST_SOLS if
         ` 0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME msd ` v3.04 turn off display
         1096 getmsg kdm_dsp_line ` "  Solenoid Test       Press Aux1/Aux2"
    else
         1095 getmsg kdm_dsp_line ` "     Auxiliaries         Restored"
         2000 #delay -1 kdm_stroke
         ` 99 gi == DISPLAY_OPTIONS ` Reset the display options 
    endif
;

: key_func7                                     ` spindle
    menu_status? if :exit endif  ` do not allow if in menu
    ?DRIVE_ON not if drive_err :exit endif
    chk_motion?  if :exit endif
    SPINDLE_CODE not if :exit endif 
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    SPINDLE_CODE code_to_bits drop swap pget_bits and if
        1082 getmsg 4 led_off SPINDLE_CODE code_to_bits swap  ` 1082 "" Spindle Off."
        0 == SPINDLE_ON?    ` set flag for Spindle off
    else
        1083 getmsg   4 led_on  SPINDLE_CODE code_to_bits  ` 1083 "" Spindle On."
        1 == SPINDLE_ON?    ` set flag for Spindle on
	endif
    pset_bits
    ` 0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME msd
    kdm_dsp_line
    2 second_kdm 0 restore_user
    ` 99 gi == DISPLAY_OPTIONS ` Reset the display options.
    ;

: key_func8                                     ` aux 1 on
    menu_status? if :exit endif  ` do not allow if in menu
	?DRIVE_ON not if drive_err :exit endif
    chk_motion? if :exit endif

    TEST_SOLS SOL1_CODE land if
        PWMREG1 pget_bits       ` solenoid 1 on port PWMREG1
        if SOL1_CODE 1 solenoid_off
        else SOL1_CODE 1 solenoid_on
        endif
        :exit
    endif

    AUX1_CODE not if :exit endif
    AUX1_CODE code_to_bits drop swap pget_bits and if
        1085 getmsg 5 led_off AUX1_CODE code_to_bits swap   ` 1085 "" Auxiliary 1 Off."
    else
        1084 getmsg  5 led_on  AUX1_CODE code_to_bits  ` 1084 "" Auxiliary 1 On."
	endif
    pset_bits
    kdm_dsp_line
    2 second_kdm 0 restore_user ;

: key_func9                                     ` aux 2 on ISO2
    menu_status? if :exit endif  ` do not allow if in menu
    ?DRIVE_ON not if drive_err :exit endif
    chk_motion? if :exit endif

    TEST_SOLS SOL2_CODE land if
        PWMREG2 pget_bits        ` solenoid 2 on port PWMREG2
        if SOL2_CODE 1 solenoid_off
        else SOL2_CODE 1 solenoid_on
        endif
        :exit
    endif

    AUX2_CODE not if :exit endif
    AUX2_CODE code_to_bits drop swap pget_bits and if
        1087 getmsg 3 led_off AUX2_CODE code_to_bits swap   ` 1087 "" Auxiliary 2 Off."
    else
        1086 getmsg 3 led_on  AUX2_CODE code_to_bits  ` 1086 "" Auxiliary 2 On."
	endif
    pset_bits
    kdm_dsp_line
    2 second_kdm 0 restore_user ;

: key_func11                                    ` drives on
    ` menu_status? if :exit endif  ` do not allow if in menu
    chk_any_motion? 0 <> ?DRIVE_ON or if :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    menu_status? not if 1088 getmsg kdm_dsp_line 400 msd endif ` 1088 "" Turning Drives On."
    limits_off
    111 port_input? ESTOP_BIT and if
        check_for_faults
        dup nl s. nl word_wrap_string kdm_dsp_line
        10 duty_error ` 200 msd
        ` -1 kdm_stroke
    else
        [ RPC? not ] #ifdef enable_motion disable_motion #endif        ` enable to clear estops, disable to leave off
        mon ack_blink
        menu_status? if
        else
            0 restore_user
        endif
    endif
    ;

word LocalDNCMenu
` DNC starter
: key_func5  ` DNC
    menu_status? if :exit endif
    ?DRIVE_ON not if drive_err :exit endif
    chk_any_motion? if :exit endif
    in_dnc? if :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
`    in_ldnc? if :exit endif
    xchk if
        -1 kdm_stroke :exit             ` clear pendant and exit
    endif
    1 == NO_CLR_RPL     ` set flag so the replay buffer isn't cleared
    menu_status? if menu_leave endif  ` send cancel key to exit menu system if in menu
    0 == NO_CLR_RPL     ` clear flag
    0 == SaveLDNC
    ` erase_display
    LocalDNC? 1 and if
        1 LocalDNCMenu
    else
        0 DNCStart
    endif
;

: key_func28                                    ` jog Z
    menu_status? if :exit endif  ` do not allow if in menu
	?DRIVE_ON not if drive_err :exit endif
	chk_motion? if :exit endif
    ?CONTROLLED_Z ?INDEXING or not if :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    monFP       ` Should be in Quarter Power so pump it up before jogging
    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    show_z_box
    loop
        0 4 kdm_jog 13 <>
    while repeat
    end_motion
    hide_z_box
    1 restore_user ;

: key_func43                                    ` flat/cyl axis switch
    menu_status? if :exit endif  ` do not allow if in menu
    chk_any_motion? if :exit endif      ` don't do this if paused or moving

    0 == TEST_SOLS ` In case they Menu while testing Aux's
    ` Check if DriveC is enabled
    DRIVE_ENABLE_MASK 1 DriveC shlv and not if 1923 getmsg word_wrap_string kdm_dsp_line 1 second 0 restore_user :exit endif ` "" No cylindrical option available."

    CYL_MODE? if                      ` switch to flat X
        switch_to_flat
        ?SOL1_LINK if SOL1_CODE 1 solenoid_on endif
    else                                        ` switch to cylindrical X
        ?CYL_TRANS if                           ` Check the Cylindrical Mode Translation flag
            setcyldiam not if                   ` query user for diameter or default
                1919 getmsg kdm_dsp_line 300 #delay           ` User cancelled "" Cyl Mode Cancelled  "
                0 restore_user :exit                                       ` Cancelled so get out of dodge
            endif                                                          ` diameter selection finished and correct
            1 170 gf 1000. f* ftoi switch_x                                ` switch to Cyl with a diameter
        else
            switch_to_cyl                                                  ` just switch to Cyl without diameter
        endif
        ?SOL1_LINK if SOL1_CODE 1 solenoid_off endif
	endif
    ?DRIVE_ON if    ` if drives were on, turn them back on
        300 #delay ?INDEXING not if mon 200 #delay endif ` no need to do mon if using fourth driver
    endif
	0 restore_user ;
	

0 ivar bounce_time
0 ivar ViewLDNCJob?    ` do we view the file size or execute the job.
-1 ivar LastLDNCJob     ` number of last DNC job we ran.
word LDNC
: key_func58                             ` start button
    menu_status? LocalDNCMenus? not land if :exit endif  ` menu_status? 0=not in menu, 1=in main menu, 2=in submenu.
	?DRIVE_ON not if drive_err :exit endif
    0 == in_ldnc?
    xchk if -1 kdm_stroke :exit endif            ` clear pendant and exit
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    chk_pause? if       ` see if paused
            check_drive_overtemp not if
                ` do not allow continue if drives are HOT!
                clr_pause_flag
                XYZ_SHOWN? if hide_xyz_box endif 
                ` clear the variables so the display is updated right away.
                0 == PREV_JOB_TIME
                -1.0 == PREV_Z_DEPTH_PASS
                -1 == PREV_MP_PASSES
                2 led_on cont
            endif
    else
		chk_any_motion? if :exit endif
        get_rtc_clk bounce_time - 200 >
        if
            LocalDNC? 1 and if
                0 == ViewLDNCJob?
                menu_status? if
                    12 kdm_stroke     ` if we are in a menu, execute current menu item.
                else
                    0 == ViewLDNCJob?
                    LastLDNCJob 0 > if
                        LastLDNCJob LDNC
                    else
                        MPJ_BITESIZE 0.0 f> if ` check if running multi-pass job 
                            Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
                            MPJ_BITESIZE f/ ftoi 1+ == MPJ_PASSES       ` calc # MP_BITESIZE passes needed to reach cut depth, add one because they are subtracted in end_plot
                            MPJ_PASSES == MP_TOTAL_PASSES               ` save total passes for display only.
                            MPJ_BITESIZE Z_DEPTH fmin == MPJ_Z_DEPTH
                        endif 
                        ReplayJob
                    endif  ` replay last job
                endif
                :exit
            else
                MPJ_BITESIZE 0.0 f> if ` check if running multi-pass job 
                    Z_DEPTH 0.001 inch_to_mm f-                 ` yes, get cut depth, minus FUZZ
                    MPJ_BITESIZE f/ ftoi 1+ == MPJ_PASSES       ` calc # MP_BITESIZE passes needed to reach cut depth, add one because they are subtracted in end_plot
                    MPJ_PASSES == MP_TOTAL_PASSES               ` save total passes for display only.
                    MPJ_BITESIZE Z_DEPTH fmin == MPJ_Z_DEPTH
                endif 
                ReplayJob
            endif
        ` else " <too fast>" nl
        endif
        get_rtc_clk == bounce_time
	endif ;

: key_func13                         ` Cancel
    ?JOG_Z if 0 == ?JOG_Z 1 led_off 0 restore_user endif
    SYS_MSG? 2 and if "" Key 13\n" write_err endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
	chk_pause? if                    ` see if paused
        1080 getmsg  kdm_dsp_line  ` 1080 ""   Please Wait..."
        0 == AUTORUN? 0 == BATCHRUN? 0 == MPJ_RUN?   ` make sure auto-replay is off
		2 led_off my_cancel
        vst_cancel not if alt_ethernet endif
		clr_pause_flag
        SYS_MSG? 2 and if "" returned from cancel!\n" write_err endif
	else
        alt_ethernet
        chk_any_motion? not NO_CLR_RPL not land if
            SYS_MSG? 2 and if "" cancel key\n" write_err endif
            all_off
            0 == LastLDNCJob
            INDVC> w@ 31 0 ioctl 0x060 and if      ` FIOBUFSTAT
                INDVC> w@ 37 0 ioctl drop   ` FIOKILSAVEBUF
                1920 getmsg kdm_dsp_line   ` "" Job Purged."
                0 == AUTORUN? ` 0. set_rtc_time      ` turn off auto restart
                0 == ?AUTO_RESTART  ` clear the VST buffer too.
                750 msd 
            endif
            ` Don't clear batch num v5.20
            ` 0 == #BATCH_NUM     ` clear batches
            0 == BATCHRUN?
            0 == MPJ_RUN?
            1 1 gen_error_blink eat_kdm
            kdm_dsp_rev
        endif
    endif
    ` 0 restore_user
    ;

: host_terminate
    250 msd
    false == bDNCActive
    false == DNC_JOB?
    false == in_dnc?
    kon
    AFTERJOB_TIME 0 = if -1 kdm_stroke endif
`    in_cito? if batch_off setup_boot_mode endif
    ;

ifmissing ^nul "" " ptr ^nul    
: make_start_screen_ex

    SYS_MSG? 2 and if "" make_start_screen_ex\n" write_err endif 
    ` Border around text lines.
    2001 glcd_create_control 2000 glcd_control_group
    320 240 glcd_control_extents
    /* <code> */ BGCOLOR BGCOLOR BGCOLOR cTRANSPARENT 0xF00 glcd_control_colors
    0 0 glcd_draw_control drop
    0 == TIME_SHOWN? 
    0 == TIME_SHOWN?
    0 == FRO_SHOWN?   FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID 
    0 == FEED_SHOWN?  FRO_RTC_ID dup if 3 eventqueue else drop endif 0 == FRO_RTC_ID
    0 == XYZ_SHOWN?
    0 == PASSES_SHOWN?

    ` 1 3 140  0 glcd_resource
    ` 2002 glcd_create_control 2000 glcd_control_group
    ` 204 154 glcd_control_extents
    ` /* <code> */ cGRAY BGCOLOR BGCOLOR cTRANSPARENT 0xF00 glcd_control_colors
    ` 111 5 glcd_draw_control drop
    
    make_run_screen
    
    99 gi 1 and if
        1 == DISPLAY_TIME? ` change the variable so set_time_box displays the current time.
        0 TimeToStrRaw set_time_box
        0 == DISPLAY_TIME? iRTC_TIME 2* msd 
    endif
    
    ` mp_reset drop
    ` make sure start position is not divisible by 8 for now. It will be fixed later.
    in_dnc? if
       BGCOLOR glcd_bg BGCOLOR glcd_fg
       145 0 175 240 kdm_config? drop 18 * 12 - - 0 max 240 min glcd_box  
       145 8 170 150 set_rt_image_bounds
       170 150 ^nul mp_init drop
    else
       HAVE_SAVE_REGION? if 
          glcd_restore_region drop ` copy the screen where we drew the image.
       endif
    endif

     ` 0 0  320 240 set_rt_image_bounds
     ` 320 240 ^nul mp_init drop
    
    3 kdm_lines
    JobName slen 0 > if
        JobName kdm_dsp_line
        0 1 pos
        1090 getmsg word_wrap_string kdm_dsp_string
    else
        1090 getmsg word_wrap_string kdm_dsp_line  ` "" Press START to Go,  Cancel to Abort."
    endif

;
    
    
` --> <result>
` <result>=1 for re/start,  0 = cancel
: kdm_cycle_start
    false kdm_keyintr 2 led_blink
    SYS_MSG? 2 and if "" Into KDM Cycle Start\n" write_err endif
    ?AUTO_RESTART
    if false == ?AUTO_RESTART
        in_ldnc? not if
            INDVC> w@ 38 1 ioctl drop   ` go back to replay mode, handshake off
        endif
		2 led_on 0 get_pos? 1 get_pos? 3zero 3 restart_cmd 1 :exit  ` This runs the job looking for the location.
	endif
	#BATCH_NUM if
		3 kdm_integer_size
        1091 getmsg  kdm_dsp_line  ` 1091 "" Press START ["
		#BATCH_NUM kdm_dspnum
         1092 getmsg  kdm_dsp_string  ` 1092 "" ] or  Cancel to Abort."
		8 kdm_integer_size
    else  1090 getmsg word_wrap_string kdm_dsp_line  ` 1090 "" Press START to Go,  Cancel to Abort."
	endif
    clr_ethpause  ` clear Job Console keys.
    
    ` JOB_TOOL_NUMBER 0 >= JOB_HOME_NUMBER 0 >= or if  ` displayed in Cycle Start if set.
    make_start_screen_ex
    ` endif
    
	loop
		kdm_peekkey 0 >=
		if kdm_getkey dup
            58 = if drop
                1 break       ` Start
			else dup 40 = over 0 = or if drop         ` Restart
                    4 restart_cmd         ` save coords
					2 == OPERATE_MODE
                    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
                    SYS_MSG? 2 and if "" Jog for Restart\n" write_err endif
                    JobName slen 0 > if 
                        JobName kdm_dsp_line
                        0 1 pos 1058 getmsg word_wrap_string kdm_dsp_string  ` "" Start, Cancel, Enter  or Jog then VST" 
                    else
                        1058 getmsg word_wrap_string kdm_dsp_line  ` "" Start, Cancel, Enter  or Jog then VST"
                    endif
                    0 == DISPLAY_TIME? iRTC_TIME 2* msd
                    hide_pre_job_info hide_time_box make_xyz_box
                    0 0 kdm_jog dup 0 =  ` DEL (back) = start restart search
					0 == OPERATE_MODE
		    	    if     
		    	        drop
		    	        0 get_pos? 1 get_pos? 3zero
                        [ etcx 1 > ] #ifdef "" init restart at:\n " write_err fstk #endif
                        1060 getmsg kdm_dsp_line ` "" Searching ...." 
		        	    3 restart_cmd 1
                    else
                        58 = if 1 else 0 endif 
					endif
					break
                else 13 = if end_motion all_off             ` cancel button pressed
                             kill_inque ` INDVC> w@ 19 0 ioctl drop      `  kill input que so count is zero
                             INDVC> w@ 31 0 ioctl     ` get status of replay bits -- 0x80=128 == Currently replaying job
                             128 and not if                    ` if replaying then
                                INDVC> w@ 37 0 ioctl drop      `  Kill replay buffer
                             endif
                             INDVC> w@ rdchk drop              ` read next bit to clear replay status because cnt=0
                             in_ldnc? not if 
                                 6 == iDNCHaltCode  ` cancel all reps                                
                                 DNCEndOfJob 
                             endif
                             alt_ethernet
                             0 break    ` Cancel
						 endif
			endif endif
		endif
        /* M2.87 now look for machine inputs */
         START_MASK if                              ` check for cycle_start input
             limits? START_MASK and not if   ` bit low, connection wired means START
                1 break       ` Start
             endif
         endif
        /* end machine inputs */
        /* Look for Job Console buttons */
         get_ethpause 1 = if 1 break endif ` look for start key from job console.
         get_ethpause 2 = if 0 break endif ` look for exit key from job console.
    repeat
    get_rtc_clk == bounce_time  ` v3.06 set bounce time here to avoid a replay being activated accidently.
    true kdm_keyintr
    SYS_MSG? 2 and if "" out KDM Cycle Start\n" write_err endif
	;

: CYCLE_START
    restart? if SYS_MSG? 2 and if "" CYCLE_START exit\n" write_err endif :exit endif
    PREVIEW_JOB_RUN 15 = if
        start_graph_box 
        #istk == iIStackDepth       ` set stack depth for stack error checking.
        #fstk == iFStackDepth      ` capture time at start of job
        start_motion
        :exit   ` bail out, previewing job with local DNC
    endif        
    
    JOBBASIS? 0 = if 1305 getmsg JobName s! -1 == REPS endif  ` if job was sent, we do not know it's name. ` "" Executing ..."   
        
    disable_motion
    true kdm_keyintr
    1 == IN_CYCLE_START?
    SYS_MSG? 2 and if "" Into Cycle Start\n" write_err endif
    ` VST search message getting cleared elsewhere - so this is a cludge to get the display working for now.
    ?AUTO_RESTART if 1060 getmsg kdm_dsp_line endif ` "" Searching ...." 
    loop
        CYL_MODE? if
            STATUSBITS 13 and if break endif
        else
            STATUSBITS 7 and if break endif
        endif
        ?DRIVE_ON not if drive_err endif
        ?DATUMMED not if datum_err endif
        CYL_MODE? if
            ?HOMESET_CYL not if home_err  endif
        else
            ?HOMESET not if home_err  endif
        endif
    repeat
    
    ?AUTO_RESTART not if -1 kdm_stroke endif
    ` If ?Back_talk says we should not talk back to the terminal then...
    ?BACK_TALK not in_cito? land if             ` If it's a uCito job then turn off the echo, but tell them first
            nl " Entering batch mode....use F9 to restore character echo..." nl
            SYS_MSG? not if batch endif                 ` don't echo native jobs
    endif
    8 set_machine_state
    ` auto_restart is sensitive so do kdm_cycle_start instead of start_plot, VST didn't work if CYCLE_MODE=3
    CYCLE_MODE 3 = MPJ_PASSES 0 > MPJ_PASSES MP_TOTAL_PASSES < land or ?AUTO_RESTART not land  if
        0 206 dgi 1 = if jm_setup endif ` start job monitoring.
        start_plot
    else
        kdm_cycle_start 0 = if
            end_motion all_off
            make_idle_screen kdm_dsp_rev
        else
            SYS_MSG? 2 and if "" Starting .... \n" write_err endif
            restart? not if -1 kdm_stroke endif   ` FJA refresh banner right away- M2.59 move from below
            start_plot
            restart? if
                1060 getmsg SYS_MSG? 2 and if dup s. nl endif kdm_dsp_line ` "" Searching ...."                
                5 restart_cmd         ` reset coords
            endif
        endif
    endif
    eat_kdm 
    0 == IN_CYCLE_START?
    SYS_MSG? 2 and if "" out Cycle Start\n" write_err endif
    ;

: HPGL_CYCLE_START
     SYS_MSG? 4 and if  "" HCS\n" write_err " PREVIEW_JOB_RUN " PREVIEW_JOB_RUN . nl endif
     [ SHOW_PREVIEW_JOB ] #ifdef
        PREVIEW_JOB_RUN 3 = if
            start_bounds_box 
            start_motion
            2 == PREVIEW_JOB_RUN
            :exit
        endif
        PREVIEW_JOB_RUN 2 = if
            start_graph_box 
            #istk == iIStackDepth       ` set stack depth for stack error checking.
            #fstk == iFStackDepth      ` capture time at start of job
            start_motion
            1 == PREVIEW_JOB_RUN
            :exit
        endif
        PREVIEW_JOB_RUN 1 = if 0 == PREVIEW_JOB_RUN endif
     #endif
	 CYCLE_START ;


/* **********************  Restart Support Functions  ********************* */
68 gf 9 restart_cmd     ` set tolerance

: restart_auto_core
    in_ldnc? if   ` USE CAUTION, this flag is not cleared anywhere yet
        0 == ViewLDNCJob?
        LastLDNCJob 0 >= if err LastLDNCJob LDNC in endif
        1 == ?AUTO_RESTART
        SYS_MSG? 2 and if ?AUTO_RESTART if "" Do Local Auto Restart\n" else "" Don't Local Auto Restart\n" endif write_err endif
    else
        DNCJOB_AVAILABLE? if    ` look to see if this is sent via Remote DNC
            SYS_MSG? 2 and if "" non LDNC restart auto\n" write_err endif
            1 == DNC_AUTORUN
            1 == ?AUTO_RESTART
            3 == iBANNER_FUNC   -1 kdm_stroke
            :exit               ` get out now
        else
            INDVC> w@ 27 ' ?AUTO_RESTART ptrval ioctl drop             ` get save ptr
            `  4 31 0 ioctl dup
            SYS_MSG? 2 and if ?AUTO_RESTART if ?AUTO_RESTART . " ," ' ?AUTO_RESTART . ""  Do Auto Restart\n" nl else "" Don't Auto Restart\n" endif write_err endif
        endif
    endif
	` auto replay back if ivar set to non-zero
	SYS_MSG? 2 and if " Pause Status: " get_pause_status . nl endif 
    ?AUTO_RESTART if 2 led_on INDVC> w@ 36 ' ?AUTO_RESTART ptrval ioctl drop
    else error_blink
	endif ;

` should not return from here if pointer is OK
: restart_jog 2 kdm_jog drop end_motion ;
0 ivar Z_JOG_DISPLAY?
: restart_again
    SYS_MSG? 2 and if "" into restart_again\n" write_err endif
	2 == OPERATE_MODE
    7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
    0 restart_cmd  ` clear current command
    DISPLAY_TIME? if hide_time_box endif
    hide_pre_job_info
    make_xyz_box
    0 == Z_JOG_DISPLAY?
    loop
       0 kdm_scankey -1 <> if 1 kdm_scankey
           dup 25 = if 25 restart_jog endif ` UP - jog up
           dup 24 = if 24 restart_jog endif ` DOWN - jog down
           dup 15 = if 15 restart_jog endif ` left - jog
           dup 26 = if 26 restart_jog endif ` right
           dup  0 = if drop 1 break endif   ` VST key 
           dup 28 = if 
                Z_JOG_DISPLAY? if 
                    hide_z_box 
                else
                    show_z_box
                    0 4 kdm_jog end_motion 
                endif
           endif
           dup 13 = if drop 0 break endif  ` exit key.
       endif
    repeat
    
    0 > if ` we pressed start, setup display and go.
        restart_auto_core
    else
       alt_ethernet
       disable_motion                ` turn off motion and accesories
       my_cancel                     ` Do cancel instead of all_off to reset replay bits
       1 == iDNCHaltCode DNCEndOfJob ` tell DNC we cancelled out
    endif
    :exit 
    
    0 16 kdm_jog
	0 == OPERATE_MODE
    0 =   ` if VST+, restart search
    if
        restart_auto_core  
        in_ldnc?  /* -- save current value -- */ 
        1 == vst_cancel 
        quit 
        0 == vst_cancel 
        /* saved above */ == in_ldnc?
	endif ;


: key_func0                            ` Restart Search (backward)
    SYS_MSG? 2 and if "" Key 0: into VST Key\n" write_err endif
	?DRIVE_ON not if drive_err :exit endif
    0 == TEST_SOLS ` In case they Menu while testing Aux's
	mpg_active? 0x3FFFF and 0x20000 =    ` make sure we are paused and not moving
	if
        1060 getmsg SYS_MSG? 2 and if dup s. nl endif kdm_dsp_line ` "" Searching ...." 
        false == in_dnc?    ` fool cycle_start into thinking we are not in dnc
        restart_auto_core 
        in_ldnc? 1 == vst_cancel key_func13 0 == vst_cancel /* saved above */ == in_ldnc?
	endif ;

` Alternate Prox restart that doesn't end when you cancel out of the job.  (back-door)
0 ivar DeleteLDNCJob?  ` do we delete the job.
: key_func40                          ` New Search
    0 == TEST_SOLS ` In case they Menu while testing Aux's
    LocalDNC? 1 and if
        ` if in local DNC and the user pressed Max Depth, delete the file the cursor is at.
        menu_status? if
            1 == DeleteLDNCJob?
            12 kdm_stroke
            :exit                           ` move exit inside to allow material select in local DNC mode
        endif
    endif
    key_func0
;



` 1=go, 0=next, -1=abort
: restart_query?
    PEN_ACTIVE? not if 0 :exit endif    ` skip penups
    0 == DISPLAY_TIME? 0 == DISPLAY_DELTA? iRTC_TIME 2* msd ` make sure we do not update time display.
    99 gi 1 and if JOB_TIME 60.0 f* rftoi TimeToStrRaw TIME_BOX_CTRL swap -1 -1 glcd_control_text drop endif  ` <"Text:"> set_time_box

    1 == IN_RESTART_HERE                ` flag used in pause_vst
    SYS_MSG? 2 and if "" Into restart_query, Pen Active = " write_err PEN_ACTIVE? . nl endif
    2 led_blink 1057 getmsg  kdm_dsp_line PEN# 1+ kdm_dspnum  ` "" VST Restart Here?     Pen = "
    1 start_idle                        ` short single blink
    false kdm_keyintr   ` turn off hotkeys
    eat_kdm             ` make sure that kdm_getkey is not automatically answered by having a keystroke in the buffer
    -1 kdm_pause_key
	loop
        kdm_peekkey 0 >=
		if  kdm_getkey 
		    dup 58 = if drop 2 led_on 1 break      ` start
            else dup 25 = if drop                  ` up arrow:next
                    ` redisplay because it gets cleared - cludge, fix the clear later        
                    1060 getmsg kdm_dsp_line ` "" Searching ...." 
                    0 break
                else dup 49 = if 0 restart_cmd pause_motion /* restart_again -1 break */ :exit ` Pause Key, Restart again
                    else 13 = if                        ` Cancel pressed
                          alt_ethernet
                          disable_motion                ` turn off motion and accesories
                          my_cancel                     ` Do cancel instead of all_off to reset replay bits
                          1 == iDNCHaltCode DNCEndOfJob ` tell DNC we cancelled out
                          task_port23 1 kill_task ` Restart the thread or queued up motion will execute.     
                          -1 break                      ` leave false for call below and break
                       endif            ` cancel
					endif
				endif
			endif
		endif
	repeat
    true kdm_keyintr
    dup 0 > if ` we pressed start, setup display and go.
        hide_xyz_box
        2 == iBANNER_FUNC true == EXECUTING? 
        ` 9 kdm_banner ` v3.03 change for 1 to 9
        kdm_dsp_rev
        get_rtc_elapsed == START_TIME     ` Reset start time.
        99 gi 1 and sign == DISPLAY_TIME?
        0 == TIME_SHOWN? make_time_box  ` make sure the time display is shown.
        0 show_pre_job_info 
        2 led_on
        MP_BITESIZE 0.00001 f> MPJ_BITESIZE 0.00001 f> or if 
            99 gi 2 and sign == DISPLAY_DELTA?
        endif
        ` 99 gi == DISPLAY_OPTIONS ` Reset the Display options
    endif
    dup 0 < if  
       make_idle_screen
       kdm_dsp_rev kon
    endif
    0 == IN_RESTART_HERE                ` flag used in pause_vst
    
    dup 0 <> if stop_idle endif 
    
    ` Returns 1=go, 0=next, -1=abort
    ;

: restart_prep
`    "" retart prep\n" write_err
    SPINDLE_ON? if 0 == SPINDLE_ON? spindle_on endif
    PEN_ACTIVE? if PEN# pendown endif
    2 led_on  ` turn on START led
    36 kdm_pause_key
    ;
/* *******************  End Of Restart Support Functions  ***************** */

/* ***************************************  ********************************************** */
/*                     DNC Support Macros                                                  */
/* ***************************************  ********************************************** */
0 set_warning
: SSM 
    slew_mode  true  == SLEW_MODE? 
    INVERT_Z? xlang 2 = land if 
        2 set_override        ` turn off feedrate override
        flush_plot
    endif
;
: SMM 
    machine_mode false == SLEW_MODE? 
    INVERT_Z? xlang 2 = land if 
        3 set_override      ` enable feedrate override
        ?USE_FEEDRATE not if                                            ` Check to see if bit is set
            ?INDIVIDUAL_CUTSPEED if
                PEN# 1+ select 
                => 140 gf ` Spindle 1 cut feedrate
                => 141 gf ` Spindle 2 cut feedrate 
                => 142 gf ` Both      cut feedrate
                default=> XYDN_FEED
                endselect
                fdup == XYDN_FEED 
            else
                XYDN_FEED 
            endif
            feedrate
        endif
    endif
;
: lang == xlang  ;
0 ivar was_info
: host_getkey    ` used for DNC (redefined here to remap PAUSE and START key)
    do_replay? 2 = if 43
    else
        loop
            kdm_peekkey -1 <> if
                kdm_getkey dup kdm_fastkey? if
                    128 or    ` or 128 to show that it was the fast key is held down
                endif
                swap 44 = not if break else drop endif  ` if it is just the fast key, drop the key
            else
              INDVC> w@ rdchk if
                    INDVC> w@ frchar 10 = if 0 break endif
                endif
            endif
        repeat
        was_info if
            dup 12 = if drop 77 0 == was_info endif ` don't exit dnc on these keys after file size
            dup 13 = if drop 77 0 == was_info endif ` 77 will just refresh the display
            dup 14 = if drop 77 0 == was_info endif
        endif
        dup 13 = if 128 + endif
        dup 58 = if drop 43 endif   ` remap pause to start
        dup 28 = if drop 128 13 + endif   ` remap to fast exit
        0 == was_info
    endif
    173 wchar 5 wchar ascii # wchar 3 swap pad. 172 wchar ;
/* Macros for DNC v4.51 and later */

` JNS Responds to the S8 commands via Port23 in the following format
` <FileCount><FileStartIndex><~ FolderRelativeToDNCRoot~><0> dnc_begin
` <ModifiedTime><FileSize> 101 jc_msg <FileNameDisplayString>|<FilePathRelativeToDNCRoot>
` <FileEndIndex><Flags><0> dnc_end  (If (Flags&0x01) there are more files in the folder)
: jc_msg dup 101 = if drop false == DNC_LOADING? dnc_file
       else  100 = if shape_file else drop fdrop clear_eol endif
       endif
;
0 ivar DNC_STARTED? 
0 ivar JC_PREVIEW
0 ivar JC_PREVIEW_EXIT
0 ivar JC_ACTIVE_PREVIEW 
100 100 sysallocate ptr JC_PREVIEW_JOBNAME
100 100 sysallocate ptr JC_PREVIEW_DATE
100 100 sysallocate ptr JC_PREVIEW_SIZE

` Following used for '?' when looking at DNC file. See hpgl_set_port_ex port 4002.
0 ivar DNC_END_CODE 0 ivar DNC_END_MORE 0 ivar DNC_END_LAST
: recall_dnc_end  ` call the last DNC End so it re-establishes the interrupts for dnc.
    DNC_END_LAST DNC_END_MORE DNC_END_CODE dnc_end
;
: dnc_begin true == DNC_STARTED? erase_display dnc_begin ;
: dnc_end
    dup == DNC_END_CODE over == DNC_END_MORE mover == DNC_END_LAST
    dnc_end
;
` 4 dnc_folder <1/0> <err>   if <err == 1> then the <1/0> is not present.
: dnc_folder? 4 dnc_info if 0 endif ;   
: dnckeyxxx  ` <key> dnckey <newkey>    called by firmware when using the new graphical keypad DNC.
    dup 58 = if drop 43 endif ` the 58 key is the start key in this init.
    dup 12 = if 1 == JC_PREVIEW 2 mp_status drop  drop 11 endif  ` mark that we are going to show preview.  
    dup 140 = if ` pass in start key for break of enter key.
        get_rtc_elapsed == iTempVar        ` init the clock counter so we can look for timeouts.
        loop 0 mp_status 2 = while get_rtc_elapsed iTempVar - 6000 > until repeat  ` timeout 4 seconds  
        drop 12 
    endif
;
: dnckey  ` <key> dnckey <newkey>    called by firmware when using the new graphical keypad DNC.
    dup 58 = if 0 == JC_PREVIEW drop 43 :exit endif ` the 58 key is the start key in this init.
    dup 12 = if dnc_folder? not if 1 == JC_PREVIEW drop 11 :exit endif endif  ` mark that we are going to show preview.
    dup 13 = if JC_PREVIEW if 0 == JC_PREVIEW erase_display recall_dnc_end drop 0 endif :exit endif
    JC_PREVIEW if
        JC_ACTIVE_PREVIEW if 
            2 or== JC_PREVIEW 
            dup 24 = if :exit endif
            dup 25 = if :exit endif
            dup 24 128 + = if drop 11 :exit endif  
            dup 25 128 + = if drop 11 :exit endif
        endif
        drop 0 
    endif 
;
` NOTE: Exiting preview calles ucito macro "clear_display"
: graphkey
    dup 58 = if drop 43 endif
    dup 13 = if 1 == JC_PREVIEW_EXIT endif
;
0 set_warning
: clear_display JC_PREVIEW_EXIT if erase_display else clear_display endif 0 == JC_PREVIEW_EXIT ;
1 set_warning
: dnc_preview
    1 show_pre_job_info
;
: show_dnc_preview ` This is called from 4002 set_port
    JC_PREVIEW 2 and JC_ACTIVE_PREVIEW land if
        BGCOLOR glcd_bg BGCOLOR glcd_fg
        200 24 120 192 glcd_box  
        2 mp_status drop
        
        200 24 119 105 set_rt_image_bounds  ` 10, 24 is hardcode in firmware, set to match.
        119 105 JC_PREVIEW_JOBNAME mp_init drop
        
    else
        BGCOLOR glcd_bg BGCOLOR glcd_fg
        0 0 320 240 glcd_box  
        2 mp_status drop
        
        10 24 170 150 set_rt_image_bounds  ` 10, 24 is hardcode in firmware, set to match.
        170 150 JC_PREVIEW_JOBNAME mp_init drop
        
        ` When Job Console is updated to support 2 preview sizes, we can switch to using the below method.
        ` 10 24 218 192 set_rt_image_bounds
        ` 218 192 JC_PREVIEW_JOBNAME mp_init drop
        
        get_rtc_elapsed == iTempVar        ` init the clock counter so we can look for timeouts.
        loop 0 mp_status 2 = while get_rtc_elapsed iTempVar - 6000 > until repeat  ` timeout 4 seconds
        
        cBG_TEXT_COLOR glcd_fg BGCOLOR glcd_bg 
        cBG_TEXT_COLOR BGCOLOR glcd_text_colors
        JC_PREVIEW_JOBNAME 10 0 glcd_text
        JC_PREVIEW_DATE    10 220 glcd_text
        
        dnc_preview
        ` 0 == JC_PREVIEW
    endif
;

: DNCExit ` Called by firmware when firmware controlled DNC Exits.
   SYS_MSG? 2 and if "" DNC Exit\n" write_err endif
   false == bDNCActive
   JC_ACTIVE_PREVIEW if 
        31 2 glcd_menu_util drop
        normal_control_font
   endif
   0 == SaveLDNC
   make_idle_screen
   -1 kdm_stroke kon
;
: getkey                            ` define getkey shortcut
    dup 99 = if 1 == was_info endif
    pos                             ` expects x,y to be on ISP
    1 -999 pos                      ` turn on cursor
    0 == AFTERJOB_TIME              ` do not update display via rtc proc
    koff                            ` turn off hotkeys
    16384 set_machine_state         ` tell JC we are waiting for keypresses.
    host_getkey                     ` wait for user key
    0 -999 pos                      ` turn off cursor
    ` check to see if we receive a response back within 500ms, if not, send #044 and wait again.
    ` if still no response, cancel and display error message.
    1 3 1 step
      1500 get_rtc_clk + loop dup get_rtc_clk < ?terminal or until repeat drop ` v6.23 increase to 1500.
      ?terminal if break else
        ifexists tcp_flush_host   0 tcp_flush_host  ` turn off sending ` v6.23 add.
        173 wchar 5 wchar ascii # wchar 3 44 pad. 172 wchar
        ifexists tcp_flush_host   1 tcp_flush_host  ` turn on sending
      endif
    endstep
    ?terminal not if
        "" Link to Host Timed  Out!" kdm_dsp_line kdm_getkey drop
        host_terminate
    endif
    16384 clr_machine_state
;

: DNCStartCore
    bDNCActive if drop :exit endif  ` don't start DNC if it's already started
    INDVC> w@ 41 1 ioctl drop       ` turn on Handshake lines (because of firmware version 3.50a)
    ` -1 clr_machine_state            ` just incase it is not cleared.
    true == bDNCActive
    1101 getmsg kdm_dsp_line       ` "" Connecting to host..."
    SYS_MSG? 2 and if "" DNCStartCore " write_err dup write_err_num write_err_nl endif 
    
    dup 2 <= Suite_39? not land if
        `  <iStartCode>
        dnc_cmd
        true == DNC_LOADING? ` set this here so the Cancel key will terminate the request.
        :exit
    endif
    5 AltChannelOpen 6 wchar       ` open alt channel to DNC
        dup 0 = if ascii S wchar 6040120 write_out_num endif  ` Normal DNC Start.
        dup 2 = if ascii S wchar       2 write_out_num endif  ` Replay Job
        drop
    6 wchar AltChannelClose                     ` close channel
    ;
0 ivar iStartCode
: DNCStart
    == iStartCode
    false == DNC_STARTED? 
    iStartCode DNCStartCore
    ` If start code is > than 10 or if using new KDM20G DNC, then do not call VerifyDNCStart.
    iStartCode 10 < iStartCode 2 <= not land Suite_39? or if
        get_rtc_clk == iTempVar             ` init the clock counter
        ?BATCH batch                        ` turn off echo so the rchar below wont show the ACK char when it arrives
        loop
            get_rtc_clk iTempVar - DNC_TIMEOUT > until ` timeout (2000 ticks is approx 4 secs)
            INDVC> w@ rdchk if                      ` char received from host?
                rchar 175 = until       ` if ack received - exit loop
            endif
        repeat
        not if batch_off endif              ` turn echo back on
        get_rtc_clk iTempVar - DNC_TIMEOUT >  if   ` check for timeout
            1100 getmsg kdm_dsp_line  ` 1100 "" Host Not Responding!"
            false == bDNCActive
            2 second
            -1 kdm_stroke
        endif
    else
        get_rtc_clk == iTempVar             ` init the clock counter
        SYS_MSG? 2 and if " DNC Started " DNC_STARTED? . nl endif
        ` If Replay, we cannot wait for dnc_begin.
        iStartCode 2 <> if 
            ?BATCH batch                        ` turn off echo so the rchar below wont show the ACK char when it arrives
            loop
                get_rtc_clk iTempVar - DNC_TIMEOUT > until ` timeout (2000 ticks is approx 4 secs)
                DNC_STARTED? if break endif      ` char received from host?
                100 msd                         ` add delay to give time for other thread to execute.
            repeat
            not if batch_off endif              ` turn echo back on
            get_rtc_clk iTempVar - DNC_TIMEOUT >  if   ` check for timeout
                1100 getmsg kdm_dsp_line  ` 1100 "" Host Not Responding!"
                false == bDNCActive
                2 second
                LocalDNCMenus? not SaveLDNC not land if make_idle_screen endif
                SaveLDNC not if -1 kdm_stroke endif
            else
                JC_ACTIVE_PREVIEW if
                    ` if active preview, reduce the display down to give room for preview image.
                    62 2 glcd_menu_util drop  ` index of smaller resource.
                    small_control_font 
                endif
                erase_display
            endif
        endif
    endif
;

"" host_terminate" ptr pphost
0 ivar ppinx     ` index into pphost
0 ivar ppchk     ` number of times we waited 500 ms for characters to be received
0 ivar ppcnt     ` number of bytes received.
0 ivar ppchar    ` character to search for.
0 ivar ppdvc

: Send_DNCHaltCode
    ifexists tcp_flush_host   0 tcp_flush_host  ` turn off sending
    5 AltChannelOpen 6 wchar ascii E wchar iDNCHaltCode write_out_num 6 wchar AltChannelClose
    ifexists tcp_flush_host   1 tcp_flush_host  ` turn on sending
    Suite_39? not if iDNCHaltCode eth_endjob endif ` send out code to suite 4.
    20 msd
;

: DNCEndOfJob                       ` Tell DNC a job is done (uses global var iDNCHaltCode)
    [ etcx 1 > ] #ifdef "" DNC  End Job " write_err  iDNCHaltCode write_err_num write_err_nl #endif
    0 led_off                       ` Pause was left on after pause/estop, is there a better place for this?
`    5 AltChannelOpen
`    6 wchar ascii E wchar iDNCHaltCode . 6 wchar ` Tell MX32 to stop sending, we're at the end of job
`    AltChannelClose
    Send_DNCHaltCode

    ` send PostJobTable for Job Times. Added for v3.5 of Job Server
    80 AltChannelOpen
    post_job_table  ` This tells JC that we are actually done and it is OK to update pause, play, etc buttons.
    AltChannelClose

    false == in_dnc?
    false == bDNCActive           ` this is cleared in host_terminate, but start,pause,vst,start,pause,cancel didn't clear
                                  ` this may cause other issues, so beware
    ` If we are executing a uCito Job, and we do a Pause/Cancel or CycleStart/Cancel,
    ` we want to loop until we see the host_terminate message to ensure that we stay
    ` in-sync with Job Server.
    iDNCHaltCode 0 <> if
        in_cito? if
            SYS_MSG? 2 and if "" DNCEOJ Looking...\n" write_err endif
            
            ` return 0=Success, 
            `        1=Timeout, 
            `        2=buffer de-activated while waiting, 
            `        4=KillInQ called while waiting, 
            `       -1=invalid arguments passed in, 
            `       -2=KillInQ already active, or already waiting on another string, 
            `       -3=buffer is not active
            INDVC> w@ 19 "" host_terminate" ioctl
            0 = if host_terminate 
            else Send_DNCHaltCode host_terminate endif
            
            kon
            batch_off
        endif ` endif in_cito?
    endif
    -1 == iDNCHaltCode                                  ` set halt code to UNINITIALIZED
    -1 clr_machine_state ` needed for suite 4.
`    -1 kdm_stroke
;
` ---------------------------------------------------------------------------------------------------------------------
` MACRO..........: DNC_CYCLE_START
` DESCRIPTION....: Called by MX32 DNC function at the start of each job.  Execution message is passed on
`                  the command line (not the stack)
` STACKS ON ENTRY: * NOT USED *
` STACKS ON EXIT.: * NOT USED *
` ---------------------------------------------------------------------------------------------------------------------
: combo-cycle-start
    8 set_machine_state
    curr_line_ptr 1+ dup                    ` grab bytes from the input stream 1 by 1 until we reach the end of line
    loop
`        dup b@ 10 = until 1+
        dup b@ dup 10 = swap 0 = or until 1+ ` must also check for 0 here due to bug introduced when adding local DNC
    repeat
    0 swap b!                               ` add NULL to end
    dup slen 40 > if dup 39 + 0 swap b! endif ` if > 40 chars, truncate by placing NULL in 40th spot
    JobName s!                             ` store string to be displayed on pendant while job is executing
    ParseJobName  ` get reps and shorten name.
    2 == JOBBASIS?  ` mark job as coming from DNC.
    clear_eol
    ;

word SaveDNCFile
: DNC_CYCLE_START
    curr_line_ptr 1+ dup                    ` grab bytes from the input stream 1 by 1 until we reach the end of line
    loop
`        dup b@ 10 = until
        dup b@ dup 10 = swap 0 = or until
        ` if saving file, do not save the repetitions
        SaveLDNC if
            dup b@ ascii ( = until  ` break out on first (
        endif
        1+
    repeat
    0 swap b!                               ` add NULL to end
    dup slen 20 > if dup 19 + 0 swap b! endif ` if > 20 chars, truncate by placing NULL in 20th spot
    JobName s!                              ` store string to be displayed on pendant while job is executing
    true == in_dnc?
    SaveLDNC if
        SaveDNCFile
        0 LocalDNCMenu
        clear_eol
    else
        true == DNCJOB_AVAILABLE?           ` show that this job is available when we replay.
        combo-cycle-start                   ` has a clear_eol
    endif
;

: Q_CYCLE_START
    false == in_dnc?
	combo-cycle-start
    ;   ` used for MX32 Job Queue

: HOTWATCH_CYCLE_START   ` hot watch startup
    true == in_dnc?      ` set to true so kdm_cycle_start shows up. 
    true == DNCJOB_AVAILABLE?               ` show that this job is available when we replay.
    combo-cycle-start ;

/* ***** LOCAL DNC ***** */
` 0 ivar SaveLDNC        ` flag to save file instead of running it.
` 0 ivar ViewLDNCJob?    ` do we view the file size or execute the job.
` 0 ivar DeleteLDNCJob?  ` do we delete the job.
` 1 ivar LastLDNCJob     ` number of last DNC job we ran.
100 ivar TEMPFILE

1 #ifdef
` 0 ivar LocalDNCMenus?  ` are we viewing local dnc menus.
` flash parameter 1371-1390 will be used to hold the filenames for the location DNC.
` Files 201-220 will be the local files.
11 321 sysallocate ptr chk_info_buf
: SetJobName dup slen 20 > if dup 19 + 0 swap b! endif JobName s! ;
: ClrJobName "" " SetJobName ;
: SetTempJobName dup slen 20 > if dup 19 + 0 swap b! endif TempJobName s! ;
: SetMenuTitleStr pMenuTitle 80 sn! ;
: SetMenuTitle getmsg CopyLineTrimColon SetMenuTitleStr ;  ` <message num> SetMenuTitle
: DNCFileSpace
    5000000 ` max of 5 meg, subtract each file already loaded.
    0 220 1 step I file_size 0 max - endstep 
;
ifmissing file_space : file_space DNCFileSpace 5000000 0 ; ` file_space <available> <total> <error code> 
0 set_warning
: menu_exit  ` this is called by firmware when the menu exits.
    ` put the menus back.
    [ etcx 1 > ] #ifdef "" Menu_exit\n" write_err #endif
    in_ldnc? not if alt_ethernet endif
    LocalDNCMenus? SpecialMenus? or if
        7 1 2 20 menu_config
        12 kdm_menu_exec_key
        menu_reset
        main_menu             ` load up regular menus
    endif
    0 == SpecialMenus?
    0 == LocalDNCMenus?
    ifexists menu_exit menu_exit
;
1 set_warning
: DeleteDNCFile  ` <filenum> DeleteDNCFile
    ` only try to delete file if it exists.
    dup 200 + file_size 0 > if
        "" Deleting..." 0 0 pos kdm_dsp_string
        dup 200 + delete 1 <> if " Error Deleting File\n" endif
        1370 + delete_param  ` delete the name of the file as well.
    else drop endif
;
20 ivar MAX_LDNC
 0 ivar LDNC_MENU#
"" LDNCXXXXXXXXXX" ptr LDNC_FILE  ` the name of the macro to run. added 6 more x's to reserve space for longer string
: RunLDNCJob ` <file location> RunLDNCJob
    2 == JOBBASIS? 
    dup 200 - dup LastLDNCJob <> if 1 == REPS else REPS 1+ 2 max == REPS endif == LastLDNCJob
    1 == in_ldnc?
    in_hpgl? if "" \n!ZX\n" stuff_it endif
    in_cnc?  if "" \nM99\n" stuff_it endif
    "" 200 msd\n" stuff_it
    "" \n" LDNC_FILE s! /* file num */ itoa LDNC_FILE s+! ""  load\n" LDNC_FILE s+! ` build command string
`                [ etcx 1 > ] #ifdef LDNC_FILE write_err "" \n" write_err #endif
    SYS_MSG? 2 and if LDNC_FILE write_err endif 
    LDNC_FILE stuff_it
;
: LDNC
    [ etcx 1 > ] #ifdef "" Into LDNC, file = " write_err dup write_err_num write_err_nl #endif
    == LDNC_MENU#
    1 == LOADING_LDNC?  ` needed for menu_exit to not refresh display. 
    menu_leave
    3 kdm_lines
    LDNC_MENU# not if
        DeleteLDNCJob? not if
            "" Available Space" kdm_dsp_line
            8 kdm_integer_size
            0 2 pos file_space drop drop kdm_dspnum 
            1 == SaveLDNC  ` set flag to save file instead of running it.
            "" " JC_PREVIEW_SIZE s!  ` clear size just in case. 
            0 DNCStart
        endif
        :exit
    endif
    [ etcx 1 > ] #ifdef "" LocalDNCMenus? = " write_err LocalDNCMenus? write_err_num write_err_nl #endif
    LDNC_MENU# 1370 + param? 3 <> if :exit endif   ` no file name, do not run.
    LDNC_MENU# 1370 + get_string SetTempJobName
    DeleteLDNCJob? if
        1147 getmsg kdm_dsp_line ` "" Delete Job?"
        0 1 pos TempJobName kdm_dsp_string
        kdm_getkey 12 = if LDNC_MENU# DeleteDNCFile 0 LocalDNCMenu endif
        0 == DeleteLDNCJob?
        0 == LDNC_MENU#
    else
        [ etcx 1 > ] #ifdef "" In LDNC, ViewLDNCJob? = " write_err ViewLDNCJob? write_err_num write_err_nl #endif
        SYS_MSG? 2 and if "" LDNC stack " write_err #istk write_err_num write_err_nl endif
        ViewLDNCJob? if
            LDNC_MENU# 200 + file_size 0 > if
                SYS_MSG? 2 and if "" LDNC stack " write_err #istk write_err_num write_err_nl endif
                LDNC_MENU# 200 + file_size 5000 > if
                    1106 getmsg kdm_dsp_line ` "" Loading..."
                    0 1 pos TempJobName kdm_dsp_string
                    0 kdm_cursor
                endif
                15 == PREVIEW_JOB_RUN  ` special flag for previewing local dnc job.
                LDNC_MENU# 200 +
                SYS_MSG? 2 and if "" Loading " write_err dup write_err_num write_err_nl endif 
                load
                SYS_MSG? 2 and if "" LDNC stack " write_err #istk write_err_num write_err_nl endif
                end_motion
                0 == PREVIEW_JOB_RUN
                SYS_MSG? 4 and if "" graph mode is " write_err get_graph_box write_err_num write_err_nl endif
                get_graph_box 15 and if
                    end_graph_box
                endif
                
                0 show_pre_job_info

                8 kdm_integer_size
                TempJobName kdm_dsp_line
                0 1 pos "" Size: " kdm_dsp_string LDNC_MENU# 200 + file_size kdm_dspnum ""  bytes" kdm_dsp_string
                loop
                    kdm_getkey 
                    dup 58 = if ` look for start key.
                        drop
                        SYS_MSG? 2 and if "" Run Job " write_err TempJobName write_err write_err_nl endif 
                        TempJobName SetJobName 
                        LDNC_MENU# 200 + RunLDNCJob
                        break
                    endif
                    dup 12 = if
                        1089 getmsg kdm_dsp_line ` "" Press START to run job."  
                    endif
                    13 = if
                        ` we want the display to refresh in this case because the quit the job.
                        0 == LOADING_LDNC?  
                        break 
                    endif  
                repeat
            endif
        else
            ` only run if filesize
            ` ParseJobName  ` get reps and shorten name.
            TempJobName SetJobName 
            LDNC_MENU# 200 + file_size 0 > if
                LDNC_MENU# 200 + RunLDNCJob
            endif
            1 == ViewLDNCJob?
        endif
    endif
    SYS_MSG? 2 and if "" Exit LDNC " write_err #istk write_err_num write_err_nl endif
;
: LDNC1  1  LDNC -1 ; : LDNC2   2 LDNC -1 ; : LDNC3   3 LDNC -1 ; : LDNC4   4 LDNC -1 ; : LDNC5   5 LDNC -1 ;
: LDNC6  6  LDNC -1 ; : LDNC7   7 LDNC -1 ; : LDNC8   8 LDNC -1 ; : LDNC9   9 LDNC -1 ; : LDNC10 10 LDNC -1 ;
: LDNC11 11 LDNC -1 ; : LDNC12 12 LDNC -1 ; : LDNC13 13 LDNC -1 ; : LDNC14 14 LDNC -1 ; : LDNC15 15 LDNC -1 ;
: LDNC16 16 LDNC -1 ; : LDNC17 17 LDNC -1 ; : LDNC18 18 LDNC -1 ; : LDNC19 19 LDNC -1 ; : LDNC20 20 LDNC -1 ;
: LDNC0  0  LDNC 0 ;
` : LDNC1  1  LDNC 0 ; : LDNC2   2 LDNC 0 ; : LDNC3   3 LDNC 0 ; : LDNC4   4 LDNC 0 ; : LDNC5   5 LDNC 0 ;
` : LDNC6  6  LDNC 0 ; : LDNC7   7 LDNC 0 ; : LDNC8   8 LDNC 0 ; : LDNC9   9 LDNC 0 ; : LDNC10 10 LDNC 0 ;
` : LDNC11 11 LDNC 0 ; : LDNC12 12 LDNC 0 ; : LDNC13 13 LDNC 0 ; : LDNC14 14 LDNC 0 ; : LDNC15 15 LDNC 0 ;
` : LDNC16 16 LDNC 0 ; : LDNC17 17 LDNC 0 ; : LDNC18 18 LDNC 0 ; : LDNC19 19 LDNC 0 ; : LDNC20 20 LDNC 0 ;
` : LDNC0  0  LDNC 0 ;
0 ivar InitLDNCMenu
` 0 ivar Found_a_file ` not used at this time, since we always have a menu item (load from pc)
: LocalDNCMenu ` <1=run, 0=init> LocalDNCMenu
    norm_ethernet
    == InitLDNCMenu
    InitLDNCMenu if ` if just initializing, do not show message
        1140 getmsg kdm_dsp_line 50 msd ` "" Loading Local DNC", was 500 msd
    endif
    menu_reset
    
    7 1 2 20  menu_config ` 2 rows, 1 column, start on row 1, 20 characters.
    ' LDNC0 1149 getmsg menu_add  ` "" Load Job from PC"
`    0 == Found_a_file
    1 MAX_LDNC 1 step
        200 I + file_size 0 > if
            ` there is a file, check to see if there is a name for the file.
            1370 I + param? 3 = if
                ` This location has a file, find a macro to call it.
                "" LDNC" LDNC_FILE s! I itoa LDNC_FILE s+! LDNC_FILE PATH> find if
                    1370 I + get_string menu_add
`                    1 == Found_a_file
                endif
            else
                200 I + delete drop  ` try to delete the file if there is no name associated with it.
            endif
        endif
    endstep
    1 == LocalDNCMenus?
    1 == ViewLDNCJob?
    0 == DeleteLDNCJob?
`    Found_a_file if
        InitLDNCMenu if
            [ etcx 1 > ] #ifdef " Execute menu, status = " menu_status? . nl #endif
            -1 kdm_menu_exec_key
            "" Local  DNC" SetMenuTitleStr  ` "" Local  DNC"
            erase_display
            3 kdm_lines
            menu_status? if
                0 menu_exec  ` start the menus
            else
                ldnc_menu# menu_exec
            endif
            12 kdm_menu_exec_key
            [ etcx 1 > ] #ifdef " Done with Menu\n" #endif
        endif
`    else
`        1141 getmsg kdm_dsp_line 500 msd ` "" No Local Files"
`        menu_status? if 13 kdm_stroke else menu_exit endif
`        -1 kdm_stroke
`    endif
    kdm_intr? not if kon endif  ` turn on hot keys if they are not on.
;
0 ivar NEW_DNCFILE
"" end_plot" ptr LDNC_EOF_STR  ` string to look for when ending file. (Change the 8 below for number of characters)
LDNC_EOF_STR ptr LDNC_EOF
: ErrorSaveDNCFile  ` <string> ErrorSaveDNCFile
    0 2 pos kdm_dsp_string
    kdm_getkey drop
    1 == iDNCHaltCode ; ` set to 1 so DNCEndOfJob will dump the file
: 6fwchar chk_info_buf b! chk_info_buf 6 1 write ;
: 6write dup slen 6 swap write drop ; 
: 6writeInt itoa 6write ;
: 6writefp pItoa "" %7.4f" fpprintf 6write ;

0 ivar file_prog
: SaveDNCFile
    1142 getmsg kdm_dsp_line ` "" Saving...           "
    0 1 pos JobName kdm_dsp_string
    0 2 pos JC_PREVIEW_SIZE kdm_dsp_string 
    0 == iDNCHaltCode
    ` Find first open space to store file
    0 == NEW_DNCFILE
    ` First, look for existing file name.  Can't do in 1 step due to holes left by delete
    1 MAX_LDNC 1 step
        I 1370 + Param? 3 = if
            JobName I 1370 + get_string scomp not if
                200 I + == NEW_DNCFILE break
            endif
        endif
    endstep
    ` If existing file not found, look for available slot
    NEW_DNCFILE not if 1 MAX_LDNC 1 step 200 I + file_size -1 = if 200 I + == NEW_DNCFILE break endif endstep endif

    ` if there is a place to save, use it, otherwise complain.
    NEW_DNCFILE if
        6 [ hex ] 20000 [ decimal ] TEMPFILE + open  ` open file 100 for writing.
        6 = if ` check to see if we were able to open the file.

        
            "" \n0 0.0 4000 set_port_ex\n" 6write 
            BOUND_MIN_X     6writefp  ""  0 4010 set_port_ex\n" 6write
            BOUND_MIN_Y     6writefp  ""  1 4010 set_port_ex\n" 6write
            BOUND_MAX_X     6writefp  ""  0 4011 set_port_ex\n" 6write
            BOUND_MAX_Y     6writefp  ""  1 4011 set_port_ex\n" 6write
            
            JOB_TOOL_NUMBER 6writeInt ""  4024 set_port\n" 6write
            JOB_HOME_NUMBER 6writeInt ""  4080 set_port\n" 6write

            ` read the entire file looking for LDNC_EOF_STR
            get_rtc_elapsed == iTempVar        ` init the clock counter so we can look for timeouts.
            0 == file_prog
            loop
                get_rtc_elapsed iTempVar - 1000 > until ` timeout 1 second
                INDVC> w@ rdchk if
                    INDVC> w@ frchar dup 6fwchar -1 = if 1143 getmsg ErrorSaveDNCFile break endif ` "" Error Writing File, out of room."
                    file_prog 1+ == file_prog
                    file_prog 1023 and not if
                        10 0 pos file_prog 1024 / kdm_dspnum "" K" kdm_dsp_string
                    endif
                    ` look for ending string (8 characters).
                    LDNC_EOF b@ = if LDNC_EOF 1+ == LDNC_EOF LDNC_EOF LDNC_EOF_STR - 8 >= until
                    else LDNC_EOF_STR == LDNC_EOF endif
                    get_rtc_elapsed == iTempVar   ` reset counter
                endif
            repeat

            6 close  ` close the file.
            NEW_DNCFILE file_size 0 > if
                NEW_DNCFILE delete 1 <> if " Error Deleting file\n" endif
            endif
            TEMPFILE NEW_DNCFILE rename 1 <> if " Error Renaming file\n" endif

            ` only if there is a file in the location, set the
            NEW_DNCFILE file_size 0 > if
                ` only save if we received ending string and not timed out.
                LDNC_EOF LDNC_EOF_STR - 8 >= if
                    JobName NEW_DNCFILE 200 - 1370 + set_string ` save the name
                else
                    NEW_DNCFILE delete                    ` delete the file
                    NEW_DNCFILE 200 - 1370 + delete_param ` delete the name, in case it exists from a rename
                    1144 getmsg ErrorSaveDNCFile ` "" End of Job not FoundFile not saved."
                endif

            endif

        else
            1145 getmsg ErrorSaveDNCFile ` "" Could not open Temp file.  Try again."
        endif

    else
        1146 getmsg ErrorSaveDNCFile ` "" Too Many Files,     delete one first."
    endif

    DNCEndOfJob
    -1 kdm_stroke
;
#endif
/* *** End Local DNC *** */

/* *****************************  HPGL Stuff  ***************************** */
0 ivar PORT

: hpgl_defaults                 ` DF command
	;

: hpgl_init                     ` IN command
    SYS_MSG? 2 and if "" HPGL_INIT\n" write_err endif
    hpgl_defaults ;

: hpgl_DT                       ` DT command (Digitize)
    wait_plot

    [ 0 ] #ifdef
    -1 kdm_pause_key                         ` disable pause key
    -9 kdm_menu_enter_key ` remap keys so user cannot screw up digitize
    -9 kdm_menu_exit_key
    -9 kdm_menu_exec_key

    dig_start_job

    ` Move over by scanner offsets.
    215 gf == X_TOOL_OFFSET
    216 gf == Y_TOOL_OFFSET
    do_set_home
    X_TOOL_OFFSET fneg Y_TOOL_OFFSET fneg 0. uline wait_plot
    dig_auto_scan
    1 scan_pen drop 1 scan_job

    ` Clear offsets
    0.0 == X_TOOL_OFFSET
    0.0 == Y_TOOL_OFFSET
    do_set_home

    36 kdm_pause_key                        ` re-enable pause key
    12 kdm_menu_enter_key                   ` re-enable the menu key.
    13 kdm_menu_exit_key
    12 kdm_menu_exec_key

    false == _DIG_START  ` clear variable that says we started.
    #endif
;

` Moved set_up_feedrate below set_down_feedrate because it will call the other
` takes INT and FLT on stack INT=Z or XY, FLT= new feedrate
: set_down_feedrate             ` SF command
    ?IGNORE_SF if drop fdrop :exit endif ` Set by parameter 55.
    
	UNITS not if 25.4 f/ endif
    if 520 gf fmax 521 gf fmin == ZDN_FEED
	else XYUP_FEED fmin
        500 gf fmax 510 gf fmax == XYDN_FEED
		PEN_ACTIVE? in_hpgl3d? or if XYDN_FEED feedrate endif
	endif ;

: set_up_feedrate               ` VS command
    drop        ` we aren't looking for z or xy(see set_down_feedrate), so get rid of this value
    ?USE_FEEDRATE if                                            ` Check to see if bit is set
        ` removed fdup from line below, don't know why it was there but it left float on stack
        60. f/ .01 fmax 1. fmin == VS_PERCENT              ` Set the percentage used by pendown
        PEN_ACTIVE? in_hpgl3d? or if XYDN_FEED VS_PERCENT f* feedrate endif
    else
        fdrop                                              ` bit not set, This function not used
    endif ;


: set_pen_depth                 ` ZD command
	== Z_DEPTH
	in_hpgl3d? not  PEN_ACTIVE? land if
		ZDN_FEED feedrate
		coords_2d? Z_DEPTH ualine
		XYDN_FEED feedrate
	endif ;

` <down> <up> set_pen_dwells
: set_pen_dwells                ` SD command
    ?IGNORE_SD if drop drop :exit endif ` Set by parameter 55. 
    
    dup 0 >= if == PEN_UP_DELAY
    else drop
    endif
    dup 0 >= if == PEN_DOWN_DELAY
    else drop
    endif
    ` " pen down delay = " PEN_DOWN_DELAY . "  up delay = " PEN_UP_DELAY . nl
    ;

/* <msg ptr> hpgl_tool_change */
: hpgl_tool_change
    kdm_dsp_line
    SPINDLE_ON?
	spindle_off
    kdm_getkey drop
    if spindle_on endif
	-1 kdm_stroke
    ;

: index_rel /* idelta */
    0 1 switch_x monFP   `  switch to cyl without diameter adjustment
    itof 43 gf f/ 0. 3zero uline wait_plot
    0 0 switch_x monFP   `  switch to flat
  ;
: index_abs /* iPOS */
    0 1 switch_x monFP   `  switch to cyl without diameter adjustment
    itof 43 gf f/ coords? 3 fpluck fdrop ualine wait_plot
    0 0 switch_x monFP   `  switch to flat
  ;

 `  4001 Port definitions (need to send NEED_JOB_INFO in pre_job_table)
 ` FLAG_VISION     0x00100000  Vision job
 ` FLAG_HAS_RASTER 0x01000000  Job has a PICT/RAST entity
 ` FLAG_ROTATY_JOB 0x02000000  Rotary Job
 ` FLAG_AUTO_Z     0x40000000  Auto Z job
 ` FLAG_FOCUS      0x04000000
 ` FLAG_NO_ZMOVES  0x08000000  No Z value in the job.
 ` AXIS_TYPE_Z     0x00000002  uCito 3D job
: set_job_info ` Port 4001 of set_port_ex
     dup 0x08000000 and if false == bUCito3D else true == bUCito3D endif
     drop  ` drop the rest for now.
;
: set_bound_min ` Port 4010 <min> <axis> set_bound_min
    dup 0 = if drop == BOUND_MIN_X :exit endif
    dup 1 = if drop == BOUND_MIN_Y :exit endif
    dup 2 = if drop == BOUND_MIN_Z :exit endif
    drop fdrop
;
: set_bound_max ` Port 4011 <max> <axis> set_bound_max
    dup 0 = if drop == BOUND_MAX_X :exit endif
    dup 1 = if drop == BOUND_MAX_Y :exit endif
    dup 2 = if drop == BOUND_MAX_Z :exit endif
    drop fdrop
;
: init_job_info_table
    "" " JC_PREVIEW_JOBNAME s! ` initialize the job name
    "" " JC_PREVIEW_DATE s! 
    "" " JC_PREVIEW_SIZE s!  
    0.0 == BOUND_MIN_X
    0.0 == BOUND_MIN_Y
    0.0 == BOUND_MIN_Z
    0.0 == BOUND_MAX_X
    0.0 == BOUND_MAX_Y
    0.0 == BOUND_MAX_Z
;
0 ivar CYL_INDEX_DEGREES
: index_cyl ` Move the rotary by an index ammount. JRC
    wait_plot
    switch_to_cyl
    CYL_INDEX_DEGREES itof 360.0 f/ CYL_FACTOR f* 3.14159265359 f* ` Convert degrees into user units to move. 1 Revolution = 360 degrees.
    /* Rotation */ 0. 0. uline wait_plot    
    switch_to_flat 
;

: hpgl_set_port         ` ZOp,d  --> <data> <port>
    == PORT
    ` INSERT VIRTUAL PORT DEFINITIONS HERE
    `
	` for each virtual port definition duplicate the line:
	`   PORT {virtual port number} = if {use stack data value} :exit endif
	`
    ` NOTE: Virtual ports  1 - 39 are reserved for setting physical ports
    `       Virtual ports 40 - 49 are reserved for future use
    `       Virtual ports 50 - 89 are reserved for clearing physical ports

    `       These are defined in the TRANSLATOR (XLATE) DLL for job rotation and should not be used...
    `       PORT 1008 - Rotational angle (in degrees)
    `       PORT 1009 - X Rotational point of origin
    `       PORT 1010 - Y Rotational point of origin
    `
    ` <data> on ISP
    PORT 100 = if 1 swap wait_plot spindle_speed :exit endif      ` set spindle speed
    PORT 110 = if itof 1000. f/ == MP_BITESIZE :exit endif     ` set Max Z Increment (for MultiPass)
    PORT 120 = if index_rel :exit endif
    PORT 121 = if index_abs :exit endif
    PORT 122 = if if SOL1_CODE 0 solenoid_on PEN_DOWN_DELAY delay else SOL1_CODE 0 solenoid_off endif :exit endif
    PORT 123 = if ` <enable/disable>
               if   SPINDLE_ON? not if spindle_on endif true
               else SPINDLE_ON? if spindle_off endif false
               endif == ?AUTO_SPINDLE :exit
    endif
    PORT 124 = ?DISPENSE_ENABLE land if PWMREG3 swap dup 1com set_bits :exit endif    ` manually set Sol3 current
    ` Reset default HPGL Scales...
    PORT 148 = if drop 43 gf 44 gf hpgl_scales :exit endif
    PORT 301 = if ` Index Rotary Axis for Square Tube Engraving. JRC
                == CYL_INDEX_DEGREES index_cyl
                :exit 
            endif
    PORT 1000 = if itof 1000.0 f/ == VPXHome VPSoftHome :exit endif
    PORT 1001 = if itof 1000.0 f/ == VPYHome VPSoftHome :exit endif
    PORT 1002 = if itof 1000.0 f/ == VPZHome VPSoftHome :exit endif
    PORT 1005 = if drop port_pause :exit endif
    PORT 1006 = if 1 swap switch_x chk_any_motion? if monFP endif :exit endif   ` switch with diameter adjustment
    ` JSS sending pen codes one higher then needed, old uc did a 1+ in pendown but that isn't needed here.
    PORT 1007 = if 1- == PEN_OVERRIDE :exit endif
    PORT 4024 = if == JOB_TOOL_NUMBER :exit endif ` Tool Number
    PORT 4080 = if == JOB_HOME_NUMBER PREVIEW_JOB_RUN not if 3 == PREVIEW_JOB_RUN endif :exit endif ` Home Number
    PORT 4081 = if itof 43 gf f/ 0 set_bound_min :exit endif ` X Min bounds 
    PORT 4082 = if itof 44 gf f/ 1 set_bound_min :exit endif ` Y Min bounds 
    PORT 4083 = if itof 43 gf f/ 0 set_bound_max :exit endif ` Y Min bounds 
    PORT 4084 = if itof 44 gf f/ 1 set_bound_max PREVIEW_JOB_RUN 2 min not if 2 == PREVIEW_JOB_RUN endif :exit endif ` Y Min bounds 
    ` bell "  Virtual port " PORT . "  is not defined!" nl 
    drop ; ` drop value
: hpgl_set_port_ex ` <floating data> <integer data> <port> hpgl_set_port_ex  (set_port_ex, G10, G98)
    == PORT
    PORT 201  = if  ` HPGL VS command
        fdrop drop :exit endif
    PORT 4000 = if  ` initialize job info table.
            init_job_info_table 
            drop fdrop :exit endif
    PORT 4001 = if ` Information about job.
            fdrop set_job_info :exit endif
    PORT 4002 = if 
            drop fdrop
            JC_PREVIEW if
                show_dnc_preview
            endif
            :exit endif 
    PORT 4010 = if ` Job Min Bounds
            set_bound_min :exit endif
    PORT 4011 = if ` Job Max Bounds
            set_bound_max :exit endif
    PORT 4300 >= PORT 4399 <= land if  ` Sheet commands  example  0.0 ~ 3 [24x32 0.75 MDF]~ 4300 set_port_ex
            fdrop deallocate :exit
         endif
    PORT 4500 = if fdrop dup JC_PREVIEW_JOBNAME s! deallocate :exit endif
    PORT 4501 = if fdrop dup JC_PREVIEW_SIZE s! deallocate :exit endif   ` shown when loaoding the file (saving using LDNC)     
    PORT 4502 = if fdrop dup JC_PREVIEW_DATE s! deallocate :exit endif
    PORT 4100 >= PORT 4999 <= land if  ` catch all strings that have not been processed.
            fdrop deallocate :exit
         endif
    fdrop PORT hpgl_set_port ; ` if not set_port_ex, call set_port.

: set_pen_lift                  ` ZU command
	Z_LIFT fover == Z_LIFT
    fswap f-                            ` old-new
    coord_Z? 0. f<                      ` see if above surface
	if 0. 0. 3 fpluck uline wait_plot   ` put Z to new lift
	else fdrop endif ;
: SPU set_pen_lift ;
` add commands for JobServer
: SUF 0 set_up_feedrate ;
: SDF 0 set_down_feedrate ;
: SDFZ fdrop ;
: M1222 ;
/* *************************  End Of HPGL Stuff  ************************** */

/* ************************  CNC Support Functions  *********************** */
0  ivar MCODE
0  ivar NOW_PEN#
1  ivar ?PAUSE_ENABLE   ` 0 to disable all CNC pausing (M00 and M01)

: cnc_slew_mode slew_mode ;
: cnc_machine_mode machine_mode ;

: cnc_2d cnc_mode? 2 1com and cnc_mode ;            ` set 2d mode
: cnc_3d cnc_mode? 2 or cnc_mode  ;                 ` set 3d mode
: cnc_auto_on   cnc_mode? 16 1com and cnc_mode ;    ` auto flushing on
: cnc_auto_off  cnc_mode? 16 or cnc_mode ;          ` auto flushing off
: cnc_pause_on  cnc_mode? 128 1com and cnc_mode ;   ` enable M01 pause
: cnc_pause_off cnc_mode? 128 or cnc_mode ;         ` disable M01 pause

: cnc_pause_mode? cnc_mode? 128 and if 0 else 1 endif . nl ; ` pause status

: cnc_pen_select        ` G00 tool change command (T parm)
    drop ;

: cnc_tool_change       ` G00 tool change comment (C parm)
    drop ;

: cnc_find_limits       ` G37 find limits command
    wait_plot find_limits start_motion ;

: cnc_peck_drill        ` G83 peck drill command
    f2drop fdrop ;

: cnc_spindle_speed     ` G97 spindle speed control
    1 swap spindle_speed ;

: cnc_program_pause     ` M00 program pause
    ?PAUSE_ENABLE not if :exit endif
    1 == idle_menu      ` set flag to ignore operator (hardware) pause
    eat_kdm
    1112 getmsg == iTempVar iTempVar kdm_dsp_line ` "" Pause Code Detected  ENTER To Continue"
    loop kdm_getkey  dup
        6 = if  ` if set_suface was pressed...
            kdm_intr?
            1 == OPERATE_MODE
            0 range_checking
            7 units_decpt kdm_float_size  ` set floats to 7 characters and either 2 or 3 decimals
            show_z_box
            8 4 kdm_jog 6 = if    ` pass in 6 key to change display
                2 get_pos? 1 1072 getmsg ` 1072 "" Surface Set."
            else
                0 1073 getmsg ` 1073 "" Surface Not Set."
            endif
            kdm_dsp_line 1 second
            hide_z_box
            1074 getmsg  kdm_dsp_line      ` 1074 "" Lifting..."
            if == Z_SURFACE X_HOME Y_HOME 0. set_soft_home endif    ` uses Z_SURFACE
            0. 0. coord_Z? Z_SURFACE Z_LIFT fmin f+ fneg uline wait_plot
            0 == OPERATE_MODE
            iTempVar kdm_dsp_line
            3 range_checking
            kdm_keyintr
        endif
        12 = until ` if enter was pressed
    repeat
	0 == idle_menu
    -1 kdm_stroke ;

: cnc_optional_pause    ` M01 optional pause
    ?PAUSE_ENABLE not if :exit endif
    cnc_program_pause ;

: cnc_mcode             ` main line mcode decoder
    == MCODE
    MCODE 00 = if cnc_program_pause       :exit endif     ` this is fat code
    MCODE 01 = if cnc_optional_pause      :exit endif     ` but leave it as
    MCODE 11 = if cnc_2d NOW_PEN# pendown :exit endif     ` is for now for
    MCODE 21 = if cnc_2d NOW_PEN# penup   :exit endif     ` clarity as we
    MCODE 12 = if cnc_3d NOW_PEN# pendown :exit endif     ` define/develop
    MCODE 22 = if cnc_3d NOW_PEN# penup   :exit endif     ` mcodes - i'll
    nl bell "  M code " MCODE . "  is not implemented!" ; ` squish it later

: cnc_mode_init         ` set_default cnc mode
    64 cnc_mode         ` enable 'CYCLE START' operator prompt
    cnc_2d              ` set 2d mode
    cnc_auto_on         ` auto_flush to on
    cnc_pause_off ;     ` optional pause to off
    cnc_mode_init

: cnc_set_port          ` G98 set port command
    hpgl_set_port ;

: set_port         ` for xlat
    hpgl_set_port ;
: set_port_ex
    hpgl_set_port_ex ;
: info_string drop clear_eol ;  ` M3.00 add for new xlate/JS
/* ********************  End Of CNC Support Functions  ******************** */

1 set_xy_mode
1 == ?FULL_CANCEL   ` M2.59 kill buffer save if downloading
: pause_main_menu
    7 1 2 20 menu_config

    ?INDIVIDUAL_CUTSPEED if
        UNITS if 2 fprec else 3 fprec endif
        ' submenu_spindle1_speed     1256 getmsg 140 gf menuFmake submenu_add  ` "" Spindle 1    : "
        ' submenu_spindle2_speed     1257 getmsg 141 gf menuFmake submenu_add  ` "" Spindle 2    : "
        ' submenu_spindleBoth_speed  1258 getmsg 142 gf menuFmake submenu_add  ` "" Both Spindles: "
    else
        ' menucut_speed  1000 getmsg submenu_add  ` 1000 "" Cut Speed          "
    endif
    ?CONTROLLED_Z if
        ` ' user9        1005 getmsg submenu_add  ` 1005 "" Z Delta           "
        ' menu_lift_height 1006 getmsg submenu_add  ` 1006 "" Z Lift Height      "
        ' menu_cut_depth   1007 getmsg submenu_add  ` 1007 "" Z Cut Depth/Delta  "
        ' menu_z_speed     1008 getmsg submenu_add  ` 1008 "" Z Axis Speed       "
    endif
    ?SHOW_SPINDLE if
        ' menu_spindle_speed 1019 getmsg submenu_add ` 1019 "" Spindle Speed      "` if showspindle bit set then allow speed change
    endif
    ' user11       1002 getmsg submenu_add  ` 1002 "" Jog X Y Axes       "
    ' setdwellup   1016 getmsg submenu_add  ` 1016 "" Set Dwell Up       "` Override parameter for PEN_UP_DELAY
    ' setdwelldown 1017 getmsg submenu_add  ` 1017 "" Set Dwell Down     "` Override parameter for PEN_DOWN_DELAY


    7 fprec
;
: main_menu
    7 1 2 20 menu_config

[ etcx 1 and ] #ifdef
`    ' SubDNCMode   1150 getmsg    menu_add  `      "" DNC_Mode"
`    ' SubBDNC      "" Do_replay?" menu_add  `      "" DNC_Mode"
`    ' SubAllowAlt  "" Allow Alt"  menu_add  `      "" DNC_Mode"
`    ' subreport    "" Report eth" menu_add
`    ' subtok       "" Report tok" menu_add
#endif
    ' menucut_speed    1000 getmsg  menu_add  ` "" Cut Speed          "
    ?CONTROLLED_Z if
        ' menu_cut_depth   1007 getmsg  menu_add  ` "" Z Cut Depth        "
        ` ' user9          1005 getmsg  menu_add  ` "" Z Delta            "  (This is incorporated in Z Cut Depth)
        ' menu_lift_height 1006 getmsg  menu_add  ` "" Z Lift Height      "
        ' menu_z_speed     1008 getmsg  menu_add  ` "" Z Axis Speed       "
    endif
    ' setdwellup       1016 getmsg  menu_add  ` "" Set Dwell Up       "` Override parameter for PEN_UP_DELAY
    ' setdwelldown     1017 getmsg  menu_add  ` "" Set Dwell Down     "` Override parameter for PEN_DOWN_DELAY
    ' menu_move        1001 getmsg  menu_add  ` "" Move X Y Axes      "
    ` ' user11           1002 getmsg  menu_add  ` "" Jog X Y Axes       "
    ' menu_clear_home  1003 getmsg  menu_add  ` "" Clear Home         "
    ' menu_job_time    1004 getmsg  menu_add  ` "" Display Job Time   "
    
    ' menudynamichome    1260 getmsg  menu_add  ` "" Dynamic Home   "
    LIMIT_MASK if
        ' menusethome    1011 getmsg  menu_add  ` "" Define Preset Home "
        ' menuloadhome   1012 getmsg  menu_add  ` "" Load Preset Home   "
    endif
    202 gi 1 and not if  ` if local replay is disabled, do not show menu (v3.66)
        ' purgejob       1013 getmsg  menu_add  ` "" Purge Job          "` Option to clear replay buffer
    endif

    ' batchops         1015 getmsg  menu_add  ` "" Batching           "

    ?CYL_TRANS if      ` if Cyl Mode Trans flag set then show default diameter option
        ' setcyldiam   1018 getmsg  menu_add ` "" Cyl Diameter       "` Cyl Diameter for Cylindrical Mode Translation
    endif

    ?SHOW_SPINDLE if
        ' menu_spindle_speed 1019 getmsg  menu_add ` "" Spindle Speed      "` if showspindle bit set then allow speed change
    endif

    LIMIT_MASK if
        ' menupocket  1022 getmsg  menu_add  ` "" Pocket Milling     "` 2.83 Pocket milling added.
    endif

    ' menu_ethernet   1212 getmsg menu_add ` "" Ethernet Settings "

    ` [ DIGITIZE_INPUT ]  #ifdef
    `     ' menu_digitize 1125 getmsg menu_add ` "" Digitize"
    ` #endif
    ?DISPENSE_ENABLE if
     ' menu_dispense "" Dispense Mode" menu_add
    endif
    ' menu_configure 1023 getmsg menu_add  ` "" Configuration      -"
;
main_menu

/* **************************  Homing  Routines  ************************** */
` variables move up to the variable section

` the following routine switches between plimit_high and plimit_low depending on bit 2 of CONFIG_BITS
` bit 2 = 0, N/O limit switches, bit 2 = 1, N/C limit switches
` <0/1:high/low> plimit
: plimit ?NC_LIMITS if 0 else 1 endif xor if plimit_high else plimit_low  endif ;

: find_x_home
    LIMIT_MASK switch_x_mask and not if :exit endif  ` don't find x home if not in limit mask
    1050 getmsg kdm_dsp_line         ` 1050 "" Finding X Datum..."
    limits? switch_x_mask and ?NC_LIMITS if not endif if
		Hi_speed 0. 0. velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        switch_x_mask 1 plimit
	endif
	wait_plot
    10 msd
	Lo_speed 0. 0. velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    switch_x_mask 0 plimit
    switch_x_mask 0 plimit
	wait_plot update_pos
    1051 getmsg kdm_dsp_line     ` 1051 "" Finding X Origin..."
	13 gf 0. 0. uline wait_plot ;

: find_y_home
    LIMIT_MASK LOWY and not if :exit endif  ` don't find y home if not in limit mask
    1052 getmsg kdm_dsp_line       ` 1052 "" Finding Y Datum..."
    limits? LOWY and ?NC_LIMITS if not endif if
		0. Hi_speed fneg 0. velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        LOWY 1 plimit
	endif
	wait_plot
    10 msd
	0. Lo_speed fneg 0. velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    LOWY 0 plimit
    LOWY 0 plimit
	wait_plot update_pos
    1053 getmsg kdm_dsp_line    ` 1053 "" Finding Y Origin..."
	0. 14 gf 0. uline wait_plot ;  ` must be negative for MillGraver

: find_z_home
    1054 getmsg  kdm_dsp_line    ` 1054 "" Finding Z Datum..."
	0. == Z_SURFACE
    limits? LOWZ and ?NC_LIMITS if not endif if
		0. 0. Hi_speedZ velocity flush_plot
		0. 0. 0. velocity                       ` queue the stop up
        LOWZ 1 plimit
        LOWZ 1 plimit
	endif
	wait_plot
    10 msd
	0. 0. Lo_speed velocity flush_plot
    0. 0. 0. velocity                           ` queue the stop up
    LOWZ 0 plimit
    LOWZ 0 plimit
	flush_plot
    1055 getmsg  kdm_dsp_line   ` 1055 "" Finding Z Origin..."
    update_pos
    0. 0. 15 gf uline wait_plot ;

/*      REMOVED reset_soft_home AS UNNECESSARY        */

/* findX is used by ft_origin and used to be in that macro, but had to remove because code need duplication */
: findX
    CYL_MODE? if   ` are we in Cylindrical X mode
      LOWXC == switch_x_mask
      find_x_home
      LOWX == switch_x_mask
    else
      LOWX == switch_x_mask
      find_x_home
      LOWXC == switch_x_mask
    endif
    LIMIT_MASK switch_x_mask and if  ` check if other X mode has limit mask set
        end_motion    ` have to end_motion to switch
        key_func43    ` switch to other X mode
        start_motion
        find_x_home   ` find home for it
        end_motion
        key_func43    ` switch back X
        start_motion
    endif
;

: ft_origin    ` needs hi accel rates
    500 gf 501 gf 502 gf 1.5 f* 0. 0. 0 set_axis_params
    510 gf 511 gf 512 gf 1.5 f* 0. 0. 1 set_axis_params
    520 gf 521 gf 522 gf 2.5 f* 0. 0. 2 set_axis_params
    limits_off 0 set_override 
	0 range_checking
	start_motion
    chk_motion? not if :exit endif
    ` removed setting of soft_home to 0's, as new go home logic now makes it unnecessary

    36 kdm_pause_key
    LIMIT_MASK LOWZ and if find_z_home endif ` only find Z if in LIMIT_MASK

    /* removed diagonal time saving move because we don't want X to break the Y limit add-on hardware */
    ?HOME_Y_FRST if     ` if flag set to home Y first then do it
        find_y_home     ` routine to home Y
        findX           ` routine to switch X which homes Either or both X's
    else                ` if not then do X first
        findX
        find_y_home
    endif
	update_pos
	-1 kdm_pause_key
	
    0 load_params 1 load_params 2 load_params ;

: find_limits wait_plot
    LIMIT_MASK not if 0 set_machine_fault 1 == ?DATUMMED 0 set_override :exit endif    ` exit if no limits
    2 set_machine_fault
    0 == ?DATUMMED
    ft_origin
    p0 p1 p2 nl
	#set_origin
    0 == X_FLAT_POS  0 == X_CYL_POS   ` zero out saved positions
    #set_home 0 == ?HOMESET  ` this makes sure we have full travel, was not getting full travel after soft_home
    
    ` Only set the Y position if we actually homed the machine.
    LIMIT_MASK LOWY and if  
        ` set Y coordinate to upper limit since we home to the back
        ?DATUM not if 10 gf 0.00001 f- 2 gf f* ftoi 1 set_pos endif `  the minus f is to resolve any floating p errors
    endif
    
    ` however, we want to set the home there (if not otherwise set) so that GO HOME doesn't move
    ` 0 get_pos? 1 get_pos? ssf_3d   ` set current absolute position to home position
    ` that section removed because it is no longer necessary, home must be set previous to GO HOME.
	update_pos
    ` turn on range checking if limits
    LIMIT_MASK if 1 range_checking endif
    LIMIT_MASK 64 and if limits_on endif  ` turn on limits for overtravel.
    slew_mode
    0 set_machine_fault
    1 == ?DATUMMED
    end_motion ;
/* ***********************  End Of Homing Routines  *********************** */

/* ****  Self Test Routine  **** */
: self_test
    "" fself_test" PATH> find if exec else "" Loading Self Test\n" write_err 1 load endif
    ;

/* ****  Feed Rate Override Test  **** */
: fro
    start_motion
    chk_any_motion? not if :exit endif
    1 set_override 5 set_override 3 set_override 200 delay wait_plot
    loop 0 get_current_fro? nl f. ?terminal until  1000 msd repeat
    end_motion ;
0 ivar PREV_FRO
: frokdm
    start_motion
    chk_any_motion? not if :exit endif
    1 set_override 5 set_override 3 set_override 200 delay wait_plot
    kdm_clear
    loop
        ?terminal until
        4 get_current_fro? dup PREV_FRO <> if 0 1 pos dup == PREV_FRO kdm_dspnum else drop endif
    repeat
    end_motion ;
: limits_test
    [ hex ]
    kdm_clear
    loop
        ?terminal until
        limits? dup PREV_FRO <> if
            == PREV_FRO 0 1 pos 0 15 1 step 1 I shlv PREV_FRO and if "" 1" else "" 0" endif kdm_dsp_string endstep
        else drop endif
    repeat
    [ decimal ]
    ;
/* ****  Timing  Test  **** */
: timetest
    get_rtc_clk
	1 10 1 step
       1. 0. 3zero uline
       0. 1. 3zero uline
       1. 1. 3zero uline
       0. 0. 3zero ualine
  endstep
  wait_plot
  get_rtc_clk swap - itof 500. f/ f. "   secs"
  ;
0. fvar BSIZE
: atest
    500 gf 11. 100. 503 gf 0. 0 set_axis_params
    510 gf 11. 100. 513 gf 0. 1 set_axis_params
    20. feedrate
    == BSIZE
    get_rtc_clk
	1 10 1 step
       coords_2d?
       coords_2d? fswap BSIZE f+ fswap 0. ualine
       BSIZE 0. 90. ufarc
       coords_2d? BSIZE f- 0. ualine
    endstep
    wait_plot
  get_rtc_clk swap - itof 500. f/ f. "   secs" ;


/* ****  Test Origin Routine  **** */
: test_origin
    LIMIT_MASK not if :exit endif
    wait_plot ft_origin
	0 NUM_AXES 1- 1 step
        I get_pos? fdup fabs ALLOWED_ERROR f> if
            nl "" Origin Error Axis"
		else
            nl "" Origin OK Axis   "
        endif
        dup s. kdm_dsp_line 17 0 kdm_set_pos I .axis
		" = " fdup f.
        2 second
	endstep nl
	end_motion
    0 1 kdm_set_pos 1113 getmsg kdm_dsp_string ` "" CANCEL To Return"
    10. kdm_time_out
	kdm_getkey 44 <> if true
	else
		kdm_check_password if
			"" " kdm_dsp_line 7 4 kdm_float_size
            0 0 kdm_set_pos "" X" kdm_dsp_string
            frot 2 0 kdm_set_pos 4 kdm_dspfnum
            11 0 kdm_set_pos "" Y" kdm_dsp_string
            fswap 13 0 kdm_set_pos 4 kdm_dspfnum
			0 1 kdm_set_pos "" Z" kdm_dsp_string
            2 1 kdm_set_pos 4 kdm_dspfnum
            kdm_getkey drop 8 units_decpt kdm_float_size false
		else true
        endif
	endif
    if f2drop fdrop endif
    120. kdm_time_out
    -1 kdm_stroke ;


: auto_set_range    ` set ranges only if limits active
    LIMIT_MASK LOWX and if 5 gf  9 gf 0 set_range else  9 gf fneg  9 gf 0 set_range endif 
    LIMIT_MASK LOWY and if 6 gf 10 gf 1 set_range else 10 gf fneg 10 gf 1 set_range endif 
    LIMIT_MASK LOWZ and if 7 gf 11 gf 2 set_range else 11 gf fneg 11 gf 2 set_range endif
;
: power_up1
    ` motion buffer not needed.
    ` memquery? swap drop 3000 - 528 / 5000 min     ` correct for 3X motion buffer methods
    ` ERRDVC> w@ outfile
    ` "         Motion Buffer = " over . nl
    ` outfile drop
    ` set_buf_size
 ;

: no_home
    mon ack_blink
    0 set_machine_fault
    1 == ?DATUMMED
    start_motion 
    kdm_dsp_rev ;

0 set_warning
: pre_job_table
    " UNITS " UNITS . nl
    " HOME_X " X_HOME f. nl
    " HOME_Y " Y_HOME f. nl
    " CUR_POS_X " coords_2d? fdrop f. nl
    " CUR_POS_Y " coords_2d? fswap fdrop f. nl
    ` what about cylindrical mode?
    CYL_MODE? if
        " TABLE_LOW_X " 9 gf 4.0 f* fneg f. nl
        " TABLE_HI_X " 9 gf 4.0 f* f. nl 
    else
        " TABLE_LOW_X " LIMIT_MASK LOWX and if 5 gf else 9 gf fneg endif f. nl
        " TABLE_HI_X " 9 gf f. nl
    endif
    " TABLE_LOW_Y " LIMIT_MASK LOWY and if 6 gf else 10 gf fneg endif f. nl
    " TABLE_HI_Y " 10 gf f. nl
    " NEED_JOB_INFO 1"  nl ` this will tell Job Console to send the job information.
  LocalDNC? if
    " DISABLE_SRC_PTR 1" nl ` this will not send out src_ptr and smt commands.
  else
    " DISABLE_SRC_PTR 0" nl ` this will not send out src_ptr and smt commands.
  endif
    pre_job_table ;
1 set_warning

: .version   ` display system information
	2 fprec nl board_info?
    nl 4 spaces " *********  LMCI  *********"
    nl 9 spaces " INIT   " ^NH_INI_VER s. " /M" 162 port_input? . "  Rev " 163 port_input? .
	nl 9 spaces " MCIF   V" mcif_rev_level s.
	nl 9 spaces " uCITO  " rev_level s.
	nl 9 spaces " DSP    V" DSP_REV swap itof 100. f/ f. " -" .
	nl 9 spaces " Controller:"
    nl 11 spaces " Model   " 5 pluck 10 min
                 select => " G960" => " G971" => " H971" => " J930" => " K520" => " LC520"
                        => " M2521" => " HP4"  => " Mxxx" => " M2564"
                 default=> " other" endselect
				 "  Rev " 4 pluck .
	nl 11 spaces " Serial  #" dsp_serial
    nl 11 spaces " Speed   " 3 pluck . " MHz"
	nl 11 spaces " Memory  " drop 1+
                 select => " 512K" => " 1M" => " 4M" => " 8M" => " 16M" => " 32M" endselect
	4 fprec ;
: show_drive_config
    " Config Bits  = 0x" CONFIG_BITS h. nl 
    " Controlled Z = " ?CONTROLLED_Z . nl 
    " Z Follow X   = " ?FOLLOW_X . nl
    " Z Follow Y   = " ?FOLLOW_Y . nl 
    " Indexing     = " ?INDEXING . nl
;
: qc
  koff  ` turn off HOT keys
  " \n/* --->\n"    ` make sure the whole thing except for parameters is commented out.
  ""  UPLOAD IN PROGRESS" kdm_dsp_line
  " \n--------- QC Report ---------" .version
  " \n\n---- Module Information ----\n" "" MACHINE_INFO" PATH> find if exec endif
  " * \n" ` add extra '*' so the ^d at the end of MACHINE_INFO does not get interpreted.
  " \n" dir
  ` ifexists read_fllog " \n---- Flash (Self Test) Log ----\n" read_fllog
  " \n---- Configuration ----\n" show_drive_config 
  ifexists show_drive_laxis " \n---- Drive Mapping ----\n" show_drive_laxis ` drive_checkout
  " \n\n---- Machine Parameters ----\n"
  " <--- */\n"
  upload_params
  kon
  -1 kdm_stroke
;
0 set_warning
: upload_params 100 msd nl upload_params ;  ` Machine Parameters will skip the first parameter sometimes. Put in this work-around.
1 set_warning
: info_pi. if " \007ON" else " OFF" endif nl ;
: dbprint
    " \n\007 Debug Settings:  " SYS_MSG? . "   -- Use 0 dbon to turn off debug.\n"
    SYS_MSG?
    "    1) Echo Job - - - - - - " dup    1 and info_pi.
    "    2) Keys, misc, etc  - - " dup    2 and info_pi.
    "    4) Preview  - - - - - - " dup    4 and info_pi.
    "    8) Self Test  - - - - - " dup    8 and info_pi.
    "   16) Homing - - - - - - - " dup   16 and info_pi.
    "   32) Miscellaneous  - - - " dup   32 and info_pi.
    "   64) Vebose - - - - - - - " dup   64 and info_pi.
`    "  128) KDM20G Activity LEDs " dup  128 and info_pi.  ` v63 of KDM20g firmware. (Moved to kdm_debug command)
    drop
;
ifmissing dbon  : dbon #istk if dup if SYS_MSG? or endif == SYS_MSG? else 1 == SYS_MSG? endif dbprint ;
ifmissing dboff : dboff 0 == SYS_MSG? " \007Debug = Off\n" dbprint ;
: setup_boot_mode
    SYS_MSG? 2 and if "" setup_boot_mode\n" write_err endif 
    dsp_errors ` check for errors
    slew_mode
	BOOT_MODE 0 max 2 min 1+ select
        => :exit        ` ucito
        => INDVC> w@ 3 1 ioctl drop     ` make sure echo is off for host even when using alternate ethernet
            "" hpgl\n"   ` hpgl
            nl dup s. ` output hpgl string since echo is now suppressed
        => "" cnc\n"    ` cnc
	endselect
	` "" INDVC = " s. INDVC> w@ itoa s.
    INDVC> w@ 23 rot ioctl drop ` V3.28 use to indvc, because executed after init file is loaded
   ;
    
0 #ifdef `  NOT IMPLEMENTED YET    
13 ivar KDM_RESOURCE_FILE
 1 ivar GLCD_RESOURCE_FILE
: update_kdm_resource ` <resouce file number> <controller location> update_kdm_resource
    == KDM_RESOURCE_FILE
    == GLCD_RESOURCE_FILE
    ` check if resource file exists.
    KDM_RESOURCE_FILE file_size 0 > if 
    `   <file> resource_info <number of images> <0> <version> 
        GLCD_RESOURCE_FILE resource_info dup -1 = if ` if -1 then this keypad does not have any kdm resources stored in location 7.
            drop  ` drop the -1
            KDM_RESOURCE_FILE resource_info_from_file dup 1 > if
                drop 2drop 
                -2 "" Updating KDM Resources..." dup write_err nl 841 getmsg 0 DLG_MsgBox  ` MSG 841 = "" Attention" 
                ifexists write_fllog "" Updating KDM Resources " 1 write_fllog drop
                KDM_RESOURCE_FILE resource_info_from_file 
                "" Version:" 2 write_fllog drop itoa 2 write_fllog drop
                drop ""  Number of images:" 2 write_fllog drop itoa 4 write_fllog drop

                KDM_RESOURCE_FILE GLCD_RESOURCE_FILE store_glcd_from_file 0 <> if 
                    -1 "" Error updating KDM Resources!" dup write_err nl 841 getmsg 0 DLG_MsgBox ` MSG 841 = "" Attention"
                else 
                    DestroyDialog
                endif
            else
                0 >= if 2drop endif 
            endif
        else
            ` numbers from GLCD_RESOURCE_FILE resource_info should be on stack.
            bury 2drop ` drop <0> and <number of images>
            KDM_RESOURCE_FILE resource_info_from_file dup 11 = if ` check if version == 11
                bury 2drop ` drop <0> and <number of images> 
                <> if ` Compare versions
                    -2 "" Updating KDM Resources..." dup write_err nl 841 getmsg 0 DLG_MsgBox  ` MSG 841 = "" Attention"
                    "" Updating KDM Resources " 1 write_fllog drop
                    KDM_RESOURCE_FILE resource_info_from_file 
                    "" Version:" 2 write_fllog drop itoa 2 write_fllog drop
                    drop ""  Number of images:" 2 write_fllog drop itoa 4 write_fllog drop
                    KDM_RESOURCE_FILE GLCD_RESOURCE_FILE store_glcd_from_file 0 <> if 
                        -1 "" Error updating KDM Resources!" dup write_err nl 841 getmsg 0 DLG_MsgBox ` MSG 841 = "" Attention"
                    else 
                        DestroyDialog
                    endif
                endif
            else
                ` version <> 1, drop the other stuff and get out.
                0 >= if 2drop endif
                drop  ` drop the version of the already installed resources
            endif
            
        endif
    endif
;
#endif
: startup
    [ RPC? ] #ifdef cyl_off #endif ` disable cylinder mode after booting.
    ` V3.28 change ethernet to use serial port buffer for local replay
    ` (1) External (HF1 Pin 13, port 111:0x100)
    ` (2) KDM (HM4 Pin 11, port 111:0x200)
    ` (4) Internal (HM2 Pin 21, port 111:0x400)
    ifexists set_estop_enable_mask 4 set_estop_enable_mask ` enable front panel estop
    155 0x8000 0 pset_bits
    alt_ethernet
    ack
    
    ?FEEDOVER if 0 set_override 5 set_override endif  ` M2.90 turn on analog feedrate, but not be on yet
    
    0 0 0 0 glcd_set_palette  ` backdoor way to change text color on splash screen. Reset back.
    
    2 blinks                            ` BOOT LOCATION last
    0 6 1 step I led_off endstep        ` turn off all leds
    
    config_kdm
    
   
    kdm_dsp_rev
    kon ` enable hot keys
    
    setup_boot_mode

    ` [ etcx 1 and ] #ifdef key_func11 key_func3 key_func1 #endif ` drives on, find home, set home
    ;

MCIF
nl power_up1
104 0x104 or hpgl_mode      ` 4 bit turns on HPGL VER output
43 get_float 44 get_float hpgl_scales

/* ***********  Special Hardware Setups  ********** */
NUM_AXES dup set_dimension prd_init
163 port_input? 26 < #ifdef
    3.5     set_pulse_width     ` 2 for M25; 10 for M50; 3.5 for others
    0.33    set_max_fraction
    300000. set_vsystem
#endif
163 port_input? 25 > #ifdef      ` if ID is greater than 25
    2.5     set_pulse_width
    0.33    set_max_fraction
    479000. set_vsystem
#endif
0.33    set_max_fraction
0.3     set_pause_time
6.0     set_limit_reference
/* *******  End Of Special Hardware Setups  ******* */

1 gf 2 gf 3 gf set_scale
0 load_params 1 load_params 2 load_params
0. 25 gf set_vertex_angles
` Code for reverse fraction and the delay that occurs when triggered
67 gi set_reverse_delay
` end reverse fraction code
auto_set_range
501 gf feedrate
22 gf set_res
100 set_fro_limit
0 range_checking

` short cuts
ln .version v
ln test_origin to
ln self_test st
ln COLD cold

: ep flush_plot ;    ` only define for H-board

: TC                    ` tool change command (uCito)
    curr_line_ptr 1+ dup                    ` grab bytes from the input stream 1 by 1 until we reach the end of line
    loop
        dup b@ dup 10 = swap 0 = or until 1+
    repeat
    0 swap b!
    dup slen 40 > if dup 40 + 0 swap b! endif ` if > 40 chars, truncate by placing NULL in 40th spot
    hpgl_tool_change                        ` call tool change macro with above bytes passed in as a string
    clear_eol ;                             ` make sure interpreter does not try to execute the bytes we just picked up

ifmissing !ZX : !ZX ;
: #l  uline fp ;
: #al ualine fp ;
` : PD pd_cnt 1+ == pd_cnt 1- 0 max pendown ;
: PD 1- 0 max pendown ;
: PU 1- penup ;

` just for scaling
1. fvar user_scale
1. fvar t1
1. fvar t2
: compute_arc_time
    ` figure theta from start and stop angles then multiply by radius to get distance
    PEN_ACTIVE? chk_motion? land if          ` only do this if a pen is active
        fdup                ` radius is on top of stack - dup the radius because compute_arc_time will eat it
        t2 t1 f- 57.2958 f/ ` compute theta in degrees and convert to radius
        f*                  ` times the radius by the theta (in radii, not degrees)
        fabs                ` make sure that the seconds are a positive value as some calcs may leave negative numbers
        get_feedrate 0 get_current_fro? f* f/  ` apply the feedrateoverride to the feedrate and divide distance by rate
        pen_time_update  ` Update the tool_time counters with the fp time on the stack
    endif
;
: R == t2 == t1
    frot user_scale f* frot user_scale f* frot user_scale f*
    compute_arc_time
    t1 t2 ufarc ;

/* take XY values on stack and come up with time for move, then add to appropriate variable */
: compute_line_time
    PEN_ACTIVE? chk_motion? land if                                  ` only do this if a pen is active
        coords_2d? 4 frepl f- fdup f* fswap 5 frepl f- fdup f* f+ sqrt         ` calculate distance
        get_feedrate 0 get_current_fro? f* f/ ` apply the feedrateoverride to the feedrate and divide distance by rate
        pen_time_update  ` Update the tool_time counters with the fp time on the stack
    endif
;
: U frot user_scale f* frot user_scale f* frot
    compute_line_time
    ualine ;
: AC
    coord_Z?
    compute_line_time
    U ;

` define below the AC definition because AC calls U with current Z.
0 set_warning
: U INVERT_Z? xlang 2 = land if fneg endif U ;
1 set_warning
    
` this is so when JSS sends "start_plot CYCLE_START" it will not do the first start_plot, only the cyclestart
0 set_warning
: start_plot
    curr_line_ptr
    1+    ` look for CYCLE_START
    loop
        dup b@ dup 10 = swap 0 = or if drop 0 break endif  ` look for LF or NULL to end str
        dup b@ ascii C = until
        1+  ` increment ptr to next char
	repeat
    dup if  ` valid ptr
        1+ b@ ascii Y =
    endif
    not if start_plot endif ;
1 set_warning


LIMIT_MASK #ifdef
  2 set_machine_fault 0 == ?DATUMMED end_motion
  ` turn on overtravel only for overtravel limit switch.
  LIMIT_MASK 64 and #ifdef
    109 64 64 1com 255 and pset_bits
    limits_off
  #endif
#endif
LIMIT_MASK not #ifdef
0 set_machine_fault 1 == ?DATUMMED end_motion
#endif

/* Suite 4 Job File commands */
: start_prox 1 == InProxHeader ;
: end_prox   0 == InProxHeader ;
: prg_pause if cnc_optional_pause else cnc_program_pause endif ;
: SMT get_graph_box if drop else stype_marker endif ;
: F SLEW_MODE? if fdrop XYUP_FEED else ?USE_FEEDRATE if fdup == XYDN_FEED else drop XYDN_FEED endif endif feedrate ;
: FM 60.0 f/ F ;
: speed F ;
: power fdrop ;

etcx #ifdef
: show_units
    etcx 1 and not if "" \n\007WARNING: ETCX HARDWARE MAPPING TURNED OFF\n" write_err endif
    "" \n\007WARNING: ETCX DEBUG TURNED ON\n" write_err
    UNITS if "" \007Metric\n" else "" \007Standard\n" endif write_err
;
show_units
#endif

KBOARD? RPC? or #ifdef
` test_dhcp  (take out for now)
#endif

power_up

0 led_on  ` BOOT LOCATION 5

5 host_mode                     ` Make sure uCito jobs don't enter ALT channel!!
1 2 host_check                  ` turn overflow error checking on by default
batch_off                       ` turn echo back on
49 == ACK_LEVEL                 ` set boot level to user init loaded
10 file_size 0 > #ifdef 10 load #endif

` re-def of machine info to make it easy.
: mi nl machine_info ;

` Restarting the thread was causing issues recovering from estop
` 1st bit = Restart thread?
` 2nd bit = Supress clr_machine_state on pause/cancel
1 set_thread_restart  ` needed to get estop to work??

0 == BOOTING?

` ERRDVC> w@ 19 0 ioctl drop               ` clear input queue
` ERRDVC> w@ 23 "" \nstartup\n" ioctl drop      ` start up appropriate parser (ucito/hpgl/cnc)
` Hard code to device 11 because this is our "Job" port.
`  11 19 0 ioctl drop               ` clear input queue
` 11 23 "" \nstartup\n" ioctl drop      ` start up appropriate parser (ucito/hpgl/cnc)
 
' startup 0 0.5  2 eventqueue drop


